#include <string.h>
#include <stdio.h>

#define NAME_LENGTH		24
#define INFO_LENGTH		8
#define HEADER_LENGTH   32
#define SPI_LENGTH		32

int main(int argc, char* argv[])
{
  FILE* fi;
  FILE* fo;
  FILE* f;
  int cnt;
  unsigned char data, i, k;
  char filename[100][255];
  char welcome[255] = "   Songs:  Storage:";
  char zeroes[1024]; /* Zeropage + Stack area + RAM */
  char prom[1024];
  char spi[255];
  char filename_long[100][255]; 
  int filesize[100], size, numfiles, offset;
  unsigned int bytes_left; /* counter */
  char buf[1024];

  welcome[1] = 16;
  welcome[2] = 22 + 64;
  welcome[9] = 16;
  welcome[10] = 42 + 64;

  /* We don't use it */
  for(i = 0; i < 30; i++)
    printf("%d\n", welcome[i]);
  
  if (argc == 3) {
	fi = fopen(argv[1], "r");
	fo = fopen(argv[2], "wb");
	
	printf("\nBuilding flash table of contents (FTOC) and PROM\n\n");
	
	numfiles = 0;
	
	while (feof(fi) == 0) {
        fscanf(fi, "%s", filename[numfiles]);
        if (feof(fi))
			break;
        fscanf(fi, "%s", filename_long[numfiles]);
		f = fopen(filename[numfiles], "rb"); 
		filesize[numfiles] = 0;
		while (feof(f) == 0) {
		  size = fread(buf, 1, 1024, f);
		  filesize[numfiles] += size;
		}
		numfiles++;
	}
	
	offset = 65536;
	bytes_left = 65536;
	/* We moved this part to program memory in the first 64 KB */
	/* numfiles * (NAME_LENGTH + INFO_LENGTH) + HEADER_LENGTH + SPI_LENGTH; */
	
	printf("Number of files: %d\n", numfiles);
	printf("Welcome message: '%s'\n\n", welcome);
	welcome[0] = (char)numfiles;

	fwrite(zeroes, 1, 1024, fo); /* Write zeropage and stack area */
	bytes_left -= 1024;

	fwrite(welcome, 1, HEADER_LENGTH, fo);
	bytes_left -= HEADER_LENGTH;

	for(i = 0; i < SPI_LENGTH/2; i++) {
		spi[2*i]   = i;
		spi[2*i+1] = 255 - i;
	}
	fwrite(spi, 1, SPI_LENGTH, fo);
	bytes_left -= SPI_LENGTH;

	for(i = 0; i < numfiles; i++) {
		size   = filesize[i];
		buf[0] = (size >> 24);
		buf[1] = (size >> 16);
		buf[2] = (size >> 8);
		buf[3] = (size >> 0);
		buf[4] = (offset >> 24);
		buf[5] = (offset >> 16);
		buf[6] = (offset >> 8);
		buf[7] = (offset >> 0);
		for(k = 0; k < NAME_LENGTH; k++) {
		  if (filename_long[i][k] < 32)
		    break;
		  if (filename_long[i][k] == '_')
		    buf[k+INFO_LENGTH] = ' ';
		  else
		    buf[k+INFO_LENGTH] = filename_long[i][k];
		}
		for(; k < NAME_LENGTH; k++)
		  buf[k+INFO_LENGTH] = ' ';
		fwrite(buf, 1, NAME_LENGTH+INFO_LENGTH, fo);
		bytes_left -= (NAME_LENGTH+INFO_LENGTH);
		printf("Adding '%s'\n   bytes:    %d\n   offset:   %d\n   filename: %s\n", 
		       filename[i], filesize[i], offset, filename_long[i]);
		offset += filesize[i];
	}

	printf("Adding SPACE. Bytes left: %d\n", bytes_left);
	/* Scan to the last 4 KB */
	while (bytes_left != 4096) {
	  fputc(0, fo);
	  bytes_left --;
	}

	printf("Adding PROM. Bytes left: %d\n", bytes_left);
	/* Copy the PROM */
	f = fopen("../asm/mp3rom.bin", "rb");
	while (!feof(f)) {
	  fputc(fgetc(f), fo);
	  bytes_left --;
	}

	if (bytes_left != -1) {
	  printf("Something is rotten in the state of Denmark!\n");
	  printf("Bytes left: %d\n", bytes_left);
	}

	for(i = 0; i < numfiles; i++) {
	  f = fopen(filename[i], "rb"); 
	  while (feof(f) == 0) {
	    size = fread(buf, 1, 1024, f);
            fwrite(buf, 1, size, fo);
	  }
	}

	printf("\n");

	fclose(fi);
	fclose(fo);
  } else
  	printf("Usage: buildtoc <file.toc> <file.dat>\n\n");   

    return 0;
}
