#include <string.h>
#include <stdio.h>
            
#define DISPLAY_WIDTH		20
#define DISPLAY_HEIGHT		4 

#define CURSORX(c)			((c) % DISPLAY_WIDTH) 
#define CURSORY(c)			((c) / DISPLAY_WIDTH) 
#define SETCURSOR(c)		((c) % (DISPLAY_WIDTH*DISPLAY_HEIGHT)) 

int main(int argc, char* argv[])
{
  FILE* fi;
  int cnt, bpl, b;
  unsigned int ch, move_cursor;
  unsigned char x, y, display[DISPLAY_HEIGHT][DISPLAY_WIDTH];
  unsigned char cursor;
  int tokens;

  for (y = 0; y < DISPLAY_HEIGHT; y++)
	for (x = 0; x < DISPLAY_WIDTH; x++)
		display[y][x] = ' ';

  cursor = SETCURSOR(0);

  tokens = 0;          
  move_cursor = 0;

  if (argc == 2) {
	fi = fopen(argv[1], "r"); 

	while (feof(fi) == 0) {
        fscanf(fi, "%d", &ch);
		if (feof(fi))
			break;
		tokens++;       
        if (move_cursor) {        
        	move_cursor = 0;
			cursor = SETCURSOR(ch-64);
		} 
		else
		{
			if (ch < 32) {
				if (ch == 1)
					cursor = SETCURSOR(0);
				if (ch == 8) {
					cursor = SETCURSOR(cursor-1);
					display[CURSORY(cursor)][CURSORX(cursor)] = ' ';
				}
				if (ch == 9)
					cursor = SETCURSOR(cursor + 4);
				if (ch == 10)
					cursor = SETCURSOR(cursor + DISPLAY_WIDTH);
				if (ch == 11)
					cursor = SETCURSOR(cursor - DISPLAY_WIDTH);
				if (ch == 12) {
					  for (y = 0; y < DISPLAY_HEIGHT; y++)
						for (x = 0; x < DISPLAY_WIDTH; x++)
							display[y][x] = ' ';
					cursor = SETCURSOR(0);
				}
				if (ch == 13)
					cursor = SETCURSOR(cursor + (DISPLAY_WIDTH - CURSORX(cursor)));
				if (ch == 16)
					move_cursor = 1;
				if (ch == 17) {
				  for (y = 0; y < DISPLAY_HEIGHT; y++)
					display[y][ch] = ' ';
					cursor = SETCURSOR(cursor+1);
				}
			} else {
				display[CURSORY(cursor)][CURSORX(cursor)] = ch;
				cursor = SETCURSOR(cursor+1);
			}				
		}
	}
	
	printf("\n   ======================\n");
	for (y = 0; y < DISPLAY_HEIGHT; y++) {
		printf("   |");
		for (x = 0; x < DISPLAY_WIDTH; x++) {
			printf("%c", display[y][x]);
		}
		printf("|\n");
	}
	printf("   ======================\n\ntokens in file: %d\n\n", tokens);	

	fclose(fi);
  } else
  	printf("Usage: display <lcd.txt>\n\n");   

    return 0;
}

