------------------------------------------------------------------------------
--
--              ModelVersion : 2.1.4
--
--              Release Date : Dec 03, 1996
--
------------------------------------------------------------------------------
LIBRARY IEEE;                   USE IEEE.STD_LOGIC_1164.ALL;
-- synopsys translate_off
                                USE IEEE.STD_LOGIC_ARITH.ALL;
                                USE IEEE.VITAL_TIMING.ALL;
LIBRARY STVLIB;                 USE STVLIB.ST_TIMING.ALL;

-- synopsys translate_on

LIBRARY STVLIB;
use STVLIB.ST_Timing.all;

ENTITY  SPS2_1024x8m8 IS

--synopsys translate_off
    GENERIC (
        -- Propagation Delays
        TPD_CK_Q : VitalDelayArrayType01Z(7 DOWNTO 0) := (OTHERS =>
            (3.888 ns, 3.888 ns, 1.182 ns,  3.888 ns, 1.182 ns, 3.888 ns));
        TPD_CK_Q_NT_WEN : VitalDelayArrayType01Z(7 DOWNTO 0) := (OTHERS =>
            (2.733 ns, 2.733 ns, 1.182 ns,  2.733 ns, 1.182 ns, 2.733 ns));
        TPD_OEN_Q : VitalDelayArrayType01Z(7 DOWNTO 0) := (OTHERS =>
            (0.799 ns, 0.799 ns, 0.974 ns,  0.799 ns, 0.974 ns, 0.799 ns));
        -- Timing Checks
        TSETUP_A_CK_noedge_posedge : VitalDelayArrayType(9 DOWNTO 0) := (OTHERS => 3.005 ns);
        THOLD_A_CK_noedge_posedge : VitalDelayArrayType(9 DOWNTO 0) := (OTHERS => 0.010 ns);
        TSETUP_D_CK_noedge_posedge : VitalDelayArrayType(7 DOWNTO 0) := (OTHERS => 4.893 ns);
        THOLD_D_CK_noedge_posedge : VitalDelayArrayType(7 DOWNTO 0) := (OTHERS => 0.010 ns);
        TSETUP_CSN_CK_noedge_posedge : VitalDelayType := 5.234 ns;
        THOLD_CSN_CK_noedge_posedge : VitalDelayType := 2.700 ns;
        TSETUP_WEN_CK_noedge_posedge : VitalDelayType := 1.971 ns;
        THOLD_WEN_CK_noedge_posedge : VitalDelayType := 0.010 ns;
        TPW_CK_posedge : VitalDelayType := 1.156 ns;
        TPW_CK_negedge : VitalDelayType := 2.768 ns;
        TPERIOD_CK : VitalDelayType := 8.540 ns;
        -- Interconnect Delays
        TIPD_D : VitalDelayArrayType01(7 DOWNTO 0) := (OTHERS => (0 ns, 0 ns));
        TIPD_A : VitalDelayArrayType01(9 DOWNTO 0) := (OTHERS => (0 ns, 0 ns));
        TIPD_CK : VitalDelayType01 := (0 ns, 0 ns);
        TIPD_CSN : VitalDelayType01 := (0 ns, 0 ns);
        TIPD_WEN : VitalDelayType01 := (0 ns, 0 ns);
        TIPD_OEN : VitalDelayType01 := (0 ns, 0 ns);
        InstancePath : String := "SPS2_1024x8m8";
        TimingChecksOn : Boolean := DefaultTimingChecksOn;
        XOn : Boolean := DefaultXOn;
        MsgOn : Boolean := DefaultMsgOn
    );
--synopsys translate_on

    PORT (
        Q : OUT std_logic_vector(7 DOWNTO 0);
        D : IN std_logic_vector(7 DOWNTO 0);
        A : IN std_logic_vector(9 DOWNTO 0);
        CK : IN std_logic;
        CSN : IN std_logic;
        WEN : IN std_logic;
        OEN : IN std_logic
    );
-- synopsys translate_off
    ATTRIBUTE VITAL_LEVEL0 OF SPS2_1024x8m8 : ENTITY IS TRUE;
-- synopsys translate_on
END SPS2_1024x8m8;
