library IEEE;
use ieee.std_logic_1164.all;
use ieee.std_logic_unsigned.all;

package uart_pck is
           
  type uart_ctrl_in_type is record
    data    : std_logic_vector(7 downto 0);
    send    : std_logic;
    ack_rcv : std_logic;
  end record;

  type uart_ctrl_out_type is record
    data    : std_logic_vector(7 downto 0);
    rxready : std_logic;
    txempty : std_logic; 
  end record;

  component uart
    generic ( MASTER_CLOCK : integer;
	      BAUD_RATE_OUT: integer;
	      BAUD_RATE_IN: integer
            );
    port ( clk   : in  std_logic;
           rst   : in  std_logic;
           rxd   : in  std_logic;
           txd   : out std_logic;
           uarti : in  uart_ctrl_in_type;
           uarto : out uart_ctrl_out_type
         );
  end component;


  component uart_lcd 
      generic ( MASTER_CLOCK : integer;
		BAUD_RATE: integer -- pragma translate_off;
		;
		LCD_FILENAME : string  	-- pragma translate_on;
		);
	  port ( clk   : in  std_logic;
		 rst   : in  std_logic;
		 rxd   : in  std_logic
		 );
      end component;
end;
