---------------------------------------------------
--
-- DAC Uart for stupid device
--
-- Copyleft 2003 Hkan Kvist & Linus Walleij
--
---------------------------------------------------

library IEEE;
use ieee.std_logic_1164.all;
use ieee.std_logic_unsigned.all;
library work;
use work.controller_types.all;

package dacuart_pck is
  component dacuart
  port ( clk			: in std_logic;
	 rst			: in std_logic;
	 dacbytes		: in std_logic_vector(15 downto 0);  -- Bytes to
								     -- serve
	 takethisdac		: in std_logic;  -- Take the bytes above and
						 -- send them
	 requestdac		: out std_logic; -- Gimme something
	 daco			: out spi_type
	 );
  end component;
end;


library IEEE;
use ieee.std_logic_1164.all;
use ieee.std_logic_unsigned.all;
library work;
use work.controller_types.all;
use std.textio.all;

entity dacuart is
  port ( clk			: in std_logic;
	 rst			: in std_logic;
	 dacbytes		: in std_logic_vector(15 downto 0);  -- Bytes to
								     -- serve
	 takethisdac		: in std_logic;  -- Take the bytes above and
						 -- send them
	 requestdac		: out std_logic;  -- Gimme something
	 daco			: out spi_type
       );
end;


architecture FOOBAR of dacuart is

--     procedure printbytes(b : std_logic_vector(15 downto 0)) is
-- 	variable L1 : line;
--     begin
--         write(L1, to_bitvector(b));
-- 	writeline(output,L1);
--     end;

    type feed_state_type is ( IDLE, SENDING );
        
    type feed_type is record
	     state : feed_state_type;
	     bitcount : std_logic_vector(4 downto 0);
	     dacbytes : std_logic_vector(15 downto 0);
	     requestdac : std_logic;
	     clock_out : std_logic;
    end record;

    signal feed : feed_type;
    signal feed_in : feed_type;

begin

--  borde inte denna skriva direkt till sclk?
--     process(clk)
--     begin
-- 	daco.sclk <= not clk;
--     end process;
    
    -- These two throw bytes at the DAC
    mr_feedbuffer : process(clk, feed_in)
    begin
	if ( rising_edge(clk) ) then
	    requestdac <= feed_in.requestdac;
	    
-- 	    if (feed_in.reset = '1') then
-- 		daco.cs <= '1';
-- 		daco.din <= '0';
	    if (feed_in.bitcount /= "00000") then
		daco.din <= feed_in.dacbytes(15);
		daco.cs <= '0';
	    else
		daco.cs <= '1';
	    end if;
	    -- Iterate state

	    daco.sclk <= feed_in.clock_out;
	    
	    feed <= feed_in;

	    feed.clock_out <= not feed_in.clock_out;
	    
	    if (feed_in.bitcount /= "00000" and feed_in.clock_out = '1') then
		feed.dacbytes <= shl(feed_in.dacbytes, "1");  -- Shift
		feed.bitcount <= feed_in.bitcount - 1;
	    end if;
	end if;
    end process;
    
    mr_feed : process(rst, feed, takethisdac, dacbytes)
	variable f : feed_type;
    begin
	f := feed;
-- 	    if (stopit = '1') then
-- 		f.bitcount := "00000";
-- 		f.state := IDLE;
-- 	    end if;

	case f.state is
	    when  IDLE =>
		if (takethisdac = '1') then
		    f.requestdac := '1';
		end if;
		if (takethisdac = '1' and f.requestdac = '1') then
		    f.dacbytes := dacbytes;
		    -- printbyte(f.mp3byte);
		    f.bitcount := "10000";
		    f.requestdac := '0';
		    f.state := SENDING;
		end if;
	    when SENDING =>
		if (f.bitcount = "00000") then
		    f.requestdac := '1';
		    f.state := IDLE;
		end if;
	end case;

       	if (rst = '0') then
	    f.state := IDLE;
	    -- Signals
	    f.requestdac := '1';
	    -- Variables
	    f.dacbytes := "0000000000000000";
	    f.bitcount := "00000";
	    -- Throw bytes at DAC if read out
	    f.clock_out := '1';
	end if;

       	feed_in <= f;
	
    end process;

end;
