----------------------------------------------------------------------------
-- RAM CAPSULE
-- (L) Copyleft 2003 Linus Walleij and Hkan Kvist
----------------------------------------------------------------------------
library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;

-- The mp3ram_sim is not used anymore. May be
-- removed eventually.
package ram is
  component mp3ram
    generic (BYTES : integer);
    port (addr	:in std_logic_vector (9 downto 0);
	  clk :in std_logic;
	  we :in std_logic;
	  data_in :in std_logic_vector (7 downto 0);
          data_out :out std_logic_vector (7 downto 0)
         );
  end component;
end ram;

-------------------------------------------------------------------------------
library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;
library work;
-- Genererat RAM
LIBRARY STVLIB;
USE STVLIB.ST_TIMING.all;
USE STVLIB.ST_VSS.all;
LIBRARY LIB_GENERATORS;
USE LIB_GENERATORS.PCK_GENERATORS.all;

entity mp3ram is
    generic (BYTES : integer);
    port (addr	:in std_logic_vector (9 downto 0);
	  clk :in std_logic;
	  we :in std_logic;
	  data_in :in std_logic_vector (7 downto 0);
          data_out :out std_logic_vector (7 downto 0)
         );
end mp3ram;

architecture SYNT of mp3ram is
    -- Generate 1KB RAM
    signal gnd : std_logic;
    signal ram_we_inv : std_logic;
begin
  -- Just connect to it.
  mr_ram: SPS2_1024x8m8
      port map (Q => data_out,
		D => data_in,
		A => addr,
		CK => clk, 
                CSN => gnd,
		WEN => we,
		OEN => gnd );
  gnd <= '0';
end SYNT;
