library IEEE;
use IEEE.std_logic_1164.all;

package memcomp is

  component flash
    generic( ADDR_BITS : integer := 2;
             DATA_BITS : integer := 8;
             ROM_FILE  : string
           );
    port( CLK  : in  std_logic;
          ADDR : in  std_logic_vector(ADDR_BITS-1 downto 0);
          DO   : out std_logic_vector(DATA_BITS-1 downto 0)
        );
  end component;
  
  component sram
    generic( ADDR_BITS : integer := 4;
             DATA_BITS : integer := 4
             );
      
    port( CLK  : in  std_logic;					
          ADDR : in  std_logic_vector(ADDR_BITS-1 downto 0);
          D    : in  std_logic_vector(DATA_BITS-1 downto 0);
          Q    : out std_logic_vector(DATA_BITS-1 downto 0);
          nWE  : in  std_logic;				
          nEN  : in  std_logic;				
          nOE  : in  std_logic				
        );
  end component;

end;
