library IEEE;
use IEEE.std_logic_1164.all;
use IEEE.std_logic_signed.all;
use IEEE.std_logic_arith.all;
use std.textio.all;
use work.tbcomp.all;
-- use work.memcomp.all;
-- use work.controller_types.all;
use work.mr_fnord_clock.all;

entity tb_clock is
end;

architecture behavioral of tb_clock is

  component controller_top
      port( clk : in std_logic;
	    rst : in std_logic;
            read : out std_logic; 
 	    hold : out std_logic;
 	    seconds :in std_logic_vector(7 downto 0);
 	    minutes :in std_logic_vector(7 downto 0);
 	    hours   :in std_logic_vector(7 downto 0)
	    );
  end component;

  procedure print(s : string) is
      variable L1 : line;
  begin
      L1:= new string'(s);
      writeline(output,L1);
  end;

  signal clk, rst, gnd, vdd, rst2                     : std_logic;
  signal read, hold                             : std_logic;
  signal seconds, minutes, hours		: std_logic_vector(7 downto 0);

begin
    ---------------------------------------------------------------------------
    -- CLOCK
    ---------------------------------------------------------------------------
    the_clock: clock
	-- vill den inte stta sig sjlv s fr vi gr det manuellt.
--      generic map (MASTER_CLOCK => 12_000_000 		     )
	generic map (MASTER_CLOCK => 1_000	     )
	port map ( clk         => clk,
               rst         => rst,
	       zero        => rst2,
	       read        => read,
	       hold        => hold,
	       seconds     => seconds,
	       minutes     => minutes,
	       hours       => hours
             );
               
  ----------------------------
  -- Clock and Reset
  ----------------------------

  clkgen: clock_generator
    generic map( 83 ns )
    port map ( CLK => CLK );

  rstgen: reset_generator
    generic map( 450 ns )
    port map ( RST => RST );

  gnd <= '0';
  vdd <= '1';
  read <= '0';
  hold <= '0';

  foo : process(clk, rst)
  begin
      if (rst = '0') then
	  rst2 <= '1';
      else
	  rst2 <= '0';
      end if;
  end process;

end;

