library IEEE;
use IEEE.std_logic_1164.all;

package tbcomp is

  component clock_generator
    generic( PERIOD : time );
    port( CLK : out std_logic );
  end component;

  component reset_generator
    generic( LENGTH : time );
    port( RST : out std_logic );
  end component;

  component read_file
    generic( WIDTH    : integer;
             FILENAME : string 
           );
    port( CLK : in  std_logic;
          RST : in  std_logic;
          EN  : in  std_logic;
          DO  : out std_logic_vector(WIDTH-1 downto 0) 
        );
  end component;

  component write_file
    generic( WIDTH    : integer;
             SIGNED   : boolean := true;
             FILENAME : string 
           );
    port( CLK : in  std_logic;
          RST : in  std_logic;
          DI  : in  std_logic_vector(WIDTH-1 downto 0) 
        );
  end component;

end;
