
library IEEE,MTC45000,MTC45100X,LIB_GENERATORS,STVLIB;

use IEEE.std_logic_1164.all;
use IEEE.std_logic_arith.all;
use MTC45000.VCOMPONENTS.all;
use MTC45100X.VCOMPONENTS.all;
use LIB_GENERATORS.PCK_GENERATORS.all;
use STVLIB.ST_TIMING.all;
use STVLIB.ST_VSS.all;

entity DONE_rom is

   port( addr : in std_logic_vector (10 downto 0);  DONE : out std_logic);

end DONE_rom;

architecture SYN_DONE_rom_arch of DONE_rom is

   component AN4P
      port( A, B, C, D : in std_logic;  Z : out std_logic);
   end component;
   
   component MUX21P
      port( A, B, S : in std_logic;  Z : out std_logic);
   end component;
   
   component AN3P
      port( A, B, C : in std_logic;  Z : out std_logic);
   end component;
   
   component ND3
      port( A, B, C : in std_logic;  Z : out std_logic);
   end component;
   
   component ND2
      port( A, B : in std_logic;  Z : out std_logic);
   end component;
   
   component IVP
      port( A : in std_logic;  Z : out std_logic);
   end component;
   
   component ND4
      port( A, B, C, D : in std_logic;  Z : out std_logic);
   end component;
   
   component AN2
      port( A, B : in std_logic;  Z : out std_logic);
   end component;
   
   component AN3
      port( A, B, C : in std_logic;  Z : out std_logic);
   end component;
   
   component AN5
      port( A, B, C, D, E : in std_logic;  Z : out std_logic);
   end component;
   
   component AO6N
      port( A, B, C : in std_logic;  Z : out std_logic);
   end component;
   
   component AO2A
      port( A, B, C, D : in std_logic;  Z : out std_logic);
   end component;
   
   component AO6A
      port( A, B, C : in std_logic;  Z : out std_logic);
   end component;
   
   component AO8
      port( A, B, C, D : in std_logic;  Z : out std_logic);
   end component;
   
   component AO3C
      port( A, B, C, D : in std_logic;  Z : out std_logic);
   end component;
   
   component AO17
      port( A, B, C, D : in std_logic;  Z : out std_logic);
   end component;
   
   component AO7A
      port( A, B, C : in std_logic;  Z : out std_logic);
   end component;
   
   component MUX21N
      port( A, B, S : in std_logic;  Z : out std_logic);
   end component;
   
   component AO3A
      port( A, B, C, D : in std_logic;  Z : out std_logic);
   end component;
   
   component AO29
      port( A, B, C, D, E : in std_logic;  Z : out std_logic);
   end component;
   
   component AO25
      port( A, B, C, D, E : in std_logic;  Z : out std_logic);
   end component;
   
   component AO1N
      port( A, B, C, D : in std_logic;  Z : out std_logic);
   end component;
   
   signal n862, n863, n864, n865, n866, n867, n868, n869, n870, n871, n872, 
      n873, n874, n875, n876, n877, n878, n879, n880, n881, n882, n883, n884, 
      n885, n886, n887, n888, n889, n890, n891, n892, n893, n894, n895, n896, 
      n897, n898, n899, n900, n901, n902, n903, n904, n905, n906, n907, n908, 
      n909, n910, n911, n912, n913, n914, n915, n916, n917, n918, n919, n920, 
      n921, n922, n923, n924, n925, n926, n927, n928, n929, n930, n931, n932, 
      n933, n934, n935, n936, n937, n938, n939, n940, n941, n942, n943, n944, 
      n945, n946, n947, n948, n949, n950, n951 : std_logic;

begin
   
   U40 : AN4P port map( A => addr(8), B => addr(2), C => addr(6), D => addr(5),
                           Z => n874);
   U41 : MUX21P port map( A => n893, B => n906, S => addr(0), Z => n948);
   U42 : AN3P port map( A => n894, B => n868, C => n865, Z => n893);
   U43 : AN3P port map( A => n899, B => n880, C => addr(8), Z => n940);
   U44 : ND3 port map( A => n871, B => n872, C => n899, Z => n881);
   U45 : AN4P port map( A => n871, B => n872, C => n873, D => addr(6), Z => 
                           n870);
   U46 : MUX21P port map( A => n875, B => n922, S => addr(3), Z => n920);
   U47 : ND2 port map( A => n943, B => n877, Z => n946);
   U48 : AN3P port map( A => n924, B => addr(4), C => n866, Z => n923);
   U49 : IVP port map( A => n915, Z => n922);
   U50 : MUX21P port map( A => n896, B => n949, S => addr(10), Z => n929);
   U51 : ND2 port map( A => addr(5), B => n948, Z => n949);
   U52 : MUX21P port map( A => n951, B => n950, S => addr(0), Z => n928);
   U53 : IVP port map( A => n907, Z => n916);
   U54 : ND2 port map( A => addr(6), B => n905, Z => n907);
   U55 : ND3 port map( A => n873, B => n871, C => n863, Z => n892);
   U56 : ND3 port map( A => addr(3), B => addr(4), C => n863, Z => n903);
   U57 : IVP port map( A => n903, Z => n943);
   U58 : ND2 port map( A => n906, B => addr(5), Z => n891);
   U59 : IVP port map( A => n891, Z => n876);
   U60 : IVP port map( A => n878, Z => n938);
   U61 : ND3 port map( A => addr(10), B => n894, C => n905, Z => n878);
   U62 : IVP port map( A => n881, Z => n905);
   U63 : ND2 port map( A => n862, B => n894, Z => n898);
   U64 : ND2 port map( A => addr(6), B => addr(1), Z => n913);
   U65 : ND2 port map( A => n894, B => n871, Z => n914);
   U66 : ND2 port map( A => n880, B => n877, Z => n908);
   U67 : IVP port map( A => n908, Z => n924);
   U68 : ND2 port map( A => n944, B => n883, Z => n932);
   U69 : IVP port map( A => n904, Z => n944);
   U70 : MUX21P port map( A => n927, B => n925, S => addr(3), Z => n930);
   U71 : ND2 port map( A => n926, B => n897, Z => n925);
   U72 : IVP port map( A => n900, Z => n906);
   U73 : ND2 port map( A => addr(6), B => n862, Z => n900);
   U74 : ND2 port map( A => n891, B => n892, Z => n890);
   U75 : IVP port map( A => n890, Z => n917);
   U76 : ND2 port map( A => addr(7), B => n910, Z => n909);
   U77 : IVP port map( A => n933, Z => n885);
   U78 : IVP port map( A => n892, Z => n941);
   U79 : ND2 port map( A => n937, B => n891, Z => n888);
   U80 : MUX21P port map( A => n896, B => n897, S => addr(3), Z => n895);
   U81 : ND4 port map( A => addr(2), B => addr(5), C => addr(4), D => n902, Z 
                           => n896);
   U82 : ND3 port map( A => addr(5), B => n883, C => n901, Z => n897);
   U83 : IVP port map( A => n898, Z => n901);
   U84 : IVP port map( A => n896, Z => n942);
   U85 : IVP port map( A => n897, Z => n889);
   U86 : MUX21P port map( A => n934, B => n931, S => addr(7), Z => n869);
   U87 : MUX21P port map( A => n886, B => n882, S => addr(7), Z => n947);
   U88 : MUX21P port map( A => n909, B => n911, S => addr(0), Z => n912);
   U89 : IVP port map( A => addr(8), Z => n877);
   U90 : IVP port map( A => addr(3), Z => n887);
   U91 : IVP port map( A => addr(5), Z => n899);
   U92 : IVP port map( A => addr(4), Z => n873);
   U93 : IVP port map( A => addr(10), Z => n880);
   U94 : IVP port map( A => addr(6), Z => n894);
   U95 : IVP port map( A => addr(9), Z => n868);
   U96 : IVP port map( A => addr(2), Z => n872);
   U97 : IVP port map( A => addr(1), Z => n871);
   U98 : IVP port map( A => addr(0), Z => n883);
   U99 : AN2 port map( A => n865, B => n873, Z => n862);
   U100 : AN3 port map( A => n894, B => n899, C => addr(2), Z => n863);
   U101 : AN5 port map( A => addr(5), B => addr(6), C => addr(10), D => addr(0)
                           , E => n865, Z => n864);
   U102 : AN2 port map( A => addr(1), B => n872, Z => n865);
   U103 : AN3 port map( A => n871, B => n868, C => n863, Z => n866);
   U104 : AO6N port map( A => n867, B => n868, C => n869, Z => DONE);
   U105 : AO2A port map( A => n878, B => n873, C => n876, D => n877, Z => n875)
                           ;
   U106 : AO6A port map( A => addr(4), B => n880, C => n881, Z => n879);
   U107 : AO8 port map( A => n883, B => n880, C => n884, D => n885, Z => n882);
   U108 : AO8 port map( A => addr(0), B => n887, C => n888, D => n889, Z => 
                           n886);
   U109 : AO3C port map( A => n870, B => n901, C => addr(3), D => n899, Z => 
                           n904);
   U110 : AO17 port map( A => n906, B => addr(7), C => n890, D => addr(3), Z =>
                           n911);
   U111 : AO7A port map( A => n916, B => addr(4), C => n917, Z => n915);
   U112 : MUX21N port map( A => n919, B => n920, S => addr(0), Z => n918);
   U113 : AO6A port map( A => addr(8), B => addr(10), C => n922, Z => n921);
   U114 : AO3A port map( A => n864, B => addr(9), C => n928, D => n929, Z => 
                           n927);
   U115 : AO29 port map( A => n932, B => n933, C => n895, D => n868, E => n908,
                           Z => n931);
   U116 : AO3C port map( A => n880, B => n897, C => n930, D => n935, Z => n934)
                           ;
   U117 : AO8 port map( A => addr(5), B => n894, C => n865, D => n916, Z => 
                           n936);
   U118 : AO8 port map( A => n899, B => n880, C => n901, D => n938, Z => n937);
   U119 : AO2A port map( A => n895, B => n880, C => n864, D => n887, Z => n939)
                           ;
   U120 : AO3A port map( A => n900, B => n941, C => addr(3), D => addr(0), Z =>
                           n933);
   U121 : AO17 port map( A => n863, B => n873, C => n874, D => n887, Z => n945)
                           ;
   U122 : AO17 port map( A => n942, B => n887, C => n918, D => addr(9), Z => 
                           n935);
   U123 : AO7A port map( A => addr(1), B => n903, C => n904, Z => n884);
   U124 : AO25 port map( A => n936, B => n898, C => addr(3), D => n898, E => 
                           n899, Z => n910);
   U125 : AO25 port map( A => n939, B => n947, C => n877, D => n880, E => n912,
                           Z => n867);
   U126 : MUX21N port map( A => n913, B => n914, S => addr(0), Z => n902);
   U127 : AO1N port map( A => n946, B => n945, C => addr(10), D => n871, Z => 
                           n919);
   U128 : MUX21N port map( A => n923, B => n921, S => addr(0), Z => n926);
   U129 : AO3A port map( A => n907, B => n866, C => n924, D => n873, Z => n950)
                           ;
   U130 : AO17 port map( A => n940, B => n862, C => n879, D => addr(6), Z => 
                           n951);

end SYN_DONE_rom_arch;

library IEEE,MTC45000,MTC45100X,LIB_GENERATORS,STVLIB;

use IEEE.std_logic_1164.all;
use IEEE.std_logic_arith.all;
use MTC45000.VCOMPONENTS.all;
use MTC45100X.VCOMPONENTS.all;
use LIB_GENERATORS.PCK_GENERATORS.all;
use STVLIB.ST_TIMING.all;
use STVLIB.ST_VSS.all;

entity ADDR_OP_rom is

   port( addr : in std_logic_vector (10 downto 0);  ADDR_OP : out 
         std_logic_vector (0 to 4));

end ADDR_OP_rom;

architecture SYN_ADDR_OP_rom_arch of ADDR_OP_rom is

   component ND2
      port( A, B : in std_logic;  Z : out std_logic);
   end component;
   
   component MUX21P
      port( A, B, S : in std_logic;  Z : out std_logic);
   end component;
   
   component AN3P
      port( A, B, C : in std_logic;  Z : out std_logic);
   end component;
   
   component ND3
      port( A, B, C : in std_logic;  Z : out std_logic);
   end component;
   
   component AN4P
      port( A, B, C, D : in std_logic;  Z : out std_logic);
   end component;
   
   component IVP
      port( A : in std_logic;  Z : out std_logic);
   end component;
   
   component ND5P
      port( A, B, C, D, E : in std_logic;  Z : out std_logic);
   end component;
   
   component ND4
      port( A, B, C, D : in std_logic;  Z : out std_logic);
   end component;
   
   component AN3
      port( A, B, C : in std_logic;  Z : out std_logic);
   end component;
   
   component AN5
      port( A, B, C, D, E : in std_logic;  Z : out std_logic);
   end component;
   
   component AN2
      port( A, B : in std_logic;  Z : out std_logic);
   end component;
   
   component AN4
      port( A, B, C, D : in std_logic;  Z : out std_logic);
   end component;
   
   component MUX21N
      port( A, B, S : in std_logic;  Z : out std_logic);
   end component;
   
   component ND6P
      port( A, B, C, D, E, F : in std_logic;  Z : out std_logic);
   end component;
   
   component AO3A
      port( A, B, C, D : in std_logic;  Z : out std_logic);
   end component;
   
   component AO29
      port( A, B, C, D, E : in std_logic;  Z : out std_logic);
   end component;
   
   component AO6A
      port( A, B, C : in std_logic;  Z : out std_logic);
   end component;
   
   component AO7A
      port( A, B, C : in std_logic;  Z : out std_logic);
   end component;
   
   component AO35
      port( A, B, C, D, E : in std_logic;  Z : out std_logic);
   end component;
   
   component AO1N
      port( A, B, C, D : in std_logic;  Z : out std_logic);
   end component;
   
   component AO25
      port( A, B, C, D, E : in std_logic;  Z : out std_logic);
   end component;
   
   component AO3N
      port( A, B, C, D : in std_logic;  Z : out std_logic);
   end component;
   
   component AO34
      port( A, B, C, D : in std_logic;  Z : out std_logic);
   end component;
   
   component AO8
      port( A, B, C, D : in std_logic;  Z : out std_logic);
   end component;
   
   component AO17
      port( A, B, C, D : in std_logic;  Z : out std_logic);
   end component;
   
   component OR8
      port( A, B, C, D, E, F, G, H : in std_logic;  Z : out std_logic);
   end component;
   
   component AO3C
      port( A, B, C, D : in std_logic;  Z : out std_logic);
   end component;
   
   signal n753, n754, n755, n756, n757, n758, n759, n760, n761, n762, n763, 
      n764, n765, n766, n767, n768, n769, n770, n771, n772, n773, n774, n775, 
      n776, n777, n778, n779, n780, n781, n782, n783, n784, n785, n786, n787, 
      n788, n789, n790, n791, n792, n793, n794, n795, n796, n797, n798, n799, 
      n800, n801, n802, n803, n804, n805, n806, n807, n808, n809, n810, n811, 
      n812, n813, n814, n815, n816, n817, n818, n819, n820, n821, n822, n823, 
      n824, n825, n826, n827, n828, n829, n830, n831, n832, n833, n834, n835, 
      n836, n837, n838, n839, n840, n841, n842, n843, n844, n845, n846, n847, 
      n848, n849, n850, n851, n852, n853, n854, n855, n856, n857, n858, n859, 
      n860, n861 : std_logic;

begin
   
   U73 : ND2 port map( A => n790, B => n808, Z => n837);
   U74 : ND2 port map( A => n840, B => n790, Z => n839);
   U75 : MUX21P port map( A => n757, B => addr(0), S => addr(8), Z => n840);
   U76 : MUX21P port map( A => n826, B => n818, S => addr(5), Z => n850);
   U77 : AN3P port map( A => n784, B => n785, C => n764, Z => n783);
   U78 : ND3 port map( A => n801, B => n802, C => n805, Z => n794);
   U79 : ND2 port map( A => addr(3), B => addr(4), Z => n803);
   U80 : AN4P port map( A => addr(7), B => n800, C => n850, D => n755, Z => 
                           n849);
   U81 : ND3 port map( A => n764, B => n808, C => n759, Z => n776);
   U82 : ND2 port map( A => n758, B => n814, Z => n777);
   U83 : AN3P port map( A => addr(0), B => addr(9), C => n790, Z => n824);
   U84 : MUX21P port map( A => n786, B => n859, S => addr(2), Z => n825);
   U85 : ND3 port map( A => addr(0), B => n764, C => n759, Z => n848);
   U86 : IVP port map( A => n821, Z => n826);
   U87 : ND2 port map( A => addr(3), B => n801, Z => n821);
   U88 : ND2 port map( A => n787, B => n793, Z => n822);
   U89 : ND2 port map( A => n813, B => n803, Z => n832);
   U90 : ND2 port map( A => n813, B => n820, Z => n858);
   U91 : IVP port map( A => n822, Z => n785);
   U92 : IVP port map( A => n832, Z => n855);
   U93 : MUX21P port map( A => n820, B => n792, S => n842, Z => n856);
   U94 : ND2 port map( A => n821, B => n815, Z => n820);
   U95 : ND5P port map( A => addr(6), B => n811, C => addr(0), D => n797, E => 
                           n753, Z => n819);
   U96 : ND3 port map( A => n797, B => n780, C => n798, Z => n796);
   U97 : MUX21P port map( A => n841, B => addr(4), S => n842, Z => n835);
   U98 : MUX21P port map( A => n861, B => n860, S => addr(7), Z => n854);
   U99 : AN3P port map( A => n761, B => n790, C => n791, Z => n789);
   U100 : IVP port map( A => n794, Z => n790);
   U101 : ND2 port map( A => n760, B => n805, Z => n827);
   U102 : ND3 port map( A => n798, B => n797, C => addr(7), Z => n810);
   U103 : IVP port map( A => n820, Z => n841);
   U104 : IVP port map( A => n815, Z => n818);
   U105 : ND2 port map( A => addr(4), B => n802, Z => n815);
   U106 : IVP port map( A => n811, Z => n842);
   U107 : ND2 port map( A => addr(10), B => n807, Z => n811);
   U108 : IVP port map( A => n812, Z => n846);
   U109 : ND3 port map( A => n813, B => addr(0), C => n814, Z => n812);
   U110 : IVP port map( A => n810, Z => n814);
   U111 : IVP port map( A => n799, Z => n791);
   U112 : ND3 port map( A => n800, B => n787, C => n784, Z => n799);
   U113 : ND2 port map( A => addr(5), B => n800, Z => n809);
   U114 : ND3 port map( A => n787, B => n802, C => n780, Z => n845);
   U115 : ND2 port map( A => n804, B => n805, Z => n795);
   U116 : IVP port map( A => n803, Z => n804);
   U117 : IVP port map( A => n828, Z => n779);
   U118 : ND4 port map( A => n798, B => n808, C => addr(1), D => n829, Z => 
                           n828);
   U119 : IVP port map( A => n827, Z => n829);
   U120 : AN3P port map( A => n777, B => n770, C => n848, Z => n781);
   U121 : ND2 port map( A => n857, B => addr(7), Z => n770);
   U122 : IVP port map( A => n819, Z => n857);
   U123 : ND4 port map( A => n813, B => addr(7), C => n755, D => n856, Z => 
                           n766);
   U124 : IVP port map( A => n809, Z => n813);
   U125 : ND2 port map( A => n758, B => n784, Z => n771);
   U126 : IVP port map( A => n796, Z => n784);
   U127 : IVP port map( A => n823, Z => n831);
   U128 : IVP port map( A => n834, Z => n768);
   U129 : ND4 port map( A => n775, B => n782, C => n773, D => n769, Z => 
                           ADDR_OP(0));
   U130 : ND3 port map( A => n800, B => n797, C => n754, Z => n775);
   U131 : ND3 port map( A => n806, B => n807, C => n759, Z => n773);
   U132 : IVP port map( A => n795, Z => n806);
   U133 : IVP port map( A => n816, Z => n769);
   U134 : IVP port map( A => n775, Z => n847);
   U135 : IVP port map( A => addr(8), Z => n793);
   U136 : IVP port map( A => addr(3), Z => n802);
   U137 : IVP port map( A => addr(5), Z => n805);
   U138 : IVP port map( A => addr(4), Z => n801);
   U139 : IVP port map( A => addr(9), Z => n807);
   U140 : IVP port map( A => addr(10), Z => n787);
   U141 : IVP port map( A => addr(6), Z => n798);
   U142 : IVP port map( A => addr(7), Z => n780);
   U143 : IVP port map( A => addr(2), Z => n800);
   U144 : IVP port map( A => addr(1), Z => n797);
   U145 : IVP port map( A => addr(0), Z => n808);
   U146 : AN3 port map( A => addr(2), B => addr(5), C => n818, Z => n753);
   U147 : AN5 port map( A => n787, B => n798, C => n806, D => addr(7), E => 
                           n761, Z => n754);
   U148 : AN2 port map( A => n757, B => addr(1), Z => n755);
   U149 : AN4 port map( A => n805, B => n808, C => addr(2), D => n826, Z => 
                           n756);
   U150 : AN2 port map( A => addr(6), B => n808, Z => n757);
   U151 : AN3 port map( A => n811, B => n808, C => n753, Z => n758);
   U152 : AN2 port map( A => n791, B => n793, Z => n759);
   U153 : AN2 port map( A => n826, B => n800, Z => n760);
   U154 : AN2 port map( A => addr(8), B => n807, Z => n761);
   U155 : AN2 port map( A => n830, B => n831, Z => n762);
   U156 : AN2 port map( A => n833, B => n831, Z => n763);
   U157 : MUX21N port map( A => n794, B => n795, S => addr(9), Z => n764);
   U158 : ND6P port map( A => n765, B => n766, C => n767, D => n768, E => n769,
                           F => n762, Z => ADDR_OP(4));
   U159 : ND6P port map( A => n770, B => n766, C => n771, D => n772, E => n773,
                           F => n763, Z => ADDR_OP(3));
   U160 : ND6P port map( A => n774, B => n775, C => n776, D => n777, E => n778,
                           F => n763, Z => ADDR_OP(2));
   U161 : AO3A port map( A => n779, B => n780, C => n781, D => n762, Z => 
                           ADDR_OP(1));
   U162 : AO29 port map( A => n787, B => n780, C => n788, D => addr(1), E => 
                           n754, Z => n786);
   U163 : AO6A port map( A => addr(3), B => n793, C => addr(4), Z => n792);
   U164 : AO7A port map( A => addr(0), B => n773, C => n817, Z => n816);
   U165 : AO7A port map( A => n824, B => n799, C => n825, Z => n823);
   U166 : AO35 port map( A => n827, B => n796, C => n808, D => n812, E => n835,
                           Z => n834);
   U167 : AO1N port map( A => addr(8), B => n837, C => n838, D => n820, Z => 
                           n836);
   U168 : AO25 port map( A => n813, B => n802, C => n760, D => addr(8), E => 
                           n760, Z => n843);
   U169 : AO6A port map( A => n809, B => n820, C => n829, Z => n844);
   U170 : AO29 port map( A => n818, B => n842, C => n846, D => addr(0), E => 
                           n847, Z => n817);
   U171 : AO3A port map( A => n807, B => n790, C => n805, D => n798, Z => n838)
                           ;
   U172 : AO3N port map( A => addr(7), B => n819, C => n771, D => n776, Z => 
                           n830);
   U173 : AO34 port map( A => n799, B => n841, C => n805, D => n852, Z => n851)
                           ;
   U174 : AO3N port map( A => addr(7), B => n828, C => n848, D => n765, Z => 
                           n833);
   U175 : AO6A port map( A => n810, B => n756, C => n834, Z => n778);
   U176 : AO29 port map( A => n755, B => n780, C => n853, D => n756, E => n784,
                           Z => n772);
   U177 : AO8 port map( A => n757, B => n797, C => n854, D => n789, Z => n767);
   U178 : AO17 port map( A => n829, B => n814, C => n851, D => addr(0), Z => 
                           n765);
   U179 : OR8 port map( A => addr(4), B => n793, C => n845, D => n809, E => 
                           n808, F => n798, G => n797, H => n807, Z => n782);
   U180 : AO3C port map( A => n761, B => addr(10), C => n796, D => n855, Z => 
                           n852);
   U181 : AO17 port map( A => n842, B => addr(8), C => n829, D => n849, Z => 
                           n774);
   U182 : AO7A port map( A => n822, B => n832, C => n858, Z => n853);
   U183 : MUX21N port map( A => n839, B => n836, S => addr(1), Z => n788);
   U184 : AO17 port map( A => n754, B => n797, C => n783, D => n808, Z => n859)
                           ;
   U185 : MUX21N port map( A => n844, B => n843, S => n842, Z => n860);
   U186 : AO17 port map( A => n785, B => n807, C => n832, D => n858, Z => n861)
                           ;

end SYN_ADDR_OP_rom_arch;

library IEEE,MTC45000,MTC45100X,LIB_GENERATORS,STVLIB;

use IEEE.std_logic_1164.all;
use IEEE.std_logic_arith.all;
use MTC45000.VCOMPONENTS.all;
use MTC45100X.VCOMPONENTS.all;
use LIB_GENERATORS.PCK_GENERATORS.all;
use STVLIB.ST_TIMING.all;
use STVLIB.ST_VSS.all;

entity DIN_LE_rom is

   port( addr : in std_logic_vector (10 downto 0);  DIN_LE : out std_logic);

end DIN_LE_rom;

architecture SYN_DIN_LE_rom_arch of DIN_LE_rom is

   component ND2
      port( A, B : in std_logic;  Z : out std_logic);
   end component;
   
   component AN3P
      port( A, B, C : in std_logic;  Z : out std_logic);
   end component;
   
   component ND4
      port( A, B, C, D : in std_logic;  Z : out std_logic);
   end component;
   
   component EO
      port( A, B : in std_logic;  Z : out std_logic);
   end component;
   
   component MUX21P
      port( A, B, S : in std_logic;  Z : out std_logic);
   end component;
   
   component AN2P
      port( A, B : in std_logic;  Z : out std_logic);
   end component;
   
   component ND3
      port( A, B, C : in std_logic;  Z : out std_logic);
   end component;
   
   component IVP
      port( A : in std_logic;  Z : out std_logic);
   end component;
   
   component NR5P
      port( A, B, C, D, E : in std_logic;  Z : out std_logic);
   end component;
   
   component AN2
      port( A, B : in std_logic;  Z : out std_logic);
   end component;
   
   component AO7C
      port( A, B, C : in std_logic;  Z : out std_logic);
   end component;
   
   component AO8
      port( A, B, C, D : in std_logic;  Z : out std_logic);
   end component;
   
   component AO7N
      port( A, B, C : in std_logic;  Z : out std_logic);
   end component;
   
   component AO29
      port( A, B, C, D, E : in std_logic;  Z : out std_logic);
   end component;
   
   component AO2A
      port( A, B, C, D : in std_logic;  Z : out std_logic);
   end component;
   
   component AO6C
      port( A, B, C : in std_logic;  Z : out std_logic);
   end component;
   
   component AO17
      port( A, B, C, D : in std_logic;  Z : out std_logic);
   end component;
   
   component AO7A
      port( A, B, C : in std_logic;  Z : out std_logic);
   end component;
   
   component AO3C
      port( A, B, C, D : in std_logic;  Z : out std_logic);
   end component;
   
   component AO1N
      port( A, B, C, D : in std_logic;  Z : out std_logic);
   end component;
   
   component AO6A
      port( A, B, C : in std_logic;  Z : out std_logic);
   end component;
   
   component AO34
      port( A, B, C, D : in std_logic;  Z : out std_logic);
   end component;
   
   component AO2N
      port( A, B, C, D : in std_logic;  Z : out std_logic);
   end component;
   
   component MUX21N
      port( A, B, S : in std_logic;  Z : out std_logic);
   end component;
   
   signal n325, n326, n327, n328, n329, n330, n331, n332, n333, n334, n335, 
      n336, n337, n338, n339, n340, n341, n342, n343, n344, n345, n346, n347, 
      n348, n349, n350, n351, n352, n353, n354, n355, n356, n357, n358, n359, 
      n360, n361, n362, n363, n364, n365, n366, n367, n368, n369, n370, n371, 
      n372, n373, n374, n375, n376, n377, n378, n379, n380, n381, n382, n383, 
      n384, n385, n386, n387, n388, n389, n390, n391, n392, n393, n394, n395, 
      n396, n397, n398, n399, n400, n401, n402, n403, n404, n405, n406, n407, 
      n408, n409, n410, n411, n412, n413, n414, n415, n416, n417, n418, n419 : 
      std_logic;

begin
   
   U70 : ND2 port map( A => addr(2), B => n327, Z => n396);
   U71 : ND2 port map( A => n408, B => n416, Z => n419);
   U72 : AN3P port map( A => n359, B => n368, C => addr(1), Z => n387);
   U73 : ND2 port map( A => n327, B => addr(3), Z => n369);
   U74 : ND4 port map( A => addr(4), B => n411, C => n371, D => n359, Z => n388
                           );
   U75 : EO port map( A => n330, B => addr(0), Z => n379);
   U76 : ND2 port map( A => n374, B => addr(0), Z => n373);
   U77 : MUX21P port map( A => n349, B => n342, S => addr(10), Z => n356);
   U78 : AN2P port map( A => n343, B => n344, Z => n342);
   U79 : ND3 port map( A => addr(2), B => n346, C => n371, Z => n370);
   U80 : IVP port map( A => n369, Z => n371);
   U81 : ND2 port map( A => n381, B => n412, Z => n377);
   U82 : ND2 port map( A => addr(0), B => n350, Z => n375);
   U83 : IVP port map( A => n370, Z => n374);
   U84 : IVP port map( A => n377, Z => n413);
   U85 : IVP port map( A => n375, Z => n411);
   U86 : ND2 port map( A => addr(0), B => n326, Z => n343);
   U87 : IVP port map( A => n367, Z => n412);
   U88 : ND2 port map( A => addr(5), B => addr(6), Z => n367);
   U89 : ND2 port map( A => n346, B => n359, Z => n358);
   U90 : AN3P port map( A => addr(1), B => addr(3), C => addr(0), Z => n406);
   U91 : MUX21P port map( A => n392, B => n391, S => addr(8), Z => n395);
   U92 : IVP port map( A => n388, Z => n393);
   U93 : NR5P port map( A => n372, B => n358, C => n330, D => addr(3), E => 
                           addr(5), Z => n391);
   U94 : ND2 port map( A => n363, B => n416, Z => n407);
   U95 : ND2 port map( A => addr(4), B => n364, Z => n416);
   U96 : ND3 port map( A => n330, B => n368, C => n361, Z => n344);
   U97 : ND2 port map( A => n327, B => n366, Z => n365);
   U98 : ND2 port map( A => n373, B => n385, Z => n384);
   U99 : MUX21P port map( A => n383, B => n380, S => addr(10), Z => n382);
   U100 : MUX21P port map( A => n386, B => n390, S => addr(10), Z => n389);
   U101 : IVP port map( A => n343, Z => n390);
   U102 : ND3 port map( A => addr(10), B => n325, C => n414, Z => n333);
   U103 : ND2 port map( A => n417, B => n365, Z => n414);
   U104 : IVP port map( A => n414, Z => n383);
   U105 : ND2 port map( A => n362, B => n363, Z => n361);
   U106 : ND3 port map( A => n359, B => n351, C => addr(5), Z => n362);
   U107 : ND2 port map( A => addr(3), B => n366, Z => n363);
   U108 : IVP port map( A => n358, Z => n366);
   U109 : IVP port map( A => n361, Z => n417);
   U110 : IVP port map( A => n363, Z => n381);
   U111 : ND2 port map( A => n410, B => n350, Z => n332);
   U112 : IVP port map( A => n373, Z => n410);
   U113 : ND3 port map( A => addr(3), B => addr(1), C => n348, Z => n398);
   U114 : IVP port map( A => n365, Z => n348);
   U115 : IVP port map( A => n378, Z => n415);
   U116 : IVP port map( A => n376, Z => n354);
   U117 : IVP port map( A => n372, Z => n337);
   U118 : ND2 port map( A => addr(1), B => n368, Z => n372);
   U119 : IVP port map( A => n362, Z => n364);
   U120 : IVP port map( A => addr(3), Z => n351);
   U121 : IVP port map( A => addr(5), Z => n360);
   U122 : IVP port map( A => addr(4), Z => n346);
   U123 : IVP port map( A => addr(9), Z => n357);
   U124 : IVP port map( A => addr(10), Z => n341);
   U125 : IVP port map( A => addr(6), Z => n330);
   U126 : IVP port map( A => addr(8), Z => n339);
   U127 : MUX21P port map( A => n400, B => n397, S => addr(7), Z => n329);
   U128 : IVP port map( A => addr(7), Z => n335);
   U129 : IVP port map( A => addr(2), Z => n359);
   U130 : IVP port map( A => addr(1), Z => n350);
   U131 : IVP port map( A => addr(0), Z => n368);
   U132 : AN2 port map( A => n368, B => n350, Z => n325);
   U133 : AN2 port map( A => n364, B => addr(6), Z => n326);
   U134 : AN2 port map( A => n360, B => n330, Z => n327);
   U135 : AO7C port map( A => addr(9), B => n328, C => n329, Z => DIN_LE);
   U136 : AO8 port map( A => n332, B => n333, C => n334, D => n335, Z => n331);
   U137 : AO8 port map( A => n337, B => n330, C => n338, D => n331, Z => n336);
   U138 : AO7N port map( A => n336, B => n339, C => n340, Z => n328);
   U139 : AO29 port map( A => n325, B => n346, C => n347, D => n348, E => 
                           addr(1), Z => n345);
   U140 : AO2A port map( A => n345, B => n351, C => n326, D => n350, Z => n349)
                           ;
   U141 : AO6C port map( A => n353, B => n354, C => addr(8), Z => n352);
   U142 : AO8 port map( A => n354, B => n333, C => n356, D => n357, Z => n355);
   U143 : AO17 port map( A => n370, B => n377, C => n375, D => n378, Z => n376)
                           ;
   U144 : AO8 port map( A => n359, B => n351, C => n330, D => n381, Z => n380);
   U145 : AO7A port map( A => n387, B => n369, C => n388, Z => n386);
   U146 : AO3C port map( A => n346, B => n343, C => n393, D => n394, Z => n392)
                           ;
   U147 : AO29 port map( A => n332, B => n398, C => n399, D => n357, E => 
                           addr(10), Z => n397);
   U148 : AO1N port map( A => n401, B => n341, C => n352, D => n355, Z => n400)
                           ;
   U149 : AO6A port map( A => addr(5), B => n335, C => n330, Z => n402);
   U150 : AO29 port map( A => addr(7), B => n368, C => n348, D => n402, E => 
                           n381, Z => n403);
   U151 : AO8 port map( A => addr(0), B => addr(6), C => n381, D => n389, Z => 
                           n334);
   U152 : AO29 port map( A => n350, B => n335, C => n404, D => addr(10), E => 
                           n405, Z => n340);
   U153 : AO8 port map( A => n337, B => n330, C => n407, D => n390, Z => n353);
   U154 : AO8 port map( A => n359, B => n360, C => addr(3), D => n381, Z => 
                           n408);
   U155 : AO6C port map( A => n325, B => n348, C => n409, Z => n399);
   U156 : AO17 port map( A => n412, B => n366, C => n348, D => n406, Z => n378)
                           ;
   U157 : AO17 port map( A => addr(6), B => n350, C => n379, D => n407, Z => 
                           n409);
   U158 : AO17 port map( A => n348, B => n351, C => n413, D => addr(0), Z => 
                           n385);
   U159 : AO34 port map( A => n382, B => addr(0), C => n339, D => n418, Z => 
                           n404);
   U160 : AO2N port map( A => n364, B => n335, C => addr(10), D => n361, Z => 
                           n338);
   U161 : AO17 port map( A => n403, B => n344, C => addr(1), D => n398, Z => 
                           n405);
   U162 : AO17 port map( A => n419, B => n330, C => n348, D => n337, Z => n394)
                           ;
   U163 : AO1N port map( A => n325, B => n407, C => n415, D => n395, Z => n401)
                           ;
   U164 : MUX21N port map( A => n384, B => n326, S => addr(10), Z => n418);
   U165 : MUX21N port map( A => n396, B => n367, S => addr(8), Z => n347);

end SYN_DIN_LE_rom_arch;

library IEEE,MTC45000,MTC45100X,LIB_GENERATORS,STVLIB;

use IEEE.std_logic_1164.all;
use IEEE.std_logic_arith.all;
use MTC45000.VCOMPONENTS.all;
use MTC45100X.VCOMPONENTS.all;
use LIB_GENERATORS.PCK_GENERATORS.all;
use STVLIB.ST_TIMING.all;
use STVLIB.ST_VSS.all;

entity RD_EN_rom is

   port( addr : in std_logic_vector (10 downto 0);  RD_EN : out std_logic);

end RD_EN_rom;

architecture SYN_RD_EN_rom_arch of RD_EN_rom is

   component ND2
      port( A, B : in std_logic;  Z : out std_logic);
   end component;
   
   component AN3P
      port( A, B, C : in std_logic;  Z : out std_logic);
   end component;
   
   component MUX21P
      port( A, B, S : in std_logic;  Z : out std_logic);
   end component;
   
   component IVP
      port( A : in std_logic;  Z : out std_logic);
   end component;
   
   component ND3
      port( A, B, C : in std_logic;  Z : out std_logic);
   end component;
   
   component ND4
      port( A, B, C, D : in std_logic;  Z : out std_logic);
   end component;
   
   component ND5P
      port( A, B, C, D, E : in std_logic;  Z : out std_logic);
   end component;
   
   component AN3
      port( A, B, C : in std_logic;  Z : out std_logic);
   end component;
   
   component AN2
      port( A, B : in std_logic;  Z : out std_logic);
   end component;
   
   component AO4A
      port( A, B, C, D : in std_logic;  Z : out std_logic);
   end component;
   
   component AO7A
      port( A, B, C : in std_logic;  Z : out std_logic);
   end component;
   
   component MUX21N
      port( A, B, S : in std_logic;  Z : out std_logic);
   end component;
   
   component AO8
      port( A, B, C, D : in std_logic;  Z : out std_logic);
   end component;
   
   component AO29
      port( A, B, C, D, E : in std_logic;  Z : out std_logic);
   end component;
   
   component AO2A
      port( A, B, C, D : in std_logic;  Z : out std_logic);
   end component;
   
   component AO17
      port( A, B, C, D : in std_logic;  Z : out std_logic);
   end component;
   
   component AO3A
      port( A, B, C, D : in std_logic;  Z : out std_logic);
   end component;
   
   component AO3C
      port( A, B, C, D : in std_logic;  Z : out std_logic);
   end component;
   
   signal n186, n187, n188, n189, n190, n191, n192, n193, n194, n195, n196, 
      n197, n198, n199, n200, n201, n202, n203, n204, n205, n206, n207, n208, 
      n209, n210, n211, n212, n213, n214, n215, n216, n217, n218, n219, n220, 
      n221, n222, n223, n224, n225, n226, n227, n228, n229, n230, n231, n232, 
      n233, n234, n235, n236, n237, n238, n239, n240 : std_logic;

begin
   
   U46 : ND2 port map( A => n187, B => n197, Z => n229);
   U47 : AN3P port map( A => addr(7), B => addr(8), C => n231, Z => n230);
   U48 : AN3P port map( A => addr(8), B => n194, C => n195, Z => n193);
   U49 : ND2 port map( A => n235, B => addr(10), Z => n228);
   U50 : MUX21P port map( A => addr(8), B => n201, S => addr(9), Z => n235);
   U51 : ND2 port map( A => n192, B => n197, Z => n196);
   U52 : IVP port map( A => n196, Z => n231);
   U53 : ND3 port map( A => n192, B => n199, C => n201, Z => n203);
   U54 : AN3P port map( A => addr(5), B => n192, C => n187, Z => n191);
   U55 : ND2 port map( A => n195, B => n200, Z => n204);
   U56 : IVP port map( A => n232, Z => n233);
   U57 : ND2 port map( A => addr(0), B => n240, Z => n212);
   U58 : MUX21P port map( A => n239, B => n193, S => addr(6), Z => n240);
   U59 : ND2 port map( A => n237, B => addr(1), Z => n221);
   U60 : IVP port map( A => n221, Z => n238);
   U61 : MUX21P port map( A => n217, B => n219, S => addr(1), Z => n218);
   U62 : ND3 port map( A => n197, B => n194, C => n195, Z => n217);
   U63 : IVP port map( A => n203, Z => n195);
   U64 : IVP port map( A => n206, Z => n219);
   U65 : ND2 port map( A => addr(5), B => n194, Z => n202);
   U66 : ND4 port map( A => n205, B => n194, C => addr(9), D => n216, Z => n215
                           );
   U67 : MUX21P port map( A => n236, B => n191, S => addr(6), Z => n216);
   U68 : IVP port map( A => n204, Z => n236);
   U69 : ND5P port map( A => n205, B => n209, C => n207, D => n210, E => n226, 
                           Z => n225);
   U70 : IVP port map( A => n198, Z => n226);
   U71 : ND2 port map( A => addr(3), B => n199, Z => n198);
   U72 : IVP port map( A => n202, Z => n208);
   U73 : ND3 port map( A => n197, B => n200, C => addr(10), Z => n210);
   U74 : MUX21P port map( A => n218, B => n220, S => addr(6), Z => n223);
   U75 : IVP port map( A => n210, Z => n237);
   U76 : IVP port map( A => addr(8), Z => n200);
   U77 : IVP port map( A => addr(3), Z => n194);
   U78 : IVP port map( A => addr(5), Z => n199);
   U79 : IVP port map( A => addr(4), Z => n205);
   U80 : IVP port map( A => addr(9), Z => n197);
   U81 : MUX21P port map( A => n224, B => n225, S => addr(2), Z => n189);
   U82 : MUX21P port map( A => n214, B => n215, S => addr(1), Z => n190);
   U83 : IVP port map( A => addr(10), Z => n192);
   U84 : IVP port map( A => addr(6), Z => n207);
   U85 : IVP port map( A => addr(7), Z => n201);
   U86 : IVP port map( A => addr(1), Z => n209);
   U87 : IVP port map( A => addr(0), Z => n188);
   U88 : AN3 port map( A => addr(4), B => addr(6), C => n208, Z => n186);
   U89 : AN2 port map( A => addr(8), B => n201, Z => n187);
   U90 : AO4A port map( A => n188, B => n189, C => addr(2), D => n190, Z => 
                           RD_EN);
   U91 : AO7A port map( A => addr(9), B => n203, C => n198, Z => n206);
   U92 : MUX21N port map( A => n212, B => n213, S => addr(4), Z => n211);
   U93 : AO8 port map( A => n201, B => n188, C => n186, D => n211, Z => n214);
   U94 : AO29 port map( A => addr(3), B => addr(7), C => n221, D => addr(5), E 
                           => n222, Z => n220);
   U95 : AO2A port map( A => n223, B => n205, C => n186, D => n210, Z => n224);
   U96 : AO17 port map( A => n228, B => n229, C => n202, D => n204, Z => n227);
   U97 : AO29 port map( A => n208, B => addr(0), C => n210, D => n226, E => 
                           n230, Z => n232);
   U98 : AO8 port map( A => n201, B => n209, C => n196, D => n187, Z => n234);
   U99 : AO3A port map( A => addr(3), B => n238, C => n234, D => n228, Z => 
                           n222);
   U100 : AO3C port map( A => n237, B => n194, C => n227, D => n219, Z => n239)
                           ;
   U101 : AO17 port map( A => n236, B => addr(3), C => n233, D => n207, Z => 
                           n213);

end SYN_RD_EN_rom_arch;

library IEEE,MTC45000,MTC45100X,LIB_GENERATORS,STVLIB;

use IEEE.std_logic_1164.all;
use IEEE.std_logic_arith.all;
use MTC45000.VCOMPONENTS.all;
use MTC45100X.VCOMPONENTS.all;
use LIB_GENERATORS.PCK_GENERATORS.all;
use STVLIB.ST_TIMING.all;
use STVLIB.ST_VSS.all;

entity DOUT_OP_rom is

   port( addr : in std_logic_vector (10 downto 0);  DOUT_OP : out 
         std_logic_vector (0 to 2));

end DOUT_OP_rom;

architecture SYN_DOUT_OP_rom_arch of DOUT_OP_rom is

   component ND2
      port( A, B : in std_logic;  Z : out std_logic);
   end component;
   
   component MUX21P
      port( A, B, S : in std_logic;  Z : out std_logic);
   end component;
   
   component ND3
      port( A, B, C : in std_logic;  Z : out std_logic);
   end component;
   
   component IVP
      port( A : in std_logic;  Z : out std_logic);
   end component;
   
   component EO
      port( A, B : in std_logic;  Z : out std_logic);
   end component;
   
   component ND4
      port( A, B, C, D : in std_logic;  Z : out std_logic);
   end component;
   
   component NR2
      port( A, B : in std_logic;  Z : out std_logic);
   end component;
   
   component AN4
      port( A, B, C, D : in std_logic;  Z : out std_logic);
   end component;
   
   component AN2
      port( A, B : in std_logic;  Z : out std_logic);
   end component;
   
   component AO3C
      port( A, B, C, D : in std_logic;  Z : out std_logic);
   end component;
   
   component AO3A
      port( A, B, C, D : in std_logic;  Z : out std_logic);
   end component;
   
   component AO8
      port( A, B, C, D : in std_logic;  Z : out std_logic);
   end component;
   
   component AO6A
      port( A, B, C : in std_logic;  Z : out std_logic);
   end component;
   
   component AO29
      port( A, B, C, D, E : in std_logic;  Z : out std_logic);
   end component;
   
   component AO35
      port( A, B, C, D, E : in std_logic;  Z : out std_logic);
   end component;
   
   component OR6
      port( A, B, C, D, E, F : in std_logic;  Z : out std_logic);
   end component;
   
   component AO7A
      port( A, B, C : in std_logic;  Z : out std_logic);
   end component;
   
   component MUX21N
      port( A, B, S : in std_logic;  Z : out std_logic);
   end component;
   
   signal n23, n24, n25, n26, n27, n28, n29, n30, n31, n129, n130, n131, n132, 
      n133, n134, n135, n136, n137, n138, n139, n140, n141, n142, n143, n144, 
      n145, n146, n147, n148, n149, n150, n151, n152, n153, n154, n155, n156, 
      n157, n158, n159, n160, n161, n162, n163, n164, n165, n166, n167, n168 : 
      std_logic;

begin
   
   U27 : ND2 port map( A => addr(8), B => n142, Z => n158);
   U28 : ND2 port map( A => addr(9), B => n151, Z => n157);
   U29 : MUX21P port map( A => n157, B => n158, S => addr(7), Z => n159);
   U30 : ND3 port map( A => n142, B => n140, C => n23, Z => n152);
   U31 : ND3 port map( A => n140, B => n138, C => addr(0), Z => n144);
   U32 : ND2 port map( A => n143, B => n131, Z => n147);
   U33 : ND2 port map( A => n163, B => addr(8), Z => n162);
   U34 : IVP port map( A => n152, Z => n163);
   U35 : EO port map( A => addr(0), B => addr(6), Z => n156);
   U36 : ND4 port map( A => n151, B => n148, C => addr(3), D => n164, Z => n155
                           );
   U37 : MUX21P port map( A => n160, B => n161, S => addr(2), Z => n154);
   U38 : ND3 port map( A => n140, B => n143, C => n30, Z => n161);
   U39 : ND2 port map( A => n138, B => n139, Z => n145);
   U40 : IVP port map( A => n150, Z => n135);
   U41 : ND4 port map( A => n151, B => n133, C => addr(6), D => n23, Z => n150)
                           ;
   U42 : IVP port map( A => addr(5), Z => n143);
   U43 : ND2 port map( A => addr(10), B => n142, Z => n141);
   U44 : IVP port map( A => n144, Z => n132);
   U45 : IVP port map( A => n141, Z => n164);
   U46 : IVP port map( A => addr(4), Z => n148);
   U47 : IVP port map( A => addr(3), Z => n146);
   U48 : IVP port map( A => n147, Z => n149);
   U49 : NR2 port map( A => addr(9), B => n144, Z => n136);
   U50 : IVP port map( A => addr(8), Z => n151);
   U51 : IVP port map( A => n134, Z => n167);
   U52 : IVP port map( A => addr(10), Z => n137);
   U53 : IVP port map( A => addr(6), Z => n140);
   U54 : IVP port map( A => addr(7), Z => n131);
   U55 : ND3 port map( A => n25, B => n26, C => n27, Z => DOUT_OP(2));
   U56 : IVP port map( A => addr(9), Z => n142);
   U57 : MUX21P port map( A => n129, B => n168, S => addr(4), Z => n26);
   U58 : ND3 port map( A => addr(1), B => n133, C => n165, Z => n27);
   U59 : IVP port map( A => n129, Z => n29);
   U60 : IVP port map( A => n145, Z => n30);
   U61 : IVP port map( A => n153, Z => n25);
   U62 : IVP port map( A => addr(2), Z => n133);
   U63 : IVP port map( A => addr(1), Z => n138);
   U64 : IVP port map( A => addr(0), Z => n139);
   U65 : AN4 port map( A => n148, B => n146, C => n137, D => n149, Z => n23);
   U66 : AN2 port map( A => addr(1), B => n139, Z => n24);
   U67 : AO3C port map( A => addr(2), B => n28, C => n29, D => n27, Z => 
                           DOUT_OP(1));
   U68 : AO3A port map( A => n30, B => n31, C => n25, D => n129, Z => 
                           DOUT_OP(0));
   U69 : AO8 port map( A => addr(6), B => n131, C => n24, D => n132, Z => n130)
                           ;
   U70 : AO6A port map( A => n133, B => n134, C => n135, Z => n31);
   U71 : AO29 port map( A => addr(8), B => n23, C => n136, D => n24, E => n134,
                           Z => n28);
   U72 : AO35 port map( A => n150, B => n145, C => n142, D => n154, E => n155, 
                           Z => n153);
   U73 : AO29 port map( A => addr(6), B => n147, C => n24, D => n132, E => 
                           addr(5), Z => n160);
   U74 : OR6 port map( A => addr(2), B => addr(3), C => addr(8), D => n143, E 
                           => n141, F => n130, Z => n129);
   U75 : OR6 port map( A => addr(5), B => addr(10), C => addr(6), D => n146, E 
                           => n148, F => n159, Z => n166);
   U76 : AO7A port map( A => n151, B => n152, C => n166, Z => n134);
   U77 : MUX21N port map( A => n162, B => n167, S => addr(0), Z => n165);
   U78 : OR6 port map( A => n143, B => n133, C => n156, D => addr(1), E => 
                           addr(3), F => n164, Z => n168);

end SYN_DOUT_OP_rom_arch;

library IEEE,MTC45000,MTC45100X,LIB_GENERATORS,STVLIB;

use IEEE.std_logic_1164.all;
use IEEE.std_logic_arith.all;
use MTC45000.VCOMPONENTS.all;
use MTC45100X.VCOMPONENTS.all;
use LIB_GENERATORS.PCK_GENERATORS.all;
use STVLIB.ST_TIMING.all;
use STVLIB.ST_VSS.all;

entity DINT1_OP_rom is

   port( addr : in std_logic_vector (10 downto 0);  DINT1_OP : out std_logic);

end DINT1_OP_rom;

architecture SYN_DINT1_OP_rom_arch of DINT1_OP_rom is

   component AN4P
      port( A, B, C, D : in std_logic;  Z : out std_logic);
   end component;
   
   component MUX21P
      port( A, B, S : in std_logic;  Z : out std_logic);
   end component;
   
   component NR2
      port( A, B : in std_logic;  Z : out std_logic);
   end component;
   
   component ND2
      port( A, B : in std_logic;  Z : out std_logic);
   end component;
   
   component NR5P
      port( A, B, C, D, E : in std_logic;  Z : out std_logic);
   end component;
   
   component ND3
      port( A, B, C : in std_logic;  Z : out std_logic);
   end component;
   
   component IVP
      port( A : in std_logic;  Z : out std_logic);
   end component;
   
   component AN3P
      port( A, B, C : in std_logic;  Z : out std_logic);
   end component;
   
   component AN2
      port( A, B : in std_logic;  Z : out std_logic);
   end component;
   
   component AO29
      port( A, B, C, D, E : in std_logic;  Z : out std_logic);
   end component;
   
   component AO3N
      port( A, B, C, D : in std_logic;  Z : out std_logic);
   end component;
   
   component AO7N
      port( A, B, C : in std_logic;  Z : out std_logic);
   end component;
   
   component AO6C
      port( A, B, C : in std_logic;  Z : out std_logic);
   end component;
   
   component AO16
      port( A, B, C, D, E, F, G, H : in std_logic;  Z : out std_logic);
   end component;
   
   component AO17
      port( A, B, C, D : in std_logic;  Z : out std_logic);
   end component;
   
   component AO3C
      port( A, B, C, D : in std_logic;  Z : out std_logic);
   end component;
   
   component AO7A
      port( A, B, C : in std_logic;  Z : out std_logic);
   end component;
   
   signal n292, n293, n294, n295, n296, n297, n298, n299, n300, n301, n302, 
      n303, n304, n305, n306, n307, n308, n309, n310, n311, n312, n313, n314, 
      n315, n316, n317, n318, n319, n320, n321, n322, n323, n324 : std_logic;

begin
   
   U26 : AN4P port map( A => addr(9), B => addr(8), C => n298, D => n299, Z => 
                           n297);
   U27 : MUX21P port map( A => n306, B => n292, S => addr(7), Z => n294);
   U28 : NR2 port map( A => addr(9), B => addr(8), Z => n295);
   U29 : ND2 port map( A => addr(5), B => addr(6), Z => n312);
   U30 : ND2 port map( A => n309, B => n310, Z => n308);
   U31 : MUX21P port map( A => n304, B => n302, S => addr(0), Z => n321);
   U32 : NR2 port map( A => addr(10), B => n293, Z => n304);
   U33 : NR5P port map( A => addr(10), B => n313, C => n305, D => n307, E => 
                           n311, Z => n317);
   U34 : MUX21P port map( A => n308, B => n312, S => addr(8), Z => n313);
   U35 : ND3 port map( A => n303, B => n299, C => n301, Z => n305);
   U36 : IVP port map( A => n305, Z => n296);
   U37 : IVP port map( A => addr(8), Z => n306);
   U38 : IVP port map( A => addr(3), Z => n301);
   U39 : IVP port map( A => addr(5), Z => n310);
   U40 : IVP port map( A => addr(4), Z => n303);
   U41 : IVP port map( A => addr(9), Z => n307);
   U42 : IVP port map( A => addr(10), Z => n298);
   U43 : IVP port map( A => addr(6), Z => n309);
   U44 : MUX21P port map( A => n318, B => n319, S => addr(1), Z => DINT1_OP);
   U45 : MUX21P port map( A => n317, B => n314, S => addr(0), Z => n318);
   U46 : AN3P port map( A => n320, B => n311, C => n321, Z => n319);
   U47 : IVP port map( A => n308, Z => n320);
   U48 : IVP port map( A => addr(7), Z => n299);
   U49 : IVP port map( A => addr(2), Z => n311);
   U50 : AN2 port map( A => addr(8), B => n307, Z => n292);
   U51 : AO29 port map( A => addr(3), B => addr(4), C => n294, D => n295, E => 
                           n296, Z => n293);
   U52 : AO3N port map( A => addr(9), B => n298, C => addr(4), D => n301, Z => 
                           n300);
   U53 : AO7N port map( A => n297, B => addr(3), C => n303, Z => n302);
   U54 : AO6C port map( A => n315, B => n316, C => n311, Z => n314);
   U55 : AO16 port map( A => n292, B => n320, C => n296, D => n298, E => 
                           addr(6), F => addr(3), G => addr(7), H => n303, Z =>
                           n315);
   U56 : AO17 port map( A => n307, B => n306, C => addr(7), D => n301, Z => 
                           n322);
   U57 : AO3C port map( A => n292, B => n299, C => addr(3), D => addr(10), Z =>
                           n323);
   U58 : AO7A port map( A => n322, B => addr(4), C => n323, Z => n324);
   U59 : AO17 port map( A => addr(6), B => n324, C => n300, D => addr(5), Z => 
                           n316);

end SYN_DINT1_OP_rom_arch;

library IEEE,MTC45000,MTC45100X,LIB_GENERATORS,STVLIB;

use IEEE.std_logic_1164.all;
use IEEE.std_logic_arith.all;
use MTC45000.VCOMPONENTS.all;
use MTC45100X.VCOMPONENTS.all;
use LIB_GENERATORS.PCK_GENERATORS.all;
use STVLIB.ST_TIMING.all;
use STVLIB.ST_VSS.all;

entity DINT2_OP_rom is

   port( addr : in std_logic_vector (10 downto 0);  DINT2_OP : out std_logic);

end DINT2_OP_rom;

architecture SYN_DINT2_OP_rom_arch of DINT2_OP_rom is

   component AN6
      port( A, B, C, D, E, F : in std_logic;  Z : out std_logic);
   end component;
   
   component NR2
      port( A, B : in std_logic;  Z : out std_logic);
   end component;
   
   component AO6A
      port( A, B, C : in std_logic;  Z : out std_logic);
   end component;
   
   signal n751, n752 : std_logic;

begin
   
   U12 : AN6 port map( A => addr(6), B => addr(5), C => addr(4), D => addr(1), 
                           E => n751, F => n752, Z => DINT2_OP);
   U13 : NR2 port map( A => addr(3), B => addr(2), Z => n752);
   U14 : AO6A port map( A => addr(9), B => addr(10), C => addr(0), Z => n751);

end SYN_DINT2_OP_rom_arch;

library IEEE,MTC45000,MTC45100X,LIB_GENERATORS,STVLIB;

use IEEE.std_logic_1164.all;
use IEEE.std_logic_arith.all;
use MTC45000.VCOMPONENTS.all;
use MTC45100X.VCOMPONENTS.all;
use LIB_GENERATORS.PCK_GENERATORS.all;
use STVLIB.ST_TIMING.all;
use STVLIB.ST_VSS.all;

entity DINT3_OP_rom is

   port( addr : in std_logic_vector (10 downto 0);  DINT3_OP : out std_logic);

end DINT3_OP_rom;

architecture SYN_DINT3_OP_rom_arch of DINT3_OP_rom is

   component AN3P
      port( A, B, C : in std_logic;  Z : out std_logic);
   end component;
   
   component AO41
      port( A, B, C, D : in std_logic;  Z : out std_logic);
   end component;
   
   component MUX21P
      port( A, B, S : in std_logic;  Z : out std_logic);
   end component;
   
   component IVP
      port( A : in std_logic;  Z : out std_logic);
   end component;
   
   component AO7A
      port( A, B, C : in std_logic;  Z : out std_logic);
   end component;
   
   signal n285, n286, n287, n288, n289, n290, n291 : std_logic;

begin
   
   U14 : AN3P port map( A => n288, B => n289, C => addr(2), Z => n287);
   U15 : AN3P port map( A => addr(0), B => n291, C => addr(1), Z => n290);
   U16 : AO41 port map( A => addr(3), B => n286, C => addr(4), D => n285, Z => 
                           DINT3_OP);
   U17 : MUX21P port map( A => n290, B => n287, S => addr(6), Z => n285);
   U18 : IVP port map( A => addr(2), Z => n291);
   U19 : IVP port map( A => addr(1), Z => n289);
   U20 : IVP port map( A => addr(0), Z => n288);
   U21 : AO7A port map( A => addr(10), B => addr(9), C => addr(5), Z => n286);

end SYN_DINT3_OP_rom_arch;

library IEEE,MTC45000,MTC45100X,LIB_GENERATORS,STVLIB;

use IEEE.std_logic_1164.all;
use IEEE.std_logic_arith.all;
use MTC45000.VCOMPONENTS.all;
use MTC45100X.VCOMPONENTS.all;
use LIB_GENERATORS.PCK_GENERATORS.all;
use STVLIB.ST_TIMING.all;
use STVLIB.ST_VSS.all;

entity PC_OP_rom is

   port( addr : in std_logic_vector (10 downto 0);  PC_OP : out 
         std_logic_vector (0 to 3));

end PC_OP_rom;

architecture SYN_PC_OP_rom_arch of PC_OP_rom is

   component MUX21P
      port( A, B, S : in std_logic;  Z : out std_logic);
   end component;
   
   component ND2
      port( A, B : in std_logic;  Z : out std_logic);
   end component;
   
   component AN3P
      port( A, B, C : in std_logic;  Z : out std_logic);
   end component;
   
   component NR2
      port( A, B : in std_logic;  Z : out std_logic);
   end component;
   
   component IVP
      port( A : in std_logic;  Z : out std_logic);
   end component;
   
   component EO
      port( A, B : in std_logic;  Z : out std_logic);
   end component;
   
   component ND4
      port( A, B, C, D : in std_logic;  Z : out std_logic);
   end component;
   
   component ND3
      port( A, B, C : in std_logic;  Z : out std_logic);
   end component;
   
   component AN4P
      port( A, B, C, D : in std_logic;  Z : out std_logic);
   end component;
   
   component AN4
      port( A, B, C, D : in std_logic;  Z : out std_logic);
   end component;
   
   component AN2
      port( A, B : in std_logic;  Z : out std_logic);
   end component;
   
   component AO3A
      port( A, B, C, D : in std_logic;  Z : out std_logic);
   end component;
   
   component AO3C
      port( A, B, C, D : in std_logic;  Z : out std_logic);
   end component;
   
   component AO29
      port( A, B, C, D, E : in std_logic;  Z : out std_logic);
   end component;
   
   component AO8
      port( A, B, C, D : in std_logic;  Z : out std_logic);
   end component;
   
   component OR6
      port( A, B, C, D, E, F : in std_logic;  Z : out std_logic);
   end component;
   
   component AO7C
      port( A, B, C : in std_logic;  Z : out std_logic);
   end component;
   
   component AO17
      port( A, B, C, D : in std_logic;  Z : out std_logic);
   end component;
   
   component AO7A
      port( A, B, C : in std_logic;  Z : out std_logic);
   end component;
   
   component AO25
      port( A, B, C, D, E : in std_logic;  Z : out std_logic);
   end component;
   
   component MUX21N
      port( A, B, S : in std_logic;  Z : out std_logic);
   end component;
   
   signal n630, n631, n632, n633, n634, n635, n636, n637, n638, n639, n640, 
      n641, n642, n643, n644, n645, n697, n698, n699, n700, n701, n702, n703, 
      n704, n705, n706, n707, n708, n709, n710, n711, n712, n713, n714, n715, 
      n716, n717, n718, n719, n720, n721, n722, n723, n724, n725, n726, n727, 
      n728, n729, n730, n731, n732, n733, n734, n735, n736, n737, n738, n739, 
      n740, n741, n742, n743, n744, n745, n746, n747, n748, n749, n750 : 
      std_logic;

begin
   
   U46 : MUX21P port map( A => n719, B => addr(6), S => n631, Z => n750);
   U47 : ND2 port map( A => addr(9), B => n698, Z => n742);
   U48 : ND2 port map( A => n643, B => n728, Z => n729);
   U49 : AN3P port map( A => n707, B => n708, C => n709, Z => n706);
   U50 : AN3P port map( A => addr(2), B => addr(0), C => addr(8), Z => n710);
   U51 : ND2 port map( A => n726, B => n707, Z => n732);
   U52 : ND2 port map( A => addr(2), B => addr(9), Z => n731);
   U53 : ND2 port map( A => n713, B => n698, Z => n730);
   U54 : MUX21P port map( A => n717, B => n722, S => addr(3), Z => n734);
   U55 : NR2 port map( A => addr(4), B => n723, Z => n722);
   U56 : IVP port map( A => n730, Z => n723);
   U57 : IVP port map( A => n729, Z => n748);
   U58 : AN3P port map( A => addr(5), B => addr(9), C => n716, Z => n715);
   U59 : MUX21P port map( A => n710, B => n706, S => addr(1), Z => n716);
   U60 : AN3P port map( A => n712, B => n713, C => n714, Z => n711);
   U61 : EO port map( A => addr(0), B => addr(8), Z => n712);
   U62 : ND2 port map( A => n641, B => n740, Z => n739);
   U63 : ND2 port map( A => n631, B => n709, Z => n637);
   U64 : ND2 port map( A => n704, B => n727, Z => n740);
   U65 : IVP port map( A => n718, Z => n704);
   U66 : ND2 port map( A => n631, B => addr(8), Z => n718);
   U67 : ND4 port map( A => n726, B => n709, C => n643, D => n727, Z => n641);
   U68 : ND3 port map( A => n746, B => n643, C => n727, Z => n642);
   U69 : ND2 port map( A => addr(8), B => n726, Z => n728);
   U70 : ND4 port map( A => addr(7), B => n632, C => n697, D => n630, Z => n636
                           );
   U71 : MUX21P port map( A => n733, B => n735, S => addr(2), Z => n736);
   U72 : ND2 port map( A => n734, B => addr(6), Z => n733);
   U73 : ND2 port map( A => n738, B => n707, Z => n737);
   U74 : ND3 port map( A => addr(8), B => n643, C => n741, Z => n645);
   U75 : ND2 port map( A => addr(9), B => n727, Z => n640);
   U76 : IVP port map( A => n636, Z => n727);
   U77 : IVP port map( A => n724, Z => n697);
   U78 : ND2 port map( A => n719, B => n725, Z => n724);
   U79 : MUX21P port map( A => n711, B => n715, S => addr(6), Z => n699);
   U80 : AN4P port map( A => addr(4), B => addr(3), C => addr(1), D => n630, Z 
                           => n700);
   U81 : MUX21P port map( A => n709, B => n746, S => addr(7), Z => n701);
   U82 : IVP port map( A => n728, Z => n746);
   U83 : IVP port map( A => n645, Z => n638);
   U84 : MUX21P port map( A => n737, B => n736, S => addr(0), Z => n633);
   U85 : AN3P port map( A => n642, B => n641, C => n740, Z => n634);
   U86 : ND3 port map( A => n643, B => n709, C => n741, Z => n635);
   U87 : IVP port map( A => n640, Z => n741);
   U88 : IVP port map( A => addr(8), Z => n709);
   U89 : IVP port map( A => addr(3), Z => n725);
   U90 : IVP port map( A => addr(5), Z => n713);
   U91 : IVP port map( A => addr(4), Z => n719);
   U92 : IVP port map( A => addr(9), Z => n726);
   U93 : IVP port map( A => addr(10), Z => n643);
   U94 : IVP port map( A => addr(6), Z => n703);
   U95 : IVP port map( A => addr(7), Z => n698);
   U96 : IVP port map( A => addr(2), Z => n707);
   U97 : IVP port map( A => addr(1), Z => n632);
   U98 : IVP port map( A => addr(0), Z => n708);
   U99 : AN4 port map( A => addr(0), B => n703, C => n713, D => n707, Z => n630
                           );
   U100 : AN2 port map( A => addr(10), B => n726, Z => n631);
   U101 : AO3A port map( A => n632, B => n633, C => n634, D => n635, Z => 
                           PC_OP(3));
   U102 : AO3C port map( A => n636, B => n637, C => n638, D => n639, Z => 
                           PC_OP(2));
   U103 : AO3A port map( A => addr(10), B => n640, C => n641, D => n642, Z => 
                           PC_OP(1));
   U104 : AO3A port map( A => n643, B => n644, C => n645, D => n635, Z => 
                           PC_OP(0));
   U105 : AO29 port map( A => n697, B => n698, C => n699, D => n700, E => n701,
                           Z => n644);
   U106 : AO29 port map( A => n698, B => n703, C => n704, D => addr(5), E => 
                           n705, Z => n702);
   U107 : AO8 port map( A => n718, B => n719, C => n720, D => n721, Z => n717);
   U108 : OR6 port map( A => n726, B => n709, C => n730, D => addr(6), E => 
                           addr(10), F => n724, Z => n735);
   U109 : AO8 port map( A => addr(10), B => n709, C => n741, D => n739, Z => 
                           n639);
   U110 : AO29 port map( A => addr(5), B => n698, C => n744, D => n745, E => 
                           n703, Z => n743);
   U111 : AO7C port map( A => n698, B => n637, C => n713, Z => n721);
   U112 : AO17 port map( A => n643, B => n726, C => addr(7), D => n713, Z => 
                           n747);
   U113 : AO3A port map( A => addr(10), B => n742, C => n747, D => n725, Z => 
                           n745);
   U114 : AO7A port map( A => addr(6), B => n726, C => n748, Z => n744);
   U115 : AO7C port map( A => addr(7), B => n637, C => n725, Z => n749);
   U116 : AO3A port map( A => addr(10), B => addr(7), C => n750, D => n718, Z 
                           => n705);
   U117 : AO25 port map( A => n743, B => n749, C => addr(4), D => addr(3), E =>
                           n702, Z => n738);
   U118 : AO17 port map( A => addr(9), B => n709, C => n729, D => n698, Z => 
                           n720);
   U119 : MUX21N port map( A => n731, B => n732, S => addr(1), Z => n714);

end SYN_PC_OP_rom_arch;

library IEEE,MTC45000,MTC45100X,LIB_GENERATORS,STVLIB;

use IEEE.std_logic_1164.all;
use IEEE.std_logic_arith.all;
use MTC45000.VCOMPONENTS.all;
use MTC45100X.VCOMPONENTS.all;
use LIB_GENERATORS.PCK_GENERATORS.all;
use STVLIB.ST_TIMING.all;
use STVLIB.ST_VSS.all;

entity SP_OP_rom is

   port( addr : in std_logic_vector (10 downto 0);  SP_OP : out 
         std_logic_vector (0 to 1));

end SP_OP_rom;

architecture SYN_SP_OP_rom_arch of SP_OP_rom is

   component ND2
      port( A, B : in std_logic;  Z : out std_logic);
   end component;
   
   component EO
      port( A, B : in std_logic;  Z : out std_logic);
   end component;
   
   component MUX21P
      port( A, B, S : in std_logic;  Z : out std_logic);
   end component;
   
   component AN4P
      port( A, B, C, D : in std_logic;  Z : out std_logic);
   end component;
   
   component IVP
      port( A : in std_logic;  Z : out std_logic);
   end component;
   
   component ND3
      port( A, B, C : in std_logic;  Z : out std_logic);
   end component;
   
   component AN3
      port( A, B, C : in std_logic;  Z : out std_logic);
   end component;
   
   component AO34
      port( A, B, C, D : in std_logic;  Z : out std_logic);
   end component;
   
   component AO7A
      port( A, B, C : in std_logic;  Z : out std_logic);
   end component;
   
   component AO29
      port( A, B, C, D, E : in std_logic;  Z : out std_logic);
   end component;
   
   component AO8
      port( A, B, C, D : in std_logic;  Z : out std_logic);
   end component;
   
   component AO2A
      port( A, B, C, D : in std_logic;  Z : out std_logic);
   end component;
   
   component OR7
      port( A, B, C, D, E, F, G : in std_logic;  Z : out std_logic);
   end component;
   
   component MUX21N
      port( A, B, S : in std_logic;  Z : out std_logic);
   end component;
   
   signal n483, n484, n485, n486, n487, n488, n489, n490, n491, n492, n493, 
      n494, n495, n496, n497, n498, n499, n500, n501, n502, n503, n504, n505, 
      n506, n507, n508, n509, n510, n511, n512, n513 : std_logic;

begin
   
   U15 : ND2 port map( A => addr(9), B => n504, Z => n510);
   U16 : ND2 port map( A => addr(7), B => n495, Z => n511);
   U17 : ND2 port map( A => n509, B => n507, Z => n512);
   U18 : EO port map( A => addr(1), B => addr(0), Z => n509);
   U19 : MUX21P port map( A => n499, B => addr(2), S => addr(1), Z => n498);
   U20 : ND2 port map( A => addr(2), B => n501, Z => n499);
   U21 : AN4P port map( A => n492, B => addr(3), C => addr(4), D => n493, Z => 
                           n491);
   U22 : IVP port map( A => n498, Z => n493);
   U23 : ND3 port map( A => n507, B => n502, C => n484, Z => n506);
   U24 : IVP port map( A => addr(8), Z => n502);
   U25 : IVP port map( A => addr(3), Z => n505);
   U26 : IVP port map( A => addr(9), Z => n495);
   U27 : IVP port map( A => n506, Z => n497);
   U28 : AN4P port map( A => n513, B => n508, C => n507, D => n483, Z => n487);
   U29 : IVP port map( A => addr(5), Z => n513);
   U30 : IVP port map( A => addr(10), Z => n508);
   U31 : IVP port map( A => addr(6), Z => n489);
   U32 : IVP port map( A => addr(4), Z => n503);
   U33 : IVP port map( A => addr(7), Z => n504);
   U34 : IVP port map( A => addr(2), Z => n507);
   U35 : IVP port map( A => addr(1), Z => n500);
   U36 : IVP port map( A => addr(0), Z => n501);
   U37 : AN3 port map( A => n503, B => n504, C => n505, Z => n483);
   U38 : AN3 port map( A => n501, B => n500, C => addr(6), Z => n484);
   U39 : AO34 port map( A => n485, B => addr(10), C => addr(5), D => n486, Z =>
                           SP_OP(1));
   U40 : AO7A port map( A => n487, B => n488, C => n486, Z => SP_OP(0));
   U41 : AO29 port map( A => addr(9), B => n489, C => n490, D => addr(8), E => 
                           n484, Z => n488);
   U42 : AO8 port map( A => n483, B => n495, C => n496, D => n491, Z => n494);
   U43 : AO2A port map( A => n494, B => n489, C => n497, D => n483, Z => n485);
   U44 : OR7 port map( A => addr(9), B => addr(5), C => addr(3), D => n503, E 
                           => n508, F => n504, G => n506, Z => n486);
   U45 : AO7A port map( A => n501, B => addr(8), C => addr(1), Z => n490);
   U46 : MUX21N port map( A => n510, B => n511, S => addr(8), Z => n492);
   U47 : MUX21N port map( A => n498, B => n512, S => addr(8), Z => n496);

end SYN_SP_OP_rom_arch;

library IEEE,MTC45000,MTC45100X,LIB_GENERATORS,STVLIB;

use IEEE.std_logic_1164.all;
use IEEE.std_logic_arith.all;
use MTC45000.VCOMPONENTS.all;
use MTC45100X.VCOMPONENTS.all;
use LIB_GENERATORS.PCK_GENERATORS.all;
use STVLIB.ST_TIMING.all;
use STVLIB.ST_VSS.all;

entity ALU1_rom is

   port( addr : in std_logic_vector (10 downto 0);  ALU1 : out std_logic_vector
         (0 to 1));

end ALU1_rom;

architecture SYN_ALU1_rom_arch of ALU1_rom is

   component ND2
      port( A, B : in std_logic;  Z : out std_logic);
   end component;
   
   component ND3
      port( A, B, C : in std_logic;  Z : out std_logic);
   end component;
   
   component MUX21P
      port( A, B, S : in std_logic;  Z : out std_logic);
   end component;
   
   component ND4
      port( A, B, C, D : in std_logic;  Z : out std_logic);
   end component;
   
   component IVP
      port( A : in std_logic;  Z : out std_logic);
   end component;
   
   component AN3P
      port( A, B, C : in std_logic;  Z : out std_logic);
   end component;
   
   component AN2
      port( A, B : in std_logic;  Z : out std_logic);
   end component;
   
   component AO7A
      port( A, B, C : in std_logic;  Z : out std_logic);
   end component;
   
   component AO8
      port( A, B, C, D : in std_logic;  Z : out std_logic);
   end component;
   
   component MUX21N
      port( A, B, S : in std_logic;  Z : out std_logic);
   end component;
   
   component AO3A
      port( A, B, C, D : in std_logic;  Z : out std_logic);
   end component;
   
   component AO3C
      port( A, B, C, D : in std_logic;  Z : out std_logic);
   end component;
   
   component AO35
      port( A, B, C, D, E : in std_logic;  Z : out std_logic);
   end component;
   
   component AO4A
      port( A, B, C, D : in std_logic;  Z : out std_logic);
   end component;
   
   signal n241, n242, n243, n244, n245, n246, n247, n248, n249, n250, n251, 
      n252, n253, n254, n255, n256, n257, n258, n259, n260, n261, n262, n263, 
      n264, n265, n266, n267, n268 : std_logic;

begin
   
   U31 : ND2 port map( A => n241, B => n248, Z => n265);
   U32 : ND3 port map( A => n255, B => n256, C => n257, Z => n254);
   U33 : MUX21P port map( A => n260, B => n264, S => addr(8), Z => n246);
   U34 : ND4 port map( A => addr(6), B => n241, C => n261, D => n262, Z => n260
                           );
   U35 : IVP port map( A => n254, Z => n261);
   U36 : AN3P port map( A => addr(1), B => n259, C => addr(0), Z => n251);
   U37 : AN3P port map( A => n262, B => n257, C => addr(6), Z => n252);
   U38 : ND3 port map( A => n267, B => n263, C => n268, Z => n244);
   U39 : IVP port map( A => n260, Z => n249);
   U40 : ND2 port map( A => addr(4), B => addr(5), Z => n266);
   U41 : IVP port map( A => n250, Z => n242);
   U42 : IVP port map( A => addr(8), Z => n267);
   U43 : IVP port map( A => addr(3), Z => n258);
   U44 : IVP port map( A => addr(5), Z => n256);
   U45 : IVP port map( A => addr(4), Z => n263);
   U46 : IVP port map( A => addr(10), Z => n253);
   U47 : IVP port map( A => addr(6), Z => n259);
   U48 : IVP port map( A => addr(7), Z => n245);
   U49 : IVP port map( A => addr(2), Z => n255);
   U50 : IVP port map( A => addr(1), Z => n257);
   U51 : IVP port map( A => addr(0), Z => n262);
   U52 : AN2 port map( A => addr(10), B => n258, Z => n241);
   U53 : AO7A port map( A => n242, B => n243, C => n244, Z => ALU1(1));
   U54 : AO7A port map( A => n245, B => n246, C => n244, Z => ALU1(0));
   U55 : AO8 port map( A => n241, B => addr(9), C => n248, D => n249, Z => n247
                           );
   U56 : MUX21N port map( A => n251, B => n252, S => addr(2), Z => n250);
   U57 : AO3A port map( A => n265, B => n249, C => addr(9), D => n263, Z => 
                           n264);
   U58 : AO3C port map( A => addr(9), B => n253, C => n266, D => n258, Z => 
                           n243);
   U59 : AO35 port map( A => n254, B => addr(6), C => n262, D => n250, E => 
                           n256, Z => n248);
   U60 : AO4A port map( A => n249, B => addr(9), C => addr(7), D => n247, Z => 
                           n268);

end SYN_ALU1_rom_arch;

library IEEE,MTC45000,MTC45100X,LIB_GENERATORS,STVLIB;

use IEEE.std_logic_1164.all;
use IEEE.std_logic_arith.all;
use MTC45000.VCOMPONENTS.all;
use MTC45100X.VCOMPONENTS.all;
use LIB_GENERATORS.PCK_GENERATORS.all;
use STVLIB.ST_TIMING.all;
use STVLIB.ST_VSS.all;

entity ALU2_rom is

   port( addr : in std_logic_vector (10 downto 0);  ALU2 : out std_logic_vector
         (0 to 1));

end ALU2_rom;

architecture SYN_ALU2_rom_arch of ALU2_rom is

   component ND2
      port( A, B : in std_logic;  Z : out std_logic);
   end component;
   
   component NR2
      port( A, B : in std_logic;  Z : out std_logic);
   end component;
   
   component ND3
      port( A, B, C : in std_logic;  Z : out std_logic);
   end component;
   
   component IVP
      port( A : in std_logic;  Z : out std_logic);
   end component;
   
   component MUX21P
      port( A, B, S : in std_logic;  Z : out std_logic);
   end component;
   
   component AN3
      port( A, B, C : in std_logic;  Z : out std_logic);
   end component;
   
   component NR3X4
      port( A, B, C : in std_logic;  Z : out std_logic);
   end component;
   
   component AO16
      port( A, B, C, D, E, F, G, H : in std_logic;  Z : out std_logic);
   end component;
   
   component OR8
      port( A, B, C, D, E, F, G, H : in std_logic;  Z : out std_logic);
   end component;
   
   component AO25
      port( A, B, C, D, E : in std_logic;  Z : out std_logic);
   end component;
   
   signal n169, n170, n171, n172, n173, n174, n175, n176, n177, n178, n179, 
      n180, n181, n182, n183, n184, n185 : std_logic;

begin
   
   U28 : ND2 port map( A => n169, B => n183, Z => n185);
   U29 : NR2 port map( A => n172, B => n173, Z => ALU2(0));
   U30 : ND3 port map( A => n175, B => n176, C => addr(6), Z => n173);
   U31 : IVP port map( A => n173, Z => n183);
   U32 : MUX21P port map( A => n182, B => n185, S => addr(2), Z => n170);
   U33 : IVP port map( A => addr(8), Z => n177);
   U34 : IVP port map( A => addr(5), Z => n181);
   U35 : IVP port map( A => addr(4), Z => n179);
   U36 : IVP port map( A => addr(9), Z => n180);
   U37 : IVP port map( A => addr(10), Z => n171);
   U38 : IVP port map( A => addr(6), Z => n174);
   U39 : IVP port map( A => addr(7), Z => n178);
   U40 : IVP port map( A => addr(1), Z => n175);
   U41 : IVP port map( A => addr(0), Z => n176);
   U42 : AN3 port map( A => addr(5), B => addr(4), C => addr(9), Z => n169);
   U43 : NR3X4 port map( A => n170, B => addr(3), C => n171, Z => ALU2(1));
   U44 : AO16 port map( A => addr(0), B => addr(1), C => n174, D => n169, E => 
                           n178, F => n181, G => n183, H => n184, Z => n182);
   U45 : OR8 port map( A => n179, B => n171, C => n177, D => n178, E => addr(9)
                           , F => addr(3), G => addr(5), H => addr(2), Z => 
                           n172);
   U46 : AO25 port map( A => addr(8), B => n180, C => addr(4), D => addr(8), E 
                           => n180, Z => n184);

end SYN_ALU2_rom_arch;

library IEEE,MTC45000,MTC45100X,LIB_GENERATORS,STVLIB;

use IEEE.std_logic_1164.all;
use IEEE.std_logic_arith.all;
use MTC45000.VCOMPONENTS.all;
use MTC45100X.VCOMPONENTS.all;
use LIB_GENERATORS.PCK_GENERATORS.all;
use STVLIB.ST_TIMING.all;
use STVLIB.ST_VSS.all;

entity ALU_OP_rom is

   port( addr : in std_logic_vector (10 downto 0);  ALU_OP : out 
         std_logic_vector (0 to 3));

end ALU_OP_rom;

architecture SYN_ALU_OP_rom_arch of ALU_OP_rom is

   component ND2
      port( A, B : in std_logic;  Z : out std_logic);
   end component;
   
   component AN4P
      port( A, B, C, D : in std_logic;  Z : out std_logic);
   end component;
   
   component MUX21P
      port( A, B, S : in std_logic;  Z : out std_logic);
   end component;
   
   component ND3
      port( A, B, C : in std_logic;  Z : out std_logic);
   end component;
   
   component ND4
      port( A, B, C, D : in std_logic;  Z : out std_logic);
   end component;
   
   component IVP
      port( A : in std_logic;  Z : out std_logic);
   end component;
   
   component AN3
      port( A, B, C : in std_logic;  Z : out std_logic);
   end component;
   
   component AN4
      port( A, B, C, D : in std_logic;  Z : out std_logic);
   end component;
   
   component AN2
      port( A, B : in std_logic;  Z : out std_logic);
   end component;
   
   component AO2
      port( A, B, C, D : in std_logic;  Z : out std_logic);
   end component;
   
   component MUX21N
      port( A, B, S : in std_logic;  Z : out std_logic);
   end component;
   
   component AO3C
      port( A, B, C, D : in std_logic;  Z : out std_logic);
   end component;
   
   component AO3N
      port( A, B, C, D : in std_logic;  Z : out std_logic);
   end component;
   
   component AO3A
      port( A, B, C, D : in std_logic;  Z : out std_logic);
   end component;
   
   component AO7A
      port( A, B, C : in std_logic;  Z : out std_logic);
   end component;
   
   component AO8
      port( A, B, C, D : in std_logic;  Z : out std_logic);
   end component;
   
   component AO29
      port( A, B, C, D, E : in std_logic;  Z : out std_logic);
   end component;
   
   component AO17
      port( A, B, C, D : in std_logic;  Z : out std_logic);
   end component;
   
   component AO25
      port( A, B, C, D, E : in std_logic;  Z : out std_logic);
   end component;
   
   signal n420, n421, n422, n423, n424, n425, n426, n427, n428, n429, n430, 
      n431, n432, n433, n434, n435, n436, n437, n438, n439, n440, n441, n442, 
      n443, n444, n445, n446, n447, n448, n449, n450, n451, n452, n453, n454, 
      n455, n456, n457, n458, n459, n460, n461, n462, n463, n464, n465, n466, 
      n467, n468, n469, n470, n471, n472, n473, n474, n475, n476, n477, n478, 
      n479, n480, n481, n482 : std_logic;

begin
   
   U45 : ND2 port map( A => addr(1), B => n453, Z => n468);
   U46 : ND2 port map( A => addr(7), B => n439, Z => n469);
   U47 : ND2 port map( A => addr(10), B => n423, Z => n472);
   U48 : AN4P port map( A => addr(2), B => addr(6), C => n439, D => n440, Z => 
                           n438);
   U49 : MUX21P port map( A => n448, B => n446, S => addr(0), Z => n466);
   U50 : AN4P port map( A => addr(7), B => n439, C => addr(4), D => n420, Z => 
                           n448);
   U51 : AN4P port map( A => addr(1), B => n447, C => addr(9), D => n422, Z => 
                           n446);
   U52 : AN4P port map( A => addr(6), B => n454, C => n453, D => n452, Z => 
                           n465);
   U53 : ND3 port map( A => addr(0), B => n451, C => n421, Z => n478);
   U54 : ND2 port map( A => n471, B => addr(8), Z => n470);
   U55 : ND4 port map( A => addr(0), B => addr(1), C => n451, D => n452, Z => 
                           n462);
   U56 : ND2 port map( A => addr(2), B => n482, Z => n449);
   U57 : ND2 port map( A => n421, B => addr(6), Z => n450);
   U58 : ND3 port map( A => addr(9), B => n460, C => n443, Z => n427);
   U59 : ND3 port map( A => n423, B => n460, C => n443, Z => n428);
   U60 : IVP port map( A => n463, Z => n459);
   U61 : ND3 port map( A => addr(6), B => n440, C => n421, Z => n463);
   U62 : ND2 port map( A => addr(8), B => n474, Z => n431);
   U63 : ND3 port map( A => n444, B => n454, C => n475, Z => n430);
   U64 : ND2 port map( A => addr(9), B => addr(10), Z => n461);
   U65 : IVP port map( A => n462, Z => n479);
   U66 : IVP port map( A => n476, Z => n477);
   U67 : ND2 port map( A => n471, B => n447, Z => n476);
   U68 : IVP port map( A => n456, Z => n471);
   U69 : ND3 port map( A => n432, B => n424, C => n433, Z => ALU_OP(1));
   U70 : ND3 port map( A => n427, B => n428, C => n425, Z => ALU_OP(3));
   U71 : ND2 port map( A => n442, B => n460, Z => n434);
   U72 : IVP port map( A => n458, Z => n442);
   U73 : ND2 port map( A => n431, B => n428, Z => n436);
   U74 : ND3 port map( A => addr(8), B => n444, C => n443, Z => n437);
   U75 : IVP port map( A => n461, Z => n444);
   U76 : IVP port map( A => n455, Z => n443);
   U77 : IVP port map( A => n434, Z => n474);
   U78 : IVP port map( A => addr(8), Z => n445);
   U79 : IVP port map( A => addr(3), Z => n454);
   U80 : IVP port map( A => addr(5), Z => n453);
   U81 : IVP port map( A => addr(4), Z => n457);
   U82 : IVP port map( A => addr(9), Z => n435);
   U83 : ND4 port map( A => n429, B => n430, C => n431, D => n425, Z => 
                           ALU_OP(2));
   U84 : IVP port map( A => addr(10), Z => n460);
   U85 : IVP port map( A => addr(6), Z => n451);
   U86 : IVP port map( A => addr(7), Z => n447);
   U87 : IVP port map( A => addr(2), Z => n452);
   U88 : IVP port map( A => addr(1), Z => n439);
   U89 : IVP port map( A => addr(0), Z => n440);
   U90 : AN3 port map( A => addr(10), B => n435, C => addr(8), Z => n420);
   U91 : AN4 port map( A => n447, B => n453, C => n452, D => n439, Z => n421);
   U92 : AN3 port map( A => n460, B => n457, C => addr(8), Z => n422);
   U93 : AN2 port map( A => n435, B => n445, Z => n423);
   U94 : AO2 port map( A => n420, B => n464, C => n465, D => n466, Z => n424);
   U95 : AN2 port map( A => n467, B => n424, Z => n425);
   U96 : MUX21N port map( A => n449, B => n450, S => addr(0), Z => n426);
   U97 : AO3C port map( A => n434, B => n435, C => n436, D => n437, Z => 
                           ALU_OP(0));
   U98 : AO3N port map( A => n442, B => n443, C => n444, D => n445, Z => n441);
   U99 : AO3A port map( A => n456, B => n426, C => addr(3), D => n457, Z => 
                           n455);
   U100 : AO3A port map( A => n456, B => n459, C => addr(4), D => n454, Z => 
                           n458);
   U101 : AO7A port map( A => n462, B => n438, C => addr(5), Z => n456);
   U102 : AO3N port map( A => addr(8), B => n427, C => n430, D => n437, Z => 
                           n433);
   U103 : AO8 port map( A => n457, B => n454, C => n473, D => n441, Z => n432);
   U104 : AO29 port map( A => addr(8), B => addr(9), C => n474, D => n474, E =>
                           n423, Z => n467);
   U105 : AO17 port map( A => addr(3), B => n426, C => n471, D => n457, Z => 
                           n480);
   U106 : AO17 port map( A => n456, B => n478, C => addr(3), D => n480, Z => 
                           n464);
   U107 : AO25 port map( A => n476, B => n478, C => n461, D => n463, E => n472,
                           Z => n473);
   U108 : AO17 port map( A => n479, B => addr(5), C => n426, D => addr(3), Z =>
                           n481);
   U109 : AO3A port map( A => n481, B => n477, C => n422, D => n435, Z => n429)
                           ;
   U110 : MUX21N port map( A => n468, B => n469, S => addr(6), Z => n482);
   U111 : MUX21N port map( A => n463, B => n470, S => addr(4), Z => n475);

end SYN_ALU_OP_rom_arch;

library IEEE,MTC45000,MTC45100X,LIB_GENERATORS,STVLIB;

use IEEE.std_logic_1164.all;
use IEEE.std_logic_arith.all;
use MTC45000.VCOMPONENTS.all;
use MTC45100X.VCOMPONENTS.all;
use LIB_GENERATORS.PCK_GENERATORS.all;
use STVLIB.ST_TIMING.all;
use STVLIB.ST_VSS.all;

entity A_LE_rom is

   port( addr : in std_logic_vector (10 downto 0);  A_LE : out std_logic);

end A_LE_rom;

architecture SYN_A_LE_rom_arch of A_LE_rom is

   component ND2
      port( A, B : in std_logic;  Z : out std_logic);
   end component;
   
   component MUX21P
      port( A, B, S : in std_logic;  Z : out std_logic);
   end component;
   
   component IVP
      port( A : in std_logic;  Z : out std_logic);
   end component;
   
   component ND3
      port( A, B, C : in std_logic;  Z : out std_logic);
   end component;
   
   component NR2
      port( A, B : in std_logic;  Z : out std_logic);
   end component;
   
   component AN4P
      port( A, B, C, D : in std_logic;  Z : out std_logic);
   end component;
   
   component AN3P
      port( A, B, C : in std_logic;  Z : out std_logic);
   end component;
   
   component AO17
      port( A, B, C, D : in std_logic;  Z : out std_logic);
   end component;
   
   component OR6
      port( A, B, C, D, E, F : in std_logic;  Z : out std_logic);
   end component;
   
   component MUX21N
      port( A, B, S : in std_logic;  Z : out std_logic);
   end component;
   
   signal n514, n515, n516, n517, n518, n519, n520, n590, n591, n592, n593, 
      n594, n595, n596, n597, n598, n599, n600, n601, n602, n603, n604, n605, 
      n606, n607, n608, n609, n610, n611 : std_logic;

begin
   
   U20 : ND2 port map( A => n590, B => n592, Z => n591);
   U21 : MUX21P port map( A => n599, B => n600, S => addr(6), Z => n515);
   U22 : ND2 port map( A => addr(5), B => addr(1), Z => n599);
   U23 : ND2 port map( A => n601, B => n520, Z => n600);
   U24 : IVP port map( A => n591, Z => n601);
   U25 : MUX21P port map( A => n597, B => n598, S => addr(6), Z => n518);
   U26 : ND2 port map( A => addr(1), B => n590, Z => n597);
   U27 : ND2 port map( A => n591, B => n520, Z => n598);
   U28 : ND3 port map( A => n596, B => n593, C => n604, Z => n603);
   U29 : MUX21P port map( A => n516, B => n514, S => addr(0), Z => n609);
   U30 : NR2 port map( A => n517, B => n518, Z => n516);
   U31 : NR2 port map( A => addr(2), B => n515, Z => n514);
   U32 : ND2 port map( A => addr(10), B => n595, Z => n594);
   U33 : IVP port map( A => n594, Z => n604);
   U34 : ND2 port map( A => n606, B => n520, Z => n605);
   U35 : IVP port map( A => addr(8), Z => n595);
   U36 : IVP port map( A => addr(9), Z => n596);
   U37 : IVP port map( A => addr(10), Z => n519);
   U38 : MUX21P port map( A => n610, B => n608, S => addr(3), Z => A_LE);
   U39 : AN4P port map( A => n590, B => n517, C => addr(6), D => n611, Z => 
                           n610);
   U40 : IVP port map( A => addr(5), Z => n590);
   U41 : AN3P port map( A => n594, B => n593, C => n609, Z => n608);
   U42 : IVP port map( A => addr(4), Z => n593);
   U43 : IVP port map( A => addr(7), Z => n592);
   U44 : IVP port map( A => addr(2), Z => n517);
   U45 : IVP port map( A => addr(1), Z => n520);
   U46 : AO17 port map( A => n596, B => n595, C => n519, D => addr(4), Z => 
                           n602);
   U47 : OR6 port map( A => n595, B => n596, C => n520, D => addr(10), E => 
                           addr(7), F => addr(4), Z => n607);
   U48 : MUX21N port map( A => n602, B => n603, S => addr(7), Z => n606);
   U49 : MUX21N port map( A => n605, B => n607, S => addr(0), Z => n611);

end SYN_A_LE_rom_arch;

library IEEE,MTC45000,MTC45100X,LIB_GENERATORS,STVLIB;

use IEEE.std_logic_1164.all;
use IEEE.std_logic_arith.all;
use MTC45000.VCOMPONENTS.all;
use MTC45100X.VCOMPONENTS.all;
use LIB_GENERATORS.PCK_GENERATORS.all;
use STVLIB.ST_TIMING.all;
use STVLIB.ST_VSS.all;

entity X_LE_rom is

   port( addr : in std_logic_vector (10 downto 0);  X_LE : out std_logic);

end X_LE_rom;

architecture SYN_X_LE_rom_arch of X_LE_rom is

   component ND2
      port( A, B : in std_logic;  Z : out std_logic);
   end component;
   
   component NR5P
      port( A, B, C, D, E : in std_logic;  Z : out std_logic);
   end component;
   
   component ND3
      port( A, B, C : in std_logic;  Z : out std_logic);
   end component;
   
   component EO
      port( A, B : in std_logic;  Z : out std_logic);
   end component;
   
   component IVP
      port( A : in std_logic;  Z : out std_logic);
   end component;
   
   component MUX21P
      port( A, B, S : in std_logic;  Z : out std_logic);
   end component;
   
   component AN3AP
      port( A, B, C : in std_logic;  Z : out std_logic);
   end component;
   
   component NR3X4
      port( A, B, C : in std_logic;  Z : out std_logic);
   end component;
   
   component AO29
      port( A, B, C, D, E : in std_logic;  Z : out std_logic);
   end component;
   
   component MUX21N
      port( A, B, S : in std_logic;  Z : out std_logic);
   end component;
   
   signal n612, n613, n614, n615, n616, n617, n618, n619, n620, n621, n622, 
      n623, n624, n625, n626, n627, n628, n629 : std_logic;

begin
   
   U11 : ND2 port map( A => n625, B => n623, Z => n624);
   U12 : ND2 port map( A => addr(5), B => n628, Z => n629);
   U13 : NR5P port map( A => n614, B => n615, C => addr(5), D => addr(7), E => 
                           addr(2), Z => n613);
   U14 : ND3 port map( A => n620, B => n622, C => addr(6), Z => n614);
   U15 : EO port map( A => n618, B => addr(8), Z => n615);
   U16 : IVP port map( A => n614, Z => n628);
   U17 : MUX21P port map( A => n626, B => n629, S => addr(2), Z => n617);
   U18 : IVP port map( A => addr(8), Z => n619);
   U19 : IVP port map( A => addr(5), Z => n623);
   U20 : IVP port map( A => addr(4), Z => n618);
   U21 : IVP port map( A => addr(6), Z => n621);
   U22 : AN3AP port map( A => addr(3), B => addr(10), C => n612, Z => X_LE);
   U23 : MUX21P port map( A => n616, B => n613, S => addr(9), Z => n612);
   U24 : IVP port map( A => addr(7), Z => n625);
   U25 : IVP port map( A => addr(1), Z => n622);
   U26 : IVP port map( A => addr(0), Z => n620);
   U27 : NR3X4 port map( A => n617, B => n618, C => n619, Z => n616);
   U28 : AO29 port map( A => addr(0), B => n621, C => n627, D => n628, E => 
                           n623, Z => n626);
   U29 : MUX21N port map( A => n624, B => n623, S => addr(1), Z => n627);

end SYN_X_LE_rom_arch;

library IEEE,MTC45000,MTC45100X,LIB_GENERATORS,STVLIB;

use IEEE.std_logic_1164.all;
use IEEE.std_logic_arith.all;
use MTC45000.VCOMPONENTS.all;
use MTC45100X.VCOMPONENTS.all;
use LIB_GENERATORS.PCK_GENERATORS.all;
use STVLIB.ST_TIMING.all;
use STVLIB.ST_VSS.all;

entity Y_LE_rom is

   port( addr : in std_logic_vector (10 downto 0);  Y_LE : out std_logic);

end Y_LE_rom;

architecture SYN_Y_LE_rom_arch of Y_LE_rom is

   component AN3P
      port( A, B, C : in std_logic;  Z : out std_logic);
   end component;
   
   component ND3
      port( A, B, C : in std_logic;  Z : out std_logic);
   end component;
   
   component MUX21P
      port( A, B, S : in std_logic;  Z : out std_logic);
   end component;
   
   component NR4
      port( A, B, C, D : in std_logic;  Z : out std_logic);
   end component;
   
   component IVP
      port( A : in std_logic;  Z : out std_logic);
   end component;
   
   component NR2
      port( A, B : in std_logic;  Z : out std_logic);
   end component;
   
   component AO7A
      port( A, B, C : in std_logic;  Z : out std_logic);
   end component;
   
   signal n269, n270, n271, n272, n273, n274, n275, n276, n277, n278, n279, 
      n280, n281, n282, n283, n284 : std_logic;

begin
   
   U11 : AN3P port map( A => n272, B => n273, C => addr(2), Z => n271);
   U12 : AN3P port map( A => addr(0), B => n275, C => addr(1), Z => n274);
   U13 : ND3 port map( A => n281, B => n279, C => addr(8), Z => n284);
   U14 : AN3P port map( A => addr(8), B => n279, C => n280, Z => n278);
   U15 : MUX21P port map( A => n274, B => n271, S => addr(6), Z => n280);
   U16 : NR4 port map( A => n277, B => addr(7), C => addr(2), D => addr(1), Z 
                           => n276);
   U17 : MUX21P port map( A => n283, B => n284, S => addr(0), Z => n277);
   U18 : IVP port map( A => addr(8), Z => n282);
   U19 : IVP port map( A => addr(9), Z => n279);
   U20 : IVP port map( A => addr(6), Z => n281);
   U21 : AN3P port map( A => n269, B => addr(10), C => n270, Z => Y_LE);
   U22 : NR2 port map( A => addr(4), B => addr(3), Z => n269);
   U23 : MUX21P port map( A => n276, B => n278, S => addr(5), Z => n270);
   U24 : IVP port map( A => addr(2), Z => n275);
   U25 : IVP port map( A => addr(1), Z => n273);
   U26 : IVP port map( A => addr(0), Z => n272);
   U27 : AO7A port map( A => addr(9), B => n282, C => addr(6), Z => n283);

end SYN_Y_LE_rom_arch;

library IEEE,MTC45000,MTC45100X,LIB_GENERATORS,STVLIB;

use IEEE.std_logic_1164.all;
use IEEE.std_logic_arith.all;
use MTC45000.VCOMPONENTS.all;
use MTC45100X.VCOMPONENTS.all;
use LIB_GENERATORS.PCK_GENERATORS.all;
use STVLIB.ST_TIMING.all;
use STVLIB.ST_VSS.all;

entity FLAG_OP_rom is

   port( addr : in std_logic_vector (10 downto 0);  FLAG_OP : out 
         std_logic_vector (0 to 3));

end FLAG_OP_rom;

architecture SYN_FLAG_OP_rom_arch of FLAG_OP_rom is

   component MUX21P
      port( A, B, S : in std_logic;  Z : out std_logic);
   end component;
   
   component ND2
      port( A, B : in std_logic;  Z : out std_logic);
   end component;
   
   component ND3
      port( A, B, C : in std_logic;  Z : out std_logic);
   end component;
   
   component AN5
      port( A, B, C, D, E : in std_logic;  Z : out std_logic);
   end component;
   
   component NR2
      port( A, B : in std_logic;  Z : out std_logic);
   end component;
   
   component AN4P
      port( A, B, C, D : in std_logic;  Z : out std_logic);
   end component;
   
   component IVP
      port( A : in std_logic;  Z : out std_logic);
   end component;
   
   component ND5P
      port( A, B, C, D, E : in std_logic;  Z : out std_logic);
   end component;
   
   component NR5P
      port( A, B, C, D, E : in std_logic;  Z : out std_logic);
   end component;
   
   component ND4
      port( A, B, C, D : in std_logic;  Z : out std_logic);
   end component;
   
   component AN2
      port( A, B : in std_logic;  Z : out std_logic);
   end component;
   
   component AN3
      port( A, B, C : in std_logic;  Z : out std_logic);
   end component;
   
   component AN4
      port( A, B, C, D : in std_logic;  Z : out std_logic);
   end component;
   
   component OR6
      port( A, B, C, D, E, F : in std_logic;  Z : out std_logic);
   end component;
   
   component AO8
      port( A, B, C, D : in std_logic;  Z : out std_logic);
   end component;
   
   component AO2N
      port( A, B, C, D : in std_logic;  Z : out std_logic);
   end component;
   
   component AO3N
      port( A, B, C, D : in std_logic;  Z : out std_logic);
   end component;
   
   component AO29
      port( A, B, C, D, E : in std_logic;  Z : out std_logic);
   end component;
   
   component AO6A
      port( A, B, C : in std_logic;  Z : out std_logic);
   end component;
   
   component AO35
      port( A, B, C, D, E : in std_logic;  Z : out std_logic);
   end component;
   
   component AO7A
      port( A, B, C : in std_logic;  Z : out std_logic);
   end component;
   
   component AO17
      port( A, B, C, D : in std_logic;  Z : out std_logic);
   end component;
   
   component AO1N
      port( A, B, C, D : in std_logic;  Z : out std_logic);
   end component;
   
   signal n32, n33, n34, n35, n36, n37, n38, n39, n40, n41, n42, n43, n44, n45,
      n46, n47, n48, n49, n50, n51, n52, n53, n54, n55, n56, n57, n58, n59, n60
      , n61, n62, n63, n64, n65, n66, n67, n68, n69, n70, n71, n72, n73, n74, 
      n75, n76, n77, n78, n79, n80, n81, n82, n83, n84, n85, n86, n87, n88, n89
      , n90, n91, n92, n93, n94, n95, n96, n97, n98, n99, n100, n101, n102, 
      n120, n121, n122, n123, n124, n125, n126, n127, n128 : std_logic;

begin
   
   U39 : MUX21P port map( A => n122, B => n124, S => addr(7), Z => n92);
   U40 : ND2 port map( A => n100, B => n60, Z => n126);
   U41 : MUX21P port map( A => n93, B => n91, S => addr(3), Z => n63);
   U42 : ND2 port map( A => n94, B => n60, Z => n93);
   U43 : ND2 port map( A => n92, B => addr(4), Z => n91);
   U44 : ND2 port map( A => addr(6), B => n70, Z => n69);
   U45 : MUX21P port map( A => n122, B => n124, S => addr(6), Z => n123);
   U46 : MUX21P port map( A => n65, B => n66, S => addr(2), Z => n64);
   U47 : ND3 port map( A => addr(0), B => n68, C => addr(1), Z => n65);
   U48 : ND2 port map( A => n74, B => n73, Z => n66);
   U49 : MUX21P port map( A => n128, B => n127, S => addr(4), Z => n90);
   U50 : MUX21P port map( A => n59, B => n62, S => addr(0), Z => n86);
   U51 : AN5 port map( A => n60, B => n61, C => n38, D => addr(3), E => addr(4)
                           , Z => n59);
   U52 : NR2 port map( A => n61, B => n63, Z => n62);
   U53 : AN4P port map( A => n77, B => n68, C => n71, D => n70, Z => n85);
   U54 : IVP port map( A => n57, Z => n76);
   U55 : ND5P port map( A => n71, B => n72, C => n61, D => n73, E => n74, Z => 
                           n57);
   U56 : IVP port map( A => addr(5), Z => n71);
   U57 : IVP port map( A => n69, Z => n74);
   U58 : ND2 port map( A => n123, B => n35, Z => n88);
   U59 : ND2 port map( A => n122, B => n36, Z => n40);
   U60 : ND2 port map( A => addr(9), B => n79, Z => n78);
   U61 : IVP port map( A => n78, Z => n122);
   U62 : ND2 port map( A => n84, B => n125, Z => n96);
   U63 : ND2 port map( A => addr(8), B => addr(9), Z => n81);
   U64 : IVP port map( A => n80, Z => n125);
   U65 : ND2 port map( A => addr(10), B => n33, Z => n80);
   U66 : ND2 port map( A => n124, B => n36, Z => n95);
   U67 : ND2 port map( A => n38, B => n36, Z => n89);
   U68 : IVP port map( A => addr(8), Z => n79);
   U69 : ND3 port map( A => n94, B => n77, C => n120, Z => n41);
   U70 : IVP port map( A => n82, Z => n94);
   U71 : ND2 port map( A => n38, B => n75, Z => n82);
   U72 : IVP port map( A => addr(4), Z => n75);
   U73 : IVP port map( A => addr(10), Z => n77);
   U74 : IVP port map( A => n58, Z => n120);
   U75 : ND3 port map( A => n68, B => n70, C => n32, Z => n58);
   U76 : IVP port map( A => addr(6), Z => n68);
   U77 : NR5P port map( A => n54, B => n55, C => addr(7), D => addr(4), E => 
                           addr(10), Z => n50);
   U78 : ND3 port map( A => addr(5), B => n72, C => n83, Z => n54);
   U79 : IVP port map( A => addr(3), Z => n72);
   U80 : IVP port map( A => n64, Z => n83);
   U81 : ND2 port map( A => addr(8), B => n67, Z => n55);
   U82 : IVP port map( A => addr(9), Z => n67);
   U83 : IVP port map( A => n54, Z => n100);
   U84 : IVP port map( A => n55, Z => n124);
   U85 : IVP port map( A => addr(7), Z => n60);
   U86 : ND4 port map( A => n43, B => n44, C => n45, D => n39, Z => FLAG_OP(2))
                           ;
   U87 : IVP port map( A => n81, Z => n84);
   U88 : IVP port map( A => n51, Z => n45);
   U89 : ND2 port map( A => n52, B => n53, Z => FLAG_OP(0));
   U90 : ND4 port map( A => n40, B => n41, C => n42, D => n39, Z => FLAG_OP(3))
                           ;
   U91 : IVP port map( A => n41, Z => n46);
   U92 : IVP port map( A => n89, Z => n47);
   U93 : IVP port map( A => n95, Z => n48);
   U94 : IVP port map( A => n96, Z => n49);
   U95 : IVP port map( A => addr(2), Z => n61);
   U96 : IVP port map( A => addr(1), Z => n70);
   U97 : IVP port map( A => addr(0), Z => n73);
   U98 : AN2 port map( A => n34, B => n72, Z => n32);
   U99 : AN3 port map( A => addr(7), B => n75, C => n76, Z => n33);
   U100 : AN4 port map( A => addr(0), B => n60, C => n71, D => n61, Z => n34);
   U101 : AN4 port map( A => n77, B => n75, C => addr(1), D => n32, Z => n35);
   U102 : AN2 port map( A => n33, B => n77, Z => n36);
   U103 : AN3 port map( A => addr(3), B => n75, C => n87, Z => n37);
   U104 : AN2 port map( A => n67, B => n79, Z => n38);
   U105 : AN3 port map( A => n88, B => n89, C => n90, Z => n39);
   U106 : OR6 port map( A => n46, B => n47, C => n48, D => n49, E => n50, F => 
                           n51, Z => FLAG_OP(1));
   U107 : AO8 port map( A => n57, B => n58, C => n54, D => n55, Z => n56);
   U108 : AO2N port map( A => n84, B => n36, C => n85, D => n86, Z => n51);
   U109 : AO3N port map( A => n80, B => n55, C => n88, D => n40, Z => n53);
   U110 : AO3N port map( A => n78, B => n80, C => n95, D => n96, Z => n52);
   U111 : AO29 port map( A => addr(2), B => n73, C => n98, D => n34, E => n74, 
                           Z => n97);
   U112 : AO29 port map( A => addr(4), B => addr(9), C => n100, D => n76, E => 
                           n101, Z => n99);
   U113 : AO8 port map( A => addr(3), B => n79, C => n87, D => n120, Z => n102)
                           ;
   U114 : AO29 port map( A => n84, B => addr(6), C => n35, D => n37, E => n121,
                           Z => n43);
   U115 : AO6A port map( A => n81, B => n37, C => n49, Z => n42);
   U116 : AO35 port map( A => n70, B => addr(5), C => addr(6), D => n69, E => 
                           n60, Z => n98);
   U117 : AO7A port map( A => addr(5), B => n64, C => n97, Z => n87);
   U118 : AO17 port map( A => addr(4), B => addr(8), C => addr(7), D => n82, Z 
                           => n101);
   U119 : AO7A port map( A => n77, B => addr(8), C => n55, Z => n121);
   U120 : AO7A port map( A => n99, B => n56, C => addr(10), Z => n44);
   U121 : AO17 port map( A => n76, B => n60, C => n100, D => n77, Z => n127);
   U122 : AO1N port map( A => n102, B => n126, C => n77, D => n67, Z => n128);

end SYN_FLAG_OP_rom_arch;

library IEEE,MTC45000,MTC45100X,LIB_GENERATORS,STVLIB;

use IEEE.std_logic_1164.all;
use IEEE.std_logic_arith.all;
use MTC45000.VCOMPONENTS.all;
use MTC45100X.VCOMPONENTS.all;
use LIB_GENERATORS.PCK_GENERATORS.all;
use STVLIB.ST_TIMING.all;
use STVLIB.ST_VSS.all;

entity mc_rom is

   port( opcode : in std_logic_vector (7 downto 0);  step : in std_logic_vector
         (2 downto 0);  DONE : out std_logic;  ADDR_OP : out std_logic_vector 
         (0 to 4);  DIN_LE, RD_EN : out std_logic;  DOUT_OP : out 
         std_logic_vector (0 to 2);  DINT1_OP, DINT2_OP, DINT3_OP : out 
         std_logic;  PC_OP : out std_logic_vector (0 to 3);  SP_OP, ALU1, ALU2 
         : out std_logic_vector (0 to 1);  ALU_OP : out std_logic_vector (0 to 
         3);  A_LE, X_LE, Y_LE : out std_logic;  FLAG_OP : out std_logic_vector
         (0 to 3));

end mc_rom;

architecture SYN_mc_rom_arch of mc_rom is

   component DONE_rom
      port( addr : in std_logic_vector (10 downto 0);  DONE : out std_logic);
   end component;
   
   component ADDR_OP_rom
      port( addr : in std_logic_vector (10 downto 0);  ADDR_OP : out 
            std_logic_vector (0 to 4));
   end component;
   
   component DIN_LE_rom
      port( addr : in std_logic_vector (10 downto 0);  DIN_LE : out std_logic);
   end component;
   
   component RD_EN_rom
      port( addr : in std_logic_vector (10 downto 0);  RD_EN : out std_logic);
   end component;
   
   component DOUT_OP_rom
      port( addr : in std_logic_vector (10 downto 0);  DOUT_OP : out 
            std_logic_vector (0 to 2));
   end component;
   
   component DINT1_OP_rom
      port( addr : in std_logic_vector (10 downto 0);  DINT1_OP : out std_logic
            );
   end component;
   
   component DINT2_OP_rom
      port( addr : in std_logic_vector (10 downto 0);  DINT2_OP : out std_logic
            );
   end component;
   
   component DINT3_OP_rom
      port( addr : in std_logic_vector (10 downto 0);  DINT3_OP : out std_logic
            );
   end component;
   
   component PC_OP_rom
      port( addr : in std_logic_vector (10 downto 0);  PC_OP : out 
            std_logic_vector (0 to 3));
   end component;
   
   component SP_OP_rom
      port( addr : in std_logic_vector (10 downto 0);  SP_OP : out 
            std_logic_vector (0 to 1));
   end component;
   
   component ALU1_rom
      port( addr : in std_logic_vector (10 downto 0);  ALU1 : out 
            std_logic_vector (0 to 1));
   end component;
   
   component ALU2_rom
      port( addr : in std_logic_vector (10 downto 0);  ALU2 : out 
            std_logic_vector (0 to 1));
   end component;
   
   component ALU_OP_rom
      port( addr : in std_logic_vector (10 downto 0);  ALU_OP : out 
            std_logic_vector (0 to 3));
   end component;
   
   component A_LE_rom
      port( addr : in std_logic_vector (10 downto 0);  A_LE : out std_logic);
   end component;
   
   component X_LE_rom
      port( addr : in std_logic_vector (10 downto 0);  X_LE : out std_logic);
   end component;
   
   component Y_LE_rom
      port( addr : in std_logic_vector (10 downto 0);  Y_LE : out std_logic);
   end component;
   
   component FLAG_OP_rom
      port( addr : in std_logic_vector (10 downto 0);  FLAG_OP : out 
            std_logic_vector (0 to 3));
   end component;

begin
   
   U00 : DONE_rom port map( addr(10) => opcode(7), addr(9) => opcode(6), 
                           addr(8) => opcode(5), addr(7) => opcode(4), addr(6) 
                           => opcode(3), addr(5) => opcode(2), addr(4) => 
                           opcode(1), addr(3) => opcode(0), addr(2) => step(2),
                           addr(1) => step(1), addr(0) => step(0), DONE => DONE
                           );
   U01 : ADDR_OP_rom port map( addr(10) => opcode(7), addr(9) => opcode(6), 
                           addr(8) => opcode(5), addr(7) => opcode(4), addr(6) 
                           => opcode(3), addr(5) => opcode(2), addr(4) => 
                           opcode(1), addr(3) => opcode(0), addr(2) => step(2),
                           addr(1) => step(1), addr(0) => step(0), ADDR_OP(0) 
                           => ADDR_OP(0), ADDR_OP(1) => ADDR_OP(1), ADDR_OP(2) 
                           => ADDR_OP(2), ADDR_OP(3) => ADDR_OP(3), ADDR_OP(4) 
                           => ADDR_OP(4));
   U06 : DINT2_OP_rom port map( addr(10) => opcode(7), addr(9) => opcode(6), 
                           addr(8) => opcode(5), addr(7) => opcode(4), addr(6) 
                           => opcode(3), addr(5) => opcode(2), addr(4) => 
                           opcode(1), addr(3) => opcode(0), addr(2) => step(2),
                           addr(1) => step(1), addr(0) => step(0), DINT2_OP => 
                           DINT2_OP);
   U08 : PC_OP_rom port map( addr(10) => opcode(7), addr(9) => opcode(6), 
                           addr(8) => opcode(5), addr(7) => opcode(4), addr(6) 
                           => opcode(3), addr(5) => opcode(2), addr(4) => 
                           opcode(1), addr(3) => opcode(0), addr(2) => step(2),
                           addr(1) => step(1), addr(0) => step(0), PC_OP(0) => 
                           PC_OP(0), PC_OP(1) => PC_OP(1), PC_OP(2) => PC_OP(2)
                           , PC_OP(3) => PC_OP(3));
   U14 : X_LE_rom port map( addr(10) => opcode(7), addr(9) => opcode(6), 
                           addr(8) => opcode(5), addr(7) => opcode(4), addr(6) 
                           => opcode(3), addr(5) => opcode(2), addr(4) => 
                           opcode(1), addr(3) => opcode(0), addr(2) => step(2),
                           addr(1) => step(1), addr(0) => step(0), X_LE => X_LE
                           );
   U13 : A_LE_rom port map( addr(10) => opcode(7), addr(9) => opcode(6), 
                           addr(8) => opcode(5), addr(7) => opcode(4), addr(6) 
                           => opcode(3), addr(5) => opcode(2), addr(4) => 
                           opcode(1), addr(3) => opcode(0), addr(2) => step(2),
                           addr(1) => step(1), addr(0) => step(0), A_LE => A_LE
                           );
   U09 : SP_OP_rom port map( addr(10) => opcode(7), addr(9) => opcode(6), 
                           addr(8) => opcode(5), addr(7) => opcode(4), addr(6) 
                           => opcode(3), addr(5) => opcode(2), addr(4) => 
                           opcode(1), addr(3) => opcode(0), addr(2) => step(2),
                           addr(1) => step(1), addr(0) => step(0), SP_OP(0) => 
                           SP_OP(0), SP_OP(1) => SP_OP(1));
   U12 : ALU_OP_rom port map( addr(10) => opcode(7), addr(9) => opcode(6), 
                           addr(8) => opcode(5), addr(7) => opcode(4), addr(6) 
                           => opcode(3), addr(5) => opcode(2), addr(4) => 
                           opcode(1), addr(3) => opcode(0), addr(2) => step(2),
                           addr(1) => step(1), addr(0) => step(0), ALU_OP(0) =>
                           ALU_OP(0), ALU_OP(1) => ALU_OP(1), ALU_OP(2) => 
                           ALU_OP(2), ALU_OP(3) => ALU_OP(3));
   U02 : DIN_LE_rom port map( addr(10) => opcode(7), addr(9) => opcode(6), 
                           addr(8) => opcode(5), addr(7) => opcode(4), addr(6) 
                           => opcode(3), addr(5) => opcode(2), addr(4) => 
                           opcode(1), addr(3) => opcode(0), addr(2) => step(2),
                           addr(1) => step(1), addr(0) => step(0), DIN_LE => 
                           DIN_LE);
   U05 : DINT1_OP_rom port map( addr(10) => opcode(7), addr(9) => opcode(6), 
                           addr(8) => opcode(5), addr(7) => opcode(4), addr(6) 
                           => opcode(3), addr(5) => opcode(2), addr(4) => 
                           opcode(1), addr(3) => opcode(0), addr(2) => step(2),
                           addr(1) => step(1), addr(0) => step(0), DINT1_OP => 
                           DINT1_OP);
   U07 : DINT3_OP_rom port map( addr(10) => opcode(7), addr(9) => opcode(6), 
                           addr(8) => opcode(5), addr(7) => opcode(4), addr(6) 
                           => opcode(3), addr(5) => opcode(2), addr(4) => 
                           opcode(1), addr(3) => opcode(0), addr(2) => step(2),
                           addr(1) => step(1), addr(0) => step(0), DINT3_OP => 
                           DINT3_OP);
   U15 : Y_LE_rom port map( addr(10) => opcode(7), addr(9) => opcode(6), 
                           addr(8) => opcode(5), addr(7) => opcode(4), addr(6) 
                           => opcode(3), addr(5) => opcode(2), addr(4) => 
                           opcode(1), addr(3) => opcode(0), addr(2) => step(2),
                           addr(1) => step(1), addr(0) => step(0), Y_LE => Y_LE
                           );
   U10 : ALU1_rom port map( addr(10) => opcode(7), addr(9) => opcode(6), 
                           addr(8) => opcode(5), addr(7) => opcode(4), addr(6) 
                           => opcode(3), addr(5) => opcode(2), addr(4) => 
                           opcode(1), addr(3) => opcode(0), addr(2) => step(2),
                           addr(1) => step(1), addr(0) => step(0), ALU1(0) => 
                           ALU1(0), ALU1(1) => ALU1(1));
   U03 : RD_EN_rom port map( addr(10) => opcode(7), addr(9) => opcode(6), 
                           addr(8) => opcode(5), addr(7) => opcode(4), addr(6) 
                           => opcode(3), addr(5) => opcode(2), addr(4) => 
                           opcode(1), addr(3) => opcode(0), addr(2) => step(2),
                           addr(1) => step(1), addr(0) => step(0), RD_EN => 
                           RD_EN);
   U11 : ALU2_rom port map( addr(10) => opcode(7), addr(9) => opcode(6), 
                           addr(8) => opcode(5), addr(7) => opcode(4), addr(6) 
                           => opcode(3), addr(5) => opcode(2), addr(4) => 
                           opcode(1), addr(3) => opcode(0), addr(2) => step(2),
                           addr(1) => step(1), addr(0) => step(0), ALU2(0) => 
                           ALU2(0), ALU2(1) => ALU2(1));
   U04 : DOUT_OP_rom port map( addr(10) => opcode(7), addr(9) => opcode(6), 
                           addr(8) => opcode(5), addr(7) => opcode(4), addr(6) 
                           => opcode(3), addr(5) => opcode(2), addr(4) => 
                           opcode(1), addr(3) => opcode(0), addr(2) => step(2),
                           addr(1) => step(1), addr(0) => step(0), DOUT_OP(0) 
                           => DOUT_OP(0), DOUT_OP(1) => DOUT_OP(1), DOUT_OP(2) 
                           => DOUT_OP(2));
   U16 : FLAG_OP_rom port map( addr(10) => opcode(7), addr(9) => opcode(6), 
                           addr(8) => opcode(5), addr(7) => opcode(4), addr(6) 
                           => opcode(3), addr(5) => opcode(2), addr(4) => 
                           opcode(1), addr(3) => opcode(0), addr(2) => step(2),
                           addr(1) => step(1), addr(0) => step(0), FLAG_OP(0) 
                           => FLAG_OP(0), FLAG_OP(1) => FLAG_OP(1), FLAG_OP(2) 
                           => FLAG_OP(2), FLAG_OP(3) => FLAG_OP(3));

end SYN_mc_rom_arch;

library IEEE,MTC45000,MTC45100X,LIB_GENERATORS,STVLIB;

use IEEE.std_logic_1164.all;
use IEEE.std_logic_arith.all;
use MTC45000.VCOMPONENTS.all;
use MTC45100X.VCOMPONENTS.all;
use LIB_GENERATORS.PCK_GENERATORS.all;
use STVLIB.ST_TIMING.all;
use STVLIB.ST_VSS.all;

entity core_6502_debug_DW01_add_16_0 is

   port( A, B : in std_logic_vector (15 downto 0);  CI : in std_logic;  SUM : 
         out std_logic_vector (15 downto 0);  CO : out std_logic);

end core_6502_debug_DW01_add_16_0;

architecture SYN_rpl of core_6502_debug_DW01_add_16_0 is

   component FA1
      port( A, B, CI : in std_logic;  CO, Z : out std_logic);
   end component;
   
   component AN2
      port( A, B : in std_logic;  Z : out std_logic);
   end component;
   
   component EO
      port( A, B : in std_logic;  Z : out std_logic);
   end component;
   
   signal carry_15, carry_1, carry_8, carry_14, carry_13, carry_12, carry_7, 
      carry_6, carry_9, carry_2, carry_11, carry_10, carry_5, carry_4, carry_3 
      : std_logic;

begin
   
   U1_15 : FA1 port map( A => A(15), B => B(15), CI => carry_15, CO => open, Z 
                           => SUM(15));
   U1_14 : FA1 port map( A => A(14), B => B(14), CI => carry_14, CO => carry_15
                           , Z => SUM(14));
   U1_13 : FA1 port map( A => A(13), B => B(13), CI => carry_13, CO => carry_14
                           , Z => SUM(13));
   U1_12 : FA1 port map( A => A(12), B => B(12), CI => carry_12, CO => carry_13
                           , Z => SUM(12));
   U1_11 : FA1 port map( A => A(11), B => B(11), CI => carry_11, CO => carry_12
                           , Z => SUM(11));
   U1_10 : FA1 port map( A => A(10), B => B(10), CI => carry_10, CO => carry_11
                           , Z => SUM(10));
   U1_9 : FA1 port map( A => A(9), B => B(9), CI => carry_9, CO => carry_10, Z 
                           => SUM(9));
   U1_8 : FA1 port map( A => A(8), B => B(8), CI => carry_8, CO => carry_9, Z 
                           => SUM(8));
   U1_7 : FA1 port map( A => A(7), B => B(7), CI => carry_7, CO => carry_8, Z 
                           => SUM(7));
   U1_6 : FA1 port map( A => A(6), B => B(6), CI => carry_6, CO => carry_7, Z 
                           => SUM(6));
   U1_5 : FA1 port map( A => A(5), B => B(5), CI => carry_5, CO => carry_6, Z 
                           => SUM(5));
   U1_4 : FA1 port map( A => A(4), B => B(4), CI => carry_4, CO => carry_5, Z 
                           => SUM(4));
   U1_3 : FA1 port map( A => A(3), B => B(3), CI => carry_3, CO => carry_4, Z 
                           => SUM(3));
   U1_2 : FA1 port map( A => A(2), B => B(2), CI => carry_2, CO => carry_3, Z 
                           => SUM(2));
   U1_1 : FA1 port map( A => A(1), B => B(1), CI => carry_1, CO => carry_2, Z 
                           => SUM(1));
   U4 : AN2 port map( A => B(0), B => A(0), Z => carry_1);
   U5 : EO port map( A => A(0), B => B(0), Z => SUM(0));

end SYN_rpl;

library IEEE,MTC45000,MTC45100X,LIB_GENERATORS,STVLIB;

use IEEE.std_logic_1164.all;
use IEEE.std_logic_arith.all;
use MTC45000.VCOMPONENTS.all;
use MTC45100X.VCOMPONENTS.all;
use LIB_GENERATORS.PCK_GENERATORS.all;
use STVLIB.ST_TIMING.all;
use STVLIB.ST_VSS.all;

entity core_6502_debug_DW01_inc_16_0 is

   port( A : in std_logic_vector (15 downto 0);  SUM : out std_logic_vector (15
         downto 0));

end core_6502_debug_DW01_inc_16_0;

architecture SYN_rpl of core_6502_debug_DW01_inc_16_0 is

   component EN
      port( A, B : in std_logic;  Z : out std_logic);
   end component;
   
   component IVP
      port( A : in std_logic;  Z : out std_logic);
   end component;
   
   component HA01D1
      port( A, B : in std_logic;  CO, S : out std_logic);
   end component;
   
   signal carry_15, carry_8, carry_12, carry_6, carry_14, carry_13, carry_7, 
      carry_9, carry_2, carry_11, carry_5, carry_10, carry_4, carry_3, n22 : 
      std_logic;

begin
   
   U5 : EN port map( A => n22, B => A(15), Z => SUM(15));
   U6 : IVP port map( A => carry_15, Z => n22);
   U7 : IVP port map( A => A(0), Z => SUM(0));
   U1_1_3 : HA01D1 port map( A => A(3), B => carry_3, CO => carry_4, S => 
                           SUM(3));
   U1_1_4 : HA01D1 port map( A => A(4), B => carry_4, CO => carry_5, S => 
                           SUM(4));
   U1_1_10 : HA01D1 port map( A => A(10), B => carry_10, CO => carry_11, S => 
                           SUM(10));
   U1_1_1 : HA01D1 port map( A => A(1), B => A(0), CO => carry_2, S => SUM(1));
   U1_1_2 : HA01D1 port map( A => A(2), B => carry_2, CO => carry_3, S => 
                           SUM(2));
   U1_1_5 : HA01D1 port map( A => A(5), B => carry_5, CO => carry_6, S => 
                           SUM(5));
   U1_1_11 : HA01D1 port map( A => A(11), B => carry_11, CO => carry_12, S => 
                           SUM(11));
   U1_1_7 : HA01D1 port map( A => A(7), B => carry_7, CO => carry_8, S => 
                           SUM(7));
   U1_1_13 : HA01D1 port map( A => A(13), B => carry_13, CO => carry_14, S => 
                           SUM(13));
   U1_1_9 : HA01D1 port map( A => A(9), B => carry_9, CO => carry_10, S => 
                           SUM(9));
   U1_1_14 : HA01D1 port map( A => A(14), B => carry_14, CO => carry_15, S => 
                           SUM(14));
   U1_1_6 : HA01D1 port map( A => A(6), B => carry_6, CO => carry_7, S => 
                           SUM(6));
   U1_1_8 : HA01D1 port map( A => A(8), B => carry_8, CO => carry_9, S => 
                           SUM(8));
   U1_1_12 : HA01D1 port map( A => A(12), B => carry_12, CO => carry_13, S => 
                           SUM(12));

end SYN_rpl;

library IEEE,MTC45000,MTC45100X,LIB_GENERATORS,STVLIB;

use IEEE.std_logic_1164.all;
use IEEE.std_logic_arith.all;
use MTC45000.VCOMPONENTS.all;
use MTC45100X.VCOMPONENTS.all;
use LIB_GENERATORS.PCK_GENERATORS.all;
use STVLIB.ST_TIMING.all;
use STVLIB.ST_VSS.all;

entity core_6502_debug_DW01_add_9_1 is

   port( A, B : in std_logic_vector (8 downto 0);  CI : in std_logic;  SUM : 
         out std_logic_vector (8 downto 0);  CO : out std_logic);

end core_6502_debug_DW01_add_9_1;

architecture SYN_rpl of core_6502_debug_DW01_add_9_1 is

   component FA1
      port( A, B, CI : in std_logic;  CO, Z : out std_logic);
   end component;
   
   signal carry_1, carry_7, carry_6, carry_2, carry_5, carry_4, carry_3 : 
      std_logic;

begin
   
   U1_7 : FA1 port map( A => A(7), B => B(7), CI => carry_7, CO => SUM(8), Z =>
                           SUM(7));
   U1_6 : FA1 port map( A => A(6), B => B(6), CI => carry_6, CO => carry_7, Z 
                           => SUM(6));
   U1_5 : FA1 port map( A => A(5), B => B(5), CI => carry_5, CO => carry_6, Z 
                           => SUM(5));
   U1_4 : FA1 port map( A => A(4), B => B(4), CI => carry_4, CO => carry_5, Z 
                           => SUM(4));
   U1_3 : FA1 port map( A => A(3), B => B(3), CI => carry_3, CO => carry_4, Z 
                           => SUM(3));
   U1_2 : FA1 port map( A => A(2), B => B(2), CI => carry_2, CO => carry_3, Z 
                           => SUM(2));
   U1_1 : FA1 port map( A => A(1), B => B(1), CI => carry_1, CO => carry_2, Z 
                           => SUM(1));
   U1_0 : FA1 port map( A => A(0), B => B(0), CI => CI, CO => carry_1, Z => 
                           SUM(0));

end SYN_rpl;

library IEEE,MTC45000,MTC45100X,LIB_GENERATORS,STVLIB;

use IEEE.std_logic_1164.all;
use IEEE.std_logic_arith.all;
use MTC45000.VCOMPONENTS.all;
use MTC45100X.VCOMPONENTS.all;
use LIB_GENERATORS.PCK_GENERATORS.all;
use STVLIB.ST_TIMING.all;
use STVLIB.ST_VSS.all;

entity core_6502_debug_DW01_add_9_0 is

   port( A, B : in std_logic_vector (8 downto 0);  CI : in std_logic;  SUM : 
         out std_logic_vector (8 downto 0);  CO : out std_logic);

end core_6502_debug_DW01_add_9_0;

architecture SYN_rpl of core_6502_debug_DW01_add_9_0 is

   component FA1
      port( A, B, CI : in std_logic;  CO, Z : out std_logic);
   end component;
   
   component EO
      port( A, B : in std_logic;  Z : out std_logic);
   end component;
   
   signal carry_8, carry_1, carry_7, carry_6, carry_2, carry_5, carry_4, 
      carry_3 : std_logic;

begin
   
   U1_7 : FA1 port map( A => A(7), B => B(7), CI => carry_7, CO => carry_8, Z 
                           => SUM(7));
   U1_6 : FA1 port map( A => A(6), B => B(6), CI => carry_6, CO => carry_7, Z 
                           => SUM(6));
   U1_5 : FA1 port map( A => A(5), B => B(5), CI => carry_5, CO => carry_6, Z 
                           => SUM(5));
   U1_4 : FA1 port map( A => A(4), B => B(4), CI => carry_4, CO => carry_5, Z 
                           => SUM(4));
   U1_3 : FA1 port map( A => A(3), B => B(3), CI => carry_3, CO => carry_4, Z 
                           => SUM(3));
   U1_2 : FA1 port map( A => A(2), B => B(2), CI => carry_2, CO => carry_3, Z 
                           => SUM(2));
   U1_1 : FA1 port map( A => A(1), B => B(1), CI => carry_1, CO => carry_2, Z 
                           => SUM(1));
   U1_0 : FA1 port map( A => A(0), B => B(0), CI => CI, CO => carry_1, Z => 
                           SUM(0));
   U4 : EO port map( A => B(8), B => carry_8, Z => SUM(8));

end SYN_rpl;

library IEEE,MTC45000,MTC45100X,LIB_GENERATORS,STVLIB;

use IEEE.std_logic_1164.all;
use IEEE.std_logic_arith.all;
use MTC45000.VCOMPONENTS.all;
use MTC45100X.VCOMPONENTS.all;
use LIB_GENERATORS.PCK_GENERATORS.all;
use STVLIB.ST_TIMING.all;
use STVLIB.ST_VSS.all;

entity core_6502_debug_DW01_incdec_8_0 is

   port( A : in std_logic_vector (7 downto 0);  INC_DEC : in std_logic;  SUM : 
         out std_logic_vector (7 downto 0));

end core_6502_debug_DW01_incdec_8_0;

architecture SYN_rpl of core_6502_debug_DW01_incdec_8_0 is

   component FA1
      port( A, B, CI : in std_logic;  CO, Z : out std_logic);
   end component;
   
   component IVP
      port( A : in std_logic;  Z : out std_logic);
   end component;
   
   signal carry_1, carry_7, carry_6, carry_2, carry_0, carry_5, carry_4, 
      carry_3 : std_logic;

begin
   
   U1_4 : FA1 port map( A => A(4), B => INC_DEC, CI => carry_4, CO => carry_5, 
                           Z => SUM(4));
   U1_3 : FA1 port map( A => A(3), B => INC_DEC, CI => carry_3, CO => carry_4, 
                           Z => SUM(3));
   U1_2 : FA1 port map( A => A(2), B => INC_DEC, CI => carry_2, CO => carry_3, 
                           Z => SUM(2));
   U1_1 : FA1 port map( A => A(1), B => INC_DEC, CI => carry_1, CO => carry_2, 
                           Z => SUM(1));
   U1_0 : FA1 port map( A => A(0), B => INC_DEC, CI => carry_0, CO => carry_1, 
                           Z => SUM(0));
   U6 : IVP port map( A => INC_DEC, Z => carry_0);
   U1_7 : FA1 port map( A => A(7), B => INC_DEC, CI => carry_7, CO => open, Z 
                           => SUM(7));
   U1_6 : FA1 port map( A => A(6), B => INC_DEC, CI => carry_6, CO => carry_7, 
                           Z => SUM(6));
   U1_5 : FA1 port map( A => A(5), B => INC_DEC, CI => carry_5, CO => carry_6, 
                           Z => SUM(5));

end SYN_rpl;

library IEEE,MTC45000,MTC45100X,LIB_GENERATORS,STVLIB;

use IEEE.std_logic_1164.all;
use IEEE.std_logic_arith.all;
use MTC45000.VCOMPONENTS.all;
use MTC45100X.VCOMPONENTS.all;
use LIB_GENERATORS.PCK_GENERATORS.all;
use STVLIB.ST_TIMING.all;
use STVLIB.ST_VSS.all;

entity core_6502_debug is

   port( clk, reset, irq_in, nmi_in : in std_logic;  addr_pin : out 
         std_logic_vector (15 downto 0);  din : in std_logic_vector (7 downto 
         0);  dout : out std_logic_vector (7 downto 0);  dout_oe, we_pin, 
         rd_pin, sync : out std_logic;  halt : in std_logic;  stack_page : in 
         std_logic_vector (7 downto 0);  reg_a_out, reg_x_out, reg_y_out, 
         reg_sr_out, reg_sp_out : out std_logic_vector (7 downto 0);  
         reg_pc_out : out std_logic_vector (15 downto 0));

end core_6502_debug;

architecture SYN_core_6502_arch_debug of core_6502_debug is

   component mc_rom
      port( opcode : in std_logic_vector (7 downto 0);  step : in 
            std_logic_vector (2 downto 0);  DONE : out std_logic;  ADDR_OP : 
            out std_logic_vector (0 to 4);  DIN_LE, RD_EN : out std_logic;  
            DOUT_OP : out std_logic_vector (0 to 2);  DINT1_OP, DINT2_OP, 
            DINT3_OP : out std_logic;  PC_OP : out std_logic_vector (0 to 3);  
            SP_OP, ALU1, ALU2 : out std_logic_vector (0 to 1);  ALU_OP : out 
            std_logic_vector (0 to 3);  A_LE, X_LE, Y_LE : out std_logic;  
            FLAG_OP : out std_logic_vector (0 to 3));
   end component;
   
   component MUX21P
      port( A, B, S : in std_logic;  Z : out std_logic);
   end component;
   
   component ND2
      port( A, B : in std_logic;  Z : out std_logic);
   end component;
   
   component ND4
      port( A, B, C, D : in std_logic;  Z : out std_logic);
   end component;
   
   component ND3
      port( A, B, C : in std_logic;  Z : out std_logic);
   end component;
   
   component IVP
      port( A : in std_logic;  Z : out std_logic);
   end component;
   
   component AN4P
      port( A, B, C, D : in std_logic;  Z : out std_logic);
   end component;
   
   component NR2
      port( A, B : in std_logic;  Z : out std_logic);
   end component;
   
   component EO
      port( A, B : in std_logic;  Z : out std_logic);
   end component;
   
   component ND2A
      port( A, B : in std_logic;  Z : out std_logic);
   end component;
   
   component AN3P
      port( A, B, C : in std_logic;  Z : out std_logic);
   end component;
   
   component AN2
      port( A, B : in std_logic;  Z : out std_logic);
   end component;
   
   component AN4
      port( A, B, C, D : in std_logic;  Z : out std_logic);
   end component;
   
   component AN3
      port( A, B, C : in std_logic;  Z : out std_logic);
   end component;
   
   component AO2
      port( A, B, C, D : in std_logic;  Z : out std_logic);
   end component;
   
   component BF1T1
      port( A : in std_logic;  Z : out std_logic);
   end component;
   
   component AO2N
      port( A, B, C, D : in std_logic;  Z : out std_logic);
   end component;
   
   component AO7A
      port( A, B, C : in std_logic;  Z : out std_logic);
   end component;
   
   component AO3A
      port( A, B, C, D : in std_logic;  Z : out std_logic);
   end component;
   
   component AO34
      port( A, B, C, D : in std_logic;  Z : out std_logic);
   end component;
   
   component AO12
      port( A, B, C, D, E, F, G, H : in std_logic;  Z : out std_logic);
   end component;
   
   component AO1N
      port( A, B, C, D : in std_logic;  Z : out std_logic);
   end component;
   
   component AO7C
      port( A, B, C : in std_logic;  Z : out std_logic);
   end component;
   
   component AO8
      port( A, B, C, D : in std_logic;  Z : out std_logic);
   end component;
   
   component AO3N
      port( A, B, C, D : in std_logic;  Z : out std_logic);
   end component;
   
   component AO7N
      port( A, B, C : in std_logic;  Z : out std_logic);
   end component;
   
   component AO29
      port( A, B, C, D, E : in std_logic;  Z : out std_logic);
   end component;
   
   component MUX21N
      port( A, B, S : in std_logic;  Z : out std_logic);
   end component;
   
   component AO1CN
      port( A, B, C, D : in std_logic;  Z : out std_logic);
   end component;
   
   component MUX21X4
      port( A, B, S : in std_logic;  Z : out std_logic);
   end component;
   
   component AO4A
      port( A, B, C, D : in std_logic;  Z : out std_logic);
   end component;
   
   component AO6A
      port( A, B, C : in std_logic;  Z : out std_logic);
   end component;
   
   component AO2A
      port( A, B, C, D : in std_logic;  Z : out std_logic);
   end component;
   
   component AO25
      port( A, B, C, D, E : in std_logic;  Z : out std_logic);
   end component;
   
   component AO17
      port( A, B, C, D : in std_logic;  Z : out std_logic);
   end component;
   
   component OR8
      port( A, B, C, D, E, F, G, H : in std_logic;  Z : out std_logic);
   end component;
   
   component AO3C
      port( A, B, C, D : in std_logic;  Z : out std_logic);
   end component;
   
   component AO35
      port( A, B, C, D, E : in std_logic;  Z : out std_logic);
   end component;
   
   component AO28
      port( A, B, C, D : in std_logic;  Z : out std_logic);
   end component;
   
   component FD2
      port( CD, CP, D : in std_logic;  Q, QN : out std_logic);
   end component;
   
   component FD4
      port( CP, D, SD : in std_logic;  Q, QN : out std_logic);
   end component;
   
   component core_6502_debug_DW01_add_16_0
      port( A, B : in std_logic_vector (15 downto 0);  CI : in std_logic;  SUM 
            : out std_logic_vector (15 downto 0);  CO : out std_logic);
   end component;
   
   component core_6502_debug_DW01_inc_16_0
      port( A : in std_logic_vector (15 downto 0);  SUM : out std_logic_vector 
            (15 downto 0));
   end component;
   
   component core_6502_debug_DW01_add_9_1
      port( A, B : in std_logic_vector (8 downto 0);  CI : in std_logic;  SUM :
            out std_logic_vector (8 downto 0);  CO : out std_logic);
   end component;
   
   component core_6502_debug_DW01_add_9_0
      port( A, B : in std_logic_vector (8 downto 0);  CI : in std_logic;  SUM :
            out std_logic_vector (8 downto 0);  CO : out std_logic);
   end component;
   
   component core_6502_debug_DW01_incdec_8_0
      port( A : in std_logic_vector (7 downto 0);  INC_DEC : in std_logic;  SUM
            : out std_logic_vector (7 downto 0));
   end component;
   
   component AO6C
      port( A, B, C : in std_logic;  Z : out std_logic);
   end component;
   
   component AO6N
      port( A, B, C : in std_logic;  Z : out std_logic);
   end component;
   
   signal reg_a_out_5, R1167_6, addr_out_high985_6, reg_x_out_7, reg_pc_out_2, 
      alu_add_6, pc_add656_13, pc_add656_8, dint3_3, opcode_reg_6, opcode_2, 
      addr_out_low987_5, dint2_3, reg_y_out_7, irq_reg, L1249_15, alu1_0, 
      addr_op_3, dout_1, pc_inc654_10, done, pc_inc654_2, addr_pin_4, ARG1587_1
      , dint1_6, reg_sr_out_5, pc_add656_1, data_in_3, alu_add_in2_6, L1249_9, 
      reg_sr_out_2, reg_sp_out_1, step_0, flag_op_1, reg_sp_out_6, 
      alu_add_in2_1, data_in_4, reg_y_out_0, dint1_1, reg_pc_out_11, ARG1587_6,
      addr_pin_3, state_2, alu_op_2, pc_add656_6, addr_op_4, dout_6, pc_op_0, 
      R1167_8, pc_inc654_5, alu_add_8, reg_a_out_3, reg_a_out_2, reg_x_out_0, 
      reg_pc_out_5, addr_pin_11, L1249_12, addr_out_low987_2, alu_add_in2_8, 
      opcode_5, dint2_4, pc_add656_14, L1165_7, opcode_reg_1, dint3_4, R1167_1,
      dint3_op, alu_add_1, reg_y_out_1, addr_out_high985_1, dout_7, pc_op_1, 
      pc_inc654_4, dint1_0, reg_sr_out_3, reg_pc_out_10, addr_pin_2, ARG1587_7,
      alu_op_3, pc_add656_7, data_in_5, alu_add_in2_0, sync_port, flag_op_0, 
      reg_sp_out_7, reg_pc_out_4, addr_add_cin1016, alu_add_0, 
      addr_out_high985_0, nmi_reg2, dout_op_2, pc_add656_15, L1165_6, 
      opcode_reg_0, dint3_5, addr_out_low987_3, dint2_op, opcode_4, dint2_5, 
      reg_x_out_6, reg_x_out_1, addr_pin_10, L1249_13, reg_a_out_6, reg_a_out_4
      , L1249_14, alu1_1, opcode_3, addr_out_low987_4, din_le, dint2_2, 
      pc_add656_12, pc_add656_9, alu_add_cin, dint3_2, opcode_reg_7, L1165_1, 
      R1167_7, addr_out_high985_7, first_run, reg_sr_out_4, reg_pc_out_3, 
      alu_add_7, reg_sp_out_0, step_1, data_in_2, alu_add_in2_7, reg_y_out_6, 
      L1249_8, ARG1587_0, addr_pin_5, dint1_7, L1165_8, pc_add656_0, addr_op_2,
      pc_inc654_11, dout_0, reg_pc_out_1, pc_inc654_3, dout_oe_port, alu_add_5,
      addr_out_high985_5, pc_inc654_8, R1167_5, L1165_3, dint3_0, opcode_reg_5,
      pc_add656_10, dint2_0, addr_out_low987_6, opcode_1, alu_in1_7, 
      reg_x_out_4, addr_pin_15, reg_x_out_3, reg_y_out_4, y_le, pc_inc654_1, 
      pc_inc654_13, reg_pc_out_15, reg_pc_out_8, addr_op_0, dout_2, pc_add656_2
      , dint1_op, addr_pin_7, ARG1587_2, dint1_5, reg_sr_out_6, alu_add_in2_5, 
      reg_sp_out_2, data_in_0, reg_sp_out_5, flag_op_2, reg_y_out_3, 
      reg_sr_out_1, data_in_7, addr_out_low987_8, reg_pc_out_12, alu_add_in2_2,
      pc_add656_5, alu_op_1, dint1_2, ARG1587_5, addr_pin_0, state_1, 
      pc_inc654_14, pc_op_3, alu2_1, pc_inc654_6, dout_5, L1249_11, addr_pin_12
      , reg_a_out_1, dint2_7, opcode_6, addr_out_low987_1, opcode_reg_2, 
      dint3_7, sp_op_1, L1165_4, dout_op_0, addr_pin_9, addr_out_high985_2, 
      reg_a_out_0, alu_add_2, reg_y_out_2, reg_pc_out_6, R1167_2, reg_pc_out_13
      , state_0, pc_op_2, pc_inc654_15, alu2_0, pc_inc654_7, nmi_event, dout_4,
      alu_op_0, pc_add656_4, dint1_3, addr_pin_1, ARG1587_4, reg_sr_out_0, 
      data_in_6, rd_en, reg_sp_out_4, alu_add_in2_3, R1251, alu_in1_8, 
      flag_op_3, we_pin_port, addr_out_high985_3, alu_add_3, reg_x_out_2, 
      reg_pc_out_7, R1167_3, opcode_reg_3, dint3_6, L1165_5, sp_op_0, nmi_reg1,
      dout_op_1, addr_pin_8, dint2_6, opcode_7, addr_out_low987_0, L1249_10, 
      addr_pin_13, alu_in1_6, reg_a_out_7, reg_x_out_5, addr_pin_14, dint2_1, 
      addr_out_low987_7, opcode_0, fetch_d, dint3_1, L1165_2, opcode_reg_4, 
      pc_add656_11, reg_pc_out_0, alu_add_4, addr_out_high985_4, reg_sp_out_3, 
      pc_inc654_9, R1167_4, step_2, reg_y_out_5, reg_sr_out_7, x_le, 
      alu_add_in2_4, reg_pc_out_14, data_in_1, pc_add656_3, ARG1587_3, 
      addr_pin_6, dint1_4, reg_pc_out_9, pc_inc654_0, pc_inc654_12, a_le, 
      addr_op_1, dout_3, n_741, n2797, n2798, n2799, n2800, n2801, n2802, n2803
      , n2804, n2805, n2806, n2807, n2808, n2809, n2810, n2811, n2812, n2813, 
      n2814, n2815, n2816, n2817, n2818, n2819, n2820, n2821, n2822, n2823, 
      n2824, n2825, n2826, n2827, n2828, n2829, n2830, n2831, n2832, n2833, 
      n2834, n2835, n2836, n2837, n2838, n2839, n2840, n2841, n2842, n2843, 
      n2844, n2845, n2846, n2847, n2848, n2849, add_649_plus_plus_carry_1, 
      add_649_plus_plus_carry_7, add_649_plus_plus_carry_6, 
      add_649_plus_plus_carry_2, add_649_plus_plus_carry_5, 
      add_649_plus_plus_carry_4, add_649_plus_plus_carry_3, n2850, n2851, n2852
      , n2853, n2854, n2855, n2856, n2857, n2858, n2859, n2860, n2861, n2862, 
      n2863, n2864, n2865, n2866, n2867, n2868, n2869, n2870, n2871, n2872, 
      n2873, n2874, n2875, n2876, n2877, n2878, n2879, n2880, n2881, n2882, 
      n2883, n2884, n2885, n2886, n2887, n2888, n2889, n2890, n2891, n2892, 
      n2893, n2894, n2895, n2896, n2897, n2898, n2899, n2900, n2901, n2902, 
      n2903, n2904, n2905, n2906, n2907, n2908, n2909, n2910, n2911, n2912, 
      n2913, n2914, n2915, n2916, n2917, n2918, n2919, n2920, n2921, n2922, 
      n2923, n2924, n2925, n2926, n2927, n2928, n2929, n2930, n2931, n2932, 
      n2933, n2934, n2935, n2936, n2937, n2938, n2939, n2940, n2941, n2942, 
      n2943, n2944, n2945, n2946, n2947, n2948, n2949, n2950, n2951, n2952, 
      n2953, n2954, n2955, n2956, n2957, n2958, n2959, n2960, n2961, n2962, 
      n2963, n2964, n2965, n2966, n2967, n2968, n2969, n2970, n2971, n2972, 
      n2973, n2974, n2975, n2976, n2977, n2978, n2979, n2980, n2981, n2982, 
      n2983, n2984, n2985, n2986, n2987, n2988, n2989, n2990, n2991, n2992, 
      n2993, n2994, n2995, n2996, n2997, n2998, n2999, n3000, n3001, n3002, 
      n3003, n3004, n3005, n3006, n3007, n3008, n3009, n3010, n3011, n3012, 
      n3013, n3014, n3015, n3016, n3017, n3018, n3019, n3020, n3021, n3022, 
      n3023, n3024, n3025, n3026, n3027, n3028, n3029, n3030, n3031, n3032, 
      n3033, n3034, n3035, n3036, n3037, n3038, n3039, n3040, n3041, n3042, 
      n3043, n3044, n3045, n3046, n3047, n3048, n3049, n3050, n3051, n3052, 
      n3053, n3054, n3055, n3056, n3057, n3058, n3059, n3060, n3061, n3062, 
      n3063, n3064, n3065, n3066, n3067, n3068, n3069, n3070, n3071, n3072, 
      n3073, n3074, n3075, n3076, n3077, n3078, n3079, n3080, n3081, n3082, 
      n3083, n3084, n3085, n3086, n3087, n3088, n3089, n3090, n3091, n3092, 
      n3093, n3094, n3095, n3096, n3097, n3098, n3099, n3100, n3101, n3102, 
      n3103, n3104, n3105, n3106, n3107, n3108, n3109, net509, net510, net511, 
      net620, n3110, n3111, n3112, n3113, n3114, n3115, n3116, n3117, n3118, 
      n3119, n3120, n3121, n3122, n3123, n3124, n3125, n3126, n3127, n3128, 
      n3129, n3130, n3131, n3132, n3133, n3134, n3135, n3136, n3137, n3138, 
      n3139, n3140, n3141, n3142, n3143, n3144, n3145, n3146, n3147, n3148, 
      n3149, n3150, n3151, n3152, n3153, n3154, n3155, n3156, n3157, n3158, 
      n3159, n3160, n3161, n3162, n3163, n3164, n3165, n3166, n3167, n3168, 
      n3169, n3170, n3171, n3172, n3173, n3174, n3175, n3176, n3177, n3178, 
      n3179, n3180, n3181, n3182, n3183, n3184, n3185, n3186, n3187, n3188, 
      n3189, n3190, n3191, n3192, n3193, n3194, n3195, n3196, n3197, n3198, 
      n3199, n3200, n3201, n3202, n3203, n3204, n3205, n3206, n3207, n3208, 
      n3209, n3210, n3211, n3212, n3213, n3214, n3215, n3216, n3217, n3218, 
      n3219, n3220, n3221, n3222, n3223, n3224, n3225, n3226, n3227, n3228, 
      n3229, n3230, n3231, n3232, n3233, n3234, n3235, n3236, n3237, n3238, 
      n3239, n3240, n3241, n3242, n3243, n3244, n3245, n3246, n3247, n3248, 
      n3249, n3250, n3251, n3252, n3253, n3254, n3255, n3256, n3257, n3258, 
      n3259, n3260, n3261, n3262, n3263, n3264, n3265, n3266, n3267, n3268, 
      n3269, n3270, n3271, n3272, n3273, n3274, n3275, n3276, n3277, n3278, 
      n3279, n3280, n3281, n3282, n3283, n3284, n3285, n3286, n3287, n3288, 
      n3289, n3290, n3291, n3292, n3293, n3294, n3295, n3296, n3297, n3298, 
      n3299, n3300, n3301, n3302, n3303, n3304, n3305, n3306, n3307, n3308, 
      n3309, n3310, n3311, n3312, n3313, n3314, n3315, n3316, n3317, n3318, 
      n3319, n3320, n3321, n3322, n3323, n3324, n3325, n3326, n3327, n3328, 
      n3329, n3330, n3331, n3332, n3333, n3334, n3335, n3336, n3337, n3338, 
      n3339, n3340, n3341, n3342, n3343, n3344, n3345, n3346, n3347, n3348, 
      n3349, n3350, n3351, n3352, n3353, n3354, n3355, n3356, n3357, n3358, 
      n3359, n3360, n3361, n3362, n3363, n3364, n3365, n3366, n3367, n3368, 
      n3369, n3370, n3371, n3372, n3373, n3374, n3375, n3376, n3377, n3378, 
      n3379, n3380, n3381, n3382, n3383, n3384, n3385, n3386, n3387, n3388, 
      n3389, n3390, n3391, n3392, n3393, n3394, n3395, n3396, n3397, n3398, 
      n3399, n3400, n3401, n3402, n3403, n3404, n3405, n3406, n3407, n3408, 
      n3409, n3410, n3411, n3412, n3413, n3414, n3415, n3416, n3417, n3418, 
      n3419, n3420, n3421, n3422, n3423, n3424, n3425, n3426, n3427 : std_logic
      ;

begin
   addr_pin <= ( addr_pin_15, addr_pin_14, addr_pin_13, addr_pin_12, 
      addr_pin_11, addr_pin_10, addr_pin_9, addr_pin_8, addr_pin_7, addr_pin_6,
      addr_pin_5, addr_pin_4, addr_pin_3, addr_pin_2, addr_pin_1, addr_pin_0 );
   dout <= ( dout_7, dout_6, dout_5, dout_4, dout_3, dout_2, dout_1, dout_0 );
   dout_oe <= dout_oe_port;
   we_pin <= we_pin_port;
   sync <= sync_port;
   reg_a_out <= ( reg_a_out_7, reg_a_out_6, reg_a_out_5, reg_a_out_4, 
      reg_a_out_3, reg_a_out_2, reg_a_out_1, reg_a_out_0 );
   reg_x_out <= ( reg_x_out_7, reg_x_out_6, reg_x_out_5, reg_x_out_4, 
      reg_x_out_3, reg_x_out_2, reg_x_out_1, reg_x_out_0 );
   reg_y_out <= ( reg_y_out_7, reg_y_out_6, reg_y_out_5, reg_y_out_4, 
      reg_y_out_3, reg_y_out_2, reg_y_out_1, reg_y_out_0 );
   reg_sr_out <= ( reg_sr_out_7, reg_sr_out_6, reg_sr_out_5, reg_sr_out_4, 
      reg_sr_out_3, reg_sr_out_2, reg_sr_out_1, reg_sr_out_0 );
   reg_sp_out <= ( reg_sp_out_7, reg_sp_out_6, reg_sp_out_5, reg_sp_out_4, 
      reg_sp_out_3, reg_sp_out_2, reg_sp_out_1, reg_sp_out_0 );
   reg_pc_out <= ( reg_pc_out_15, reg_pc_out_14, reg_pc_out_13, reg_pc_out_12, 
      reg_pc_out_11, reg_pc_out_10, reg_pc_out_9, reg_pc_out_8, reg_pc_out_7, 
      reg_pc_out_6, reg_pc_out_5, reg_pc_out_4, reg_pc_out_3, reg_pc_out_2, 
      reg_pc_out_1, reg_pc_out_0 );
   
   reg_sr_out_5 <= '1';
   alu_in1_8 <= '0';
   MC_ROM0 : mc_rom port map( opcode(7) => opcode_7, opcode(6) => opcode_6, 
                           opcode(5) => opcode_5, opcode(4) => opcode_4, 
                           opcode(3) => opcode_3, opcode(2) => opcode_2, 
                           opcode(1) => opcode_1, opcode(0) => opcode_0, 
                           step(2) => step_2, step(1) => step_1, step(0) => 
                           step_0, DONE => done, ADDR_OP(0) => addr_op_4, 
                           ADDR_OP(1) => addr_op_3, ADDR_OP(2) => addr_op_2, 
                           ADDR_OP(3) => addr_op_1, ADDR_OP(4) => addr_op_0, 
                           DIN_LE => din_le, RD_EN => rd_en, DOUT_OP(0) => 
                           dout_op_2, DOUT_OP(1) => dout_op_1, DOUT_OP(2) => 
                           dout_op_0, DINT1_OP => dint1_op, DINT2_OP => 
                           dint2_op, DINT3_OP => dint3_op, PC_OP(0) => pc_op_3,
                           PC_OP(1) => pc_op_2, PC_OP(2) => pc_op_1, PC_OP(3) 
                           => pc_op_0, SP_OP(0) => sp_op_1, SP_OP(1) => sp_op_0
                           , ALU1(0) => alu1_1, ALU1(1) => alu1_0, ALU2(0) => 
                           alu2_1, ALU2(1) => alu2_0, ALU_OP(0) => alu_op_3, 
                           ALU_OP(1) => alu_op_2, ALU_OP(2) => alu_op_1, 
                           ALU_OP(3) => alu_op_0, A_LE => a_le, X_LE => x_le, 
                           Y_LE => y_le, FLAG_OP(0) => flag_op_3, FLAG_OP(1) =>
                           flag_op_2, FLAG_OP(2) => flag_op_1, FLAG_OP(3) => 
                           flag_op_0);
   U961 : MUX21P port map( A => n3302, B => n3303, S => reg_sr_out_6, Z => 
                           n3424);
   U962 : MUX21P port map( A => n3342, B => n3341, S => pc_op_1, Z => n3270);
   U963 : ND2 port map( A => reg_sr_out_1, B => n3303, Z => n3342);
   U964 : MUX21P port map( A => reg_sr_out_1, B => reg_sr_out_7, S => pc_op_0, 
                           Z => n3341);
   U965 : ND4 port map( A => addr_op_4, B => n3312, C => addr_op_0, D => n2800,
                           Z => n3326);
   U966 : MUX21P port map( A => addr_op_0, B => n3397, S => addr_op_2, Z => 
                           n3419);
   U967 : ND3 port map( A => n3309, B => n3307, C => n3313, Z => n3330);
   U968 : ND2 port map( A => addr_op_1, B => addr_op_2, Z => n3416);
   U969 : ND2 port map( A => n3312, B => n3314, Z => n3323);
   U970 : ND2 port map( A => n3322, B => n3309, Z => n3425);
   U971 : ND2 port map( A => addr_op_3, B => n3307, Z => n3321);
   U972 : ND2 port map( A => n2800, B => n3307, Z => n3426);
   U973 : ND2 port map( A => pc_op_0, B => n2803, Z => n3423);
   U974 : MUX21P port map( A => n2952, B => n3106, S => pc_op_3, Z => n3097);
   U975 : ND2 port map( A => n3424, B => n3269, Z => n3106);
   U976 : ND2 port map( A => n3395, B => n3313, Z => n3394);
   U977 : ND3 port map( A => n3322, B => n3309, C => n3329, Z => n3328);
   U978 : IVP port map( A => n3395, Z => n3336);
   U979 : ND3 port map( A => n3332, B => n3333, C => n3334, Z => n3331);
   U980 : AN4P port map( A => n3401, B => n3325, C => n3332, D => n3333, Z => 
                           n3378);
   U981 : ND2 port map( A => n2802, B => n3312, Z => n3325);
   U982 : ND3 port map( A => addr_op_1, B => n3311, C => n3410, Z => n3332);
   U983 : ND3 port map( A => n3311, B => n3313, C => n3409, Z => n3333);
   U984 : ND3 port map( A => n3325, B => n3326, C => n3327, Z => n3324);
   U985 : IVP port map( A => n3324, Z => n3334);
   U986 : NR2 port map( A => addr_op_2, B => addr_op_1, Z => n3392);
   U987 : IVP port map( A => n3335, Z => n3417);
   U988 : ND2 port map( A => n3332, B => n3326, Z => n3400);
   U989 : ND3 port map( A => n3322, B => addr_op_2, C => n3409, Z => n3401);
   U990 : IVP port map( A => n3321, Z => n3322);
   U991 : IVP port map( A => n3401, Z => n3398);
   U992 : IVP port map( A => n3320, Z => n3410);
   U993 : ND2 port map( A => addr_op_0, B => n3313, Z => n3320);
   U994 : ND2 port map( A => n3311, B => n3312, Z => n3310);
   U995 : MUX21P port map( A => n3426, B => n3425, S => n3397, Z => n3418);
   U996 : IVP port map( A => n3323, Z => n3397);
   U997 : ND2 port map( A => addr_op_2, B => n3307, Z => n3343);
   U998 : ND2 port map( A => addr_op_4, B => n3309, Z => n3308);
   U999 : IVP port map( A => n3308, Z => n3311);
   U1000 : IVP port map( A => n3315, Z => n3409);
   U1001 : ND2 port map( A => addr_op_1, B => n3314, Z => n3315);
   U1002 : ND2 port map( A => n3340, B => n3415, Z => n3319);
   U1003 : EO port map( A => addr_op_2, B => addr_op_1, Z => n3340);
   U1004 : EO port map( A => n3276, B => alu2_1, Z => n3412);
   U1005 : ND3 port map( A => alu_op_3, B => alu_op_1, C => n3295, Z => n3294);
   U1006 : MUX21P port map( A => n3421, B => n3420, S => alu_op_2, Z => n3290);
   U1007 : ND2 port map( A => n3292, B => n3266, Z => n3421);
   U1008 : ND2 port map( A => alu_op_3, B => n3287, Z => n3420);
   U1009 : ND2 port map( A => n2801, B => alu_op_3, Z => n3293);
   U1010 : MUX21P port map( A => n2811, B => n2806, S => n3411, Z => n3413);
   U1011 : IVP port map( A => alu2_0, Z => n3276);
   U1012 : ND3 port map( A => alu_op_3, B => n3280, C => n3295, Z => n3286);
   U1013 : ND2 port map( A => alu_op_0, B => n3278, Z => n3281);
   U1014 : ND3 port map( A => alu_op_2, B => n3266, C => alu_op_0, Z => n3279);
   U1015 : ND2 port map( A => n2801, B => n3266, Z => n3288);
   U1016 : IVP port map( A => alu_op_2, Z => n3278);
   U1017 : ND2 port map( A => alu1_1, B => alu1_0, Z => n3245);
   U1018 : ND2 port map( A => alu1_1, B => n3282, Z => n3246);
   U1019 : ND2 port map( A => n3282, B => n3283, Z => n3250);
   U1020 : ND2 port map( A => alu1_0, B => n3283, Z => n3248);
   U1021 : IVP port map( A => alu1_1, Z => n3283);
   U1022 : IVP port map( A => alu1_0, Z => n3282);
   U1023 : EO port map( A => n3273, B => n3274, Z => n3272);
   U1024 : MUX21P port map( A => opcode_reg_5, B => data_in_5, S => fetch_d, Z 
                           => opcode_5);
   U1025 : MUX21P port map( A => opcode_reg_6, B => data_in_6, S => fetch_d, Z 
                           => opcode_6);
   U1026 : NR2 port map( A => nmi_event, B => n2948, Z => n2971);
   U1027 : ND2 port map( A => alu_op_2, B => n3292, Z => n3291);
   U1028 : ND2 port map( A => n3295, B => n3266, Z => n3422);
   U1029 : IVP port map( A => n3281, Z => n3295);
   U1030 : ND3 port map( A => n3266, B => n3277, C => alu_op_2, Z => n3267);
   U1031 : IVP port map( A => alu_op_0, Z => n3277);
   U1032 : ND2 port map( A => state_2, B => n2951, Z => n2949);
   U1033 : MUX21P port map( A => state_0, B => n3105, S => state_2, Z => n2975)
                           ;
   U1034 : ND2A port map( A => n3301, B => n2980, Z => n2981);
   U1035 : ND4 port map( A => n3302, B => n3261, C => pc_op_3, D => n3303, Z =>
                           n3301);
   U1036 : ND3 port map( A => n3269, B => n3302, C => n3300, Z => n3305);
   U1037 : IVP port map( A => pc_op_1, Z => n3302);
   U1038 : IVP port map( A => pc_op_3, Z => n3300);
   U1039 : MUX21P port map( A => n2803, B => n3423, S => pc_op_3, Z => n2983);
   U1040 : IVP port map( A => pc_op_2, Z => n3269);
   U1041 : IVP port map( A => pc_op_0, Z => n3303);
   U1042 : IVP port map( A => n2977, Z => n2980);
   U1043 : ND2 port map( A => dint3_5, B => n3259, Z => n3390);
   U1044 : ND3 port map( A => dout_op_2, B => n3260, C => dout_op_1, Z => n3298
                           );
   U1045 : ND3 port map( A => dout_op_2, B => n3296, C => dout_op_0, Z => n3299
                           );
   U1046 : ND3 port map( A => dout_op_2, B => dout_op_0, C => dout_op_1, Z => 
                           n3297);
   U1047 : IVP port map( A => n3299, Z => n3066);
   U1048 : ND2 port map( A => n2833, B => n3260, Z => n2985);
   U1049 : MUX21P port map( A => reg_pc_out_15, B => n3351, S => n3317, Z => 
                           L1249_15);
   U1050 : ND3 port map( A => n3352, B => n3353, C => n3347, Z => n3351);
   U1051 : MUX21P port map( A => reg_pc_out_14, B => n3354, S => n3317, Z => 
                           L1249_14);
   U1052 : ND3 port map( A => n3355, B => n3356, C => n3347, Z => n3354);
   U1053 : MUX21P port map( A => reg_pc_out_13, B => n3357, S => n3317, Z => 
                           L1249_13);
   U1054 : ND3 port map( A => n3358, B => n3359, C => n3347, Z => n3357);
   U1055 : MUX21P port map( A => reg_pc_out_12, B => n3360, S => n3317, Z => 
                           L1249_12);
   U1056 : ND3 port map( A => n3361, B => n3362, C => n3347, Z => n3360);
   U1057 : MUX21P port map( A => reg_pc_out_11, B => n3363, S => n3317, Z => 
                           L1249_11);
   U1058 : ND3 port map( A => n3364, B => n3365, C => n3347, Z => n3363);
   U1059 : MUX21P port map( A => reg_pc_out_10, B => n3366, S => n3317, Z => 
                           L1249_10);
   U1060 : ND3 port map( A => n3367, B => n3368, C => n3347, Z => n3366);
   U1061 : MUX21P port map( A => reg_pc_out_9, B => n3344, S => n3317, Z => 
                           L1249_9);
   U1062 : ND3 port map( A => n3345, B => n3346, C => n3347, Z => n3344);
   U1063 : IVP port map( A => addr_op_2, Z => n3309);
   U1064 : IVP port map( A => n3329, Z => n3396);
   U1065 : MUX21P port map( A => reg_pc_out_8, B => n3348, S => n3317, Z => 
                           L1249_8);
   U1066 : ND3 port map( A => n3349, B => n3350, C => n3347, Z => n3348);
   U1067 : IVP port map( A => n3331, Z => n3347);
   U1068 : MUX21P port map( A => reg_pc_out_7, B => n3388, S => n3317, Z => 
                           L1165_1);
   U1069 : MUX21P port map( A => reg_pc_out_6, B => n3386, S => n3317, Z => 
                           L1165_2);
   U1070 : MUX21P port map( A => reg_pc_out_5, B => n3384, S => n3317, Z => 
                           L1165_3);
   U1071 : MUX21P port map( A => reg_pc_out_4, B => n3382, S => n3317, Z => 
                           L1165_4);
   U1072 : MUX21P port map( A => reg_pc_out_3, B => n3380, S => n3317, Z => 
                           L1165_5);
   U1073 : MUX21P port map( A => reg_pc_out_2, B => n3377, S => n3317, Z => 
                           L1165_6);
   U1074 : MUX21P port map( A => reg_pc_out_1, B => n3373, S => n3317, Z => 
                           L1165_7);
   U1075 : IVP port map( A => n3404, Z => n3374);
   U1076 : IVP port map( A => addr_op_0, Z => n3314);
   U1077 : IVP port map( A => n3310, Z => n3393);
   U1078 : MUX21P port map( A => reg_pc_out_0, B => n3369, S => n3317, Z => 
                           L1165_8);
   U1079 : ND2 port map( A => n3261, B => n3264, Z => n3257);
   U1080 : IVP port map( A => done, Z => n3264);
   U1081 : IVP port map( A => n3318, Z => n3268);
   U1082 : IVP port map( A => addr_op_4, Z => n3307);
   U1083 : IVP port map( A => n3257, Z => n3317);
   U1084 : IVP port map( A => addr_op_1, Z => n3312);
   U1085 : IVP port map( A => addr_op_3, Z => n3313);
   U1086 : IVP port map( A => n2997, Z => n2999);
   U1087 : ND2 port map( A => sp_op_0, B => sp_op_1, Z => n2997);
   U1088 : ND2 port map( A => n3273, B => n3049, Z => n3068);
   U1089 : IVP port map( A => n3288, Z => n3049);
   U1090 : IVP port map( A => n3272, Z => n3071);
   U1091 : EO port map( A => n3291, B => n3337, Z => alu_add_in2_7);
   U1092 : MUX21P port map( A => n3284, B => n3288, S => alu_in1_6, Z => n3073)
                           ;
   U1093 : IVP port map( A => alu_in1_7, Z => n3274);
   U1094 : EO port map( A => n3291, B => n2841, Z => alu_add_in2_6);
   U1095 : MUX21P port map( A => n3288, B => n3284, S => n3099, Z => n3077);
   U1096 : EO port map( A => n3291, B => n2842, Z => alu_add_in2_5);
   U1097 : MUX21P port map( A => n3284, B => n3288, S => n3414, Z => n3079);
   U1098 : IVP port map( A => n2879, Z => n3099);
   U1099 : EO port map( A => n3291, B => n3338, Z => alu_add_in2_4);
   U1100 : IVP port map( A => n3414, Z => n3338);
   U1101 : MUX21P port map( A => n3288, B => n3284, S => n3100, Z => n3082);
   U1102 : IVP port map( A => n2883, Z => n3080);
   U1103 : EO port map( A => n3291, B => n2830, Z => alu_add_in2_3);
   U1104 : MUX21P port map( A => n3288, B => n3284, S => n3101, Z => n3084);
   U1105 : IVP port map( A => n2880, Z => n3100);
   U1106 : EO port map( A => n3291, B => n2829, Z => alu_add_in2_2);
   U1107 : MUX21P port map( A => n3288, B => n3284, S => n3102, Z => n3086);
   U1108 : IVP port map( A => n2889, Z => n3101);
   U1109 : IVP port map( A => n3076, Z => n3072);
   U1110 : EO port map( A => n3291, B => n2831, Z => alu_add_in2_1);
   U1111 : IVP port map( A => n2886, Z => n3102);
   U1112 : IVP port map( A => n3284, Z => n3050);
   U1113 : IVP port map( A => n3279, Z => n3285);
   U1114 : IVP port map( A => alu_op_1, Z => n3280);
   U1115 : ND2 port map( A => n3290, B => n3286, Z => n3289);
   U1116 : IVP port map( A => n3289, Z => n3067);
   U1117 : MUX21P port map( A => n3288, B => n3284, S => n3103, Z => n3088);
   U1118 : IVP port map( A => n2996, Z => n3069);
   U1119 : IVP port map( A => n3339, Z => n3089);
   U1120 : IVP port map( A => n3293, Z => n2995);
   U1121 : EO port map( A => n3339, B => alu_add_in2_8, Z => alu_add_in2_0);
   U1122 : IVP port map( A => alu_op_3, Z => n3266);
   U1123 : IVP port map( A => n2892, Z => n3103);
   U1124 : IVP port map( A => n3005, Z => n3098);
   U1125 : ND2 port map( A => n3029, B => n3291, Z => n3005);
   U1126 : EO port map( A => n3272, B => n3029, Z => n2957);
   U1127 : IVP port map( A => n2972, Z => n3029);
   U1128 : EO port map( A => alu_in1_7, B => alu_add_7, Z => n2958);
   U1129 : AN3P port map( A => flag_op_3, B => n2895, C => flag_op_2, Z => 
                           n2960);
   U1130 : MUX21P port map( A => opcode_reg_4, B => data_in_4, S => fetch_d, Z 
                           => opcode_4);
   U1131 : ND2 port map( A => irq_reg, B => n2824, Z => n2876);
   U1132 : ND2 port map( A => n3296, B => n2984, Z => n2987);
   U1133 : IVP port map( A => dout_op_2, Z => n2984);
   U1134 : ND2 port map( A => n3003, B => n3107, Z => n3108);
   U1135 : ND3 port map( A => state_2, B => n2815, C => state_0, Z => n2973);
   U1136 : MUX21P port map( A => rd_en, B => n2971, S => done, Z => n3107);
   U1137 : ND3 port map( A => n3265, B => n2965, C => flag_op_2, Z => n2962);
   U1138 : IVP port map( A => n2962, Z => n2959);
   U1139 : ND2 port map( A => n2811, B => n2870, Z => n3061);
   U1140 : MUX21P port map( A => alu_add_in2_8, B => n2972, S => alu_add_8, Z 
                           => n3058);
   U1141 : IVP port map( A => n3291, Z => alu_add_in2_8);
   U1142 : IVP port map( A => n3075, Z => n3091);
   U1143 : ND3 port map( A => flag_op_3, B => n2895, C => n2870, Z => n3002);
   U1144 : ND2 port map( A => n2832, B => n3000, Z => n3093);
   U1145 : IVP port map( A => n2963, Z => n3001);
   U1146 : ND2 port map( A => flag_op_1, B => n2870, Z => n2963);
   U1147 : IVP port map( A => n2951, Z => n2969);
   U1148 : ND2 port map( A => n2815, B => n2813, Z => n2951);
   U1149 : ND3 port map( A => n2813, B => n2814, C => state_1, Z => n3261);
   U1150 : IVP port map( A => n2876, Z => n2948);
   U1151 : ND3 port map( A => n3003, B => n2816, C => n2872, Z => n2873);
   U1152 : ND2 port map( A => n2872, B => n2951, Z => n3030);
   U1153 : IVP port map( A => n2874, Z => n2872);
   U1154 : MUX21P port map( A => n3031, B => n3033, S => step_2, Z => n3113);
   U1155 : AN4P port map( A => step_0, B => step_1, C => n3032, D => n2895, Z 
                           => n3031);
   U1156 : MUX21P port map( A => n3035, B => n2974, S => step_1, Z => n3114);
   U1157 : AN3P port map( A => n3032, B => step_0, C => n2895, Z => n3035);
   U1158 : IVP port map( A => n2974, Z => n3034);
   U1159 : ND2 port map( A => n3032, B => n2817, Z => n3036);
   U1160 : IVP port map( A => n2949, Z => n3032);
   U1161 : MUX21P port map( A => din(7), B => data_in_7, S => n3037, Z => n3116
                           );
   U1162 : MUX21P port map( A => din(6), B => data_in_6, S => n3037, Z => n3117
                           );
   U1163 : MUX21P port map( A => din(5), B => data_in_5, S => n3037, Z => n3118
                           );
   U1164 : MUX21P port map( A => din(4), B => data_in_4, S => n3037, Z => n3119
                           );
   U1165 : MUX21P port map( A => din(3), B => data_in_3, S => n3037, Z => n3120
                           );
   U1166 : MUX21P port map( A => din(2), B => data_in_2, S => n3037, Z => n3121
                           );
   U1167 : MUX21P port map( A => din(1), B => data_in_1, S => n3037, Z => n3122
                           );
   U1168 : MUX21P port map( A => din(0), B => data_in_0, S => n3037, Z => n3123
                           );
   U1169 : IVP port map( A => n3096, Z => n3037);
   U1170 : MUX21P port map( A => net509, B => n2815, S => n2976, Z => n2853);
   U1171 : MUX21P port map( A => net510, B => state_0, S => n2976, Z => n2852);
   U1172 : MUX21P port map( A => net511, B => state_0, S => n2976, Z => n2851);
   U1173 : MUX21P port map( A => opcode_reg_1, B => n3038, S => n2976, Z => 
                           n3130);
   U1174 : ND2 port map( A => n3003, B => n2810, Z => n3038);
   U1175 : MUX21P port map( A => opcode_reg_0, B => n3039, S => n2976, Z => 
                           n3131);
   U1176 : ND2 port map( A => n3003, B => n2811, Z => n3039);
   U1177 : IVP port map( A => n2973, Z => n3003);
   U1178 : IVP port map( A => n2850, Z => n2976);
   U1179 : ND2 port map( A => n2975, B => n2895, Z => n2850);
   U1180 : ND2 port map( A => n2897, B => n2898, Z => n3132);
   U1181 : ND2 port map( A => n2899, B => n2900, Z => n3133);
   U1182 : ND2 port map( A => n2901, B => n2902, Z => n3134);
   U1183 : ND2 port map( A => n2903, B => n2904, Z => n3135);
   U1184 : ND2 port map( A => n2905, B => n2906, Z => n3136);
   U1185 : ND2 port map( A => n2907, B => n2908, Z => n3137);
   U1186 : ND2 port map( A => n2909, B => n2910, Z => n3138);
   U1187 : ND2 port map( A => n2911, B => n2912, Z => n3139);
   U1188 : ND2 port map( A => n2913, B => n2914, Z => n3140);
   U1189 : ND2 port map( A => n2915, B => n2916, Z => n3141);
   U1190 : ND2 port map( A => n2917, B => n2918, Z => n3142);
   U1191 : ND2 port map( A => n2919, B => n2920, Z => n3143);
   U1192 : ND2 port map( A => n2921, B => n2922, Z => n3144);
   U1193 : ND2 port map( A => n2923, B => n2924, Z => n3145);
   U1194 : ND2 port map( A => n2925, B => n2926, Z => n3146);
   U1195 : ND2 port map( A => n2927, B => n2928, Z => n3147);
   U1196 : IVP port map( A => n2979, Z => n3063);
   U1197 : IVP port map( A => n2981, Z => n3064);
   U1198 : MUX21P port map( A => n3040, B => dout_7, S => halt, Z => n2931);
   U1199 : MUX21P port map( A => n3041, B => dout_6, S => halt, Z => n2933);
   U1200 : MUX21P port map( A => n3042, B => dout_5, S => halt, Z => n2945);
   U1201 : MUX21P port map( A => n3044, B => dout_4, S => halt, Z => n2935);
   U1202 : MUX21P port map( A => n3045, B => dout_3, S => halt, Z => n2937);
   U1203 : MUX21P port map( A => n3046, B => dout_2, S => halt, Z => n2939);
   U1204 : MUX21P port map( A => n3047, B => dout_1, S => halt, Z => n2941);
   U1205 : IVP port map( A => n2986, Z => n2929);
   U1206 : ND4 port map( A => dout_op_2, B => n3296, C => n2895, D => n3260, Z 
                           => n2986);
   U1207 : IVP port map( A => dout_op_1, Z => n3296);
   U1208 : IVP port map( A => n2985, Z => n3065);
   U1209 : MUX21P port map( A => n3048, B => dout_0, S => halt, Z => n2943);
   U1210 : MUX21P port map( A => addr_out_high985_7, B => addr_pin_15, S => 
                           halt, Z => n3156);
   U1211 : MUX21P port map( A => addr_out_high985_6, B => addr_pin_14, S => 
                           halt, Z => n3157);
   U1212 : MUX21P port map( A => addr_out_high985_5, B => addr_pin_13, S => 
                           halt, Z => n3158);
   U1213 : MUX21P port map( A => addr_out_high985_4, B => addr_pin_12, S => 
                           halt, Z => n3159);
   U1214 : MUX21P port map( A => addr_out_high985_3, B => addr_pin_11, S => 
                           halt, Z => n3160);
   U1215 : MUX21P port map( A => addr_out_high985_2, B => addr_pin_10, S => 
                           halt, Z => n3161);
   U1216 : MUX21P port map( A => addr_out_high985_1, B => addr_pin_9, S => halt
                           , Z => n3162);
   U1217 : MUX21P port map( A => addr_out_high985_0, B => addr_pin_8, S => halt
                           , Z => n3163);
   U1218 : MUX21P port map( A => addr_out_low987_7, B => addr_pin_7, S => halt,
                           Z => n3164);
   U1219 : MUX21P port map( A => addr_out_low987_6, B => addr_pin_6, S => halt,
                           Z => n3165);
   U1220 : MUX21P port map( A => addr_out_low987_5, B => addr_pin_5, S => halt,
                           Z => n3166);
   U1221 : MUX21P port map( A => addr_out_low987_4, B => addr_pin_4, S => halt,
                           Z => n3167);
   U1222 : MUX21P port map( A => addr_out_low987_3, B => addr_pin_3, S => halt,
                           Z => n3168);
   U1223 : MUX21P port map( A => addr_out_low987_2, B => addr_pin_2, S => halt,
                           Z => n3169);
   U1224 : MUX21P port map( A => addr_out_low987_1, B => addr_pin_1, S => halt,
                           Z => n3170);
   U1225 : MUX21P port map( A => addr_out_low987_0, B => addr_pin_0, S => halt,
                           Z => n3171);
   U1226 : MUX21P port map( A => dint1_7, B => data_in_7, S => n2838, Z => 
                           n3172);
   U1227 : MUX21P port map( A => dint1_6, B => data_in_6, S => n2838, Z => 
                           n3173);
   U1228 : MUX21P port map( A => dint1_5, B => data_in_5, S => n2838, Z => 
                           n3174);
   U1229 : MUX21P port map( A => dint1_4, B => data_in_4, S => n2838, Z => 
                           n3175);
   U1230 : MUX21P port map( A => dint1_3, B => data_in_3, S => n2838, Z => 
                           n3176);
   U1231 : MUX21P port map( A => dint1_2, B => data_in_2, S => n2838, Z => 
                           n3177);
   U1232 : MUX21P port map( A => dint1_1, B => data_in_1, S => n2838, Z => 
                           n3178);
   U1233 : MUX21P port map( A => dint1_0, B => data_in_0, S => n2838, Z => 
                           n3179);
   U1234 : MUX21P port map( A => dint2_7, B => data_in_7, S => n2839, Z => 
                           n3180);
   U1235 : MUX21P port map( A => dint2_6, B => data_in_6, S => n2839, Z => 
                           n3181);
   U1236 : MUX21P port map( A => dint2_5, B => data_in_5, S => n2839, Z => 
                           n3182);
   U1237 : MUX21P port map( A => dint2_4, B => data_in_4, S => n2839, Z => 
                           n3183);
   U1238 : MUX21P port map( A => dint2_3, B => data_in_3, S => n2839, Z => 
                           n3184);
   U1239 : MUX21P port map( A => dint2_2, B => data_in_2, S => n2839, Z => 
                           n3185);
   U1240 : MUX21P port map( A => dint2_1, B => data_in_1, S => n2839, Z => 
                           n3186);
   U1241 : MUX21P port map( A => dint2_0, B => data_in_0, S => n2839, Z => 
                           n3187);
   U1242 : MUX21P port map( A => dint3_7, B => n3026, S => n2840, Z => n3188);
   U1243 : MUX21P port map( A => dint3_6, B => n3023, S => n2840, Z => n3189);
   U1244 : MUX21P port map( A => dint3_5, B => n3020, S => n2840, Z => n3190);
   U1245 : MUX21P port map( A => dint3_4, B => n3017, S => n2840, Z => n3191);
   U1246 : MUX21P port map( A => dint3_3, B => n3014, S => n2840, Z => n3192);
   U1247 : MUX21P port map( A => dint3_2, B => n3011, S => n2840, Z => n3193);
   U1248 : MUX21P port map( A => dint3_1, B => n3008, S => n2840, Z => n3194);
   U1249 : MUX21P port map( A => dint3_0, B => n3004, S => n2840, Z => n3195);
   U1250 : ND2 port map( A => n2854, B => n2997, Z => n2860);
   U1251 : IVP port map( A => n2998, Z => n2854);
   U1252 : IVP port map( A => n2860, Z => n3092);
   U1253 : MUX21P port map( A => reg_a_out_7, B => n3026, S => n2843, Z => 
                           n3204);
   U1254 : MUX21P port map( A => reg_a_out_6, B => n3023, S => n2843, Z => 
                           n3205);
   U1255 : MUX21P port map( A => reg_a_out_5, B => n3020, S => n2843, Z => 
                           n3206);
   U1256 : MUX21P port map( A => reg_a_out_4, B => n3017, S => n2843, Z => 
                           n3207);
   U1257 : MUX21P port map( A => reg_a_out_3, B => n3014, S => n2843, Z => 
                           n3208);
   U1258 : MUX21P port map( A => reg_a_out_2, B => n3011, S => n2843, Z => 
                           n3209);
   U1259 : MUX21P port map( A => reg_a_out_1, B => n3008, S => n2843, Z => 
                           n3210);
   U1260 : MUX21P port map( A => reg_a_out_0, B => n3004, S => n2843, Z => 
                           n3211);
   U1261 : MUX21P port map( A => reg_x_out_7, B => n3026, S => n2844, Z => 
                           n3212);
   U1262 : MUX21P port map( A => reg_x_out_6, B => n3023, S => n2844, Z => 
                           n3213);
   U1263 : MUX21P port map( A => reg_x_out_5, B => n3020, S => n2844, Z => 
                           n3214);
   U1264 : MUX21P port map( A => reg_x_out_4, B => n3017, S => n2844, Z => 
                           n3215);
   U1265 : MUX21P port map( A => reg_x_out_3, B => n3014, S => n2844, Z => 
                           n3216);
   U1266 : MUX21P port map( A => reg_x_out_2, B => n3011, S => n2844, Z => 
                           n3217);
   U1267 : MUX21P port map( A => reg_x_out_1, B => n3008, S => n2844, Z => 
                           n3218);
   U1268 : MUX21P port map( A => reg_x_out_0, B => n3004, S => n2844, Z => 
                           n3219);
   U1269 : MUX21P port map( A => reg_y_out_5, B => n3020, S => n2845, Z => 
                           n3222);
   U1270 : MUX21P port map( A => n3051, B => reg_sr_out_6, S => n2953, Z => 
                           n3228);
   U1271 : MUX21P port map( A => nmi_in, B => nmi_reg1, S => halt, Z => n3229);
   U1272 : MUX21P port map( A => irq_in, B => irq_reg, S => halt, Z => n3230);
   U1273 : IVP port map( A => flag_op_0, Z => n3265);
   U1274 : ND2 port map( A => flag_op_0, B => n2895, Z => n2868);
   U1275 : ND2 port map( A => n2965, B => n3000, Z => n2869);
   U1276 : IVP port map( A => flag_op_2, Z => n2870);
   U1277 : MUX21P port map( A => n2821, B => n3252, S => n3095, Z => n2871);
   U1278 : IVP port map( A => n2869, Z => n2955);
   U1279 : MUX21P port map( A => n3052, B => reg_sr_out_7, S => n3053, Z => 
                           n3233);
   U1280 : MUX21P port map( A => n3026, B => data_in_7, S => flag_op_3, Z => 
                           n3052);
   U1281 : IVP port map( A => n2873, Z => n2875);
   U1282 : MUX21P port map( A => n3054, B => we_pin_port, S => halt, Z => n3235
                           );
   U1283 : ND2 port map( A => n3259, B => n3260, Z => n3054);
   U1284 : IVP port map( A => n2987, Z => n3259);
   U1285 : IVP port map( A => dout_op_0, Z => n3260);
   U1286 : ND2 port map( A => n2877, B => n2878, Z => n3236);
   U1287 : MUX21P port map( A => n3108, B => net620, S => halt, Z => n2877);
   U1288 : MUX21P port map( A => n3055, B => reg_sr_out_1, S => n3053, Z => 
                           n3237);
   U1289 : IVP port map( A => n3026, Z => n3056);
   U1290 : IVP port map( A => flag_op_3, Z => n3000);
   U1291 : IVP port map( A => n3104, Z => n3053);
   U1292 : MUX21P port map( A => nmi_reg1, B => nmi_reg2, S => halt, Z => n3238
                           );
   U1293 : MUX21P port map( A => n3062, B => reg_sr_out_0, S => n2964, Z => 
                           n3239);
   U1294 : MUX21P port map( A => n3059, B => n3061, S => flag_op_3, Z => n3062)
                           ;
   U1295 : IVP port map( A => n2868, Z => n2966);
   U1296 : ND2 port map( A => n2846, B => n2895, Z => n2865);
   U1297 : IVP port map( A => n3002, Z => n3094);
   U1298 : IVP port map( A => flag_op_1, Z => n2965);
   U1299 : IVP port map( A => n2865, Z => n3095);
   U1300 : IVP port map( A => n2896, Z => n3242);
   U1301 : ND2 port map( A => n_741, B => n2895, Z => n2878);
   U1302 : IVP port map( A => n3261, Z => n_741);
   U1303 : IVP port map( A => reset, Z => n3109);
   U1304 : IVP port map( A => data_in_6, Z => n3249);
   U1305 : IVP port map( A => data_in_5, Z => n3253);
   U1306 : IVP port map( A => data_in_4, Z => n3252);
   U1307 : IVP port map( A => data_in_2, Z => n3256);
   U1308 : IVP port map( A => dint1_1, Z => n3306);
   U1309 : IVP port map( A => dint1_0, Z => n3304);
   U1310 : IVP port map( A => dint3_7, Z => n2988);
   U1311 : IVP port map( A => dint3_6, Z => n2989);
   U1312 : IVP port map( A => dint3_4, Z => n2990);
   U1313 : IVP port map( A => dint3_3, Z => n2991);
   U1314 : IVP port map( A => dint3_2, Z => n2992);
   U1315 : IVP port map( A => dint3_1, Z => n2993);
   U1316 : IVP port map( A => dint3_0, Z => n2994);
   U1317 : IVP port map( A => reg_a_out_7, Z => n3255);
   U1318 : IVP port map( A => reg_a_out_6, Z => n3251);
   U1319 : IVP port map( A => reg_a_out_4, Z => n2885);
   U1320 : IVP port map( A => reg_a_out_3, Z => n2882);
   U1321 : IVP port map( A => reg_a_out_2, Z => n2891);
   U1322 : IVP port map( A => reg_a_out_1, Z => n2888);
   U1323 : IVP port map( A => reg_a_out_0, Z => n2893);
   U1324 : IVP port map( A => reg_x_out_7, Z => n3254);
   U1325 : IVP port map( A => reg_x_out_6, Z => n3247);
   U1326 : IVP port map( A => reg_x_out_4, Z => n2884);
   U1327 : IVP port map( A => reg_x_out_3, Z => n2881);
   U1328 : IVP port map( A => reg_x_out_2, Z => n2890);
   U1329 : IVP port map( A => reg_x_out_1, Z => n2887);
   U1330 : IVP port map( A => reg_x_out_0, Z => n2894);
   U1331 : IVP port map( A => nmi_reg2, Z => n2970);
   U1332 : AN2 port map( A => n2802, B => addr_op_1, Z => n2797);
   U1333 : AN2 port map( A => n2800, B => n3409, Z => n2798);
   U1334 : AN4 port map( A => n3312, B => n3313, C => n3316, D => n3317, Z => 
                           n2799);
   U1335 : AN2 port map( A => addr_op_2, B => n3313, Z => n2800);
   U1336 : AN3 port map( A => n3277, B => n3278, C => alu_op_1, Z => n2801);
   U1337 : AN3 port map( A => addr_op_2, B => addr_op_0, C => n3322, Z => n2802
                           );
   U1338 : AN2 port map( A => n3269, B => n3302, Z => n2803);
   U1339 : IVP port map( A => n3273, Z => n3337);
   U1340 : AN3 port map( A => n3269, B => pc_op_1, C => n3303, Z => n2828);
   U1341 : AO2 port map( A => n3412, B => data_in_2, C => reg_sp_out_2, D => 
                           n3411, Z => n2829);
   U1342 : ND2 port map( A => alu2_1, B => n3276, Z => n3275);
   U1343 : IVP port map( A => n3275, Z => n3411);
   U1344 : AO2 port map( A => n3412, B => data_in_3, C => reg_sp_out_3, D => 
                           n3411, Z => n2830);
   U1345 : AO2 port map( A => n3412, B => data_in_1, C => reg_sp_out_1, D => 
                           n3411, Z => n2831);
   U1346 : ND2 port map( A => n3277, B => n3280, Z => n3287);
   U1347 : IVP port map( A => n3287, Z => n3292);
   U1348 : AN3 port map( A => n3265, B => flag_op_2, C => n2895, Z => n2832);
   U1349 : AN3 port map( A => n2984, B => n2895, C => dout_op_1, Z => n2833);
   U1350 : AN2 port map( A => n2854, B => n2999, Z => n2834);
   U1351 : AN2 port map( A => n2833, B => dout_op_0, Z => n2835);
   U1352 : AN2 port map( A => n2837, B => state_0, Z => n2836);
   U1353 : AN2 port map( A => n2976, B => state_2, Z => n2837);
   U1354 : AN2 port map( A => dint1_op, B => n2895, Z => n2838);
   U1355 : AN2 port map( A => dint2_op, B => n2895, Z => n2839);
   U1356 : AN2 port map( A => dint3_op, B => n2895, Z => n2840);
   U1357 : AO2 port map( A => n3412, B => data_in_6, C => reg_sp_out_6, D => 
                           n3411, Z => n2841);
   U1358 : AO2 port map( A => n3412, B => data_in_5, C => reg_sp_out_5, D => 
                           n3411, Z => n2842);
   U1359 : AN2 port map( A => a_le, B => n2895, Z => n2843);
   U1360 : AN2 port map( A => x_le, B => n2895, Z => n2844);
   U1361 : AN2 port map( A => y_le, B => n2895, Z => n2845);
   U1362 : AN3 port map( A => flag_op_3, B => flag_op_0, C => n3001, Z => n2846
                           );
   U1363 : IVP port map( A => sp_op_1, Z => n2856);
   U1364 : IVP port map( A => halt, Z => n2895);
   U1365 : ND2 port map( A => n2978, B => n2895, Z => n2977);
   U1366 : ND2 port map( A => n3285, B => n3280, Z => n3284);
   U1367 : BF1T1 port map( A => n3244, Z => n2847);
   U1368 : MUX21P port map( A => n3054, B => dout_oe_port, S => halt, Z => 
                           n3244);
   U1369 : BF1T1 port map( A => n3240, Z => n2848);
   U1370 : BF1T1 port map( A => n3234, Z => n2849);
   U1371 : EO port map( A => add_649_plus_plus_carry_7, B => L1249_15, Z => 
                           addr_out_high985_7);
   U1372 : AN2 port map( A => L1249_14, B => add_649_plus_plus_carry_6, Z => 
                           add_649_plus_plus_carry_7);
   U1373 : EO port map( A => L1249_14, B => add_649_plus_plus_carry_6, Z => 
                           addr_out_high985_6);
   U1374 : AN2 port map( A => L1249_13, B => add_649_plus_plus_carry_5, Z => 
                           add_649_plus_plus_carry_6);
   U1375 : EO port map( A => L1249_13, B => add_649_plus_plus_carry_5, Z => 
                           addr_out_high985_5);
   U1376 : AN2 port map( A => L1249_12, B => add_649_plus_plus_carry_4, Z => 
                           add_649_plus_plus_carry_5);
   U1377 : EO port map( A => L1249_12, B => add_649_plus_plus_carry_4, Z => 
                           addr_out_high985_4);
   U1378 : AN2 port map( A => L1249_11, B => add_649_plus_plus_carry_3, Z => 
                           add_649_plus_plus_carry_4);
   U1379 : EO port map( A => L1249_11, B => add_649_plus_plus_carry_3, Z => 
                           addr_out_high985_3);
   U1380 : AN2 port map( A => L1249_10, B => add_649_plus_plus_carry_2, Z => 
                           add_649_plus_plus_carry_3);
   U1381 : EO port map( A => L1249_10, B => add_649_plus_plus_carry_2, Z => 
                           addr_out_high985_2);
   U1382 : AN2 port map( A => L1249_9, B => add_649_plus_plus_carry_1, Z => 
                           add_649_plus_plus_carry_2);
   U1383 : EO port map( A => L1249_9, B => add_649_plus_plus_carry_1, Z => 
                           addr_out_high985_1);
   U1384 : AN2 port map( A => L1249_8, B => R1251, Z => 
                           add_649_plus_plus_carry_1);
   U1385 : EO port map( A => L1249_8, B => R1251, Z => addr_out_high985_0);
   U1386 : AO2N port map( A => opcode_reg_2, B => n2850, C => n2836, D => 
                           data_in_2, Z => n3129);
   U1387 : AO2N port map( A => opcode_reg_3, B => n2850, C => n2836, D => 
                           data_in_3, Z => n3128);
   U1388 : AO7A port map( A => n2837, B => n3252, C => n2851, Z => n3127);
   U1389 : AO7A port map( A => n2837, B => n3253, C => n2852, Z => n3126);
   U1390 : AO7A port map( A => n2836, B => n3249, C => n2853, Z => n3125);
   U1391 : AO2N port map( A => opcode_reg_7, B => n2850, C => n2836, D => 
                           data_in_7, Z => n3124);
   U1392 : AO7A port map( A => reg_sp_out_1, B => n2854, C => n2855, Z => n3202
                           );
   U1393 : AO7A port map( A => reg_sp_out_2, B => n2854, C => n2857, Z => n3201
                           );
   U1394 : AO7A port map( A => reg_sp_out_3, B => n2854, C => n2858, Z => n3200
                           );
   U1395 : AO7A port map( A => reg_sp_out_4, B => n2854, C => n2859, Z => n3199
                           );
   U1396 : AO7A port map( A => ARG1587_5, B => n2860, C => n2861, Z => n3198);
   U1397 : AO7A port map( A => ARG1587_6, B => n2860, C => n2862, Z => n3197);
   U1398 : AO7A port map( A => ARG1587_7, B => n2860, C => n2863, Z => n3196);
   U1399 : AO7A port map( A => reg_sp_out_0, B => n2854, C => n2864, Z => n3203
                           );
   U1400 : AO3A port map( A => data_in_3, B => n2865, C => n2866, D => n2867, Z
                           => n3231);
   U1401 : AO34 port map( A => n2868, B => n2869, C => n2870, D => n2871, Z => 
                           n3232);
   U1402 : AO7A port map( A => state_1, B => n2872, C => n2873, Z => n3111);
   U1403 : AO2N port map( A => sync_port, B => n2874, C => n2875, D => n2876, Z
                           => n3234);
   U1404 : AO12 port map( A => n3246, B => n2820, C => n3250, D => n2819, E => 
                           n3245, F => n2818, G => n3253, H => n3248, Z => 
                           n2879);
   U1405 : AO12 port map( A => n3246, B => n2881, C => n3250, D => n2882, E => 
                           n3245, F => n2823, G => n2809, H => n3248, Z => 
                           n2880);
   U1406 : AO12 port map( A => n3246, B => n2884, C => n3250, D => n2885, E => 
                           n3245, F => n2822, G => n3252, H => n3248, Z => 
                           n2883);
   U1407 : AO12 port map( A => n3246, B => n2887, C => n3250, D => n2888, E => 
                           n3245, F => n2826, G => n2810, H => n3248, Z => 
                           n2886);
   U1408 : AO12 port map( A => n3246, B => n2890, C => n3250, D => n2891, E => 
                           n3245, F => n2825, G => n3248, H => n3256, Z => 
                           n2889);
   U1409 : AO7A port map( A => alu2_0, B => alu2_1, C => n3413, Z => n3339);
   U1410 : AO12 port map( A => n3248, B => n2811, C => n3250, D => n2893, E => 
                           n3246, F => n2894, G => n3245, H => n2827, Z => 
                           n2892);
   U1411 : AO7A port map( A => first_run, B => n2895, C => n2878, Z => n3240);
   U1412 : AO7A port map( A => fetch_d, B => n2895, C => n2878, Z => n3243);
   U1413 : AO1N port map( A => reg_sr_out_7, B => n2929, C => n2930, D => n2931
                           , Z => n3148);
   U1414 : AO1N port map( A => reg_sr_out_6, B => n2929, C => n2932, D => n2933
                           , Z => n3149);
   U1415 : AO1N port map( A => reg_sr_out_4, B => n2929, C => n2934, D => n2935
                           , Z => n3151);
   U1416 : AO1N port map( A => reg_sr_out_3, B => n2929, C => n2936, D => n2937
                           , Z => n3152);
   U1417 : AO1N port map( A => reg_sr_out_2, B => n2929, C => n2938, D => n2939
                           , Z => n3153);
   U1418 : AO1N port map( A => reg_sr_out_1, B => n2929, C => n2940, D => n2941
                           , Z => n3154);
   U1419 : AO1N port map( A => n2929, B => reg_sr_out_0, C => n2942, D => n2943
                           , Z => n3155);
   U1420 : AO1N port map( A => n2835, B => reg_pc_out_5, C => n2944, D => n2945
                           , Z => n3150);
   U1421 : AO7C port map( A => n3256, B => n2865, C => n2946, Z => n3241);
   U1422 : AO8 port map( A => n2816, B => n2815, C => n2948, D => n2949, Z => 
                           n2947);
   U1423 : AO3N port map( A => state_1, B => n2816, C => n2951, D => n2872, Z 
                           => n2950);
   U1424 : AO7N port map( A => n3269, B => n3270, C => n3271, Z => n2952);
   U1425 : AO29 port map( A => n2870, B => n2895, C => n2954, D => n2955, E => 
                           n2832, Z => n2953);
   U1426 : AO29 port map( A => n2957, B => n2870, C => n2958, D => n2959, E => 
                           data_in_6, Z => n2956);
   U1427 : AO3N port map( A => flag_op_2, B => n3265, C => n2962, D => n2963, Z
                           => n2961);
   U1428 : AO29 port map( A => flag_op_3, B => n2965, C => n2832, D => n2966, E
                           => n2967, Z => n2964);
   U1429 : AO8 port map( A => state_2, B => n2969, C => n2895, D => n2816, Z =>
                           n2968);
   U1430 : MUX21N port map( A => n3422, B => n3267, S => alu_op_1, Z => n2972);
   U1431 : AO7C port map( A => done, B => n2973, C => halt, Z => n2874);
   U1432 : AO7C port map( A => step_0, B => n2949, C => halt, Z => n2974);
   U1433 : AO7A port map( A => n3305, B => n_741, C => n2980, Z => n2979);
   U1434 : AO3A port map( A => n2983, B => n2828, C => n3261, D => n2980, Z => 
                           n2982);
   U1435 : AO7A port map( A => alu_op_1, B => n3279, C => n3286, Z => n2996);
   U1436 : AO7C port map( A => sp_op_1, B => sp_op_0, C => halt, Z => n2998);
   U1437 : AO1CN port map( A => alu_add_0, B => n3005, C => n3007, D => n3006, 
                           Z => n3004);
   U1438 : AO1N port map( A => alu_add_1, B => n3005, C => n3009, D => n3010, Z
                           => n3008);
   U1439 : AO1N port map( A => alu_add_2, B => n3005, C => n3012, D => n3013, Z
                           => n3011);
   U1440 : AO1N port map( A => alu_add_3, B => n3005, C => n3015, D => n3016, Z
                           => n3014);
   U1441 : AO1N port map( A => alu_add_4, B => n3005, C => n3018, D => n3019, Z
                           => n3017);
   U1442 : AO1N port map( A => alu_add_5, B => n3005, C => n3021, D => n3022, Z
                           => n3020);
   U1443 : AO1N port map( A => alu_add_6, B => n3005, C => n3024, D => n3025, Z
                           => n3023);
   U1444 : AO1N port map( A => alu_add_7, B => n3005, C => n3027, D => n3028, Z
                           => n3026);
   U1445 : MUX21N port map( A => n2813, B => n2947, S => n2872, Z => n3110);
   U1446 : MUX21N port map( A => n3030, B => n2950, S => state_2, Z => n3112);
   U1447 : AO7A port map( A => n3032, B => step_1, C => n3034, Z => n3033);
   U1448 : MUX21N port map( A => n3036, B => n2817, S => halt, Z => n3115);
   U1449 : AO12 port map( A => n3254, B => n3298, C => n3255, D => n3299, E => 
                           n2807, F => n3297, G => n2987, H => n2988, Z => 
                           n3040);
   U1450 : AO12 port map( A => n3247, B => n3298, C => n3251, D => n3299, E => 
                           n2808, F => n3297, G => n2987, H => n2989, Z => 
                           n3041);
   U1451 : AO3A port map( A => reg_x_out_5, B => n3298, C => n3390, D => n3043,
                           Z => n3042);
   U1452 : AO12 port map( A => n3298, B => n2884, C => n3299, D => n2885, E => 
                           n3297, F => n2822, G => n2987, H => n2990, Z => 
                           n3044);
   U1453 : AO12 port map( A => n3298, B => n2881, C => n3299, D => n2882, E => 
                           n3297, F => n2823, G => n2987, H => n2991, Z => 
                           n3045);
   U1454 : AO12 port map( A => n3298, B => n2890, C => n3299, D => n2891, E => 
                           n3297, F => n2825, G => n2987, H => n2992, Z => 
                           n3046);
   U1455 : AO12 port map( A => n3298, B => n2887, C => n3299, D => n2888, E => 
                           n3297, F => n2826, G => n2987, H => n2993, Z => 
                           n3047);
   U1456 : AO12 port map( A => n3298, B => n2894, C => n3299, D => n2893, E => 
                           n3297, F => n2827, G => n2987, H => n2994, Z => 
                           n3048);
   U1457 : MUX21X4 port map( A => reg_y_out_7, B => n3026, S => n2845, Z => 
                           n3220);
   U1458 : MUX21X4 port map( A => reg_y_out_6, B => n3023, S => n2845, Z => 
                           n3221);
   U1459 : MUX21X4 port map( A => reg_y_out_4, B => n3017, S => n2845, Z => 
                           n3223);
   U1460 : MUX21X4 port map( A => reg_y_out_3, B => n3014, S => n2845, Z => 
                           n3224);
   U1461 : MUX21X4 port map( A => reg_y_out_2, B => n3011, S => n2845, Z => 
                           n3225);
   U1462 : MUX21X4 port map( A => reg_y_out_1, B => n3008, S => n2845, Z => 
                           n3226);
   U1463 : MUX21X4 port map( A => reg_y_out_0, B => n3004, S => n2845, Z => 
                           n3227);
   U1464 : AO4A port map( A => n2846, B => n3249, C => flag_op_3, D => n2956, Z
                           => n3051);
   U1465 : AO4A port map( A => n3056, B => n3057, C => n2810, D => n3000, Z => 
                           n3055);
   U1466 : AO6A port map( A => n3058, B => n3060, C => flag_op_2, Z => n3059);
   U1467 : AO2A port map( A => n2812, B => n3064, C => pc_inc654_15, D => n3063
                           , Z => n2898);
   U1468 : AO2A port map( A => n2982, B => pc_add656_15, C => reg_pc_out_15, D 
                           => n2977, Z => n2897);
   U1469 : AO2A port map( A => n3249, B => n3064, C => pc_inc654_14, D => n3063
                           , Z => n2900);
   U1470 : AO2A port map( A => n2982, B => pc_add656_14, C => reg_pc_out_14, D 
                           => n2977, Z => n2899);
   U1471 : AO2A port map( A => n3253, B => n3064, C => pc_inc654_13, D => n3063
                           , Z => n2902);
   U1472 : AO2A port map( A => n2982, B => pc_add656_13, C => reg_pc_out_13, D 
                           => n2977, Z => n2901);
   U1473 : AO2A port map( A => n3252, B => n3064, C => pc_inc654_12, D => n3063
                           , Z => n2904);
   U1474 : AO2A port map( A => n2982, B => pc_add656_12, C => reg_pc_out_12, D 
                           => n2977, Z => n2903);
   U1475 : AO2A port map( A => n2809, B => n3064, C => pc_inc654_11, D => n3063
                           , Z => n2906);
   U1476 : AO2A port map( A => n2982, B => pc_add656_11, C => reg_pc_out_11, D 
                           => n2977, Z => n2905);
   U1477 : AO2A port map( A => n3256, B => n3064, C => pc_inc654_10, D => n3063
                           , Z => n2908);
   U1478 : AO2A port map( A => n2982, B => pc_add656_10, C => reg_pc_out_10, D 
                           => n2977, Z => n2907);
   U1479 : AO2A port map( A => n2810, B => n3064, C => pc_inc654_9, D => n3063,
                           Z => n2910);
   U1480 : AO2A port map( A => n2982, B => pc_add656_9, C => reg_pc_out_9, D =>
                           n2977, Z => n2909);
   U1481 : AO2A port map( A => n2811, B => n3064, C => pc_inc654_8, D => n3063,
                           Z => n2912);
   U1482 : AO2A port map( A => n2982, B => pc_add656_8, C => reg_pc_out_8, D =>
                           n2977, Z => n2911);
   U1483 : AO2A port map( A => n2981, B => dint1_7, C => pc_inc654_7, D => 
                           n3063, Z => n2914);
   U1484 : AO2A port map( A => n2982, B => pc_add656_7, C => reg_pc_out_7, D =>
                           n2977, Z => n2913);
   U1485 : AO2A port map( A => n2981, B => dint1_6, C => pc_inc654_6, D => 
                           n3063, Z => n2916);
   U1486 : AO2A port map( A => n2982, B => pc_add656_6, C => reg_pc_out_6, D =>
                           n2977, Z => n2915);
   U1487 : AO2A port map( A => n2981, B => dint1_5, C => pc_inc654_5, D => 
                           n3063, Z => n2918);
   U1488 : AO2A port map( A => n2982, B => pc_add656_5, C => reg_pc_out_5, D =>
                           n2977, Z => n2917);
   U1489 : AO2A port map( A => n2981, B => dint1_4, C => pc_inc654_4, D => 
                           n3063, Z => n2920);
   U1490 : AO2A port map( A => n2982, B => pc_add656_4, C => reg_pc_out_4, D =>
                           n2977, Z => n2919);
   U1491 : AO2A port map( A => n2981, B => dint1_3, C => pc_inc654_3, D => 
                           n3063, Z => n2922);
   U1492 : AO2A port map( A => n2982, B => pc_add656_3, C => reg_pc_out_3, D =>
                           n2977, Z => n2921);
   U1493 : AO2A port map( A => n2981, B => dint1_2, C => pc_inc654_2, D => 
                           n3063, Z => n2924);
   U1494 : AO2A port map( A => n2982, B => pc_add656_2, C => n2977, D => 
                           reg_pc_out_2, Z => n2923);
   U1495 : AO2A port map( A => n3306, B => n3064, C => pc_inc654_1, D => n3063,
                           Z => n2926);
   U1496 : AO2A port map( A => n2982, B => pc_add656_1, C => reg_pc_out_1, D =>
                           n2977, Z => n2925);
   U1497 : AO2A port map( A => n3304, B => n3064, C => pc_inc654_0, D => n3063,
                           Z => n2928);
   U1498 : AO2A port map( A => n2982, B => pc_add656_0, C => reg_pc_out_0, D =>
                           n2977, Z => n2927);
   U1499 : AO2N port map( A => n2835, B => reg_pc_out_7, C => n3065, D => 
                           reg_pc_out_15, Z => n2930);
   U1500 : AO2N port map( A => n2835, B => reg_pc_out_6, C => n3065, D => 
                           reg_pc_out_14, Z => n2932);
   U1501 : AO2A port map( A => n3297, B => reg_y_out_5, C => reg_a_out_5, D => 
                           n3066, Z => n3043);
   U1502 : AO7A port map( A => reg_pc_out_13, B => n2985, C => n2986, Z => 
                           n2944);
   U1503 : AO2N port map( A => n2835, B => reg_pc_out_4, C => n3065, D => 
                           reg_pc_out_12, Z => n2934);
   U1504 : AO2N port map( A => n2835, B => reg_pc_out_3, C => n3065, D => 
                           reg_pc_out_11, Z => n2936);
   U1505 : AO2N port map( A => n2835, B => reg_pc_out_2, C => n3065, D => 
                           reg_pc_out_10, Z => n2938);
   U1506 : AO2N port map( A => n2835, B => reg_pc_out_1, C => n3065, D => 
                           reg_pc_out_9, Z => n2940);
   U1507 : AO2N port map( A => n2835, B => reg_pc_out_0, C => n3065, D => 
                           reg_pc_out_8, Z => n2942);
   U1508 : AO25 port map( A => n3067, B => n3068, C => n3274, D => n3069, E => 
                           n3337, Z => n3028);
   U1509 : AO2A port map( A => n3294, B => reg_sr_out_0, C => n3050, D => n3071
                           , Z => n3070);
   U1510 : AO7A port map( A => alu_in1_6, B => n3072, C => n3070, Z => n3027);
   U1511 : AO17 port map( A => n3073, B => n3069, C => n2841, D => n3074, Z => 
                           n3025);
   U1512 : AO2N port map( A => n3075, B => alu_in1_7, C => n2879, D => n3076, Z
                           => n3024);
   U1513 : AO17 port map( A => n3077, B => n3069, C => n2842, D => n3078, Z => 
                           n3022);
   U1514 : AO2N port map( A => alu_in1_6, B => n3075, C => n2883, D => n3076, Z
                           => n3021);
   U1515 : AO17 port map( A => n3079, B => n3067, C => n3080, D => n3081, Z => 
                           n3019);
   U1516 : AO2N port map( A => n3075, B => n2879, C => n2880, D => n3076, Z => 
                           n3018);
   U1517 : AO17 port map( A => n3082, B => n3069, C => n2830, D => n3083, Z => 
                           n3016);
   U1518 : AO2N port map( A => n2883, B => n3075, C => n2889, D => n3076, Z => 
                           n3015);
   U1519 : AO17 port map( A => n3084, B => n3069, C => n2829, D => n3085, Z => 
                           n3013);
   U1520 : AO2N port map( A => n2880, B => n3075, C => n2886, D => n3076, Z => 
                           n3012);
   U1521 : AO17 port map( A => n3086, B => n3069, C => n2831, D => n3087, Z => 
                           n3010);
   U1522 : AO2N port map( A => n2889, B => n3075, C => n2892, D => n3076, Z => 
                           n3009);
   U1523 : AO17 port map( A => n3088, B => n3069, C => n3089, D => n3090, Z => 
                           n3006);
   U1524 : AO2A port map( A => n3091, B => n2886, C => n2995, D => reg_sr_out_0
                           , Z => n3090);
   U1525 : AO2A port map( A => n3254, B => n2834, C => reg_sp_out_7, D => n2998
                           , Z => n2863);
   U1526 : AO2A port map( A => n3247, B => n2834, C => reg_sp_out_6, D => n2998
                           , Z => n2862);
   U1527 : AO2A port map( A => n2820, B => n2834, C => reg_sp_out_5, D => n2998
                           , Z => n2861);
   U1528 : AO2A port map( A => n2884, B => n2834, C => ARG1587_4, D => n3092, Z
                           => n2859);
   U1529 : AO2A port map( A => n2881, B => n2834, C => ARG1587_3, D => n3092, Z
                           => n2858);
   U1530 : AO2A port map( A => n2890, B => n2834, C => ARG1587_2, D => n3092, Z
                           => n2857);
   U1531 : AO2A port map( A => n2887, B => n2834, C => ARG1587_1, D => n3092, Z
                           => n2855);
   U1532 : AO2A port map( A => n2894, B => n2834, C => ARG1587_0, D => n3092, Z
                           => n2864);
   U1533 : OR8 port map( A => n2846, B => n3004, C => n3008, D => n3011, E => 
                           n3014, F => n3017, G => n3020, H => n3023, Z => 
                           n3057);
   U1534 : AO2A port map( A => n3091, B => n2892, C => n3076, D => alu_in1_7, Z
                           => n3060);
   U1535 : AO25 port map( A => n3094, B => flag_op_0, C => n2824, D => n2965, E
                           => n3093, Z => n2946);
   U1536 : AO7A port map( A => din_le, B => halt, C => n2878, Z => n3096);
   U1537 : AO3C port map( A => n3303, B => n3305, C => n_741, D => n3097, Z => 
                           n2978);
   U1538 : AO34 port map( A => n3280, B => alu_op_3, C => n3281, D => n3293, Z 
                           => n3076);
   U1539 : AO34 port map( A => n3287, B => alu_op_2, C => n3266, D => n3294, Z 
                           => n3075);
   U1540 : AO17 port map( A => n2841, B => n3050, C => n3289, D => alu_in1_6, Z
                           => n3074);
   U1541 : AO17 port map( A => n2842, B => n3050, C => n3289, D => n2879, Z => 
                           n3078);
   U1542 : AO17 port map( A => n3080, B => n3050, C => n2996, D => n3414, Z => 
                           n3081);
   U1543 : AO17 port map( A => n2830, B => n3050, C => n3289, D => n2880, Z => 
                           n3083);
   U1544 : AO17 port map( A => n2829, B => n3050, C => n3289, D => n2889, Z => 
                           n3085);
   U1545 : AO17 port map( A => n2831, B => n3050, C => n3289, D => n2886, Z => 
                           n3087);
   U1546 : AO17 port map( A => n3089, B => n3050, C => n3289, D => n2892, Z => 
                           n3007);
   U1547 : AO35 port map( A => n3098, B => n3265, C => n2869, D => n2965, E => 
                           n3000, Z => n2954);
   U1548 : AO3C port map( A => n2960, B => reg_sr_out_3, C => flag_op_1, D => 
                           flag_op_0, Z => n2867);
   U1549 : AO17 port map( A => flag_op_1, B => n3265, C => n3002, D => 
                           reg_sr_out_3, Z => n2866);
   U1550 : AO35 port map( A => n2961, B => halt, C => flag_op_3, D => n2963, E 
                           => n2868, Z => n3104);
   U1551 : AO17 port map( A => flag_op_2, B => n2965, C => flag_op_3, D => 
                           n2963, Z => n2967);
   U1552 : AO7A port map( A => first_run, B => state_1, C => n2951, Z => n3105)
                           ;
   U1553 : AO28 port map( A => n2970, B => nmi_reg1, C => n2895, D => n2968, Z 
                           => n2896);
   state_reg_0 : FD2 port map( CD => n3109, CP => clk, D => n3110, Q => state_0
                           , QN => n2813);
   state_reg_1 : FD2 port map( CD => n3109, CP => clk, D => n3111, Q => state_1
                           , QN => n2815);
   state_reg_2 : FD2 port map( CD => n3109, CP => clk, D => n3112, Q => state_2
                           , QN => n2814);
   step_reg_2 : FD2 port map( CD => n3109, CP => clk, D => n3113, Q => step_2, 
                           QN => open);
   step_reg_1 : FD2 port map( CD => n3109, CP => clk, D => n3114, Q => step_1, 
                           QN => open);
   step_reg_0 : FD2 port map( CD => n3109, CP => clk, D => n3115, Q => step_0, 
                           QN => n2817);
   data_in_reg_7 : FD2 port map( CD => n3109, CP => clk, D => n3116, Q => 
                           data_in_7, QN => n2812);
   data_in_reg_6 : FD2 port map( CD => n3109, CP => clk, D => n3117, Q => 
                           data_in_6, QN => open);
   data_in_reg_5 : FD2 port map( CD => n3109, CP => clk, D => n3118, Q => 
                           data_in_5, QN => open);
   data_in_reg_4 : FD2 port map( CD => n3109, CP => clk, D => n3119, Q => 
                           data_in_4, QN => open);
   data_in_reg_3 : FD2 port map( CD => n3109, CP => clk, D => n3120, Q => 
                           data_in_3, QN => n2809);
   data_in_reg_2 : FD2 port map( CD => n3109, CP => clk, D => n3121, Q => 
                           data_in_2, QN => open);
   data_in_reg_1 : FD2 port map( CD => n3109, CP => clk, D => n3122, Q => 
                           data_in_1, QN => n2810);
   data_in_reg_0 : FD2 port map( CD => n3109, CP => clk, D => n3123, Q => 
                           data_in_0, QN => n2811);
   opcode_reg_reg_7 : FD2 port map( CD => n3109, CP => clk, D => n3124, Q => 
                           opcode_reg_7, QN => open);
   opcode_reg_reg_6 : FD2 port map( CD => n3109, CP => clk, D => n3125, Q => 
                           opcode_reg_6, QN => net509);
   opcode_reg_reg_5 : FD2 port map( CD => n3109, CP => clk, D => n3126, Q => 
                           opcode_reg_5, QN => net510);
   opcode_reg_reg_4 : FD2 port map( CD => n3109, CP => clk, D => n3127, Q => 
                           opcode_reg_4, QN => net511);
   opcode_reg_reg_3 : FD2 port map( CD => n3109, CP => clk, D => n3128, Q => 
                           opcode_reg_3, QN => open);
   opcode_reg_reg_2 : FD2 port map( CD => n3109, CP => clk, D => n3129, Q => 
                           opcode_reg_2, QN => open);
   opcode_reg_reg_1 : FD2 port map( CD => n3109, CP => clk, D => n3130, Q => 
                           opcode_reg_1, QN => open);
   opcode_reg_reg_0 : FD2 port map( CD => n3109, CP => clk, D => n3131, Q => 
                           opcode_reg_0, QN => open);
   pc_reg_15 : FD2 port map( CD => n3109, CP => clk, D => n3132, Q => 
                           reg_pc_out_15, QN => open);
   pc_reg_14 : FD2 port map( CD => n3109, CP => clk, D => n3133, Q => 
                           reg_pc_out_14, QN => open);
   pc_reg_13 : FD2 port map( CD => n3109, CP => clk, D => n3134, Q => 
                           reg_pc_out_13, QN => open);
   pc_reg_12 : FD2 port map( CD => n3109, CP => clk, D => n3135, Q => 
                           reg_pc_out_12, QN => open);
   pc_reg_11 : FD2 port map( CD => n3109, CP => clk, D => n3136, Q => 
                           reg_pc_out_11, QN => open);
   pc_reg_10 : FD2 port map( CD => n3109, CP => clk, D => n3137, Q => 
                           reg_pc_out_10, QN => open);
   pc_reg_9 : FD2 port map( CD => n3109, CP => clk, D => n3138, Q => 
                           reg_pc_out_9, QN => open);
   pc_reg_8 : FD2 port map( CD => n3109, CP => clk, D => n3139, Q => 
                           reg_pc_out_8, QN => open);
   pc_reg_7 : FD2 port map( CD => n3109, CP => clk, D => n3140, Q => 
                           reg_pc_out_7, QN => open);
   pc_reg_6 : FD2 port map( CD => n3109, CP => clk, D => n3141, Q => 
                           reg_pc_out_6, QN => open);
   pc_reg_5 : FD2 port map( CD => n3109, CP => clk, D => n3142, Q => 
                           reg_pc_out_5, QN => open);
   pc_reg_4 : FD2 port map( CD => n3109, CP => clk, D => n3143, Q => 
                           reg_pc_out_4, QN => open);
   pc_reg_3 : FD2 port map( CD => n3109, CP => clk, D => n3144, Q => 
                           reg_pc_out_3, QN => open);
   pc_reg_2 : FD2 port map( CD => n3109, CP => clk, D => n3145, Q => 
                           reg_pc_out_2, QN => n2804);
   pc_reg_1 : FD2 port map( CD => n3109, CP => clk, D => n3146, Q => 
                           reg_pc_out_1, QN => open);
   pc_reg_0 : FD2 port map( CD => n3109, CP => clk, D => n3147, Q => 
                           reg_pc_out_0, QN => open);
   data_out_reg_7 : FD2 port map( CD => n3109, CP => clk, D => n3148, Q => 
                           dout_7, QN => open);
   data_out_reg_6 : FD2 port map( CD => n3109, CP => clk, D => n3149, Q => 
                           dout_6, QN => open);
   data_out_reg_5 : FD2 port map( CD => n3109, CP => clk, D => n3150, Q => 
                           dout_5, QN => open);
   data_out_reg_4 : FD2 port map( CD => n3109, CP => clk, D => n3151, Q => 
                           dout_4, QN => open);
   data_out_reg_3 : FD2 port map( CD => n3109, CP => clk, D => n3152, Q => 
                           dout_3, QN => open);
   data_out_reg_2 : FD2 port map( CD => n3109, CP => clk, D => n3153, Q => 
                           dout_2, QN => open);
   data_out_reg_1 : FD2 port map( CD => n3109, CP => clk, D => n3154, Q => 
                           dout_1, QN => open);
   data_out_reg_0 : FD2 port map( CD => n3109, CP => clk, D => n3155, Q => 
                           dout_0, QN => open);
   addr_out_reg_15 : FD2 port map( CD => n3109, CP => clk, D => n3156, Q => 
                           addr_pin_15, QN => open);
   addr_out_reg_14 : FD2 port map( CD => n3109, CP => clk, D => n3157, Q => 
                           addr_pin_14, QN => open);
   addr_out_reg_13 : FD2 port map( CD => n3109, CP => clk, D => n3158, Q => 
                           addr_pin_13, QN => open);
   addr_out_reg_12 : FD2 port map( CD => n3109, CP => clk, D => n3159, Q => 
                           addr_pin_12, QN => open);
   addr_out_reg_11 : FD2 port map( CD => n3109, CP => clk, D => n3160, Q => 
                           addr_pin_11, QN => open);
   addr_out_reg_10 : FD2 port map( CD => n3109, CP => clk, D => n3161, Q => 
                           addr_pin_10, QN => open);
   addr_out_reg_9 : FD2 port map( CD => n3109, CP => clk, D => n3162, Q => 
                           addr_pin_9, QN => open);
   addr_out_reg_8 : FD2 port map( CD => n3109, CP => clk, D => n3163, Q => 
                           addr_pin_8, QN => open);
   addr_out_reg_7 : FD2 port map( CD => n3109, CP => clk, D => n3164, Q => 
                           addr_pin_7, QN => open);
   addr_out_reg_6 : FD2 port map( CD => n3109, CP => clk, D => n3165, Q => 
                           addr_pin_6, QN => open);
   addr_out_reg_5 : FD2 port map( CD => n3109, CP => clk, D => n3166, Q => 
                           addr_pin_5, QN => open);
   addr_out_reg_4 : FD2 port map( CD => n3109, CP => clk, D => n3167, Q => 
                           addr_pin_4, QN => open);
   addr_out_reg_3 : FD2 port map( CD => n3109, CP => clk, D => n3168, Q => 
                           addr_pin_3, QN => open);
   addr_out_reg_2 : FD2 port map( CD => n3109, CP => clk, D => n3169, Q => 
                           addr_pin_2, QN => open);
   addr_out_reg_1 : FD2 port map( CD => n3109, CP => clk, D => n3170, Q => 
                           addr_pin_1, QN => open);
   addr_out_reg_0 : FD2 port map( CD => n3109, CP => clk, D => n3171, Q => 
                           addr_pin_0, QN => open);
   dint1_reg_7 : FD2 port map( CD => n3109, CP => clk, D => n3172, Q => dint1_7
                           , QN => open);
   dint1_reg_6 : FD2 port map( CD => n3109, CP => clk, D => n3173, Q => dint1_6
                           , QN => open);
   dint1_reg_5 : FD2 port map( CD => n3109, CP => clk, D => n3174, Q => dint1_5
                           , QN => open);
   dint1_reg_4 : FD2 port map( CD => n3109, CP => clk, D => n3175, Q => dint1_4
                           , QN => open);
   dint1_reg_3 : FD2 port map( CD => n3109, CP => clk, D => n3176, Q => dint1_3
                           , QN => open);
   dint1_reg_2 : FD2 port map( CD => n3109, CP => clk, D => n3177, Q => dint1_2
                           , QN => open);
   dint1_reg_1 : FD2 port map( CD => n3109, CP => clk, D => n3178, Q => dint1_1
                           , QN => open);
   dint1_reg_0 : FD2 port map( CD => n3109, CP => clk, D => n3179, Q => dint1_0
                           , QN => open);
   dint2_reg_7 : FD2 port map( CD => n3109, CP => clk, D => n3180, Q => dint2_7
                           , QN => open);
   dint2_reg_6 : FD2 port map( CD => n3109, CP => clk, D => n3181, Q => dint2_6
                           , QN => open);
   dint2_reg_5 : FD2 port map( CD => n3109, CP => clk, D => n3182, Q => dint2_5
                           , QN => open);
   dint2_reg_4 : FD2 port map( CD => n3109, CP => clk, D => n3183, Q => dint2_4
                           , QN => open);
   dint2_reg_3 : FD2 port map( CD => n3109, CP => clk, D => n3184, Q => dint2_3
                           , QN => open);
   dint2_reg_2 : FD2 port map( CD => n3109, CP => clk, D => n3185, Q => dint2_2
                           , QN => open);
   dint2_reg_1 : FD2 port map( CD => n3109, CP => clk, D => n3186, Q => dint2_1
                           , QN => open);
   dint2_reg_0 : FD2 port map( CD => n3109, CP => clk, D => n3187, Q => dint2_0
                           , QN => open);
   dint3_reg_7 : FD2 port map( CD => n3109, CP => clk, D => n3188, Q => dint3_7
                           , QN => open);
   dint3_reg_6 : FD2 port map( CD => n3109, CP => clk, D => n3189, Q => dint3_6
                           , QN => open);
   dint3_reg_5 : FD2 port map( CD => n3109, CP => clk, D => n3190, Q => dint3_5
                           , QN => open);
   dint3_reg_4 : FD2 port map( CD => n3109, CP => clk, D => n3191, Q => dint3_4
                           , QN => open);
   dint3_reg_3 : FD2 port map( CD => n3109, CP => clk, D => n3192, Q => dint3_3
                           , QN => open);
   dint3_reg_2 : FD2 port map( CD => n3109, CP => clk, D => n3193, Q => dint3_2
                           , QN => open);
   dint3_reg_1 : FD2 port map( CD => n3109, CP => clk, D => n3194, Q => dint3_1
                           , QN => open);
   dint3_reg_0 : FD2 port map( CD => n3109, CP => clk, D => n3195, Q => dint3_0
                           , QN => open);
   sp_reg_7 : FD4 port map( CP => clk, D => n3196, SD => n3109, Q => 
                           reg_sp_out_7, QN => open);
   sp_reg_6 : FD4 port map( CP => clk, D => n3197, SD => n3109, Q => 
                           reg_sp_out_6, QN => open);
   sp_reg_5 : FD4 port map( CP => clk, D => n3198, SD => n3109, Q => 
                           reg_sp_out_5, QN => open);
   sp_reg_4 : FD4 port map( CP => clk, D => n3199, SD => n3109, Q => 
                           reg_sp_out_4, QN => open);
   sp_reg_3 : FD4 port map( CP => clk, D => n3200, SD => n3109, Q => 
                           reg_sp_out_3, QN => open);
   sp_reg_2 : FD4 port map( CP => clk, D => n3201, SD => n3109, Q => 
                           reg_sp_out_2, QN => open);
   sp_reg_1 : FD4 port map( CP => clk, D => n3202, SD => n3109, Q => 
                           reg_sp_out_1, QN => open);
   sp_reg_0 : FD4 port map( CP => clk, D => n3203, SD => n3109, Q => 
                           reg_sp_out_0, QN => n2806);
   a_reg_reg_7 : FD2 port map( CD => n3109, CP => clk, D => n3204, Q => 
                           reg_a_out_7, QN => open);
   a_reg_reg_6 : FD2 port map( CD => n3109, CP => clk, D => n3205, Q => 
                           reg_a_out_6, QN => open);
   a_reg_reg_5 : FD2 port map( CD => n3109, CP => clk, D => n3206, Q => 
                           reg_a_out_5, QN => n2819);
   a_reg_reg_4 : FD2 port map( CD => n3109, CP => clk, D => n3207, Q => 
                           reg_a_out_4, QN => open);
   a_reg_reg_3 : FD2 port map( CD => n3109, CP => clk, D => n3208, Q => 
                           reg_a_out_3, QN => open);
   a_reg_reg_2 : FD2 port map( CD => n3109, CP => clk, D => n3209, Q => 
                           reg_a_out_2, QN => open);
   a_reg_reg_1 : FD2 port map( CD => n3109, CP => clk, D => n3210, Q => 
                           reg_a_out_1, QN => open);
   a_reg_reg_0 : FD2 port map( CD => n3109, CP => clk, D => n3211, Q => 
                           reg_a_out_0, QN => open);
   x_reg_reg_7 : FD2 port map( CD => n3109, CP => clk, D => n3212, Q => 
                           reg_x_out_7, QN => open);
   x_reg_reg_6 : FD2 port map( CD => n3109, CP => clk, D => n3213, Q => 
                           reg_x_out_6, QN => open);
   x_reg_reg_5 : FD2 port map( CD => n3109, CP => clk, D => n3214, Q => 
                           reg_x_out_5, QN => n2820);
   x_reg_reg_4 : FD2 port map( CD => n3109, CP => clk, D => n3215, Q => 
                           reg_x_out_4, QN => open);
   x_reg_reg_3 : FD2 port map( CD => n3109, CP => clk, D => n3216, Q => 
                           reg_x_out_3, QN => open);
   x_reg_reg_2 : FD2 port map( CD => n3109, CP => clk, D => n3217, Q => 
                           reg_x_out_2, QN => open);
   x_reg_reg_1 : FD2 port map( CD => n3109, CP => clk, D => n3218, Q => 
                           reg_x_out_1, QN => open);
   x_reg_reg_0 : FD2 port map( CD => n3109, CP => clk, D => n3219, Q => 
                           reg_x_out_0, QN => open);
   y_reg_reg_7 : FD2 port map( CD => n3109, CP => clk, D => n3220, Q => 
                           reg_y_out_7, QN => n2807);
   y_reg_reg_6 : FD2 port map( CD => n3109, CP => clk, D => n3221, Q => 
                           reg_y_out_6, QN => n2808);
   y_reg_reg_5 : FD2 port map( CD => n3109, CP => clk, D => n3222, Q => 
                           reg_y_out_5, QN => n2818);
   y_reg_reg_4 : FD2 port map( CD => n3109, CP => clk, D => n3223, Q => 
                           reg_y_out_4, QN => n2822);
   y_reg_reg_3 : FD2 port map( CD => n3109, CP => clk, D => n3224, Q => 
                           reg_y_out_3, QN => n2823);
   y_reg_reg_2 : FD2 port map( CD => n3109, CP => clk, D => n3225, Q => 
                           reg_y_out_2, QN => n2825);
   y_reg_reg_1 : FD2 port map( CD => n3109, CP => clk, D => n3226, Q => 
                           reg_y_out_1, QN => n2826);
   y_reg_reg_0 : FD2 port map( CD => n3109, CP => clk, D => n3227, Q => 
                           reg_y_out_0, QN => n2827);
   v_flag_reg : FD2 port map( CD => n3109, CP => clk, D => n3228, Q => 
                           reg_sr_out_6, QN => open);
   nmi_reg1_reg : FD2 port map( CD => n3109, CP => clk, D => n3229, Q => 
                           nmi_reg1, QN => open);
   irq_reg_reg : FD2 port map( CD => n3109, CP => clk, D => n3230, Q => irq_reg
                           , QN => open);
   d_flag_reg : FD2 port map( CD => n3109, CP => clk, D => n3231, Q => 
                           reg_sr_out_3, QN => open);
   b_flag_reg : FD2 port map( CD => n3109, CP => clk, D => n3232, Q => 
                           reg_sr_out_4, QN => n2821);
   n_flag_reg : FD2 port map( CD => n3109, CP => clk, D => n3233, Q => 
                           reg_sr_out_7, QN => open);
   sync_reg : FD2 port map( CD => n3109, CP => clk, D => n2849, Q => sync_port,
                           QN => open);
   we_out_reg : FD2 port map( CD => n3109, CP => clk, D => n3235, Q => 
                           we_pin_port, QN => open);
   rd_pin_reg : FD2 port map( CD => n3109, CP => clk, D => n3236, Q => rd_pin, 
                           QN => net620);
   z_flag_reg : FD4 port map( CP => clk, D => n3237, SD => n3109, Q => 
                           reg_sr_out_1, QN => open);
   nmi_reg2_reg : FD2 port map( CD => n3109, CP => clk, D => n3238, Q => 
                           nmi_reg2, QN => open);
   c_flag_reg : FD2 port map( CD => n3109, CP => clk, D => n3239, Q => 
                           reg_sr_out_0, QN => n2805);
   first_run_reg : FD2 port map( CD => n3109, CP => clk, D => n2848, Q => 
                           first_run, QN => open);
   i_flag_reg : FD4 port map( CP => clk, D => n3241, SD => n3109, Q => 
                           reg_sr_out_2, QN => n2824);
   nmi_event_reg : FD2 port map( CD => n3109, CP => clk, D => n3242, Q => 
                           nmi_event, QN => n2816);
   fetch_d_reg : FD2 port map( CD => n3109, CP => clk, D => n3243, Q => fetch_d
                           , QN => open);
   data_oe_reg : FD2 port map( CD => n3109, CP => clk, D => n2847, Q => 
                           dout_oe_port, QN => open);
   add_426_plus_plus : core_6502_debug_DW01_add_16_0 port map( A(15) => 
                           reg_pc_out_15, A(14) => reg_pc_out_14, A(13) => 
                           reg_pc_out_13, A(12) => reg_pc_out_12, A(11) => 
                           reg_pc_out_11, A(10) => reg_pc_out_10, A(9) => 
                           reg_pc_out_9, A(8) => reg_pc_out_8, A(7) => 
                           reg_pc_out_7, A(6) => reg_pc_out_6, A(5) => 
                           reg_pc_out_5, A(4) => reg_pc_out_4, A(3) => 
                           reg_pc_out_3, A(2) => reg_pc_out_2, A(1) => 
                           reg_pc_out_1, A(0) => reg_pc_out_0, B(15) => 
                           data_in_7, B(14) => data_in_7, B(13) => data_in_7, 
                           B(12) => data_in_7, B(11) => data_in_7, B(10) => 
                           data_in_7, B(9) => data_in_7, B(8) => data_in_7, 
                           B(7) => data_in_7, B(6) => data_in_6, B(5) => 
                           data_in_5, B(4) => data_in_4, B(3) => data_in_3, 
                           B(2) => data_in_2, B(1) => data_in_1, B(0) => 
                           data_in_0, CI => n3427, SUM(15) => pc_add656_15, 
                           SUM(14) => pc_add656_14, SUM(13) => pc_add656_13, 
                           SUM(12) => pc_add656_12, SUM(11) => pc_add656_11, 
                           SUM(10) => pc_add656_10, SUM(9) => pc_add656_9, 
                           SUM(8) => pc_add656_8, SUM(7) => pc_add656_7, SUM(6)
                           => pc_add656_6, SUM(5) => pc_add656_5, SUM(4) => 
                           pc_add656_4, SUM(3) => pc_add656_3, SUM(2) => 
                           pc_add656_2, SUM(1) => pc_add656_1, SUM(0) => 
                           pc_add656_0, CO => open);
   add_430_plus_plus : core_6502_debug_DW01_inc_16_0 port map( A(15) => 
                           reg_pc_out_15, A(14) => reg_pc_out_14, A(13) => 
                           reg_pc_out_13, A(12) => reg_pc_out_12, A(11) => 
                           reg_pc_out_11, A(10) => reg_pc_out_10, A(9) => 
                           reg_pc_out_9, A(8) => reg_pc_out_8, A(7) => 
                           reg_pc_out_7, A(6) => reg_pc_out_6, A(5) => 
                           reg_pc_out_5, A(4) => reg_pc_out_4, A(3) => 
                           reg_pc_out_3, A(2) => reg_pc_out_2, A(1) => 
                           reg_pc_out_1, A(0) => reg_pc_out_0, SUM(15) => 
                           pc_inc654_15, SUM(14) => pc_inc654_14, SUM(13) => 
                           pc_inc654_13, SUM(12) => pc_inc654_12, SUM(11) => 
                           pc_inc654_11, SUM(10) => pc_inc654_10, SUM(9) => 
                           pc_inc654_9, SUM(8) => pc_inc654_8, SUM(7) => 
                           pc_inc654_7, SUM(6) => pc_inc654_6, SUM(5) => 
                           pc_inc654_5, SUM(4) => pc_inc654_4, SUM(3) => 
                           pc_inc654_3, SUM(2) => pc_inc654_2, SUM(1) => 
                           pc_inc654_1, SUM(0) => pc_inc654_0);
   add_648_plus_plus_319 : core_6502_debug_DW01_add_9_1 port map( A(8) => 
                           alu_in1_8, A(7) => R1167_1, A(6) => R1167_2, A(5) =>
                           R1167_3, A(4) => R1167_4, A(3) => R1167_5, A(2) => 
                           R1167_6, A(1) => R1167_7, A(0) => R1167_8, B(8) => 
                           alu_in1_8, B(7) => L1165_1, B(6) => L1165_2, B(5) =>
                           L1165_3, B(4) => L1165_4, B(3) => L1165_5, B(2) => 
                           L1165_6, B(1) => L1165_7, B(0) => L1165_8, CI => 
                           addr_add_cin1016, SUM(8) => addr_out_low987_8, 
                           SUM(7) => addr_out_low987_7, SUM(6) => 
                           addr_out_low987_6, SUM(5) => addr_out_low987_5, 
                           SUM(4) => addr_out_low987_4, SUM(3) => 
                           addr_out_low987_3, SUM(2) => addr_out_low987_2, 
                           SUM(1) => addr_out_low987_1, SUM(0) => 
                           addr_out_low987_0, CO => open);
   add_781_plus_plus_442 : core_6502_debug_DW01_add_9_0 port map( A(8) => 
                           alu_in1_8, A(7) => alu_in1_7, A(6) => alu_in1_6, 
                           A(5) => n2879, A(4) => n2883, A(3) => n2880, A(2) =>
                           n2889, A(1) => n2886, A(0) => n2892, B(8) => 
                           alu_add_in2_8, B(7) => alu_add_in2_7, B(6) => 
                           alu_add_in2_6, B(5) => alu_add_in2_5, B(4) => 
                           alu_add_in2_4, B(3) => alu_add_in2_3, B(2) => 
                           alu_add_in2_2, B(1) => alu_add_in2_1, B(0) => 
                           alu_add_in2_0, CI => alu_add_cin, SUM(8) => 
                           alu_add_8, SUM(7) => alu_add_7, SUM(6) => alu_add_6,
                           SUM(5) => alu_add_5, SUM(4) => alu_add_4, SUM(3) => 
                           alu_add_3, SUM(2) => alu_add_2, SUM(1) => alu_add_1,
                           SUM(0) => alu_add_0, CO => open);
   r473 : core_6502_debug_DW01_incdec_8_0 port map( A(7) => reg_sp_out_7, A(6) 
                           => reg_sp_out_6, A(5) => reg_sp_out_5, A(4) => 
                           reg_sp_out_4, A(3) => reg_sp_out_3, A(2) => 
                           reg_sp_out_2, A(1) => reg_sp_out_1, A(0) => 
                           reg_sp_out_0, INC_DEC => n2856, SUM(7) => ARG1587_7,
                           SUM(6) => ARG1587_6, SUM(5) => ARG1587_5, SUM(4) => 
                           ARG1587_4, SUM(3) => ARG1587_3, SUM(2) => ARG1587_2,
                           SUM(1) => ARG1587_1, SUM(0) => ARG1587_0);
   U1554 : AO12 port map( A => n3245, B => n2808, C => n3246, D => n3247, E => 
                           n3248, F => n3249, G => n3250, H => n3251, Z => 
                           alu_in1_6);
   U1555 : AO12 port map( A => n3245, B => n2807, C => n3246, D => n3254, E => 
                           n3248, F => n2812, G => n3250, H => n3255, Z => 
                           alu_in1_7);
   U1556 : AO7N port map( A => n3257, B => n3258, C => addr_out_low987_8, Z => 
                           R1251);
   U1557 : AO6C port map( A => n3262, B => n3263, C => n3264, Z => 
                           addr_add_cin1016);
   U1558 : AO2N port map( A => alu_add_in2_8, B => n3266, C => reg_sr_out_0, D 
                           => n3267, Z => alu_add_cin);
   U1559 : AO2N port map( A => n3268, B => reg_x_out_0, C => n2799, D => 
                           reg_y_out_0, Z => R1167_8);
   U1560 : AO2N port map( A => n3268, B => reg_x_out_1, C => n2799, D => 
                           reg_y_out_1, Z => R1167_7);
   U1561 : AO2N port map( A => n3268, B => reg_x_out_2, C => n2799, D => 
                           reg_y_out_2, Z => R1167_6);
   U1562 : AO2N port map( A => n3268, B => reg_x_out_3, C => n2799, D => 
                           reg_y_out_3, Z => R1167_5);
   U1563 : AO2N port map( A => n3268, B => reg_x_out_4, C => n2799, D => 
                           reg_y_out_4, Z => R1167_4);
   U1564 : AO2N port map( A => n3268, B => reg_x_out_5, C => n2799, D => 
                           reg_y_out_5, Z => R1167_3);
   U1565 : AO2N port map( A => n3268, B => reg_x_out_6, C => n2799, D => 
                           reg_y_out_6, Z => R1167_2);
   U1566 : AO2N port map( A => n3268, B => reg_x_out_7, C => n2799, D => 
                           reg_y_out_7, Z => R1167_1);
   U1567 : AO3A port map( A => n3319, B => n2798, C => n3307, D => n3317, Z => 
                           n3318);
   U1568 : AO35 port map( A => n3336, B => addr_op_3, C => n3323, D => n3312, E
                           => n3330, Z => n3335);
   U1569 : MUX21X4 port map( A => opcode_reg_7, B => data_in_7, S => fetch_d, Z
                           => opcode_7);
   U1570 : MUX21X4 port map( A => opcode_reg_3, B => data_in_3, S => fetch_d, Z
                           => opcode_3);
   U1571 : MUX21X4 port map( A => opcode_reg_2, B => data_in_2, S => fetch_d, Z
                           => opcode_2);
   U1572 : MUX21X4 port map( A => opcode_reg_1, B => data_in_1, S => fetch_d, Z
                           => opcode_1);
   U1573 : MUX21X4 port map( A => opcode_reg_0, B => data_in_0, S => fetch_d, Z
                           => opcode_0);
   U1574 : AO1N port map( A => data_in_0, B => n3370, C => n3371, D => n3372, Z
                           => n3369);
   U1575 : AO3C port map( A => n3374, B => n3306, C => n3375, D => n3376, Z => 
                           n3373);
   U1576 : AO3A port map( A => dint1_2, B => n3374, C => n3378, D => n3379, Z 
                           => n3377);
   U1577 : AO1N port map( A => data_in_3, B => n3370, C => n3331, D => n3381, Z
                           => n3380);
   U1578 : AO1N port map( A => data_in_4, B => n3370, C => n3331, D => n3383, Z
                           => n3382);
   U1579 : AO1N port map( A => data_in_5, B => n3370, C => n3331, D => n3385, Z
                           => n3384);
   U1580 : AO1N port map( A => data_in_6, B => n3370, C => n3331, D => n3387, Z
                           => n3386);
   U1581 : AO1N port map( A => data_in_7, B => n3370, C => n3331, D => n3389, Z
                           => n3388);
   U1582 : AO2A port map( A => n3303, B => n3391, C => n2828, D => n2805, Z => 
                           n3271);
   U1583 : AO8 port map( A => n3314, B => n3313, C => n3393, D => n_741, Z => 
                           n3262);
   U1584 : AO1N port map( A => n3314, B => n3309, C => n3396, D => n3394, Z => 
                           n3258);
   U1585 : AO8 port map( A => n3397, B => addr_op_4, C => n2800, D => n3398, Z 
                           => n3327);
   U1586 : AO2A port map( A => n3328, B => dint2_1, C => reg_pc_out_9, D => 
                           n3399, Z => n3346);
   U1587 : AO2A port map( A => n2810, B => n3335, C => n2797, D => 
                           stack_page(1), Z => n3345);
   U1588 : AO2A port map( A => n3328, B => dint2_0, C => reg_pc_out_8, D => 
                           n3399, Z => n3350);
   U1589 : AO2A port map( A => n2811, B => n3335, C => stack_page(0), D => 
                           n2797, Z => n3349);
   U1590 : AO2A port map( A => n3328, B => dint2_7, C => reg_pc_out_15, D => 
                           n3399, Z => n3353);
   U1591 : AO2A port map( A => n2812, B => n3335, C => stack_page(7), D => 
                           n2797, Z => n3352);
   U1592 : AO2A port map( A => n3328, B => dint2_6, C => reg_pc_out_14, D => 
                           n3399, Z => n3356);
   U1593 : AO2A port map( A => n3249, B => n3335, C => stack_page(6), D => 
                           n2797, Z => n3355);
   U1594 : AO2A port map( A => n3328, B => dint2_5, C => reg_pc_out_13, D => 
                           n3399, Z => n3359);
   U1595 : AO2A port map( A => n3253, B => n3335, C => stack_page(5), D => 
                           n2797, Z => n3358);
   U1596 : AO2A port map( A => n3328, B => dint2_4, C => reg_pc_out_12, D => 
                           n3399, Z => n3362);
   U1597 : AO2A port map( A => n3252, B => n3335, C => stack_page(4), D => 
                           n2797, Z => n3361);
   U1598 : AO2A port map( A => n3328, B => dint2_3, C => reg_pc_out_11, D => 
                           n3399, Z => n3365);
   U1599 : AO2A port map( A => n2809, B => n3335, C => stack_page(3), D => 
                           n2797, Z => n3364);
   U1600 : AO2A port map( A => n3328, B => dint2_2, C => reg_pc_out_10, D => 
                           n3399, Z => n3368);
   U1601 : AO2A port map( A => n3256, B => n3335, C => stack_page(2), D => 
                           n2797, Z => n3367);
   U1602 : AO3C port map( A => n3374, B => n3304, C => n3400, D => n3401, Z => 
                           n3372);
   U1603 : AO2N port map( A => n2797, B => reg_sp_out_0, C => reg_pc_out_0, D 
                           => n3399, Z => n3371);
   U1604 : AO2N port map( A => reg_pc_out_1, B => n3399, C => n2797, D => 
                           reg_sp_out_1, Z => n3375);
   U1605 : AO6A port map( A => n2810, B => n3370, C => n3324, Z => n3376);
   U1606 : AO6C port map( A => data_in_2, B => n3370, C => n3402, Z => n3379);
   U1607 : AO2A port map( A => n2804, B => n3399, C => n2797, D => reg_sp_out_2
                           , Z => n3402);
   U1608 : AO2N port map( A => reg_pc_out_3, B => n3399, C => n2797, D => 
                           reg_sp_out_3, Z => n3403);
   U1609 : AO6N port map( A => dint1_3, B => n3404, C => n3403, Z => n3381);
   U1610 : AO2N port map( A => reg_pc_out_4, B => n3399, C => n2797, D => 
                           reg_sp_out_4, Z => n3405);
   U1611 : AO6N port map( A => dint1_4, B => n3404, C => n3405, Z => n3383);
   U1612 : AO2N port map( A => reg_pc_out_5, B => n3399, C => n2797, D => 
                           reg_sp_out_5, Z => n3406);
   U1613 : AO6N port map( A => dint1_5, B => n3404, C => n3406, Z => n3385);
   U1614 : AO2N port map( A => reg_pc_out_6, B => n3399, C => n2797, D => 
                           reg_sp_out_6, Z => n3407);
   U1615 : AO6N port map( A => dint1_6, B => n3404, C => n3407, Z => n3387);
   U1616 : AO2N port map( A => reg_pc_out_7, B => n3399, C => n2797, D => 
                           reg_sp_out_7, Z => n3408);
   U1617 : AO6N port map( A => dint1_7, B => n3404, C => n3408, Z => n3389);
   U1618 : AO2N port map( A => data_in_4, B => n3412, C => reg_sp_out_4, D => 
                           n3411, Z => n3414);
   U1619 : AO2N port map( A => data_in_7, B => n3412, C => reg_sp_out_7, D => 
                           n3411, Z => n3273);
   U1620 : AO2N port map( A => reg_sr_out_0, B => n3269, C => reg_sr_out_7, D 
                           => n3302, Z => n3391);
   U1621 : AO7A port map( A => addr_op_3, B => addr_op_0, C => n3320, Z => 
                           n3415);
   U1622 : AO17 port map( A => n3392, B => n3415, C => n2798, D => n3307, Z => 
                           n3263);
   U1623 : AO7A port map( A => addr_op_2, B => addr_op_4, C => n3308, Z => 
                           n3395);
   U1624 : AO7A port map( A => addr_op_0, B => addr_op_1, C => n3315, Z => 
                           n3329);
   U1625 : AO25 port map( A => n3313, B => n3416, C => n3307, D => addr_op_1, E
                           => n3330, Z => n3399);
   U1626 : AO7A port map( A => n3410, B => n3310, C => n3418, Z => n3370);
   U1627 : AO3A port map( A => n3419, B => n3321, C => n3328, D => n3417, Z => 
                           n3404);
   U1628 : MUX21N port map( A => n3343, B => n3308, S => addr_op_0, Z => n3316)
                           ;
   n3427 <= '0';

end SYN_core_6502_arch_debug;

library IEEE,MTC45000,MTC45100X,LIB_GENERATORS,STVLIB;

use IEEE.std_logic_1164.all;
use IEEE.std_logic_arith.all;
use MTC45000.VCOMPONENTS.all;
use MTC45100X.VCOMPONENTS.all;
use LIB_GENERATORS.PCK_GENERATORS.all;
use STVLIB.ST_TIMING.all;
use STVLIB.ST_VSS.all;

entity core_6502 is

   port( clk, reset, irq_in, nmi_in : in std_logic;  addr_pin : out 
         std_logic_vector (15 downto 0);  din : in std_logic_vector (7 downto 
         0);  dout : out std_logic_vector (7 downto 0);  dout_oe, we_pin, 
         rd_pin, sync : out std_logic;  halt : in std_logic);

end core_6502;

architecture SYN_arch_core_6502 of core_6502 is

   component core_6502_debug
      port( clk, reset, irq_in, nmi_in : in std_logic;  addr_pin : out 
            std_logic_vector (15 downto 0);  din : in std_logic_vector (7 
            downto 0);  dout : out std_logic_vector (7 downto 0);  dout_oe, 
            we_pin, rd_pin, sync : out std_logic;  halt : in std_logic;  
            stack_page : in std_logic_vector (7 downto 0);  reg_a_out, 
            reg_x_out, reg_y_out, reg_sr_out, reg_sp_out : out std_logic_vector
            (7 downto 0);  reg_pc_out : out std_logic_vector (15 downto 0));
   end component;
   
   signal stack_page_7, stack_page_0 : std_logic;

begin
   
   stack_page_7 <= '0';
   stack_page_0 <= '1';
   U6502 : core_6502_debug port map( clk => clk, reset => reset, irq_in => 
                           irq_in, nmi_in => nmi_in, addr_pin(15) => 
                           addr_pin(15), addr_pin(14) => addr_pin(14), 
                           addr_pin(13) => addr_pin(13), addr_pin(12) => 
                           addr_pin(12), addr_pin(11) => addr_pin(11), 
                           addr_pin(10) => addr_pin(10), addr_pin(9) => 
                           addr_pin(9), addr_pin(8) => addr_pin(8), addr_pin(7)
                           => addr_pin(7), addr_pin(6) => addr_pin(6), 
                           addr_pin(5) => addr_pin(5), addr_pin(4) => 
                           addr_pin(4), addr_pin(3) => addr_pin(3), addr_pin(2)
                           => addr_pin(2), addr_pin(1) => addr_pin(1), 
                           addr_pin(0) => addr_pin(0), din(7) => din(7), din(6)
                           => din(6), din(5) => din(5), din(4) => din(4), 
                           din(3) => din(3), din(2) => din(2), din(1) => din(1)
                           , din(0) => din(0), dout(7) => dout(7), dout(6) => 
                           dout(6), dout(5) => dout(5), dout(4) => dout(4), 
                           dout(3) => dout(3), dout(2) => dout(2), dout(1) => 
                           dout(1), dout(0) => dout(0), dout_oe => dout_oe, 
                           we_pin => we_pin, rd_pin => rd_pin, sync => sync, 
                           halt => halt, stack_page(7) => stack_page_7, 
                           stack_page(6) => stack_page_7, stack_page(5) => 
                           stack_page_7, stack_page(4) => stack_page_7, 
                           stack_page(3) => stack_page_7, stack_page(2) => 
                           stack_page_7, stack_page(1) => stack_page_7, 
                           stack_page(0) => stack_page_0, reg_a_out => open, 
                           reg_x_out => open, reg_y_out => open, reg_sr_out => 
                           open, reg_sp_out => open, reg_pc_out => open);

end SYN_arch_core_6502;

library IEEE,MTC45000,MTC45100X,LIB_GENERATORS,STVLIB;

use IEEE.std_logic_1164.all;
use IEEE.std_logic_arith.all;
use MTC45000.VCOMPONENTS.all;
use MTC45100X.VCOMPONENTS.all;
use LIB_GENERATORS.PCK_GENERATORS.all;
use STVLIB.ST_TIMING.all;
use STVLIB.ST_VSS.all;

entity clock_MASTER_CLOCK12000000_DW01_inc_8_2 is

   port( A : in std_logic_vector (7 downto 0);  SUM : out std_logic_vector (7 
         downto 0));

end clock_MASTER_CLOCK12000000_DW01_inc_8_2;

architecture SYN_rpl of clock_MASTER_CLOCK12000000_DW01_inc_8_2 is

   component EN
      port( A, B : in std_logic;  Z : out std_logic);
   end component;
   
   component IVP
      port( A : in std_logic;  Z : out std_logic);
   end component;
   
   component HA01D1
      port( A, B : in std_logic;  CO, S : out std_logic);
   end component;
   
   signal carry_6, carry_7, carry_2, carry_5, carry_4, carry_3, n19 : std_logic
      ;

begin
   
   U5 : EN port map( A => n19, B => A(7), Z => SUM(7));
   U6 : IVP port map( A => carry_7, Z => n19);
   U7 : IVP port map( A => A(0), Z => SUM(0));
   U1_1_3 : HA01D1 port map( A => A(3), B => carry_3, CO => carry_4, S => 
                           SUM(3));
   U1_1_4 : HA01D1 port map( A => A(4), B => carry_4, CO => carry_5, S => 
                           SUM(4));
   U1_1_1 : HA01D1 port map( A => A(1), B => A(0), CO => carry_2, S => SUM(1));
   U1_1_2 : HA01D1 port map( A => A(2), B => carry_2, CO => carry_3, S => 
                           SUM(2));
   U1_1_5 : HA01D1 port map( A => A(5), B => carry_5, CO => carry_6, S => 
                           SUM(5));
   U1_1_6 : HA01D1 port map( A => A(6), B => carry_6, CO => carry_7, S => 
                           SUM(6));

end SYN_rpl;

library IEEE,MTC45000,MTC45100X,LIB_GENERATORS,STVLIB;

use IEEE.std_logic_1164.all;
use IEEE.std_logic_arith.all;
use MTC45000.VCOMPONENTS.all;
use MTC45100X.VCOMPONENTS.all;
use LIB_GENERATORS.PCK_GENERATORS.all;
use STVLIB.ST_TIMING.all;
use STVLIB.ST_VSS.all;

entity clock_MASTER_CLOCK12000000_DW01_incdec_24_0 is

   port( A : in std_logic_vector (23 downto 0);  INC_DEC : in std_logic;  SUM :
         out std_logic_vector (23 downto 0));

end clock_MASTER_CLOCK12000000_DW01_incdec_24_0;

architecture SYN_rpl of clock_MASTER_CLOCK12000000_DW01_incdec_24_0 is

   component EN
      port( A, B : in std_logic;  Z : out std_logic);
   end component;
   
   component OR2
      port( A, B : in std_logic;  Z : out std_logic);
   end component;
   
   component IV
      port( A : in std_logic;  Z : out std_logic);
   end component;
   
   signal carry_20, carry_15, carry_8, carry_21, carry_14, carry_13, carry_12, 
      carry_7, carry_6, carry_9, carry_2, carry_23, carry_16, carry_18, 
      carry_22, carry_19, carry_11, carry_5, carry_17, carry_10, carry_4, 
      carry_3 : std_logic;

begin
   
   U6 : EN port map( A => carry_23, B => A(23), Z => SUM(23));
   U7 : OR2 port map( A => A(22), B => carry_22, Z => carry_23);
   U8 : EN port map( A => carry_22, B => A(22), Z => SUM(22));
   U9 : OR2 port map( A => A(21), B => carry_21, Z => carry_22);
   U10 : EN port map( A => carry_21, B => A(21), Z => SUM(21));
   U11 : OR2 port map( A => A(20), B => carry_20, Z => carry_21);
   U12 : EN port map( A => carry_20, B => A(20), Z => SUM(20));
   U13 : OR2 port map( A => A(19), B => carry_19, Z => carry_20);
   U14 : EN port map( A => carry_19, B => A(19), Z => SUM(19));
   U15 : OR2 port map( A => A(18), B => carry_18, Z => carry_19);
   U16 : EN port map( A => carry_18, B => A(18), Z => SUM(18));
   U17 : OR2 port map( A => A(17), B => carry_17, Z => carry_18);
   U18 : EN port map( A => carry_17, B => A(17), Z => SUM(17));
   U19 : OR2 port map( A => A(16), B => carry_16, Z => carry_17);
   U20 : EN port map( A => carry_16, B => A(16), Z => SUM(16));
   U21 : OR2 port map( A => A(15), B => carry_15, Z => carry_16);
   U22 : EN port map( A => carry_15, B => A(15), Z => SUM(15));
   U23 : OR2 port map( A => A(14), B => carry_14, Z => carry_15);
   U24 : EN port map( A => carry_14, B => A(14), Z => SUM(14));
   U25 : OR2 port map( A => A(13), B => carry_13, Z => carry_14);
   U26 : EN port map( A => carry_13, B => A(13), Z => SUM(13));
   U27 : OR2 port map( A => A(12), B => carry_12, Z => carry_13);
   U28 : EN port map( A => carry_12, B => A(12), Z => SUM(12));
   U29 : OR2 port map( A => A(11), B => carry_11, Z => carry_12);
   U30 : EN port map( A => carry_11, B => A(11), Z => SUM(11));
   U31 : OR2 port map( A => A(10), B => carry_10, Z => carry_11);
   U32 : EN port map( A => carry_10, B => A(10), Z => SUM(10));
   U33 : OR2 port map( A => A(9), B => carry_9, Z => carry_10);
   U34 : EN port map( A => carry_9, B => A(9), Z => SUM(9));
   U35 : OR2 port map( A => A(8), B => carry_8, Z => carry_9);
   U36 : EN port map( A => carry_8, B => A(8), Z => SUM(8));
   U37 : OR2 port map( A => A(7), B => carry_7, Z => carry_8);
   U38 : EN port map( A => carry_7, B => A(7), Z => SUM(7));
   U39 : OR2 port map( A => A(6), B => carry_6, Z => carry_7);
   U40 : EN port map( A => carry_6, B => A(6), Z => SUM(6));
   U41 : OR2 port map( A => A(5), B => carry_5, Z => carry_6);
   U42 : EN port map( A => carry_5, B => A(5), Z => SUM(5));
   U43 : OR2 port map( A => A(4), B => carry_4, Z => carry_5);
   U44 : EN port map( A => carry_4, B => A(4), Z => SUM(4));
   U45 : OR2 port map( A => A(3), B => carry_3, Z => carry_4);
   U46 : EN port map( A => carry_3, B => A(3), Z => SUM(3));
   U47 : OR2 port map( A => A(2), B => carry_2, Z => carry_3);
   U48 : EN port map( A => carry_2, B => A(2), Z => SUM(2));
   U49 : OR2 port map( A => A(1), B => A(0), Z => carry_2);
   U50 : EN port map( A => A(0), B => A(1), Z => SUM(1));
   U51 : IV port map( A => A(0), Z => SUM(0));

end SYN_rpl;

library IEEE,MTC45000,MTC45100X,LIB_GENERATORS,STVLIB;

use IEEE.std_logic_1164.all;
use IEEE.std_logic_arith.all;
use MTC45000.VCOMPONENTS.all;
use MTC45100X.VCOMPONENTS.all;
use LIB_GENERATORS.PCK_GENERATORS.all;
use STVLIB.ST_TIMING.all;
use STVLIB.ST_VSS.all;

entity clock_MASTER_CLOCK12000000_DW01_inc_8_1 is

   port( A : in std_logic_vector (7 downto 0);  SUM : out std_logic_vector (7 
         downto 0));

end clock_MASTER_CLOCK12000000_DW01_inc_8_1;

architecture SYN_rpl of clock_MASTER_CLOCK12000000_DW01_inc_8_1 is

   component EN
      port( A, B : in std_logic;  Z : out std_logic);
   end component;
   
   component IVP
      port( A : in std_logic;  Z : out std_logic);
   end component;
   
   component HA01D1
      port( A, B : in std_logic;  CO, S : out std_logic);
   end component;
   
   signal carry_6, carry_7, carry_2, carry_5, carry_4, carry_3, n20 : std_logic
      ;

begin
   
   U5 : EN port map( A => n20, B => A(7), Z => SUM(7));
   U6 : IVP port map( A => carry_7, Z => n20);
   U7 : IVP port map( A => A(0), Z => SUM(0));
   U1_1_3 : HA01D1 port map( A => A(3), B => carry_3, CO => carry_4, S => 
                           SUM(3));
   U1_1_4 : HA01D1 port map( A => A(4), B => carry_4, CO => carry_5, S => 
                           SUM(4));
   U1_1_1 : HA01D1 port map( A => A(1), B => A(0), CO => carry_2, S => SUM(1));
   U1_1_2 : HA01D1 port map( A => A(2), B => carry_2, CO => carry_3, S => 
                           SUM(2));
   U1_1_5 : HA01D1 port map( A => A(5), B => carry_5, CO => carry_6, S => 
                           SUM(5));
   U1_1_6 : HA01D1 port map( A => A(6), B => carry_6, CO => carry_7, S => 
                           SUM(6));

end SYN_rpl;

library IEEE,MTC45000,MTC45100X,LIB_GENERATORS,STVLIB;

use IEEE.std_logic_1164.all;
use IEEE.std_logic_arith.all;
use MTC45000.VCOMPONENTS.all;
use MTC45100X.VCOMPONENTS.all;
use LIB_GENERATORS.PCK_GENERATORS.all;
use STVLIB.ST_TIMING.all;
use STVLIB.ST_VSS.all;

entity clock_MASTER_CLOCK12000000_DW01_inc_8_0 is

   port( A : in std_logic_vector (7 downto 0);  SUM : out std_logic_vector (7 
         downto 0));

end clock_MASTER_CLOCK12000000_DW01_inc_8_0;

architecture SYN_rpl of clock_MASTER_CLOCK12000000_DW01_inc_8_0 is

   component EN
      port( A, B : in std_logic;  Z : out std_logic);
   end component;
   
   component IVP
      port( A : in std_logic;  Z : out std_logic);
   end component;
   
   component HA01D1
      port( A, B : in std_logic;  CO, S : out std_logic);
   end component;
   
   signal carry_6, carry_7, carry_2, carry_5, carry_4, carry_3, n21 : std_logic
      ;

begin
   
   U5 : EN port map( A => n21, B => A(7), Z => SUM(7));
   U6 : IVP port map( A => carry_7, Z => n21);
   U7 : IVP port map( A => A(0), Z => SUM(0));
   U1_1_3 : HA01D1 port map( A => A(3), B => carry_3, CO => carry_4, S => 
                           SUM(3));
   U1_1_4 : HA01D1 port map( A => A(4), B => carry_4, CO => carry_5, S => 
                           SUM(4));
   U1_1_1 : HA01D1 port map( A => A(1), B => A(0), CO => carry_2, S => SUM(1));
   U1_1_2 : HA01D1 port map( A => A(2), B => carry_2, CO => carry_3, S => 
                           SUM(2));
   U1_1_5 : HA01D1 port map( A => A(5), B => carry_5, CO => carry_6, S => 
                           SUM(5));
   U1_1_6 : HA01D1 port map( A => A(6), B => carry_6, CO => carry_7, S => 
                           SUM(6));

end SYN_rpl;

library IEEE,MTC45000,MTC45100X,LIB_GENERATORS,STVLIB;

use IEEE.std_logic_1164.all;
use IEEE.std_logic_arith.all;
use MTC45000.VCOMPONENTS.all;
use MTC45100X.VCOMPONENTS.all;
use LIB_GENERATORS.PCK_GENERATORS.all;
use STVLIB.ST_TIMING.all;
use STVLIB.ST_VSS.all;

entity clock_MASTER_CLOCK12000000 is

   port( clk, rst, zero, read, hold : in std_logic;  seconds, minutes, hours : 
         out std_logic_vector (7 downto 0));

end clock_MASTER_CLOCK12000000;

architecture SYN_mrfnord of clock_MASTER_CLOCK12000000 is

   component ND2
      port( A, B : in std_logic;  Z : out std_logic);
   end component;
   
   component ND4
      port( A, B, C, D : in std_logic;  Z : out std_logic);
   end component;
   
   component AN3P
      port( A, B, C : in std_logic;  Z : out std_logic);
   end component;
   
   component IVP
      port( A : in std_logic;  Z : out std_logic);
   end component;
   
   component ND2A
      port( A, B : in std_logic;  Z : out std_logic);
   end component;
   
   component ND3
      port( A, B, C : in std_logic;  Z : out std_logic);
   end component;
   
   component NR2
      port( A, B : in std_logic;  Z : out std_logic);
   end component;
   
   component MUX21P
      port( A, B, S : in std_logic;  Z : out std_logic);
   end component;
   
   component FD1Q
      port( CP, D : in std_logic;  Q : out std_logic);
   end component;
   
   component AN2
      port( A, B : in std_logic;  Z : out std_logic);
   end component;
   
   component BF1T1
      port( A : in std_logic;  Z : out std_logic);
   end component;
   
   component EO
      port( A, B : in std_logic;  Z : out std_logic);
   end component;
   
   component OR2
      port( A, B : in std_logic;  Z : out std_logic);
   end component;
   
   component EN
      port( A, B : in std_logic;  Z : out std_logic);
   end component;
   
   component FD1QX4
      port( CP, D : in std_logic;  Q : out std_logic);
   end component;
   
   component FD1P
      port( CP, D : in std_logic;  Q, QN : out std_logic);
   end component;
   
   component FD1SP
      port( CP, D, TE, TI : in std_logic;  Q, QN : out std_logic);
   end component;
   
   component clock_MASTER_CLOCK12000000_DW01_inc_8_2
      port( A : in std_logic_vector (7 downto 0);  SUM : out std_logic_vector 
            (7 downto 0));
   end component;
   
   component clock_MASTER_CLOCK12000000_DW01_incdec_24_0
      port( A : in std_logic_vector (23 downto 0);  INC_DEC : in std_logic;  
            SUM : out std_logic_vector (23 downto 0));
   end component;
   
   component clock_MASTER_CLOCK12000000_DW01_inc_8_1
      port( A : in std_logic_vector (7 downto 0);  SUM : out std_logic_vector 
            (7 downto 0));
   end component;
   
   component clock_MASTER_CLOCK12000000_DW01_inc_8_0
      port( A : in std_logic_vector (7 downto 0);  SUM : out std_logic_vector 
            (7 downto 0));
   end component;
   
   component AO2N
      port( A, B, C, D : in std_logic;  Z : out std_logic);
   end component;
   
   component AO7A
      port( A, B, C : in std_logic;  Z : out std_logic);
   end component;
   
   component MUX21N
      port( A, B, S : in std_logic;  Z : out std_logic);
   end component;
   
   component AO17
      port( A, B, C, D : in std_logic;  Z : out std_logic);
   end component;
   
   component OR8
      port( A, B, C, D, E, F, G, H : in std_logic;  Z : out std_logic);
   end component;
   
   component AO34
      port( A, B, C, D : in std_logic;  Z : out std_logic);
   end component;
   
   component AO1N
      port( A, B, C, D : in std_logic;  Z : out std_logic);
   end component;
   
   component OR6
      port( A, B, C, D, E, F : in std_logic;  Z : out std_logic);
   end component;
   
   component OR7
      port( A, B, C, D, E, F, G : in std_logic;  Z : out std_logic);
   end component;
   
   component AO2A
      port( A, B, C, D : in std_logic;  Z : out std_logic);
   end component;
   
   signal mr_reg2_MR_COUNTINGFACTOR_23, mr_reg2_MR_COUNTINGFACTOR_18, 
      mr_reg2_MR_COUNTINGFACTOR_11, states31_OUT_HOURS_0, states31_MINUTES_6, 
      ARG546_2, ARG804_5, states160_HOURS_6, ARG718_6, mr_reg_OUT_SECONDS_0, 
      mr_reg_HOURS_0, states31_MR_COUNTINGFACTOR_14, 
      mr_reg_MR_COUNTINGFACTOR_11, ARG374_3, mr_reg_OUT_HOURS_6, 
      mr_reg_SECONDS_7, states31_HOURS_5, states31_OUT_MINUTES_1, ARG308_0, 
      ARG632_3, mr_reg_OUT_MINUTES_5, states31_SECONDS_3, 
      mr_reg_MR_COUNTINGFACTOR_18, mr_reg_MR_COUNTINGFACTOR_3, 
      states31_MR_COUNTINGFACTOR_21, states31_OUT_SECONDS_4, ARG308_12, 
      ARG460_0, states147_MINUTES_3, ARG308_9, states31_MR_COUNTINGFACTOR_4, 
      mr_reg_MINUTES_2, mr_reg_STATE_1, states147_MINUTES_4, ARG460_7, 
      mr_reg_MINUTES_5, states31_MR_COUNTINGFACTOR_3, states31_OUT_SECONDS_3, 
      mr_reg_MR_COUNTINGFACTOR_23, ARG308_15, states31_SECONDS_4, 
      mr_reg_MR_COUNTINGFACTOR_4, mr_reg2_MR_COUNTINGFACTOR_16, 
      states31_OUT_MINUTES_6, mr_reg_OUT_MINUTES_2, ARG632_4, ARG308_7, 
      mr_reg2_MR_COUNTINGFACTOR_8, mr_reg_OUT_HOURS_1, ARG374_4, 
      states31_HOURS_2, mr_reg_SECONDS_0, ARG308_20, 
      states31_MR_COUNTINGFACTOR_13, mr_reg_MR_COUNTINGFACTOR_16, 
      mr_reg_HOURS_7, mr_reg_OUT_SECONDS_7, states31_MINUTES_1, ARG718_1, 
      ARG804_2, ARG546_5, states31_OUT_HOURS_7, mr_reg2_MR_COUNTINGFACTOR_17, 
      mr_reg2_MR_COUNTINGFACTOR_9, ARG632_5, mr_reg_OUT_MINUTES_3, 
      states31_SECONDS_5, mr_reg_MR_COUNTINGFACTOR_5, states31_OUT_SECONDS_2, 
      mr_reg_MR_COUNTINGFACTOR_22, ARG308_14, mr_reg_STATE_0, 
      states147_MINUTES_5, ARG460_6, states31_MR_COUNTINGFACTOR_2, 
      mr_reg_MINUTES_4, states31_MINUTES_0, ARG804_3, ARG546_4, 
      states31_OUT_HOURS_6, ARG308_21, states31_MR_COUNTINGFACTOR_12, 
      mr_reg_MR_COUNTINGFACTOR_17, mr_reg_HOURS_6, mr_reg_OUT_SECONDS_6, 
      ARG718_0, mr_reg_OUT_HOURS_0, ARG374_5, states31_HOURS_3, 
      mr_reg_SECONDS_1, states31_OUT_MINUTES_7, ARG308_6, 
      states31_OUT_MINUTES_0, ARG308_1, ARG374_2, mr_reg_OUT_HOURS_7, 
      states31_HOURS_4, mr_reg_SECONDS_6, ARG718_7, mr_reg_OUT_SECONDS_1, 
      mr_reg_HOURS_1, states31_MR_COUNTINGFACTOR_15, 
      mr_reg_MR_COUNTINGFACTOR_10, states31_OUT_HOURS_1, states31_MINUTES_7, 
      ARG804_4, ARG546_3, states160_HOURS_7, states147_MINUTES_2, ARG308_8, 
      states31_MR_COUNTINGFACTOR_5, mr_reg_MINUTES_3, 
      states31_MR_COUNTINGFACTOR_20, states31_OUT_SECONDS_5, ARG308_13, 
      states31_SECONDS_2, mr_reg_MR_COUNTINGFACTOR_19, 
      mr_reg_MR_COUNTINGFACTOR_2, mr_reg_OUT_MINUTES_4, ARG632_2, 
      mr_reg2_MR_COUNTINGFACTOR_21, mr_reg2_MR_COUNTINGFACTOR_20, 
      mr_reg2_MR_COUNTINGFACTOR_12, states160_HOURS_5, states31_MINUTES_5, 
      ARG804_6, ARG546_1, states31_OUT_HOURS_3, states31_MR_COUNTINGFACTOR_17, 
      mr_reg_MR_COUNTINGFACTOR_12, ARG718_5, mr_reg_MR_COUNTINGFACTOR_9, 
      mr_reg_HOURS_3, mr_reg_OUT_SECONDS_3, mr_reg_SECONDS_4, states31_HOURS_6,
      ARG308_18, mr_reg_OUT_HOURS_5, states31_OUT_MINUTES_2, ARG308_3, 
      mr_reg_OUT_MINUTES_6, ARG632_0, states31_STATE_0, 
      mr_reg_MR_COUNTINGFACTOR_0, states31_SECONDS_0, ARG308_11, 
      states31_OUT_SECONDS_7, states31_MR_COUNTINGFACTOR_22, 
      states31_MR_COUNTINGFACTOR_7, mr_reg_MINUTES_1, ARG460_3, 
      mr_reg_MINUTES_6, states31_MR_COUNTINGFACTOR_0, mr_reg_STATE_2, ARG460_4,
      states147_MINUTES_7, ARG308_16, mr_reg_MR_COUNTINGFACTOR_20, 
      states31_OUT_SECONDS_0, states31_MR_COUNTINGFACTOR_19, 
      mr_reg_MR_COUNTINGFACTOR_7, states31_SECONDS_7, ARG632_7, 
      mr_reg_OUT_MINUTES_1, states31_MR_COUNTINGFACTOR_9, 
      states31_OUT_MINUTES_5, ARG308_4, states31_HOURS_1, mr_reg_SECONDS_3, 
      ARG374_7, mr_reg_OUT_HOURS_2, mr_reg_OUT_SECONDS_4, mr_reg_HOURS_4, 
      ARG718_2, mr_reg_MR_COUNTINGFACTOR_15, states31_MR_COUNTINGFACTOR_10, 
      ARG308_23, states160_HOURS_2, states31_OUT_HOURS_4, states31_MINUTES_2, 
      ARG546_6, mr_reg_OUT_MINUTES_0, ARG632_6, states31_MR_COUNTINGFACTOR_18, 
      mr_reg_MR_COUNTINGFACTOR_6, states31_SECONDS_6, ARG308_17, 
      mr_reg_MR_COUNTINGFACTOR_21, states31_OUT_SECONDS_1, 
      states31_MR_COUNTINGFACTOR_1, mr_reg_MINUTES_7, ARG460_5, 
      states147_MINUTES_6, states160_HOURS_3, states31_MINUTES_3, 
      states31_OUT_HOURS_5, ARG804_0, ARG546_7, mr_reg_OUT_SECONDS_5, 
      mr_reg_HOURS_5, ARG718_3, mr_reg_MR_COUNTINGFACTOR_14, 
      states31_MR_COUNTINGFACTOR_11, ARG308_22, states31_HOURS_0, 
      mr_reg_SECONDS_2, ARG374_6, mr_reg_OUT_HOURS_3, 
      states31_MR_COUNTINGFACTOR_8, states31_OUT_MINUTES_4, ARG308_5, 
      states31_OUT_MINUTES_3, ARG308_2, states31_HOURS_7, mr_reg_SECONDS_5, 
      ARG308_19, mr_reg_OUT_HOURS_4, states31_MR_COUNTINGFACTOR_16, 
      mr_reg_MR_COUNTINGFACTOR_13, ARG718_4, mr_reg_MR_COUNTINGFACTOR_8, 
      mr_reg_HOURS_2, mr_reg_OUT_SECONDS_2, states160_HOURS_4, 
      states31_MINUTES_4, ARG546_0, ARG804_7, states31_OUT_HOURS_2, 
      states31_MR_COUNTINGFACTOR_6, mr_reg_MINUTES_0, ARG460_2, ARG308_10, 
      states31_OUT_SECONDS_6, states31_MR_COUNTINGFACTOR_23, 
      mr_reg_MR_COUNTINGFACTOR_1, states31_SECONDS_1, mr_reg_OUT_MINUTES_7, 
      states31_STATE_1, n1742, n1743, n1744, n1745, n1746, n1747, n1748, n1749,
      n1750, n1751, n1752, n1753, n1754, n1755, n1756, n1757, n1758, n1759, 
      n1760, n1761, n1762, n1763, n1764, n1765, n1766, n1767, n1768, n1769, 
      n1770, n1771, n1772, n1773, n1774, n1775, n1776, n2016, n2017, n2018, 
      n2019, n2020, n2021, n2022, n2023, n2024, n2025, n2026, n2027, n2028, 
      n2029, n2030, add_114_plus_plus_carry_7, add_114_plus_plus_carry_6, 
      add_114_plus_plus_carry_2, add_114_plus_plus_carry_5, 
      add_114_plus_plus_carry_4, add_114_plus_plus_carry_3, 
      add_107_plus_plus_carry_7, add_107_plus_plus_carry_6, 
      add_107_plus_plus_carry_2, add_107_plus_plus_carry_5, 
      add_107_plus_plus_carry_4, add_107_plus_plus_carry_3, 
      add_100_plus_plus_carry_7, add_100_plus_plus_carry_6, 
      add_100_plus_plus_carry_2, add_100_plus_plus_carry_5, 
      add_100_plus_plus_carry_4, add_100_plus_plus_carry_3, n2031, n2032, n2033
      , n2034, n2035, n2036, n2037, n2038, n2039, n2040, n2041, n2042, n2043, 
      n2044, n2045, n2046, n2047, n2048, n2049, n2050, n2051, n2052, n2053, 
      n2054, n2055, n2056, n2057, n2058, n2059, n2060, n2061, n2062, n2063, 
      n2064, n2065, n2066, n2067, n2068, n2069, n2070, n2071, n2072, n2073, 
      n2074, n2075, n2076, n2077, n2078, n2079, n2080, n2081, n2082, n2083, 
      n2084, n2085, n2086, n2087, n2088, n2089, n2090, n2091, n2092, n2093, 
      n2094, n2095, n2096, n2097, n2098, n2099, n2100, n2101, n2102, n2103, 
      n2104, n2105, n2106, n2107, n2108, n2109, n2110, n2111, n2112, n2113, 
      n2114, n2115, n2116, n2117, n2118, n2119, n2120, n2121, n2122, n2123, 
      n2124, n2125, n2126, n2127, n2128, n2129, n2130, n2131, n2132, n2133, 
      n2134, n2135, n2136, n2137, n2138, n2139, n2140, n2141, n2142, n2143 : 
      std_logic;

begin
   seconds <= ( states31_OUT_SECONDS_7, states31_OUT_SECONDS_6, 
      states31_OUT_SECONDS_5, states31_OUT_SECONDS_4, states31_OUT_SECONDS_3, 
      states31_OUT_SECONDS_2, states31_OUT_SECONDS_1, states31_OUT_SECONDS_0 );
   minutes <= ( states31_OUT_MINUTES_7, states31_OUT_MINUTES_6, 
      states31_OUT_MINUTES_5, states31_OUT_MINUTES_4, states31_OUT_MINUTES_3, 
      states31_OUT_MINUTES_2, states31_OUT_MINUTES_1, states31_OUT_MINUTES_0 );
   hours <= ( states31_OUT_HOURS_7, states31_OUT_HOURS_6, states31_OUT_HOURS_5,
      states31_OUT_HOURS_4, states31_OUT_HOURS_3, states31_OUT_HOURS_2, 
      states31_OUT_HOURS_1, states31_OUT_HOURS_0 );
   
   U149 : ND2 port map( A => n2104, B => n2102, Z => n2126);
   U150 : ND4 port map( A => add_114_plus_plus_carry_2, B => states160_HOURS_3,
                           C => n2094, D => n2093, Z => n2135);
   U151 : AN3P port map( A => n2138, B => ARG804_5, C => ARG804_6, Z => n2137);
   U152 : ND4 port map( A => add_107_plus_plus_carry_2, B => 
                           states147_MINUTES_3, C => n2086, D => n2085, Z => 
                           n2130);
   U153 : ND4 port map( A => n2134, B => ARG632_5, C => ARG632_6, D => n2133, Z
                           => n2132);
   U154 : IVP port map( A => n2132, Z => n2142);
   U155 : ND4 port map( A => add_100_plus_plus_carry_2, B => n2119, C => n2120,
                           D => ARG374_3, Z => n2118);
   U156 : ND4 port map( A => n2124, B => ARG460_5, C => ARG460_6, D => n2123, Z
                           => n2122);
   U157 : IVP port map( A => n2122, Z => n2141);
   U158 : ND2A port map( A => mr_reg_MR_COUNTINGFACTOR_8, B => n2033, Z => 
                           mr_reg2_MR_COUNTINGFACTOR_8);
   U159 : ND2A port map( A => mr_reg_MR_COUNTINGFACTOR_9, B => n2033, Z => 
                           mr_reg2_MR_COUNTINGFACTOR_9);
   U160 : ND2A port map( A => mr_reg_MR_COUNTINGFACTOR_12, B => n2033, Z => 
                           mr_reg2_MR_COUNTINGFACTOR_12);
   U161 : ND2A port map( A => mr_reg_MR_COUNTINGFACTOR_18, B => n2033, Z => 
                           mr_reg2_MR_COUNTINGFACTOR_18);
   U162 : ND2A port map( A => mr_reg_MR_COUNTINGFACTOR_21, B => n2033, Z => 
                           mr_reg2_MR_COUNTINGFACTOR_21);
   U163 : ND2A port map( A => mr_reg_MR_COUNTINGFACTOR_17, B => n2033, Z => 
                           mr_reg2_MR_COUNTINGFACTOR_17);
   U164 : ND2A port map( A => mr_reg_MR_COUNTINGFACTOR_16, B => n2033, Z => 
                           mr_reg2_MR_COUNTINGFACTOR_16);
   U165 : ND2A port map( A => mr_reg_MR_COUNTINGFACTOR_20, B => n2033, Z => 
                           mr_reg2_MR_COUNTINGFACTOR_20);
   U166 : ND2A port map( A => mr_reg_MR_COUNTINGFACTOR_11, B => n2033, Z => 
                           mr_reg2_MR_COUNTINGFACTOR_11);
   U167 : ND3 port map( A => states31_STATE_1, B => n2129, C => 
                           states31_STATE_0, Z => n2116);
   U168 : ND2A port map( A => mr_reg_MR_COUNTINGFACTOR_23, B => n2033, Z => 
                           mr_reg2_MR_COUNTINGFACTOR_23);
   U169 : ND3 port map( A => n2101, B => n2102, C => n2084, Z => n2104);
   U170 : NR2 port map( A => read, B => n2080, Z => n2108);
   U171 : ND2A port map( A => zero, B => rst, Z => n2103);
   U172 : MUX21P port map( A => n2128, B => n2127, S => hold, Z => n2140);
   U173 : ND2 port map( A => mr_reg_STATE_1, B => mr_reg_STATE_0, Z => n2082);
   U174 : ND2 port map( A => mr_reg_STATE_1, B => n2084, Z => n2083);
   U175 : IVP port map( A => n2082, Z => n2128);
   U176 : IVP port map( A => n2083, Z => n2127);
   U177 : IVP port map( A => n2125, Z => n2034);
   U178 : IVP port map( A => n2093, Z => ARG804_0);
   U179 : IVP port map( A => n2094, Z => states160_HOURS_2);
   U180 : IVP port map( A => n2095, Z => states160_HOURS_3);
   U181 : IVP port map( A => n2100, Z => states160_HOURS_4);
   U182 : IVP port map( A => ARG804_4, Z => n2138);
   U183 : IVP port map( A => n2099, Z => states160_HOURS_5);
   U184 : IVP port map( A => n2098, Z => states160_HOURS_6);
   U185 : IVP port map( A => n2097, Z => states160_HOURS_7);
   U186 : IVP port map( A => ARG804_7, Z => n2136);
   U187 : IVP port map( A => n2085, Z => ARG632_0);
   U188 : IVP port map( A => n2086, Z => states147_MINUTES_2);
   U189 : IVP port map( A => n2087, Z => states147_MINUTES_3);
   U190 : IVP port map( A => n2092, Z => states147_MINUTES_4);
   U191 : IVP port map( A => ARG632_4, Z => n2134);
   U192 : IVP port map( A => ARG632_5, Z => n2064);
   U193 : IVP port map( A => n2091, Z => states147_MINUTES_5);
   U194 : IVP port map( A => ARG632_6, Z => n2062);
   U195 : IVP port map( A => n2090, Z => states147_MINUTES_6);
   U196 : IVP port map( A => n2089, Z => states147_MINUTES_7);
   U197 : ND3 port map( A => n2117, B => n2131, C => n2132, Z => n2059);
   U198 : IVP port map( A => n2130, Z => n2131);
   U199 : IVP port map( A => ARG632_7, Z => n2133);
   U200 : IVP port map( A => n2059, Z => n2061);
   U201 : IVP port map( A => ARG460_0, Z => n2119);
   U202 : IVP port map( A => ARG374_2, Z => n2120);
   U203 : IVP port map( A => ARG374_3, Z => n2106);
   U204 : IVP port map( A => ARG460_4, Z => n2124);
   U205 : IVP port map( A => ARG460_5, Z => n2052);
   U206 : IVP port map( A => ARG460_6, Z => n2050);
   U207 : ND3 port map( A => n2117, B => n2121, C => n2122, Z => n2047);
   U208 : IVP port map( A => n2118, Z => n2121);
   U209 : IVP port map( A => ARG460_7, Z => n2123);
   U210 : IVP port map( A => n2047, Z => n2049);
   U211 : ND2 port map( A => n2046, B => n2036, Z => 
                           states31_MR_COUNTINGFACTOR_8);
   U212 : ND2 port map( A => n2045, B => n2036, Z => 
                           states31_MR_COUNTINGFACTOR_9);
   U213 : ND2 port map( A => n2044, B => n2036, Z => 
                           states31_MR_COUNTINGFACTOR_11);
   U214 : ND2 port map( A => n2043, B => n2036, Z => 
                           states31_MR_COUNTINGFACTOR_12);
   U215 : ND2 port map( A => n2042, B => n2036, Z => 
                           states31_MR_COUNTINGFACTOR_16);
   U216 : ND2 port map( A => n2041, B => n2036, Z => 
                           states31_MR_COUNTINGFACTOR_17);
   U217 : ND2 port map( A => n2040, B => n2036, Z => 
                           states31_MR_COUNTINGFACTOR_18);
   U218 : ND2 port map( A => n2039, B => n2036, Z => 
                           states31_MR_COUNTINGFACTOR_20);
   U219 : ND2 port map( A => n2038, B => n2036, Z => 
                           states31_MR_COUNTINGFACTOR_21);
   U220 : ND2 port map( A => n2035, B => n2036, Z => 
                           states31_MR_COUNTINGFACTOR_23);
   U221 : IVP port map( A => n2116, Z => n2037);
   U222 : ND2 port map( A => n2115, B => n2116, Z => n2036);
   U223 : IVP port map( A => n2112, Z => n2115);
   U224 : IVP port map( A => n2036, Z => n2117);
   U225 : IVP port map( A => n2110, Z => states31_STATE_0);
   U226 : IVP port map( A => n2107, Z => states31_STATE_1);
   U227 : IVP port map( A => n2104, Z => n2109);
   U228 : IVP port map( A => n2103, Z => n2033);
   U229 : IVP port map( A => hold, Z => n2080);
   mr_reg_reg_OUT_HOURS_7 : FD1Q port map( CP => clk, D => n2030, Q => 
                           mr_reg_OUT_HOURS_7);
   mr_reg_reg_OUT_SECONDS_4 : FD1Q port map( CP => clk, D => n2029, Q => 
                           mr_reg_OUT_SECONDS_4);
   mr_reg_reg_OUT_SECONDS_5 : FD1Q port map( CP => clk, D => n2028, Q => 
                           mr_reg_OUT_SECONDS_5);
   mr_reg_reg_OUT_SECONDS_6 : FD1Q port map( CP => clk, D => n2027, Q => 
                           mr_reg_OUT_SECONDS_6);
   mr_reg_reg_HOURS_0 : FD1Q port map( CP => clk, D => states31_HOURS_0, Q => 
                           mr_reg_HOURS_0);
   mr_reg_reg_HOURS_1 : FD1Q port map( CP => clk, D => states31_HOURS_1, Q => 
                           mr_reg_HOURS_1);
   mr_reg_reg_HOURS_2 : FD1Q port map( CP => clk, D => states31_HOURS_2, Q => 
                           mr_reg_HOURS_2);
   mr_reg_reg_HOURS_3 : FD1Q port map( CP => clk, D => states31_HOURS_3, Q => 
                           mr_reg_HOURS_3);
   mr_reg_reg_HOURS_4 : FD1Q port map( CP => clk, D => states31_HOURS_4, Q => 
                           mr_reg_HOURS_4);
   mr_reg_reg_HOURS_5 : FD1Q port map( CP => clk, D => states31_HOURS_5, Q => 
                           mr_reg_HOURS_5);
   mr_reg_reg_HOURS_6 : FD1Q port map( CP => clk, D => states31_HOURS_6, Q => 
                           mr_reg_HOURS_6);
   mr_reg_reg_HOURS_7 : FD1Q port map( CP => clk, D => states31_HOURS_7, Q => 
                           mr_reg_HOURS_7);
   mr_reg_reg_MINUTES_0 : FD1Q port map( CP => clk, D => states31_MINUTES_0, Q 
                           => mr_reg_MINUTES_0);
   mr_reg_reg_MINUTES_1 : FD1Q port map( CP => clk, D => states31_MINUTES_1, Q 
                           => mr_reg_MINUTES_1);
   mr_reg_reg_MINUTES_2 : FD1Q port map( CP => clk, D => states31_MINUTES_2, Q 
                           => mr_reg_MINUTES_2);
   mr_reg_reg_MINUTES_3 : FD1Q port map( CP => clk, D => states31_MINUTES_3, Q 
                           => mr_reg_MINUTES_3);
   mr_reg_reg_MINUTES_4 : FD1Q port map( CP => clk, D => states31_MINUTES_4, Q 
                           => mr_reg_MINUTES_4);
   mr_reg_reg_MINUTES_5 : FD1Q port map( CP => clk, D => states31_MINUTES_5, Q 
                           => mr_reg_MINUTES_5);
   mr_reg_reg_MINUTES_6 : FD1Q port map( CP => clk, D => states31_MINUTES_6, Q 
                           => mr_reg_MINUTES_6);
   mr_reg_reg_MINUTES_7 : FD1Q port map( CP => clk, D => states31_MINUTES_7, Q 
                           => mr_reg_MINUTES_7);
   mr_reg_reg_SECONDS_0 : FD1Q port map( CP => clk, D => states31_SECONDS_0, Q 
                           => mr_reg_SECONDS_0);
   mr_reg_reg_SECONDS_1 : FD1Q port map( CP => clk, D => states31_SECONDS_1, Q 
                           => mr_reg_SECONDS_1);
   mr_reg_reg_SECONDS_2 : FD1Q port map( CP => clk, D => states31_SECONDS_2, Q 
                           => mr_reg_SECONDS_2);
   mr_reg_reg_SECONDS_3 : FD1Q port map( CP => clk, D => states31_SECONDS_3, Q 
                           => mr_reg_SECONDS_3);
   mr_reg_reg_SECONDS_4 : FD1Q port map( CP => clk, D => states31_SECONDS_4, Q 
                           => mr_reg_SECONDS_4);
   mr_reg_reg_SECONDS_5 : FD1Q port map( CP => clk, D => states31_SECONDS_5, Q 
                           => mr_reg_SECONDS_5);
   mr_reg_reg_SECONDS_6 : FD1Q port map( CP => clk, D => states31_SECONDS_6, Q 
                           => mr_reg_SECONDS_6);
   mr_reg_reg_SECONDS_7 : FD1Q port map( CP => clk, D => states31_SECONDS_7, Q 
                           => mr_reg_SECONDS_7);
   mr_reg_reg_MR_COUNTINGFACTOR_0 : FD1Q port map( CP => clk, D => 
                           states31_MR_COUNTINGFACTOR_0, Q => 
                           mr_reg_MR_COUNTINGFACTOR_0);
   mr_reg_reg_MR_COUNTINGFACTOR_1 : FD1Q port map( CP => clk, D => 
                           states31_MR_COUNTINGFACTOR_1, Q => 
                           mr_reg_MR_COUNTINGFACTOR_1);
   mr_reg_reg_MR_COUNTINGFACTOR_2 : FD1Q port map( CP => clk, D => 
                           states31_MR_COUNTINGFACTOR_2, Q => 
                           mr_reg_MR_COUNTINGFACTOR_2);
   mr_reg_reg_MR_COUNTINGFACTOR_3 : FD1Q port map( CP => clk, D => 
                           states31_MR_COUNTINGFACTOR_3, Q => 
                           mr_reg_MR_COUNTINGFACTOR_3);
   mr_reg_reg_MR_COUNTINGFACTOR_4 : FD1Q port map( CP => clk, D => 
                           states31_MR_COUNTINGFACTOR_4, Q => 
                           mr_reg_MR_COUNTINGFACTOR_4);
   mr_reg_reg_MR_COUNTINGFACTOR_5 : FD1Q port map( CP => clk, D => 
                           states31_MR_COUNTINGFACTOR_5, Q => 
                           mr_reg_MR_COUNTINGFACTOR_5);
   mr_reg_reg_MR_COUNTINGFACTOR_6 : FD1Q port map( CP => clk, D => 
                           states31_MR_COUNTINGFACTOR_6, Q => 
                           mr_reg_MR_COUNTINGFACTOR_6);
   mr_reg_reg_MR_COUNTINGFACTOR_7 : FD1Q port map( CP => clk, D => 
                           states31_MR_COUNTINGFACTOR_7, Q => 
                           mr_reg_MR_COUNTINGFACTOR_7);
   mr_reg_reg_MR_COUNTINGFACTOR_8 : FD1Q port map( CP => clk, D => 
                           states31_MR_COUNTINGFACTOR_8, Q => 
                           mr_reg_MR_COUNTINGFACTOR_8);
   mr_reg_reg_MR_COUNTINGFACTOR_9 : FD1Q port map( CP => clk, D => 
                           states31_MR_COUNTINGFACTOR_9, Q => 
                           mr_reg_MR_COUNTINGFACTOR_9);
   mr_reg_reg_MR_COUNTINGFACTOR_10 : FD1Q port map( CP => clk, D => 
                           states31_MR_COUNTINGFACTOR_10, Q => 
                           mr_reg_MR_COUNTINGFACTOR_10);
   mr_reg_reg_MR_COUNTINGFACTOR_11 : FD1Q port map( CP => clk, D => 
                           states31_MR_COUNTINGFACTOR_11, Q => 
                           mr_reg_MR_COUNTINGFACTOR_11);
   mr_reg_reg_MR_COUNTINGFACTOR_12 : FD1Q port map( CP => clk, D => 
                           states31_MR_COUNTINGFACTOR_12, Q => 
                           mr_reg_MR_COUNTINGFACTOR_12);
   mr_reg_reg_MR_COUNTINGFACTOR_13 : FD1Q port map( CP => clk, D => 
                           states31_MR_COUNTINGFACTOR_13, Q => 
                           mr_reg_MR_COUNTINGFACTOR_13);
   mr_reg_reg_MR_COUNTINGFACTOR_14 : FD1Q port map( CP => clk, D => 
                           states31_MR_COUNTINGFACTOR_14, Q => 
                           mr_reg_MR_COUNTINGFACTOR_14);
   mr_reg_reg_MR_COUNTINGFACTOR_15 : FD1Q port map( CP => clk, D => 
                           states31_MR_COUNTINGFACTOR_15, Q => 
                           mr_reg_MR_COUNTINGFACTOR_15);
   mr_reg_reg_MR_COUNTINGFACTOR_16 : FD1Q port map( CP => clk, D => 
                           states31_MR_COUNTINGFACTOR_16, Q => 
                           mr_reg_MR_COUNTINGFACTOR_16);
   mr_reg_reg_MR_COUNTINGFACTOR_17 : FD1Q port map( CP => clk, D => 
                           states31_MR_COUNTINGFACTOR_17, Q => 
                           mr_reg_MR_COUNTINGFACTOR_17);
   mr_reg_reg_MR_COUNTINGFACTOR_18 : FD1Q port map( CP => clk, D => 
                           states31_MR_COUNTINGFACTOR_18, Q => 
                           mr_reg_MR_COUNTINGFACTOR_18);
   mr_reg_reg_MR_COUNTINGFACTOR_19 : FD1Q port map( CP => clk, D => 
                           states31_MR_COUNTINGFACTOR_19, Q => 
                           mr_reg_MR_COUNTINGFACTOR_19);
   mr_reg_reg_MR_COUNTINGFACTOR_20 : FD1Q port map( CP => clk, D => 
                           states31_MR_COUNTINGFACTOR_20, Q => 
                           mr_reg_MR_COUNTINGFACTOR_20);
   mr_reg_reg_MR_COUNTINGFACTOR_21 : FD1Q port map( CP => clk, D => 
                           states31_MR_COUNTINGFACTOR_21, Q => 
                           mr_reg_MR_COUNTINGFACTOR_21);
   mr_reg_reg_MR_COUNTINGFACTOR_22 : FD1Q port map( CP => clk, D => 
                           states31_MR_COUNTINGFACTOR_22, Q => 
                           mr_reg_MR_COUNTINGFACTOR_22);
   mr_reg_reg_MR_COUNTINGFACTOR_23 : FD1Q port map( CP => clk, D => 
                           states31_MR_COUNTINGFACTOR_23, Q => 
                           mr_reg_MR_COUNTINGFACTOR_23);
   mr_reg_reg_STATE_1 : FD1Q port map( CP => clk, D => states31_STATE_1, Q => 
                           mr_reg_STATE_1);
   U230 : IVP port map( A => mr_reg_STATE_1, Z => n2101);
   U231 : AN2 port map( A => mr_reg_MR_COUNTINGFACTOR_0, B => n2033, Z => n1742
                           );
   U232 : AN2 port map( A => mr_reg_MR_COUNTINGFACTOR_3, B => n2033, Z => n1743
                           );
   U233 : AN2 port map( A => mr_reg_MR_COUNTINGFACTOR_6, B => n2033, Z => n1744
                           );
   U234 : AN2 port map( A => mr_reg_MR_COUNTINGFACTOR_15, B => n2033, Z => 
                           n1745);
   U235 : AN2 port map( A => mr_reg_MR_COUNTINGFACTOR_2, B => n2033, Z => n1746
                           );
   U236 : AN2 port map( A => mr_reg_MR_COUNTINGFACTOR_1, B => n2033, Z => n1747
                           );
   U237 : AN2 port map( A => mr_reg_MR_COUNTINGFACTOR_5, B => n2033, Z => n1748
                           );
   U238 : AN2 port map( A => mr_reg_MR_COUNTINGFACTOR_4, B => n2033, Z => n1749
                           );
   U239 : AN2 port map( A => mr_reg_MR_COUNTINGFACTOR_7, B => n2033, Z => n1750
                           );
   U240 : AN2 port map( A => mr_reg_MR_COUNTINGFACTOR_10, B => n2033, Z => 
                           n1751);
   U241 : AN2 port map( A => mr_reg_MR_COUNTINGFACTOR_14, B => n2033, Z => 
                           n1752);
   U242 : AN2 port map( A => mr_reg_MR_COUNTINGFACTOR_13, B => n2033, Z => 
                           n1753);
   U243 : AN2 port map( A => mr_reg_MR_COUNTINGFACTOR_19, B => n2033, Z => 
                           n1754);
   U244 : AN2 port map( A => mr_reg_MR_COUNTINGFACTOR_22, B => n2033, Z => 
                           n1755);
   U245 : AN2 port map( A => mr_reg_MINUTES_7, B => n2033, Z => n1756);
   U246 : AN2 port map( A => mr_reg_MINUTES_6, B => n2033, Z => n1757);
   U247 : AN2 port map( A => mr_reg_MINUTES_5, B => n2033, Z => n1758);
   U248 : AN2 port map( A => mr_reg_MINUTES_4, B => n2033, Z => n1759);
   U249 : AN2 port map( A => mr_reg_MINUTES_3, B => n2033, Z => n1760);
   U250 : AN2 port map( A => mr_reg_MINUTES_2, B => n2033, Z => n1761);
   U251 : AN2 port map( A => mr_reg_MINUTES_1, B => n2033, Z => n1762);
   U252 : AN2 port map( A => mr_reg_MINUTES_0, B => n2033, Z => n1763);
   U253 : AN2 port map( A => mr_reg_HOURS_7, B => n2033, Z => n1764);
   U254 : AN2 port map( A => mr_reg_HOURS_6, B => n2033, Z => n1765);
   U255 : AN2 port map( A => mr_reg_HOURS_5, B => n2033, Z => n1766);
   U256 : AN2 port map( A => mr_reg_HOURS_4, B => n2033, Z => n1767);
   U257 : AN2 port map( A => mr_reg_HOURS_3, B => n2033, Z => n1768);
   U258 : AN2 port map( A => mr_reg_HOURS_2, B => n2033, Z => n1769);
   U259 : AN2 port map( A => mr_reg_HOURS_1, B => n2033, Z => n1770);
   U260 : AN2 port map( A => mr_reg_HOURS_0, B => n2033, Z => n1771);
   U261 : AN2 port map( A => mr_reg_SECONDS_7, B => n2033, Z => n1772);
   U262 : AN2 port map( A => mr_reg_SECONDS_6, B => n2033, Z => n1773);
   U263 : AN2 port map( A => mr_reg_SECONDS_5, B => n2033, Z => n1774);
   U264 : AN2 port map( A => mr_reg_SECONDS_4, B => n2033, Z => n1775);
   U265 : AN2 port map( A => mr_reg_SECONDS_3, B => n2033, Z => n1776);
   U266 : AN2 port map( A => mr_reg_SECONDS_2, B => n2033, Z => n2016);
   U267 : AN2 port map( A => mr_reg_SECONDS_1, B => n2033, Z => n2017);
   U268 : AN2 port map( A => mr_reg_SECONDS_0, B => n2033, Z => n2018);
   U269 : AN2 port map( A => mr_reg_STATE_0, B => n2101, Z => n2019);
   U270 : AN2 port map( A => n2116, B => n2112, Z => n2020);
   U271 : AN2 port map( A => n2117, B => n2130, Z => n2021);
   U272 : AN2 port map( A => n2117, B => n2118, Z => n2022);
   U273 : AN2 port map( A => n2117, B => n2135, Z => n2023);
   U274 : AN2 port map( A => n2141, B => n2121, Z => n2024);
   U275 : AN2 port map( A => n2142, B => n2131, Z => n2025);
   U276 : IVP port map( A => add_100_plus_plus_carry_2, Z => n2105);
   U277 : IVP port map( A => n2088, Z => add_107_plus_plus_carry_2);
   U278 : IVP port map( A => n2096, Z => add_114_plus_plus_carry_2);
   U279 : BF1T1 port map( A => n2129, Z => n2026);
   U280 : BF1T1 port map( A => states31_OUT_SECONDS_6, Z => n2027);
   U281 : BF1T1 port map( A => states31_OUT_SECONDS_5, Z => n2028);
   U282 : BF1T1 port map( A => states31_OUT_SECONDS_4, Z => n2029);
   U283 : BF1T1 port map( A => states31_OUT_HOURS_7, Z => n2030);
   U284 : EO port map( A => add_114_plus_plus_carry_7, B => states160_HOURS_7, 
                           Z => ARG804_7);
   U285 : AN2 port map( A => states160_HOURS_6, B => add_114_plus_plus_carry_6,
                           Z => add_114_plus_plus_carry_7);
   U286 : EO port map( A => states160_HOURS_6, B => add_114_plus_plus_carry_6, 
                           Z => ARG804_6);
   U287 : AN2 port map( A => states160_HOURS_5, B => add_114_plus_plus_carry_5,
                           Z => add_114_plus_plus_carry_6);
   U288 : EO port map( A => states160_HOURS_5, B => add_114_plus_plus_carry_5, 
                           Z => ARG804_5);
   U289 : AN2 port map( A => states160_HOURS_4, B => add_114_plus_plus_carry_4,
                           Z => add_114_plus_plus_carry_5);
   U290 : EO port map( A => states160_HOURS_4, B => add_114_plus_plus_carry_4, 
                           Z => ARG804_4);
   U291 : AN2 port map( A => states160_HOURS_3, B => add_114_plus_plus_carry_3,
                           Z => add_114_plus_plus_carry_4);
   U292 : EO port map( A => states160_HOURS_3, B => add_114_plus_plus_carry_3, 
                           Z => ARG804_3);
   U293 : OR2 port map( A => states160_HOURS_2, B => add_114_plus_plus_carry_2,
                           Z => add_114_plus_plus_carry_3);
   U294 : EN port map( A => add_114_plus_plus_carry_2, B => states160_HOURS_2, 
                           Z => ARG804_2);
   U295 : EO port map( A => add_107_plus_plus_carry_7, B => states147_MINUTES_7
                           , Z => ARG632_7);
   U296 : AN2 port map( A => states147_MINUTES_6, B => 
                           add_107_plus_plus_carry_6, Z => 
                           add_107_plus_plus_carry_7);
   U297 : EO port map( A => states147_MINUTES_6, B => add_107_plus_plus_carry_6
                           , Z => ARG632_6);
   U298 : AN2 port map( A => states147_MINUTES_5, B => 
                           add_107_plus_plus_carry_5, Z => 
                           add_107_plus_plus_carry_6);
   U299 : EO port map( A => states147_MINUTES_5, B => add_107_plus_plus_carry_5
                           , Z => ARG632_5);
   U300 : AN2 port map( A => states147_MINUTES_4, B => 
                           add_107_plus_plus_carry_4, Z => 
                           add_107_plus_plus_carry_5);
   U301 : EO port map( A => states147_MINUTES_4, B => add_107_plus_plus_carry_4
                           , Z => ARG632_4);
   U302 : AN2 port map( A => states147_MINUTES_3, B => 
                           add_107_plus_plus_carry_3, Z => 
                           add_107_plus_plus_carry_4);
   U303 : EO port map( A => states147_MINUTES_3, B => add_107_plus_plus_carry_3
                           , Z => ARG632_3);
   U304 : OR2 port map( A => states147_MINUTES_2, B => 
                           add_107_plus_plus_carry_2, Z => 
                           add_107_plus_plus_carry_3);
   U305 : EN port map( A => add_107_plus_plus_carry_2, B => states147_MINUTES_2
                           , Z => ARG632_2);
   U306 : EO port map( A => add_100_plus_plus_carry_7, B => ARG374_7, Z => 
                           ARG460_7);
   U307 : AN2 port map( A => ARG374_6, B => add_100_plus_plus_carry_6, Z => 
                           add_100_plus_plus_carry_7);
   U308 : EO port map( A => ARG374_6, B => add_100_plus_plus_carry_6, Z => 
                           ARG460_6);
   U309 : AN2 port map( A => ARG374_5, B => add_100_plus_plus_carry_5, Z => 
                           add_100_plus_plus_carry_6);
   U310 : EO port map( A => ARG374_5, B => add_100_plus_plus_carry_5, Z => 
                           ARG460_5);
   U311 : AN2 port map( A => ARG374_4, B => add_100_plus_plus_carry_4, Z => 
                           add_100_plus_plus_carry_5);
   U312 : EO port map( A => ARG374_4, B => add_100_plus_plus_carry_4, Z => 
                           ARG460_4);
   U313 : AN2 port map( A => ARG374_3, B => add_100_plus_plus_carry_3, Z => 
                           add_100_plus_plus_carry_4);
   U314 : EO port map( A => ARG374_3, B => add_100_plus_plus_carry_3, Z => 
                           ARG460_3);
   U315 : OR2 port map( A => ARG374_2, B => add_100_plus_plus_carry_2, Z => 
                           add_100_plus_plus_carry_3);
   U316 : EN port map( A => add_100_plus_plus_carry_2, B => ARG374_2, Z => 
                           ARG460_2);
   mr_reg_reg_OUT_HOURS_0 : FD1QX4 port map( CP => clk, D => 
                           states31_OUT_HOURS_0, Q => mr_reg_OUT_HOURS_0);
   mr_reg_reg_OUT_HOURS_1 : FD1QX4 port map( CP => clk, D => 
                           states31_OUT_HOURS_1, Q => mr_reg_OUT_HOURS_1);
   mr_reg_reg_OUT_HOURS_2 : FD1QX4 port map( CP => clk, D => 
                           states31_OUT_HOURS_2, Q => mr_reg_OUT_HOURS_2);
   mr_reg_reg_OUT_HOURS_3 : FD1QX4 port map( CP => clk, D => 
                           states31_OUT_HOURS_3, Q => mr_reg_OUT_HOURS_3);
   mr_reg_reg_OUT_HOURS_4 : FD1QX4 port map( CP => clk, D => 
                           states31_OUT_HOURS_4, Q => mr_reg_OUT_HOURS_4);
   mr_reg_reg_OUT_HOURS_5 : FD1QX4 port map( CP => clk, D => 
                           states31_OUT_HOURS_5, Q => mr_reg_OUT_HOURS_5);
   mr_reg_reg_OUT_HOURS_6 : FD1QX4 port map( CP => clk, D => 
                           states31_OUT_HOURS_6, Q => mr_reg_OUT_HOURS_6);
   mr_reg_reg_OUT_MINUTES_0 : FD1QX4 port map( CP => clk, D => 
                           states31_OUT_MINUTES_0, Q => mr_reg_OUT_MINUTES_0);
   mr_reg_reg_OUT_MINUTES_1 : FD1QX4 port map( CP => clk, D => 
                           states31_OUT_MINUTES_1, Q => mr_reg_OUT_MINUTES_1);
   mr_reg_reg_OUT_MINUTES_2 : FD1QX4 port map( CP => clk, D => 
                           states31_OUT_MINUTES_2, Q => mr_reg_OUT_MINUTES_2);
   mr_reg_reg_OUT_MINUTES_3 : FD1QX4 port map( CP => clk, D => 
                           states31_OUT_MINUTES_3, Q => mr_reg_OUT_MINUTES_3);
   mr_reg_reg_OUT_MINUTES_4 : FD1QX4 port map( CP => clk, D => 
                           states31_OUT_MINUTES_4, Q => mr_reg_OUT_MINUTES_4);
   mr_reg_reg_OUT_MINUTES_5 : FD1QX4 port map( CP => clk, D => 
                           states31_OUT_MINUTES_5, Q => mr_reg_OUT_MINUTES_5);
   mr_reg_reg_OUT_MINUTES_6 : FD1QX4 port map( CP => clk, D => 
                           states31_OUT_MINUTES_6, Q => mr_reg_OUT_MINUTES_6);
   mr_reg_reg_OUT_MINUTES_7 : FD1QX4 port map( CP => clk, D => 
                           states31_OUT_MINUTES_7, Q => mr_reg_OUT_MINUTES_7);
   mr_reg_reg_OUT_SECONDS_0 : FD1QX4 port map( CP => clk, D => 
                           states31_OUT_SECONDS_0, Q => mr_reg_OUT_SECONDS_0);
   mr_reg_reg_OUT_SECONDS_1 : FD1QX4 port map( CP => clk, D => 
                           states31_OUT_SECONDS_1, Q => mr_reg_OUT_SECONDS_1);
   mr_reg_reg_OUT_SECONDS_2 : FD1QX4 port map( CP => clk, D => 
                           states31_OUT_SECONDS_2, Q => mr_reg_OUT_SECONDS_2);
   mr_reg_reg_OUT_SECONDS_3 : FD1QX4 port map( CP => clk, D => 
                           states31_OUT_SECONDS_3, Q => mr_reg_OUT_SECONDS_3);
   mr_reg_reg_OUT_SECONDS_7 : FD1QX4 port map( CP => clk, D => 
                           states31_OUT_SECONDS_7, Q => mr_reg_OUT_SECONDS_7);
   mr_reg_reg_STATE_0 : FD1P port map( CP => clk, D => states31_STATE_0, Q => 
                           mr_reg_STATE_0, QN => n2084);
   mr_reg_reg_STATE_2 : FD1SP port map( CP => clk, D => n2031, TE => n2026, TI 
                           => n2032, Q => mr_reg_STATE_2, QN => n2102);
   n2031 <= '1';
   n2032 <= '0';
   add_110_plus_plus : clock_MASTER_CLOCK12000000_DW01_inc_8_2 port map( A(7) 
                           => n1764, A(6) => n1765, A(5) => n1766, A(4) => 
                           n1767, A(3) => n1768, A(2) => n1769, A(1) => n1770, 
                           A(0) => n1771, SUM(7) => ARG718_7, SUM(6) => 
                           ARG718_6, SUM(5) => ARG718_5, SUM(4) => ARG718_4, 
                           SUM(3) => ARG718_3, SUM(2) => ARG718_2, SUM(1) => 
                           ARG718_1, SUM(0) => ARG718_0);
   sub_120_minus_minus : clock_MASTER_CLOCK12000000_DW01_incdec_24_0 port map( 
                           A(23) => mr_reg2_MR_COUNTINGFACTOR_23, A(22) => 
                           n1755, A(21) => mr_reg2_MR_COUNTINGFACTOR_21, A(20) 
                           => mr_reg2_MR_COUNTINGFACTOR_20, A(19) => n1754, 
                           A(18) => mr_reg2_MR_COUNTINGFACTOR_18, A(17) => 
                           mr_reg2_MR_COUNTINGFACTOR_17, A(16) => 
                           mr_reg2_MR_COUNTINGFACTOR_16, A(15) => n1745, A(14) 
                           => n1752, A(13) => n1753, A(12) => 
                           mr_reg2_MR_COUNTINGFACTOR_12, A(11) => 
                           mr_reg2_MR_COUNTINGFACTOR_11, A(10) => n1751, A(9) 
                           => mr_reg2_MR_COUNTINGFACTOR_9, A(8) => 
                           mr_reg2_MR_COUNTINGFACTOR_8, A(7) => n1750, A(6) => 
                           n1744, A(5) => n1748, A(4) => n1749, A(3) => n1743, 
                           A(2) => n1746, A(1) => n1747, A(0) => n1742, INC_DEC
                           => n2143, SUM(23) => ARG308_23, SUM(22) => ARG308_22
                           , SUM(21) => ARG308_21, SUM(20) => ARG308_20, 
                           SUM(19) => ARG308_19, SUM(18) => ARG308_18, SUM(17) 
                           => ARG308_17, SUM(16) => ARG308_16, SUM(15) => 
                           ARG308_15, SUM(14) => ARG308_14, SUM(13) => 
                           ARG308_13, SUM(12) => ARG308_12, SUM(11) => 
                           ARG308_11, SUM(10) => ARG308_10, SUM(9) => ARG308_9,
                           SUM(8) => ARG308_8, SUM(7) => ARG308_7, SUM(6) => 
                           ARG308_6, SUM(5) => ARG308_5, SUM(4) => ARG308_4, 
                           SUM(3) => ARG308_3, SUM(2) => ARG308_2, SUM(1) => 
                           ARG308_1, SUM(0) => ARG308_0);
   add_103_plus_plus : clock_MASTER_CLOCK12000000_DW01_inc_8_1 port map( A(7) 
                           => n1756, A(6) => n1757, A(5) => n1758, A(4) => 
                           n1759, A(3) => n1760, A(2) => n1761, A(1) => n1762, 
                           A(0) => n1763, SUM(7) => ARG546_7, SUM(6) => 
                           ARG546_6, SUM(5) => ARG546_5, SUM(4) => ARG546_4, 
                           SUM(3) => ARG546_3, SUM(2) => ARG546_2, SUM(1) => 
                           ARG546_1, SUM(0) => ARG546_0);
   add_98_plus_plus : clock_MASTER_CLOCK12000000_DW01_inc_8_0 port map( A(7) =>
                           n1772, A(6) => n1773, A(5) => n1774, A(4) => n1775, 
                           A(3) => n1776, A(2) => n2016, A(1) => n2017, A(0) =>
                           n2018, SUM(7) => ARG374_7, SUM(6) => ARG374_6, 
                           SUM(5) => ARG374_5, SUM(4) => ARG374_4, SUM(3) => 
                           ARG374_3, SUM(2) => ARG374_2, SUM(1) => 
                           add_100_plus_plus_carry_2, SUM(0) => ARG460_0);
   U319 : AO2N port map( A => n2019, B => n1772, C => mr_reg_OUT_SECONDS_7, D 
                           => n2034, Z => states31_OUT_SECONDS_7);
   U320 : AO2N port map( A => n2019, B => n1773, C => mr_reg_OUT_SECONDS_6, D 
                           => n2034, Z => states31_OUT_SECONDS_6);
   U321 : AO2N port map( A => n2019, B => n1774, C => mr_reg_OUT_SECONDS_5, D 
                           => n2034, Z => states31_OUT_SECONDS_5);
   U322 : AO2N port map( A => n2019, B => n1775, C => mr_reg_OUT_SECONDS_4, D 
                           => n2034, Z => states31_OUT_SECONDS_4);
   U323 : AO2N port map( A => n2019, B => n1776, C => mr_reg_OUT_SECONDS_3, D 
                           => n2034, Z => states31_OUT_SECONDS_3);
   U324 : AO2N port map( A => n2019, B => n2016, C => mr_reg_OUT_SECONDS_2, D 
                           => n2034, Z => states31_OUT_SECONDS_2);
   U325 : AO2N port map( A => n2019, B => n2017, C => mr_reg_OUT_SECONDS_1, D 
                           => n2034, Z => states31_OUT_SECONDS_1);
   U326 : AO2N port map( A => n2019, B => n2018, C => mr_reg_OUT_SECONDS_0, D 
                           => n2034, Z => states31_OUT_SECONDS_0);
   U327 : AO2N port map( A => n1756, B => n2019, C => mr_reg_OUT_MINUTES_7, D 
                           => n2034, Z => states31_OUT_MINUTES_7);
   U328 : AO2N port map( A => n1757, B => n2019, C => mr_reg_OUT_MINUTES_6, D 
                           => n2034, Z => states31_OUT_MINUTES_6);
   U329 : AO2N port map( A => n1758, B => n2019, C => mr_reg_OUT_MINUTES_5, D 
                           => n2034, Z => states31_OUT_MINUTES_5);
   U330 : AO2N port map( A => n1759, B => n2019, C => mr_reg_OUT_MINUTES_4, D 
                           => n2034, Z => states31_OUT_MINUTES_4);
   U331 : AO2N port map( A => n1760, B => n2019, C => mr_reg_OUT_MINUTES_3, D 
                           => n2034, Z => states31_OUT_MINUTES_3);
   U332 : AO2N port map( A => n1761, B => n2019, C => mr_reg_OUT_MINUTES_2, D 
                           => n2034, Z => states31_OUT_MINUTES_2);
   U333 : AO2N port map( A => n1762, B => n2019, C => mr_reg_OUT_MINUTES_1, D 
                           => n2034, Z => states31_OUT_MINUTES_1);
   U334 : AO2N port map( A => n1763, B => n2019, C => mr_reg_OUT_MINUTES_0, D 
                           => n2034, Z => states31_OUT_MINUTES_0);
   U335 : AO2N port map( A => n1764, B => n2019, C => mr_reg_OUT_HOURS_7, D => 
                           n2034, Z => states31_OUT_HOURS_7);
   U336 : AO2N port map( A => n1765, B => n2019, C => mr_reg_OUT_HOURS_6, D => 
                           n2034, Z => states31_OUT_HOURS_6);
   U337 : AO2N port map( A => n1766, B => n2019, C => mr_reg_OUT_HOURS_5, D => 
                           n2034, Z => states31_OUT_HOURS_5);
   U338 : AO2N port map( A => n1767, B => n2019, C => mr_reg_OUT_HOURS_4, D => 
                           n2034, Z => states31_OUT_HOURS_4);
   U339 : AO2N port map( A => n1768, B => n2019, C => mr_reg_OUT_HOURS_3, D => 
                           n2034, Z => states31_OUT_HOURS_3);
   U340 : AO2N port map( A => n1769, B => n2019, C => mr_reg_OUT_HOURS_2, D => 
                           n2034, Z => states31_OUT_HOURS_2);
   U341 : AO2N port map( A => n1770, B => n2019, C => mr_reg_OUT_HOURS_1, D => 
                           n2034, Z => states31_OUT_HOURS_1);
   U342 : AO2N port map( A => n1771, B => n2019, C => mr_reg_OUT_HOURS_0, D => 
                           n2034, Z => states31_OUT_HOURS_0);
   U343 : AO2N port map( A => n1755, B => n2037, C => ARG308_22, D => n2020, Z 
                           => states31_MR_COUNTINGFACTOR_22);
   U344 : AO2N port map( A => n1754, B => n2037, C => ARG308_19, D => n2020, Z 
                           => states31_MR_COUNTINGFACTOR_19);
   U345 : AO2N port map( A => n1745, B => n2037, C => ARG308_15, D => n2020, Z 
                           => states31_MR_COUNTINGFACTOR_15);
   U346 : AO2N port map( A => n1752, B => n2037, C => ARG308_14, D => n2020, Z 
                           => states31_MR_COUNTINGFACTOR_14);
   U347 : AO2N port map( A => n1753, B => n2037, C => ARG308_13, D => n2020, Z 
                           => states31_MR_COUNTINGFACTOR_13);
   U348 : AO2N port map( A => n1751, B => n2037, C => ARG308_10, D => n2020, Z 
                           => states31_MR_COUNTINGFACTOR_10);
   U349 : AO2N port map( A => n1750, B => n2037, C => ARG308_7, D => n2020, Z 
                           => states31_MR_COUNTINGFACTOR_7);
   U350 : AO2N port map( A => n1744, B => n2037, C => ARG308_6, D => n2020, Z 
                           => states31_MR_COUNTINGFACTOR_6);
   U351 : AO2N port map( A => n1748, B => n2037, C => ARG308_5, D => n2020, Z 
                           => states31_MR_COUNTINGFACTOR_5);
   U352 : AO2N port map( A => n1749, B => n2037, C => ARG308_4, D => n2020, Z 
                           => states31_MR_COUNTINGFACTOR_4);
   U353 : AO2N port map( A => n1743, B => n2037, C => ARG308_3, D => n2020, Z 
                           => states31_MR_COUNTINGFACTOR_3);
   U354 : AO2N port map( A => n1746, B => n2037, C => ARG308_2, D => n2020, Z 
                           => states31_MR_COUNTINGFACTOR_2);
   U355 : AO2N port map( A => n1747, B => n2037, C => ARG308_1, D => n2020, Z 
                           => states31_MR_COUNTINGFACTOR_1);
   U356 : AO2N port map( A => n1742, B => n2037, C => ARG308_0, D => n2020, Z 
                           => states31_MR_COUNTINGFACTOR_0);
   U357 : AO7A port map( A => ARG460_7, B => n2047, C => n2048, Z => 
                           states31_SECONDS_7);
   U358 : AO7A port map( A => n2049, B => n2050, C => n2051, Z => 
                           states31_SECONDS_6);
   U359 : AO7A port map( A => n2049, B => n2052, C => n2053, Z => 
                           states31_SECONDS_5);
   U360 : AO7A port map( A => ARG460_4, B => n2047, C => n2054, Z => 
                           states31_SECONDS_4);
   U361 : AO7A port map( A => ARG460_3, B => n2047, C => n2055, Z => 
                           states31_SECONDS_3);
   U362 : AO7A port map( A => ARG460_2, B => n2047, C => n2056, Z => 
                           states31_SECONDS_2);
   U363 : AO7A port map( A => n2105, B => n2047, C => n2057, Z => 
                           states31_SECONDS_1);
   U364 : AO7A port map( A => ARG460_0, B => n2047, C => n2058, Z => 
                           states31_SECONDS_0);
   U365 : AO7A port map( A => ARG632_7, B => n2059, C => n2060, Z => 
                           states31_MINUTES_7);
   U366 : AO7A port map( A => n2061, B => n2062, C => n2063, Z => 
                           states31_MINUTES_6);
   U367 : AO7A port map( A => n2061, B => n2064, C => n2065, Z => 
                           states31_MINUTES_5);
   U368 : AO7A port map( A => ARG632_4, B => n2059, C => n2066, Z => 
                           states31_MINUTES_4);
   U369 : AO7A port map( A => ARG632_3, B => n2059, C => n2067, Z => 
                           states31_MINUTES_3);
   U370 : AO7A port map( A => ARG632_2, B => n2059, C => n2068, Z => 
                           states31_MINUTES_2);
   U371 : AO7A port map( A => n2088, B => n2059, C => n2069, Z => 
                           states31_MINUTES_1);
   U372 : AO7A port map( A => ARG632_0, B => n2059, C => n2070, Z => 
                           states31_MINUTES_0);
   U373 : AO7A port map( A => ARG804_7, B => n2071, C => n2072, Z => 
                           states31_HOURS_7);
   U374 : AO7A port map( A => ARG804_6, B => n2071, C => n2073, Z => 
                           states31_HOURS_6);
   U375 : AO7A port map( A => ARG804_5, B => n2071, C => n2074, Z => 
                           states31_HOURS_5);
   U376 : AO7A port map( A => ARG804_4, B => n2071, C => n2075, Z => 
                           states31_HOURS_4);
   U377 : AO7A port map( A => ARG804_3, B => n2071, C => n2076, Z => 
                           states31_HOURS_3);
   U378 : AO7A port map( A => ARG804_2, B => n2071, C => n2077, Z => 
                           states31_HOURS_2);
   U379 : AO7A port map( A => n2096, B => n2071, C => n2078, Z => 
                           states31_HOURS_1);
   U380 : AO7A port map( A => ARG804_0, B => n2071, C => n2079, Z => 
                           states31_HOURS_0);
   U381 : AO7A port map( A => n2080, B => n2082, C => n2083, Z => n2081);
   U382 : MUX21N port map( A => n1763, B => ARG546_0, S => n2024, Z => n2085);
   U383 : MUX21N port map( A => n1761, B => ARG546_2, S => n2024, Z => n2086);
   U384 : MUX21N port map( A => n1760, B => ARG546_3, S => n2024, Z => n2087);
   U385 : MUX21N port map( A => n1762, B => ARG546_1, S => n2024, Z => n2088);
   U386 : MUX21N port map( A => n1756, B => ARG546_7, S => n2024, Z => n2089);
   U387 : MUX21N port map( A => n1757, B => ARG546_6, S => n2024, Z => n2090);
   U388 : MUX21N port map( A => n1758, B => ARG546_5, S => n2024, Z => n2091);
   U389 : MUX21N port map( A => n1759, B => ARG546_4, S => n2024, Z => n2092);
   U390 : MUX21N port map( A => n1771, B => ARG718_0, S => n2025, Z => n2093);
   U391 : MUX21N port map( A => n1769, B => ARG718_2, S => n2025, Z => n2094);
   U392 : MUX21N port map( A => n1768, B => ARG718_3, S => n2025, Z => n2095);
   U393 : MUX21N port map( A => n1770, B => ARG718_1, S => n2025, Z => n2096);
   U394 : MUX21N port map( A => n1764, B => ARG718_7, S => n2025, Z => n2097);
   U395 : MUX21N port map( A => n1765, B => ARG718_6, S => n2025, Z => n2098);
   U396 : MUX21N port map( A => n1766, B => ARG718_5, S => n2025, Z => n2099);
   U397 : MUX21N port map( A => n1767, B => ARG718_4, S => n2025, Z => n2100);
   U398 : AO17 port map( A => n2108, B => n2109, C => n2081, D => n2033, Z => 
                           n2107);
   U399 : AO17 port map( A => mr_reg_STATE_0, B => n2081, C => n2111, D => 
                           n2033, Z => n2110);
   U400 : OR8 port map( A => mr_reg2_MR_COUNTINGFACTOR_17, B => 
                           mr_reg2_MR_COUNTINGFACTOR_16, C => 
                           mr_reg2_MR_COUNTINGFACTOR_20, D => n1753, E => n1752
                           , F => mr_reg2_MR_COUNTINGFACTOR_11, G => n2113, H 
                           => n2114, Z => n2112);
   U401 : AO34 port map( A => n2126, B => n2127, C => n2128, D => n2033, Z => 
                           n2125);
   U402 : AO1N port map( A => n2136, B => n2137, C => n2135, D => n2036, Z => 
                           n2071);
   U403 : AO2N port map( A => read, B => n2109, C => n2127, D => n2080, Z => 
                           n2111);
   U404 : OR6 port map( A => mr_reg2_MR_COUNTINGFACTOR_12, B => n1745, C => 
                           mr_reg2_MR_COUNTINGFACTOR_18, D => n1742, E => n1744
                           , F => mr_reg2_MR_COUNTINGFACTOR_9, Z => n2139);
   U405 : OR7 port map( A => n1749, B => n1750, C => 
                           mr_reg2_MR_COUNTINGFACTOR_8, D => n1747, E => n1746,
                           F => mr_reg2_MR_COUNTINGFACTOR_21, G => n2139, Z => 
                           n2114);
   U406 : OR6 port map( A => mr_reg_MR_COUNTINGFACTOR_10, B => 
                           mr_reg_MR_COUNTINGFACTOR_5, C => 
                           mr_reg_MR_COUNTINGFACTOR_3, D => 
                           mr_reg2_MR_COUNTINGFACTOR_23, E => n1754, F => n1755
                           , Z => n2113);
   U407 : AO2A port map( A => n2117, B => n1772, C => ARG374_7, D => n2022, Z 
                           => n2048);
   U408 : AO2A port map( A => n2117, B => n1773, C => ARG374_6, D => n2022, Z 
                           => n2051);
   U409 : AO2A port map( A => n2117, B => n1774, C => ARG374_5, D => n2022, Z 
                           => n2053);
   U410 : AO2A port map( A => n2117, B => n1775, C => ARG374_4, D => n2022, Z 
                           => n2054);
   U411 : AO2A port map( A => n2106, B => n2022, C => n1776, D => n2036, Z => 
                           n2055);
   U412 : AO2A port map( A => n2120, B => n2022, C => n2016, D => n2036, Z => 
                           n2056);
   U413 : AO2A port map( A => n2105, B => n2022, C => n2017, D => n2036, Z => 
                           n2057);
   U414 : AO2A port map( A => n2119, B => n2022, C => n2018, D => n2036, Z => 
                           n2058);
   U415 : AO2A port map( A => n2089, B => n2021, C => n1756, D => n2036, Z => 
                           n2060);
   U416 : AO2A port map( A => n2090, B => n2021, C => n1757, D => n2036, Z => 
                           n2063);
   U417 : AO2A port map( A => n2091, B => n2021, C => n1758, D => n2036, Z => 
                           n2065);
   U418 : AO2A port map( A => n2092, B => n2021, C => n1759, D => n2036, Z => 
                           n2066);
   U419 : AO2A port map( A => n2087, B => n2021, C => n1760, D => n2036, Z => 
                           n2067);
   U420 : AO2A port map( A => n2086, B => n2021, C => n1761, D => n2036, Z => 
                           n2068);
   U421 : AO2A port map( A => n2088, B => n2021, C => n1762, D => n2036, Z => 
                           n2069);
   U422 : AO2A port map( A => n2085, B => n2021, C => n1763, D => n2036, Z => 
                           n2070);
   U423 : AO2A port map( A => n2097, B => n2023, C => n1764, D => n2036, Z => 
                           n2072);
   U424 : AO2A port map( A => n2098, B => n2023, C => n1765, D => n2036, Z => 
                           n2073);
   U425 : AO2A port map( A => n2099, B => n2023, C => n1766, D => n2036, Z => 
                           n2074);
   U426 : AO2A port map( A => n2100, B => n2023, C => n1767, D => n2036, Z => 
                           n2075);
   U427 : AO2A port map( A => n2095, B => n2023, C => n1768, D => n2036, Z => 
                           n2076);
   U428 : AO2A port map( A => n2094, B => n2023, C => n1769, D => n2036, Z => 
                           n2077);
   U429 : AO2A port map( A => n2096, B => n2023, C => n1770, D => n2036, Z => 
                           n2078);
   U430 : AO2A port map( A => n2093, B => n2023, C => n1771, D => n2036, Z => 
                           n2079);
   U431 : AO17 port map( A => n2140, B => mr_reg_STATE_2, C => n2019, D => 
                           n2033, Z => n2129);
   U432 : MUX21N port map( A => ARG308_9, B => mr_reg2_MR_COUNTINGFACTOR_9, S 
                           => n2037, Z => n2045);
   U433 : MUX21N port map( A => ARG308_8, B => mr_reg2_MR_COUNTINGFACTOR_8, S 
                           => n2037, Z => n2046);
   U434 : MUX21N port map( A => ARG308_23, B => mr_reg2_MR_COUNTINGFACTOR_23, S
                           => n2037, Z => n2035);
   U435 : MUX21N port map( A => ARG308_21, B => mr_reg2_MR_COUNTINGFACTOR_21, S
                           => n2037, Z => n2038);
   U436 : MUX21N port map( A => ARG308_20, B => mr_reg2_MR_COUNTINGFACTOR_20, S
                           => n2037, Z => n2039);
   U437 : MUX21N port map( A => ARG308_18, B => mr_reg2_MR_COUNTINGFACTOR_18, S
                           => n2037, Z => n2040);
   U438 : MUX21N port map( A => ARG308_17, B => mr_reg2_MR_COUNTINGFACTOR_17, S
                           => n2037, Z => n2041);
   U439 : MUX21N port map( A => ARG308_16, B => mr_reg2_MR_COUNTINGFACTOR_16, S
                           => n2037, Z => n2042);
   U440 : MUX21N port map( A => ARG308_12, B => mr_reg2_MR_COUNTINGFACTOR_12, S
                           => n2037, Z => n2043);
   U441 : MUX21N port map( A => ARG308_11, B => mr_reg2_MR_COUNTINGFACTOR_11, S
                           => n2037, Z => n2044);
   n2143 <= '1';

end SYN_mrfnord;

library IEEE,MTC45000,MTC45100X,LIB_GENERATORS,STVLIB;

use IEEE.std_logic_1164.all;
use IEEE.std_logic_arith.all;
use MTC45000.VCOMPONENTS.all;
use MTC45100X.VCOMPONENTS.all;
use LIB_GENERATORS.PCK_GENERATORS.all;
use STVLIB.ST_TIMING.all;
use STVLIB.ST_VSS.all;

entity 
   uart_MASTER_CLOCK12000000_BAUD_RATE_OUT9600_BAUD_RATE_IN115200_DW01_incdec_12_1 
   is

   port( A : in std_logic_vector (11 downto 0);  INC_DEC : in std_logic;  SUM :
         out std_logic_vector (11 downto 0));

end 
   uart_MASTER_CLOCK12000000_BAUD_RATE_OUT9600_BAUD_RATE_IN115200_DW01_incdec_12_1;

architecture SYN_rpl of 
   uart_MASTER_CLOCK12000000_BAUD_RATE_OUT9600_BAUD_RATE_IN115200_DW01_incdec_12_1 
   is

   component EN
      port( A, B : in std_logic;  Z : out std_logic);
   end component;
   
   component OR2
      port( A, B : in std_logic;  Z : out std_logic);
   end component;
   
   component IV
      port( A : in std_logic;  Z : out std_logic);
   end component;
   
   signal carry_8, carry_9, carry_7, carry_6, carry_2, carry_11, carry_10, 
      carry_5, carry_4, carry_3 : std_logic;

begin
   
   U6 : EN port map( A => carry_11, B => A(11), Z => SUM(11));
   U7 : OR2 port map( A => A(10), B => carry_10, Z => carry_11);
   U8 : EN port map( A => carry_10, B => A(10), Z => SUM(10));
   U9 : OR2 port map( A => A(9), B => carry_9, Z => carry_10);
   U10 : EN port map( A => carry_9, B => A(9), Z => SUM(9));
   U11 : OR2 port map( A => A(8), B => carry_8, Z => carry_9);
   U12 : EN port map( A => carry_8, B => A(8), Z => SUM(8));
   U13 : OR2 port map( A => A(7), B => carry_7, Z => carry_8);
   U14 : EN port map( A => carry_7, B => A(7), Z => SUM(7));
   U15 : OR2 port map( A => A(6), B => carry_6, Z => carry_7);
   U16 : EN port map( A => carry_6, B => A(6), Z => SUM(6));
   U17 : OR2 port map( A => A(5), B => carry_5, Z => carry_6);
   U18 : EN port map( A => carry_5, B => A(5), Z => SUM(5));
   U19 : OR2 port map( A => A(4), B => carry_4, Z => carry_5);
   U20 : EN port map( A => carry_4, B => A(4), Z => SUM(4));
   U21 : OR2 port map( A => A(3), B => carry_3, Z => carry_4);
   U22 : EN port map( A => carry_3, B => A(3), Z => SUM(3));
   U23 : OR2 port map( A => A(2), B => carry_2, Z => carry_3);
   U24 : EN port map( A => carry_2, B => A(2), Z => SUM(2));
   U25 : OR2 port map( A => A(1), B => A(0), Z => carry_2);
   U26 : EN port map( A => A(0), B => A(1), Z => SUM(1));
   U27 : IV port map( A => A(0), Z => SUM(0));

end SYN_rpl;

library IEEE,MTC45000,MTC45100X,LIB_GENERATORS,STVLIB;

use IEEE.std_logic_1164.all;
use IEEE.std_logic_arith.all;
use MTC45000.VCOMPONENTS.all;
use MTC45100X.VCOMPONENTS.all;
use LIB_GENERATORS.PCK_GENERATORS.all;
use STVLIB.ST_TIMING.all;
use STVLIB.ST_VSS.all;

entity 
   uart_MASTER_CLOCK12000000_BAUD_RATE_OUT9600_BAUD_RATE_IN115200_DW01_incdec_12_0 
   is

   port( A : in std_logic_vector (11 downto 0);  INC_DEC : in std_logic;  SUM :
         out std_logic_vector (11 downto 0));

end 
   uart_MASTER_CLOCK12000000_BAUD_RATE_OUT9600_BAUD_RATE_IN115200_DW01_incdec_12_0;

architecture SYN_rpl of 
   uart_MASTER_CLOCK12000000_BAUD_RATE_OUT9600_BAUD_RATE_IN115200_DW01_incdec_12_0 
   is

   component EN
      port( A, B : in std_logic;  Z : out std_logic);
   end component;
   
   component OR2
      port( A, B : in std_logic;  Z : out std_logic);
   end component;
   
   component IV
      port( A : in std_logic;  Z : out std_logic);
   end component;
   
   signal carry_8, carry_9, carry_7, carry_6, carry_2, carry_11, carry_10, 
      carry_5, carry_4, carry_3 : std_logic;

begin
   
   U6 : EN port map( A => carry_11, B => A(11), Z => SUM(11));
   U7 : OR2 port map( A => A(10), B => carry_10, Z => carry_11);
   U8 : EN port map( A => carry_10, B => A(10), Z => SUM(10));
   U9 : OR2 port map( A => A(9), B => carry_9, Z => carry_10);
   U10 : EN port map( A => carry_9, B => A(9), Z => SUM(9));
   U11 : OR2 port map( A => A(8), B => carry_8, Z => carry_9);
   U12 : EN port map( A => carry_8, B => A(8), Z => SUM(8));
   U13 : OR2 port map( A => A(7), B => carry_7, Z => carry_8);
   U14 : EN port map( A => carry_7, B => A(7), Z => SUM(7));
   U15 : OR2 port map( A => A(6), B => carry_6, Z => carry_7);
   U16 : EN port map( A => carry_6, B => A(6), Z => SUM(6));
   U17 : OR2 port map( A => A(5), B => carry_5, Z => carry_6);
   U18 : EN port map( A => carry_5, B => A(5), Z => SUM(5));
   U19 : OR2 port map( A => A(4), B => carry_4, Z => carry_5);
   U20 : EN port map( A => carry_4, B => A(4), Z => SUM(4));
   U21 : OR2 port map( A => A(3), B => carry_3, Z => carry_4);
   U22 : EN port map( A => carry_3, B => A(3), Z => SUM(3));
   U23 : OR2 port map( A => A(2), B => carry_2, Z => carry_3);
   U24 : EN port map( A => carry_2, B => A(2), Z => SUM(2));
   U25 : OR2 port map( A => A(1), B => A(0), Z => carry_2);
   U26 : EN port map( A => A(0), B => A(1), Z => SUM(1));
   U27 : IV port map( A => A(0), Z => SUM(0));

end SYN_rpl;

library IEEE,MTC45000,MTC45100X,LIB_GENERATORS,STVLIB;

use IEEE.std_logic_1164.all;
use IEEE.std_logic_arith.all;
use MTC45000.VCOMPONENTS.all;
use MTC45100X.VCOMPONENTS.all;
use LIB_GENERATORS.PCK_GENERATORS.all;
use STVLIB.ST_TIMING.all;
use STVLIB.ST_VSS.all;

entity uart_MASTER_CLOCK12000000_BAUD_RATE_OUT9600_BAUD_RATE_IN115200 is

   port( clk, rst, rxd : in std_logic;  txd : out std_logic;  uarti : in 
         std_logic_vector (0 to 9);  uarto : out std_logic_vector (0 to 9));

end uart_MASTER_CLOCK12000000_BAUD_RATE_OUT9600_BAUD_RATE_IN115200;

architecture SYN_FNORD of 
   uart_MASTER_CLOCK12000000_BAUD_RATE_OUT9600_BAUD_RATE_IN115200 is

   component ND2
      port( A, B : in std_logic;  Z : out std_logic);
   end component;
   
   component ND5P
      port( A, B, C, D, E : in std_logic;  Z : out std_logic);
   end component;
   
   component IVP
      port( A : in std_logic;  Z : out std_logic);
   end component;
   
   component ND3
      port( A, B, C : in std_logic;  Z : out std_logic);
   end component;
   
   component ND4
      port( A, B, C, D : in std_logic;  Z : out std_logic);
   end component;
   
   component AN3P
      port( A, B, C : in std_logic;  Z : out std_logic);
   end component;
   
   component NR2
      port( A, B : in std_logic;  Z : out std_logic);
   end component;
   
   component FD1Q
      port( CP, D : in std_logic;  Q : out std_logic);
   end component;
   
   component FD1SQP
      port( CP, D, TE, TI : in std_logic;  Q : out std_logic);
   end component;
   
   component EO
      port( A, B : in std_logic;  Z : out std_logic);
   end component;
   
   component AN2
      port( A, B : in std_logic;  Z : out std_logic);
   end component;
   
   component AN3
      port( A, B, C : in std_logic;  Z : out std_logic);
   end component;
   
   component NR8
      port( A, B, C, D, E, F, G, H : in std_logic;  Z : out std_logic);
   end component;
   
   component BF1T1
      port( A : in std_logic;  Z : out std_logic);
   end component;
   
   component AO28
      port( A, B, C, D : in std_logic;  Z : out std_logic);
   end component;
   
   component IV
      port( A : in std_logic;  Z : out std_logic);
   end component;
   
   component EN
      port( A, B : in std_logic;  Z : out std_logic);
   end component;
   
   component OR2
      port( A, B : in std_logic;  Z : out std_logic);
   end component;
   
   component FD1QX4
      port( CP, D : in std_logic;  Q : out std_logic);
   end component;
   
   component FD1P
      port( CP, D : in std_logic;  Q, QN : out std_logic);
   end component;
   
   component FD1SP
      port( CP, D, TE, TI : in std_logic;  Q, QN : out std_logic);
   end component;
   
   component FD1SQX4
      port( CP, D, TE, TI : in std_logic;  Q : out std_logic);
   end component;
   
   component 
      uart_MASTER_CLOCK12000000_BAUD_RATE_OUT9600_BAUD_RATE_IN115200_DW01_incdec_12_1
      port( A : in std_logic_vector (11 downto 0);  INC_DEC : in std_logic;  
            SUM : out std_logic_vector (11 downto 0));
   end component;
   
   component 
      uart_MASTER_CLOCK12000000_BAUD_RATE_OUT9600_BAUD_RATE_IN115200_DW01_incdec_12_0
      port( A : in std_logic_vector (11 downto 0);  INC_DEC : in std_logic;  
            SUM : out std_logic_vector (11 downto 0));
   end component;
   
   component AO6C
      port( A, B, C : in std_logic;  Z : out std_logic);
   end component;
   
   component AO2N
      port( A, B, C, D : in std_logic;  Z : out std_logic);
   end component;
   
   component AO3N
      port( A, B, C, D : in std_logic;  Z : out std_logic);
   end component;
   
   component AO6N
      port( A, B, C : in std_logic;  Z : out std_logic);
   end component;
   
   component AO1N
      port( A, B, C, D : in std_logic;  Z : out std_logic);
   end component;
   
   component AO3A
      port( A, B, C, D : in std_logic;  Z : out std_logic);
   end component;
   
   component AO7A
      port( A, B, C : in std_logic;  Z : out std_logic);
   end component;
   
   component AO25
      port( A, B, C, D, E : in std_logic;  Z : out std_logic);
   end component;
   
   component OR8
      port( A, B, C, D, E, F, G, H : in std_logic;  Z : out std_logic);
   end component;
   
   component ND2P
      port( A, B : in std_logic;  Z : out std_logic);
   end component;
   
   component IV4
      port( A : in std_logic;  Z : out std_logic);
   end component;
   
   component AO7C
      port( A, B, C : in std_logic;  Z : out std_logic);
   end component;
   
   component AO17
      port( A, B, C, D : in std_logic;  Z : out std_logic);
   end component;
   
   component AO3C
      port( A, B, C, D : in std_logic;  Z : out std_logic);
   end component;
   
   component AO8
      port( A, B, C, D : in std_logic;  Z : out std_logic);
   end component;
   
   component AO2A
      port( A, B, C, D : in std_logic;  Z : out std_logic);
   end component;
   
   component AO34
      port( A, B, C, D : in std_logic;  Z : out std_logic);
   end component;
   
   signal toext_in_STATE_2, toext_in_STATE_0, toext_in_MR_FACTOR_0, 
      fromext_in_MR_FACTOR_11, fromext_DATA_6, toext_STATE_1, t235_BITCOUNT_3, 
      ARG1391_2, ARG1223_5, ARG1223_10, r999_DATA_5, ARG451_5, 
      fromext_in_MR_FACTOR_8, fromext_in_DATAPORT_1, fromext_MR_FACTOR_7, 
      toext_in_MR_FACTOR_9, fromext_BITCOUNT_2, toext_MR_FACTOR_3, 
      toext_BITCOUNT_2, fromext_DATAPORT_4, t235_DATA_1, fromext_in_MR_FACTOR_1
      , toext_TXD, r999_BITCOUNT_0, fromext_in_MR_FACTOR_6, toext_MR_FACTOR_4, 
      fromext_DATAPORT_3, fromext_in_STATE_0, t235_DATA_6, fromext_MR_FACTOR_10
      , fromext_in_DATAPORT_6, fromext_MR_FACTOR_0, r999_DATA_2, ARG451_2, 
      fromext_STATE_2, ARG1223_2, toext_MR_FACTOR_10, fromext_DATA_1, 
      fromext_MR_FACTOR_9, fromext_MR_FACTOR_11, fromext_in_DATAPORT_7, 
      fromext_MR_FACTOR_1, toext_MR_FACTOR_5, fromext_DATAPORT_2, 
      toext_in_MR_FACTOR_8, t235_DATA_7, fromext_in_MR_FACTOR_7, fromext_DATA_0
      , fromext_MR_FACTOR_8, ARG1223_3, toext_MR_FACTOR_11, r999_DATA_3, 
      ARG451_3, ARG451_4, r999_DATA_4, fromext_in_MR_FACTOR_9, ARG1223_11, 
      ARG1223_4, toext_STATE_0, fromext_RXREADY, t235_BITCOUNT_2, ARG1391_3, 
      fromext_in_MR_FACTOR_10, fromext_in_MR_FACTOR_0, fromext_DATA_7, 
      r999_BITCOUNT_1, toext_MR_FACTOR_2, fromext_BITCOUNT_3, toext_BITCOUNT_3,
      fromext_DATAPORT_5, t235_DATA_0, toext_in_MR_FACTOR_11, 
      toext_in_MR_FACTOR_3, fromext_in_DATAPORT_0, fromext_MR_FACTOR_6, 
      fromext_DATA_5, ARG1391_1, toext_STATE_2, t235_BITCOUNT_0, toext_DATA_7, 
      ARG1223_6, toext_MR_FACTOR_9, ARG451_6, r999_DATA_6, 
      fromext_in_DATAPORT_2, fromext_MR_FACTOR_4, fromext_in_RXREADY, 
      t235_DATA_2, fromext_DATAPORT_7, fromext_BITCOUNT_1, toext_MR_FACTOR_0, 
      toext_BITCOUNT_1, ARG534_0, r999_BITCOUNT_3, ARG451_8, ARG1223_8, 
      t235_DATA_5, toext_MR_FACTOR_7, ARG451_10, fromext_DATAPORT_0, 
      toext_in_MR_FACTOR_4, fromext_in_DATAPORT_5, fromext_MR_FACTOR_3, 
      ARG451_1, r999_DATA_1, ARG1223_1, fromext_STATE_1, toext_TXEMPTY, 
      fromext_DATA_2, fromext_in_DATAPORT_4, fromext_MR_FACTOR_2, toext_in_TXD,
      t235_DATA_4, ARG1223_9, toext_MR_FACTOR_6, ARG451_11, fromext_DATAPORT_1,
      ARG451_9, fromext_DATA_3, ARG1223_0, fromext_STATE_0, ARG451_0, 
      r999_DATA_0, ARG451_7, toext_in_MR_FACTOR_2, r999_DATA_7, ARG1223_7, 
      toext_MR_FACTOR_8, ARG1391_0, toext_in_TXEMPTY, t235_BITCOUNT_1, 
      fromext_DATA_4, fromext_in_MR_FACTOR_3, r999_BITCOUNT_2, t235_DATA_3, 
      fromext_DATAPORT_6, toext_MR_FACTOR_1, toext_BITCOUNT_0, 
      fromext_in_DATAPORT_3, fromext_MR_FACTOR_5, n1777, n1778, n1779, n1780, 
      n1781, n1782, n1783, n1784, n1785, n1786, n1787, n1788, n1789, n1790, 
      n1791, n1792, n1793, n1794, n1795, n1796, n1797, n1798, n1799, n1800, 
      n1801, n1802, n1803, n1804, n1805, n1806, n1807, n1808, n1809, n1810, 
      n1811, n1812, n1813, n1814, n1815, n1816, n1817, n1818, n1819, n1820, 
      n1821, n1822, n1823, n1824, n1825, n1826, n1827, n1828, n1829, n1830, 
      n1831, n1832, n1833, n1834, n1835, n1836, n1837, n1838, n1839, n1840, 
      n1841, n1842, sub_274_minus_minus_carry_1, sub_274_minus_minus_carry_2, 
      sub_274_minus_minus_carry_3, n1843, n1844, n1845, n1846, n1847, n1848, 
      n1849, n1850, n1851, n1852, n1853, n1854, n1855, n1856, n1857, n1858, 
      n1859, n1860, n1861, n1862, n1863, n1864, n1865, n1866, n1867, n1868, 
      n1869, n1870, n1871, n1872, n1873, n1874, n1875, n1876, n1877, n1878, 
      n1879, n1880, n1881, n1882, n1883, n1884, n1885, n1886, n1887, n1888, 
      n1889, n1890, n1891, n1892, n1893, n1894, n1895, n1896, n1897, n1898, 
      n1899, n1900, n1901, n1902, n1903, n1904, n1905, n1906, n1907, n1908, 
      n1909, n1910, n1911, n1912, n1913, n1914, n1915, n1916, n1917, n1918, 
      n1919, n1920, n1921, n1922, n1923, n1924, n1925, n1926, n1927, n1928, 
      n1929, n1930, n1931, n1932, n1933, n1934, n1935, n1936, n1937, n1938, 
      n1939, n1940, n1941, n1942, n1943, n1944, n1945, n1946, n1947, n1948, 
      n1949, n1950, n1951, n1952, n1953, n1954, n1955, n1956, n1957, n1958, 
      n1959, n1960, n1961, n1962, n1963, n1964, n1965, n1966, n1967, n1968, 
      n1969, n1970, n1971, n1972, n1973, n1974, n1975, n1976, n1977, n1978, 
      n1979, n1980, n1981, n1982, n1983, n1984, n1985, n1986, n1987, n1988, 
      n1989, n1990, n1991, n1992, n1993, n1994, n1995, n1996, n1997, n1998, 
      n1999, n2000, n2001, n2002, n2003, n2004, n2005, n2006, n2007, n2008, 
      n2009, n2010, n2011, n2012, n2013, n2014, n2015 : std_logic;

begin
   
   U213 : ND2 port map( A => n1837, B => n1838, Z => n1839);
   U214 : ND2 port map( A => toext_BITCOUNT_1, B => toext_BITCOUNT_0, Z => 
                           n1841);
   U215 : ND2 port map( A => n1840, B => ARG534_0, Z => n1842);
   U216 : ND5P port map( A => n1965, B => n1968, C => n1974, D => n1966, E => 
                           n1967, Z => n1916);
   U217 : IVP port map( A => ARG1223_0, Z => n1965);
   U218 : ND2 port map( A => n1782, B => n1923, Z => n1908);
   U219 : IVP port map( A => n1905, Z => n1993);
   U220 : ND3 port map( A => n1919, B => n1918, C => n1923, Z => n1922);
   U221 : ND4 port map( A => n1877, B => n1873, C => n1872, D => n1871, Z => 
                           n1984);
   U222 : ND2 port map( A => n1925, B => n1926, Z => n1924);
   U223 : ND2 port map( A => toext_STATE_0, B => n1919, Z => n1925);
   U224 : ND2 port map( A => toext_STATE_1, B => n1918, Z => n1926);
   U225 : IVP port map( A => n1925, Z => n1992);
   U226 : ND4 port map( A => n1779, B => toext_BITCOUNT_0, C => n1778, D => 
                           n1777, Z => n1921);
   U227 : IVP port map( A => n1842, Z => n1837);
   U228 : IVP port map( A => ARG451_3, Z => n1931);
   U229 : IVP port map( A => ARG451_2, Z => n1932);
   U230 : IVP port map( A => ARG451_0, Z => n1930);
   U231 : ND5P port map( A => n1930, B => n1941, C => n1932, D => n1931, E => 
                           n1943, Z => n1915);
   U232 : AN3P port map( A => n1955, B => n1957, C => n1786, Z => n1979);
   U233 : ND3 port map( A => n2012, B => n1957, C => n1785, Z => n1887);
   U234 : IVP port map( A => n1961, Z => n2012);
   U235 : ND2 port map( A => ARG1391_3, B => n1781, Z => n1885);
   U236 : IVP port map( A => ARG1223_1, Z => n1968);
   U237 : IVP port map( A => ARG1223_3, Z => n1966);
   U238 : IVP port map( A => ARG1223_6, Z => n1967);
   U239 : ND3 port map( A => n1951, B => n1954, C => n1783, Z => n1977);
   U240 : ND4 port map( A => n1855, B => n1857, C => n1856, D => n1854, Z => 
                           n1995);
   U241 : ND2 port map( A => fromext_STATE_1, B => n1952, Z => n1951);
   U242 : ND3 port map( A => n1950, B => n1952, C => n1957, Z => n1955);
   U243 : ND4 port map( A => n1962, B => sub_274_minus_minus_carry_1, C => 
                           n1960, D => n1959, Z => n1964);
   U244 : IVP port map( A => ARG1391_1, Z => n1962);
   U245 : IVP port map( A => ARG1391_2, Z => n1960);
   U246 : IVP port map( A => ARG1391_3, Z => n1959);
   U247 : ND3 port map( A => n2002, B => n1954, C => n1784, Z => n1886);
   U248 : IVP port map( A => n1956, Z => n2002);
   U249 : ND2 port map( A => fromext_STATE_0, B => n1950, Z => n1956);
   U250 : IVP port map( A => n1963, Z => n2013);
   U251 : ND2 port map( A => fromext_STATE_0, B => fromext_STATE_1, Z => n1958)
                           ;
   U252 : ND2 port map( A => n1910, B => n1924, Z => n1927);
   U253 : ND2 port map( A => n1912, B => n1910, Z => n1983);
   U254 : IVP port map( A => n1927, Z => n1991);
   U255 : ND2 port map( A => toext_STATE_1, B => toext_STATE_0, Z => n1920);
   U256 : ND2 port map( A => n1946, B => n1929, Z => n2008);
   U257 : ND3 port map( A => n2008, B => n1920, C => n1903, Z => n1879);
   U258 : AN3P port map( A => n1912, B => n1913, C => n1910, Z => n1882);
   U259 : ND4 port map( A => n1920, B => n1923, C => n2008, D => n2009, Z => 
                           n1881);
   U260 : IVP port map( A => n1908, Z => n1906);
   U261 : IVP port map( A => n1928, Z => n1903);
   U262 : NR2 port map( A => n1866, B => n1878, Z => toext_in_MR_FACTOR_0);
   U263 : ND2 port map( A => ARG451_0, B => n1881, Z => n1878);
   U264 : IVP port map( A => n1878, Z => n1987);
   U265 : IVP port map( A => ARG451_1, Z => n1941);
   U266 : ND2 port map( A => n1934, B => n1941, Z => n1940);
   U267 : NR2 port map( A => n1866, B => n1876, Z => toext_in_MR_FACTOR_2);
   U268 : ND2 port map( A => ARG451_2, B => n1881, Z => n1876);
   U269 : IVP port map( A => n1876, Z => n1985);
   U270 : NR2 port map( A => n1866, B => n1875, Z => toext_in_MR_FACTOR_3);
   U271 : ND2 port map( A => ARG451_3, B => n1881, Z => n1875);
   U272 : IVP port map( A => n1875, Z => n1988);
   U273 : NR2 port map( A => n1866, B => n1874, Z => toext_in_MR_FACTOR_4);
   U274 : ND2 port map( A => ARG451_4, B => n1881, Z => n1874);
   U275 : IVP port map( A => n1874, Z => n1986);
   U276 : IVP port map( A => ARG451_5, Z => n1939);
   U277 : ND2 port map( A => n1934, B => n1939, Z => n1938);
   U278 : IVP port map( A => ARG451_6, Z => n1943);
   U279 : ND2 port map( A => n1934, B => n1943, Z => n1942);
   U280 : ND2 port map( A => n1934, B => n1937, Z => n1936);
   U281 : IVP port map( A => ARG451_7, Z => n1937);
   U282 : IVP port map( A => n1936, Z => n1871);
   U283 : NR2 port map( A => n1866, B => n1870, Z => toext_in_MR_FACTOR_8);
   U284 : ND2 port map( A => ARG451_8, B => n1881, Z => n1870);
   U285 : IVP port map( A => n1870, Z => n1989);
   U286 : NR2 port map( A => n1866, B => n1869, Z => toext_in_MR_FACTOR_9);
   U287 : ND2 port map( A => ARG451_9, B => n1881, Z => n1869);
   U288 : IVP port map( A => n1869, Z => n1990);
   U289 : IVP port map( A => n1922, Z => n1946);
   U290 : ND2 port map( A => uarti(8), B => n1946, Z => n1934);
   U291 : ND2 port map( A => n1934, B => n1935, Z => n1933);
   U292 : NR2 port map( A => n1866, B => n1867, Z => toext_in_MR_FACTOR_11);
   U293 : IVP port map( A => n1867, Z => n1944);
   U294 : ND2 port map( A => ARG451_11, B => n1881, Z => n1867);
   U295 : IVP port map( A => n1866, Z => n1868);
   U296 : IVP port map( A => n1914, Z => n1910);
   U297 : IVP port map( A => n1934, Z => n1888);
   U298 : IVP port map( A => n1924, Z => n2009);
   U299 : IVP port map( A => n1949, Z => n2011);
   U300 : IVP port map( A => n1926, Z => n1948);
   U301 : IVP port map( A => n1920, Z => n1912);
   U302 : IVP port map( A => n1921, Z => n1913);
   U303 : IVP port map( A => n2010, Z => n1861);
   U304 : IVP port map( A => n1978, Z => n1860);
   U305 : IVP port map( A => n1958, Z => n1980);
   U306 : IVP port map( A => n1917, Z => n1981);
   U307 : NR2 port map( A => n1847, B => n1857, Z => fromext_in_MR_FACTOR_0);
   U308 : ND2 port map( A => ARG1223_0, B => n1977, Z => n1857);
   U309 : NR2 port map( A => n1847, B => n1856, Z => fromext_in_MR_FACTOR_1);
   U310 : ND2 port map( A => ARG1223_1, B => n1977, Z => n1856);
   U311 : ND2 port map( A => n1844, B => n1974, Z => n1973);
   U312 : IVP port map( A => ARG1223_2, Z => n1974);
   U313 : ND2 port map( A => n1853, B => n1855, Z => fromext_in_MR_FACTOR_3);
   U314 : ND2 port map( A => ARG1223_3, B => n1977, Z => n1855);
   U315 : ND2 port map( A => n1844, B => n1970, Z => n1969);
   U316 : IVP port map( A => ARG1223_4, Z => n1970);
   U317 : ND2 port map( A => n1844, B => n1972, Z => n1971);
   U318 : ND2 port map( A => n1853, B => n1854, Z => fromext_in_MR_FACTOR_6);
   U319 : ND2 port map( A => ARG1223_6, B => n1977, Z => n1854);
   U320 : NR2 port map( A => n1847, B => n1852, Z => fromext_in_MR_FACTOR_7);
   U321 : ND2 port map( A => ARG1223_7, B => n1977, Z => n1852);
   U322 : IVP port map( A => n1852, Z => n1996);
   U323 : NR2 port map( A => n1847, B => n1851, Z => fromext_in_MR_FACTOR_8);
   U324 : ND2 port map( A => ARG1223_8, B => n1977, Z => n1851);
   U325 : IVP port map( A => n1851, Z => n1997);
   U326 : NR2 port map( A => n1847, B => n1850, Z => fromext_in_MR_FACTOR_9);
   U327 : ND2 port map( A => ARG1223_9, B => n1977, Z => n1850);
   U328 : IVP port map( A => n1850, Z => n1998);
   U329 : NR2 port map( A => n1847, B => n1849, Z => fromext_in_MR_FACTOR_10);
   U330 : ND2 port map( A => ARG1223_10, B => n1977, Z => n1849);
   U331 : IVP port map( A => n1849, Z => n1999);
   U332 : NR2 port map( A => n1847, B => n1848, Z => fromext_in_MR_FACTOR_11);
   U333 : IVP port map( A => n1848, Z => n1975);
   U334 : ND2 port map( A => ARG1223_11, B => n1977, Z => n1848);
   U335 : IVP port map( A => n1847, Z => n1853);
   U336 : ND2 port map( A => n1783, B => n1785, Z => n1883);
   U337 : IVP port map( A => n1951, Z => n1953);
   U338 : IVP port map( A => n1883, Z => n1884);
   U339 : ND2 port map( A => n2000, B => n1781, Z => n1843);
   U340 : IVP port map( A => n1964, Z => n2000);
   U341 : IVP port map( A => n1955, Z => n2001);
   U342 : IVP port map( A => rst, Z => n1846);
   U343 : IVP port map( A => n1886, Z => n2007);
   U344 : IVP port map( A => n1858, Z => n1982);
   uarto_reg_TXEMPTY : FD1Q port map( CP => clk, D => toext_in_TXEMPTY, Q => 
                           uarto(9));
   uarto_reg_RXREADY : FD1Q port map( CP => clk, D => fromext_in_RXREADY, Q => 
                           uarto(8));
   uarto_reg_DATA_0 : FD1Q port map( CP => clk, D => fromext_in_DATAPORT_0, Q 
                           => uarto(7));
   uarto_reg_DATA_1 : FD1Q port map( CP => clk, D => fromext_in_DATAPORT_1, Q 
                           => uarto(6));
   uarto_reg_DATA_2 : FD1Q port map( CP => clk, D => fromext_in_DATAPORT_2, Q 
                           => uarto(5));
   uarto_reg_DATA_3 : FD1Q port map( CP => clk, D => fromext_in_DATAPORT_3, Q 
                           => uarto(4));
   uarto_reg_DATA_4 : FD1Q port map( CP => clk, D => fromext_in_DATAPORT_4, Q 
                           => uarto(3));
   uarto_reg_DATA_5 : FD1Q port map( CP => clk, D => fromext_in_DATAPORT_5, Q 
                           => uarto(2));
   uarto_reg_DATA_6 : FD1Q port map( CP => clk, D => fromext_in_DATAPORT_6, Q 
                           => uarto(1));
   uarto_reg_DATA_7 : FD1Q port map( CP => clk, D => fromext_in_DATAPORT_7, Q 
                           => uarto(0));
   toext_reg_BITCOUNT_1 : FD1Q port map( CP => clk, D => n1813, Q => 
                           toext_BITCOUNT_1);
   U345 : IVP port map( A => toext_BITCOUNT_1, Z => n1840);
   toext_reg_BITCOUNT_3 : FD1Q port map( CP => clk, D => n1811, Q => 
                           toext_BITCOUNT_3);
   toext_reg_MR_FACTOR_0 : FD1Q port map( CP => clk, D => toext_in_MR_FACTOR_0,
                           Q => toext_MR_FACTOR_0);
   toext_reg_MR_FACTOR_1 : FD1SQP port map( CP => clk, D => n1824, TE => n1868,
                           TI => n1940, Q => toext_MR_FACTOR_1);
   toext_reg_MR_FACTOR_2 : FD1Q port map( CP => clk, D => toext_in_MR_FACTOR_2,
                           Q => toext_MR_FACTOR_2);
   toext_reg_MR_FACTOR_3 : FD1Q port map( CP => clk, D => toext_in_MR_FACTOR_3,
                           Q => toext_MR_FACTOR_3);
   toext_reg_MR_FACTOR_4 : FD1Q port map( CP => clk, D => toext_in_MR_FACTOR_4,
                           Q => toext_MR_FACTOR_4);
   toext_reg_MR_FACTOR_5 : FD1SQP port map( CP => clk, D => n1825, TE => n1868,
                           TI => n1938, Q => toext_MR_FACTOR_5);
   toext_reg_MR_FACTOR_6 : FD1SQP port map( CP => clk, D => n1826, TE => n1868,
                           TI => n1942, Q => toext_MR_FACTOR_6);
   toext_reg_MR_FACTOR_7 : FD1SQP port map( CP => clk, D => n1827, TE => n1868,
                           TI => n1936, Q => toext_MR_FACTOR_7);
   toext_reg_MR_FACTOR_8 : FD1Q port map( CP => clk, D => toext_in_MR_FACTOR_8,
                           Q => toext_MR_FACTOR_8);
   toext_reg_MR_FACTOR_9 : FD1Q port map( CP => clk, D => toext_in_MR_FACTOR_9,
                           Q => toext_MR_FACTOR_9);
   toext_reg_MR_FACTOR_10 : FD1SQP port map( CP => clk, D => n1828, TE => n1868
                           , TI => n1933, Q => toext_MR_FACTOR_10);
   toext_reg_MR_FACTOR_11 : FD1Q port map( CP => clk, D => 
                           toext_in_MR_FACTOR_11, Q => toext_MR_FACTOR_11);
   toext_reg_DATA_7 : FD1Q port map( CP => clk, D => n1796, Q => toext_DATA_7);
   U346 : IVP port map( A => toext_DATA_7, Z => n1947);
   toext_reg_STATE_2 : FD1Q port map( CP => clk, D => toext_in_STATE_2, Q => 
                           toext_STATE_2);
   fromext_reg_BITCOUNT_1 : FD1Q port map( CP => clk, D => n1792, Q => 
                           fromext_BITCOUNT_1);
   fromext_reg_BITCOUNT_2 : FD1Q port map( CP => clk, D => n1791, Q => 
                           fromext_BITCOUNT_2);
   fromext_reg_BITCOUNT_3 : FD1Q port map( CP => clk, D => n1790, Q => 
                           fromext_BITCOUNT_3);
   fromext_reg_MR_FACTOR_0 : FD1Q port map( CP => clk, D => 
                           fromext_in_MR_FACTOR_0, Q => fromext_MR_FACTOR_0);
   fromext_reg_MR_FACTOR_1 : FD1Q port map( CP => clk, D => 
                           fromext_in_MR_FACTOR_1, Q => fromext_MR_FACTOR_1);
   fromext_reg_MR_FACTOR_3 : FD1Q port map( CP => clk, D => 
                           fromext_in_MR_FACTOR_3, Q => fromext_MR_FACTOR_3);
   fromext_reg_MR_FACTOR_6 : FD1Q port map( CP => clk, D => 
                           fromext_in_MR_FACTOR_6, Q => fromext_MR_FACTOR_6);
   fromext_reg_MR_FACTOR_7 : FD1Q port map( CP => clk, D => 
                           fromext_in_MR_FACTOR_7, Q => fromext_MR_FACTOR_7);
   fromext_reg_MR_FACTOR_8 : FD1Q port map( CP => clk, D => 
                           fromext_in_MR_FACTOR_8, Q => fromext_MR_FACTOR_8);
   fromext_reg_MR_FACTOR_9 : FD1Q port map( CP => clk, D => 
                           fromext_in_MR_FACTOR_9, Q => fromext_MR_FACTOR_9);
   fromext_reg_MR_FACTOR_10 : FD1Q port map( CP => clk, D => 
                           fromext_in_MR_FACTOR_10, Q => fromext_MR_FACTOR_10);
   fromext_reg_MR_FACTOR_11 : FD1Q port map( CP => clk, D => 
                           fromext_in_MR_FACTOR_11, Q => fromext_MR_FACTOR_11);
   fromext_reg_DATA_0 : FD1Q port map( CP => clk, D => r999_DATA_0, Q => 
                           fromext_DATA_0);
   fromext_reg_DATA_1 : FD1Q port map( CP => clk, D => r999_DATA_1, Q => 
                           fromext_DATA_1);
   fromext_reg_DATA_2 : FD1Q port map( CP => clk, D => r999_DATA_2, Q => 
                           fromext_DATA_2);
   fromext_reg_DATA_3 : FD1Q port map( CP => clk, D => r999_DATA_3, Q => 
                           fromext_DATA_3);
   fromext_reg_DATA_4 : FD1Q port map( CP => clk, D => r999_DATA_4, Q => 
                           fromext_DATA_4);
   fromext_reg_DATA_5 : FD1Q port map( CP => clk, D => r999_DATA_5, Q => 
                           fromext_DATA_5);
   fromext_reg_DATA_6 : FD1Q port map( CP => clk, D => r999_DATA_6, Q => 
                           fromext_DATA_6);
   fromext_reg_DATA_7 : FD1Q port map( CP => clk, D => r999_DATA_7, Q => 
                           fromext_DATA_7);
   txd_reg : FD1Q port map( CP => clk, D => n1815, Q => txd);
   U347 : EO port map( A => n1839, B => toext_BITCOUNT_3, Z => n1777);
   U348 : EO port map( A => n1838, B => n1837, Z => n1778);
   U349 : AN2 port map( A => n1842, B => n1841, Z => n1779);
   U350 : IVP port map( A => toext_BITCOUNT_0, Z => ARG534_0);
   toext_reg_BITCOUNT_0 : FD1Q port map( CP => clk, D => n1814, Q => 
                           toext_BITCOUNT_0);
   fromext_reg_BITCOUNT_0 : FD1Q port map( CP => clk, D => n1793, Q => 
                           sub_274_minus_minus_carry_1);
   U351 : AN2 port map( A => n1982, B => rst, Z => n1780);
   U352 : AN2 port map( A => n1953, B => n1784, Z => n1781);
   U353 : AN2 port map( A => n1922, B => n1910, Z => n1782);
   U354 : AN3 port map( A => n1956, B => n1957, C => n1958, Z => n1783);
   U355 : NR8 port map( A => ARG1223_5, B => ARG1223_4, C => ARG1223_7, D => 
                           ARG1223_8, E => n1916, F => ARG1223_9, G => 
                           ARG1223_10, H => ARG1223_11, Z => n1784);
   U356 : AN2 port map( A => n1955, B => n1784, Z => n1785);
   U357 : AN2 port map( A => n1956, B => n1951, Z => n1786);
   U358 : BF1T1 port map( A => n2003, Z => n1787);
   U359 : BF1T1 port map( A => n2005, Z => n1788);
   U360 : ND2 port map( A => fromext_STATE_0, B => n2006, Z => n1845);
   U361 : BF1T1 port map( A => n1845, Z => n1789);
   U362 : AO28 port map( A => n1843, B => n1844, C => n1789, D => n1846, Z => 
                           fromext_in_STATE_0);
   U363 : ND2 port map( A => n2001, B => n1954, Z => n1844);
   U364 : IV port map( A => rxd, Z => n1954);
   U365 : BF1T1 port map( A => r999_BITCOUNT_3, Z => n1790);
   U366 : BF1T1 port map( A => r999_BITCOUNT_2, Z => n1791);
   U367 : BF1T1 port map( A => r999_BITCOUNT_1, Z => n1792);
   U368 : BF1T1 port map( A => r999_BITCOUNT_0, Z => n1793);
   U369 : BF1T1 port map( A => n1795, Z => n1794);
   U370 : BF1T1 port map( A => n1863, Z => n1795);
   U371 : BF1T1 port map( A => t235_DATA_7, Z => n1796);
   U372 : BF1T1 port map( A => n1798, Z => n1797);
   U373 : BF1T1 port map( A => t235_DATA_6, Z => n1798);
   U374 : BF1T1 port map( A => n1800, Z => n1799);
   U375 : BF1T1 port map( A => t235_DATA_5, Z => n1800);
   U376 : BF1T1 port map( A => n1802, Z => n1801);
   U377 : BF1T1 port map( A => t235_DATA_4, Z => n1802);
   U378 : BF1T1 port map( A => n1804, Z => n1803);
   U379 : BF1T1 port map( A => t235_DATA_3, Z => n1804);
   U380 : BF1T1 port map( A => n1806, Z => n1805);
   U381 : BF1T1 port map( A => t235_DATA_2, Z => n1806);
   U382 : BF1T1 port map( A => n1808, Z => n1807);
   U383 : BF1T1 port map( A => t235_DATA_1, Z => n1808);
   U384 : BF1T1 port map( A => n1810, Z => n1809);
   U385 : BF1T1 port map( A => t235_DATA_0, Z => n1810);
   U386 : BF1T1 port map( A => t235_BITCOUNT_3, Z => n1811);
   U387 : IV port map( A => toext_BITCOUNT_3, Z => n1904);
   U388 : BF1T1 port map( A => t235_BITCOUNT_2, Z => n1812);
   U389 : BF1T1 port map( A => t235_BITCOUNT_1, Z => n1813);
   U390 : BF1T1 port map( A => t235_BITCOUNT_0, Z => n1814);
   U391 : BF1T1 port map( A => toext_in_TXD, Z => n1815);
   U392 : BF1T1 port map( A => fromext_DATA_7, Z => n1816);
   U393 : BF1T1 port map( A => fromext_DATA_6, Z => n1817);
   U394 : BF1T1 port map( A => fromext_DATA_5, Z => n1818);
   U395 : BF1T1 port map( A => fromext_DATA_4, Z => n1819);
   U396 : BF1T1 port map( A => fromext_DATA_3, Z => n1820);
   U397 : BF1T1 port map( A => fromext_DATA_2, Z => n1821);
   U398 : BF1T1 port map( A => fromext_DATA_1, Z => n1822);
   U399 : BF1T1 port map( A => fromext_DATA_0, Z => n1823);
   U400 : ND2 port map( A => n1980, B => n1981, Z => n1858);
   U401 : EN port map( A => sub_274_minus_minus_carry_3, B => 
                           fromext_BITCOUNT_3, Z => ARG1391_3);
   U402 : OR2 port map( A => fromext_BITCOUNT_2, B => 
                           sub_274_minus_minus_carry_2, Z => 
                           sub_274_minus_minus_carry_3);
   U403 : EN port map( A => sub_274_minus_minus_carry_2, B => 
                           fromext_BITCOUNT_2, Z => ARG1391_2);
   U404 : OR2 port map( A => fromext_BITCOUNT_1, B => 
                           sub_274_minus_minus_carry_1, Z => 
                           sub_274_minus_minus_carry_2);
   U405 : EN port map( A => sub_274_minus_minus_carry_1, B => 
                           fromext_BITCOUNT_1, Z => ARG1391_1);
   U406 : IV port map( A => sub_274_minus_minus_carry_1, Z => ARG1391_0);
   toext_reg_TXEMPTY : FD1QX4 port map( CP => clk, D => toext_in_TXEMPTY, Q => 
                           toext_TXEMPTY);
   toext_reg_TXD : FD1QX4 port map( CP => clk, D => n1815, Q => toext_TXD);
   toext_reg_BITCOUNT_2 : FD1P port map( CP => clk, D => n1812, Q => 
                           toext_BITCOUNT_2, QN => n1838);
   n1824 <= '1';
   n1825 <= '1';
   n1826 <= '1';
   n1827 <= '1';
   n1828 <= '1';
   toext_reg_DATA_0 : FD1P port map( CP => clk, D => n1809, Q => open, QN => 
                           n1901);
   toext_reg_DATA_1 : FD1P port map( CP => clk, D => n1807, Q => open, QN => 
                           n1899);
   toext_reg_DATA_2 : FD1P port map( CP => clk, D => n1805, Q => open, QN => 
                           n1897);
   toext_reg_DATA_3 : FD1P port map( CP => clk, D => n1803, Q => open, QN => 
                           n1895);
   toext_reg_DATA_4 : FD1P port map( CP => clk, D => n1801, Q => open, QN => 
                           n1893);
   toext_reg_DATA_5 : FD1P port map( CP => clk, D => n1799, Q => open, QN => 
                           n1891);
   toext_reg_DATA_6 : FD1P port map( CP => clk, D => n1797, Q => open, QN => 
                           n1889);
   toext_reg_STATE_0 : FD1P port map( CP => clk, D => toext_in_STATE_0, Q => 
                           toext_STATE_0, QN => n1918);
   toext_reg_STATE_1 : FD1SP port map( CP => clk, D => n1829, TE => rst, TI => 
                           n1794, Q => toext_STATE_1, QN => n1919);
   n1829 <= '0';
   fromext_reg_DATAPORT_0 : FD1QX4 port map( CP => clk, D => 
                           fromext_in_DATAPORT_0, Q => fromext_DATAPORT_0);
   fromext_reg_DATAPORT_1 : FD1QX4 port map( CP => clk, D => 
                           fromext_in_DATAPORT_1, Q => fromext_DATAPORT_1);
   fromext_reg_DATAPORT_2 : FD1QX4 port map( CP => clk, D => 
                           fromext_in_DATAPORT_2, Q => fromext_DATAPORT_2);
   fromext_reg_DATAPORT_3 : FD1QX4 port map( CP => clk, D => 
                           fromext_in_DATAPORT_3, Q => fromext_DATAPORT_3);
   fromext_reg_DATAPORT_4 : FD1QX4 port map( CP => clk, D => 
                           fromext_in_DATAPORT_4, Q => fromext_DATAPORT_4);
   fromext_reg_DATAPORT_5 : FD1QX4 port map( CP => clk, D => 
                           fromext_in_DATAPORT_5, Q => fromext_DATAPORT_5);
   fromext_reg_DATAPORT_6 : FD1QX4 port map( CP => clk, D => 
                           fromext_in_DATAPORT_6, Q => fromext_DATAPORT_6);
   fromext_reg_DATAPORT_7 : FD1QX4 port map( CP => clk, D => 
                           fromext_in_DATAPORT_7, Q => fromext_DATAPORT_7);
   fromext_reg_RXREADY : FD1QX4 port map( CP => clk, D => fromext_in_RXREADY, Q
                           => fromext_RXREADY);
   fromext_reg_MR_FACTOR_2 : FD1SQX4 port map( CP => clk, D => n1830, TE => 
                           n1973, TI => n1853, Q => fromext_MR_FACTOR_2);
   n1830 <= '0';
   fromext_reg_MR_FACTOR_4 : FD1SQX4 port map( CP => clk, D => n1831, TE => 
                           n1969, TI => n1853, Q => fromext_MR_FACTOR_4);
   n1831 <= '0';
   fromext_reg_MR_FACTOR_5 : FD1SQX4 port map( CP => clk, D => n1832, TE => 
                           n1853, TI => n1971, Q => fromext_MR_FACTOR_5);
   n1832 <= '1';
   fromext_reg_STATE_0 : FD1P port map( CP => clk, D => fromext_in_STATE_0, Q 
                           => fromext_STATE_0, QN => n1952);
   fromext_reg_STATE_1 : FD1SP port map( CP => clk, D => n1833, TE => n1788, TI
                           => n1834, Q => fromext_STATE_1, QN => n1950);
   n1833 <= '1';
   n1834 <= '0';
   fromext_reg_STATE_2 : FD1SP port map( CP => clk, D => n1835, TE => n1787, TI
                           => n1836, Q => fromext_STATE_2, QN => n1957);
   n1835 <= '1';
   n1836 <= '0';
   sub_245_minus_minus : 
                           uart_MASTER_CLOCK12000000_BAUD_RATE_OUT9600_BAUD_RATE_IN115200_DW01_incdec_12_1 
                           port map( A(11) => fromext_MR_FACTOR_11, A(10) => 
                           fromext_MR_FACTOR_10, A(9) => fromext_MR_FACTOR_9, 
                           A(8) => fromext_MR_FACTOR_8, A(7) => 
                           fromext_MR_FACTOR_7, A(6) => fromext_MR_FACTOR_6, 
                           A(5) => fromext_MR_FACTOR_5, A(4) => 
                           fromext_MR_FACTOR_4, A(3) => fromext_MR_FACTOR_3, 
                           A(2) => fromext_MR_FACTOR_2, A(1) => 
                           fromext_MR_FACTOR_1, A(0) => fromext_MR_FACTOR_0, 
                           INC_DEC => n2015, SUM(11) => ARG1223_11, SUM(10) => 
                           ARG1223_10, SUM(9) => ARG1223_9, SUM(8) => ARG1223_8
                           , SUM(7) => ARG1223_7, SUM(6) => ARG1223_6, SUM(5) 
                           => ARG1223_5, SUM(4) => ARG1223_4, SUM(3) => 
                           ARG1223_3, SUM(2) => ARG1223_2, SUM(1) => ARG1223_1,
                           SUM(0) => ARG1223_0);
   sub_161_minus_minus : 
                           uart_MASTER_CLOCK12000000_BAUD_RATE_OUT9600_BAUD_RATE_IN115200_DW01_incdec_12_0 
                           port map( A(11) => toext_MR_FACTOR_11, A(10) => 
                           toext_MR_FACTOR_10, A(9) => toext_MR_FACTOR_9, A(8) 
                           => toext_MR_FACTOR_8, A(7) => toext_MR_FACTOR_7, 
                           A(6) => toext_MR_FACTOR_6, A(5) => toext_MR_FACTOR_5
                           , A(4) => toext_MR_FACTOR_4, A(3) => 
                           toext_MR_FACTOR_3, A(2) => toext_MR_FACTOR_2, A(1) 
                           => toext_MR_FACTOR_1, A(0) => toext_MR_FACTOR_0, 
                           INC_DEC => n2014, SUM(11) => ARG451_11, SUM(10) => 
                           ARG451_10, SUM(9) => ARG451_9, SUM(8) => ARG451_8, 
                           SUM(7) => ARG451_7, SUM(6) => ARG451_6, SUM(5) => 
                           ARG451_5, SUM(4) => ARG451_4, SUM(3) => ARG451_3, 
                           SUM(2) => ARG451_2, SUM(1) => ARG451_1, SUM(0) => 
                           ARG451_0);
   U420 : AO6C port map( A => n1858, B => n1859, C => rst, Z => 
                           fromext_in_RXREADY);
   U421 : AO2N port map( A => n1780, B => n1816, C => fromext_DATAPORT_7, D => 
                           n1860, Z => fromext_in_DATAPORT_7);
   U422 : AO2N port map( A => n1780, B => n1817, C => fromext_DATAPORT_6, D => 
                           n1860, Z => fromext_in_DATAPORT_6);
   U423 : AO2N port map( A => n1780, B => n1818, C => fromext_DATAPORT_5, D => 
                           n1860, Z => fromext_in_DATAPORT_5);
   U424 : AO2N port map( A => n1780, B => n1819, C => fromext_DATAPORT_4, D => 
                           n1860, Z => fromext_in_DATAPORT_4);
   U425 : AO2N port map( A => n1780, B => n1820, C => fromext_DATAPORT_3, D => 
                           n1860, Z => fromext_in_DATAPORT_3);
   U426 : AO2N port map( A => n1780, B => n1821, C => fromext_DATAPORT_2, D => 
                           n1860, Z => fromext_in_DATAPORT_2);
   U427 : AO2N port map( A => n1780, B => n1822, C => fromext_DATAPORT_1, D => 
                           n1860, Z => fromext_in_DATAPORT_1);
   U428 : AO2N port map( A => n1780, B => n1823, C => fromext_DATAPORT_0, D => 
                           n1860, Z => fromext_in_DATAPORT_0);
   U429 : AO3N port map( A => n1861, B => n1862, C => rst, D => toext_STATE_2, 
                           Z => toext_in_STATE_2);
   U430 : AO6C port map( A => n1864, B => n1865, C => rst, Z => 
                           toext_in_STATE_0);
   U431 : AO6N port map( A => toext_TXD, B => n1879, C => n1880, Z => 
                           toext_in_TXD);
   U432 : AO1N port map( A => toext_TXEMPTY, B => n1881, C => n1846, D => n1882
                           , Z => toext_in_TXEMPTY);
   U433 : AO2N port map( A => n1816, B => n1883, C => rxd, D => n1781, Z => 
                           r999_DATA_7);
   U434 : AO2N port map( A => n1817, B => n1883, C => n1816, D => n1781, Z => 
                           r999_DATA_6);
   U435 : AO2N port map( A => n1818, B => n1883, C => n1817, D => n1781, Z => 
                           r999_DATA_5);
   U436 : AO2N port map( A => n1819, B => n1883, C => n1818, D => n1781, Z => 
                           r999_DATA_4);
   U437 : AO2N port map( A => n1820, B => n1883, C => n1819, D => n1781, Z => 
                           r999_DATA_3);
   U438 : AO2N port map( A => n1821, B => n1883, C => n1820, D => n1781, Z => 
                           r999_DATA_2);
   U439 : AO2N port map( A => n1822, B => n1883, C => n1821, D => n1781, Z => 
                           r999_DATA_1);
   U440 : AO2N port map( A => n1823, B => n1883, C => n1822, D => n1781, Z => 
                           r999_DATA_0);
   U441 : AO3A port map( A => fromext_BITCOUNT_3, B => n1884, C => n1885, D => 
                           n1886, Z => r999_BITCOUNT_3);
   U442 : AO2N port map( A => fromext_BITCOUNT_2, B => n1887, C => ARG1391_2, D
                           => n1781, Z => r999_BITCOUNT_2);
   U443 : AO2N port map( A => fromext_BITCOUNT_1, B => n1887, C => ARG1391_1, D
                           => n1781, Z => r999_BITCOUNT_1);
   U444 : AO2N port map( A => sub_274_minus_minus_carry_1, B => n1887, C => 
                           ARG1391_0, D => n1781, Z => r999_BITCOUNT_0);
   U445 : AO2N port map( A => toext_DATA_7, B => n1879, C => uarti(0), D => 
                           n1888, Z => t235_DATA_7);
   U446 : AO7A port map( A => n1879, B => n1889, C => n1890, Z => t235_DATA_6);
   U447 : AO7A port map( A => n1879, B => n1891, C => n1892, Z => t235_DATA_5);
   U448 : AO7A port map( A => n1879, B => n1893, C => n1894, Z => t235_DATA_4);
   U449 : AO7A port map( A => n1879, B => n1895, C => n1896, Z => t235_DATA_3);
   U450 : AO7A port map( A => n1879, B => n1897, C => n1898, Z => t235_DATA_2);
   U451 : AO7A port map( A => n1879, B => n1899, C => n1900, Z => t235_DATA_1);
   U452 : AO7A port map( A => n1879, B => n1901, C => n1902, Z => t235_DATA_0);
   U453 : AO25 port map( A => n1782, B => n1903, C => n1904, D => n1905, E => 
                           n1777, Z => t235_BITCOUNT_3);
   U454 : AO7A port map( A => toext_BITCOUNT_2, B => n1906, C => n1907, Z => 
                           t235_BITCOUNT_2);
   U455 : AO2N port map( A => toext_BITCOUNT_1, B => n1908, C => n1909, D => 
                           n1910, Z => t235_BITCOUNT_1);
   U456 : AO7A port map( A => toext_BITCOUNT_0, B => n1906, C => n1911, Z => 
                           t235_BITCOUNT_0);
   U457 : OR8 port map( A => ARG451_5, B => ARG451_4, C => ARG451_7, D => 
                           ARG451_8, E => n1915, F => ARG451_9, G => ARG451_10,
                           H => ARG451_11, Z => n1914);
   U458 : ND2P port map( A => rxd, B => n1784, Z => n1917);
   U459 : AO7A port map( A => n1924, B => n1910, C => n1923, Z => n1928);
   U460 : IV4 port map( A => toext_STATE_2, Z => n1923);
   U461 : IV4 port map( A => uarti(8), Z => n1929);
   U462 : AO7C port map( A => n1944, B => n1945, C => n1846, Z => n1866);
   U463 : AO7A port map( A => n1920, B => n1948, C => n1910, Z => n1905);
   U464 : AO7A port map( A => n1948, B => n1921, C => n1925, Z => n1949);
   U465 : AO7A port map( A => rxd, B => n1956, C => n1958, Z => n1961);
   U466 : AO17 port map( A => n1956, B => uarti(9), C => n1784, D => n1951, Z 
                           => n1963);
   U467 : AO7C port map( A => n1975, B => n1976, C => n1846, Z => n1847);
   U468 : AO7A port map( A => n1979, B => n1917, C => rst, Z => n1978);
   U469 : AO3C port map( A => n1927, B => n1901, C => n1846, D => n1983, Z => 
                           n1880);
   U470 : AO2N port map( A => n1924, B => n1914, C => n1948, D => n1921, Z => 
                           n1862);
   U471 : AO8 port map( A => n1913, B => n1948, C => n1910, D => n1888, Z => 
                           n1864);
   U472 : OR8 port map( A => n1985, B => n1986, C => n1987, D => n1988, E => 
                           n1989, F => n1984, G => n1990, H => n1933, Z => 
                           n1945);
   U473 : AO2A port map( A => n1947, B => n1991, C => uarti(1), D => n1888, Z 
                           => n1890);
   U474 : AO2A port map( A => n1889, B => n1991, C => uarti(2), D => n1888, Z 
                           => n1892);
   U475 : AO2A port map( A => n1891, B => n1991, C => uarti(3), D => n1888, Z 
                           => n1894);
   U476 : AO2A port map( A => n1893, B => n1991, C => uarti(4), D => n1888, Z 
                           => n1896);
   U477 : AO2A port map( A => n1895, B => n1991, C => uarti(5), D => n1888, Z 
                           => n1898);
   U478 : AO2A port map( A => n1897, B => n1991, C => uarti(6), D => n1888, Z 
                           => n1900);
   U479 : AO2A port map( A => n1899, B => n1991, C => uarti(7), D => n1888, Z 
                           => n1902);
   U480 : AO2A port map( A => n1778, B => n1993, C => n1992, D => n1910, Z => 
                           n1907);
   U481 : AO2A port map( A => toext_BITCOUNT_0, B => n1993, C => n1992, D => 
                           n1910, Z => n1911);
   U482 : AO6C port map( A => n1953, B => n1964, C => n1958, Z => n1994);
   U483 : OR8 port map( A => n1969, B => n1973, C => n1971, D => n1996, E => 
                           n1997, F => n1995, G => n1998, H => n1999, Z => 
                           n1976);
   U484 : IV4 port map( A => ARG451_10, Z => n1935);
   U485 : IV4 port map( A => ARG1223_5, Z => n1972);
   U486 : AO17 port map( A => fromext_STATE_2, B => n2004, C => n1982, D => rst
                           , Z => n2003);
   U487 : AO17 port map( A => fromext_STATE_1, B => n2006, C => n2007, D => rst
                           , Z => n2005);
   U488 : AO7A port map( A => n1913, B => n1914, C => n1912, Z => n2010);
   U489 : AO25 port map( A => n2009, B => n2010, C => n1919, D => n2011, E => 
                           n1914, Z => n1863);
   U490 : AO17 port map( A => n1912, B => n1921, C => n1914, D => toext_STATE_0
                           , Z => n1865);
   U491 : IV4 port map( A => n1942, Z => n1872);
   U492 : IV4 port map( A => n1940, Z => n1877);
   U493 : IV4 port map( A => n1938, Z => n1873);
   U494 : AO17 port map( A => n1926, B => n1920, C => n1779, D => n2011, Z => 
                           n1909);
   U495 : AO17 port map( A => n1786, B => uarti(9), C => n1784, D => n1994, Z 
                           => n2004);
   U496 : AO7A port map( A => n1980, B => n1981, C => n2013, Z => n2006);
   U497 : AO34 port map( A => n1963, B => n2001, C => n1961, D => 
                           fromext_RXREADY, Z => n1859);
   n2014 <= '1';
   n2015 <= '1';

end SYN_FNORD;

library IEEE,MTC45000,MTC45100X,LIB_GENERATORS,STVLIB;

use IEEE.std_logic_1164.all;
use IEEE.std_logic_arith.all;
use MTC45000.VCOMPONENTS.all;
use MTC45100X.VCOMPONENTS.all;
use LIB_GENERATORS.PCK_GENERATORS.all;
use STVLIB.ST_TIMING.all;
use STVLIB.ST_VSS.all;

entity mp3uart is

   port( clk, rst : in std_logic;  mp3byte : in std_logic_vector (7 downto 0); 
         takethismp3 : in std_logic;  requestmp3 : out std_logic;  stopit, mp3i
         : in std_logic;  mp3o : out std_logic_vector (0 to 2));

end mp3uart;

architecture SYN_FOOBAR of mp3uart is

   component IVP
      port( A : in std_logic;  Z : out std_logic);
   end component;
   
   component ND2
      port( A, B : in std_logic;  Z : out std_logic);
   end component;
   
   component MUX21P
      port( A, B, S : in std_logic;  Z : out std_logic);
   end component;
   
   component AN3P
      port( A, B, C : in std_logic;  Z : out std_logic);
   end component;
   
   component OR2P
      port( A, B : in std_logic;  Z : out std_logic);
   end component;
   
   component ND4
      port( A, B, C, D : in std_logic;  Z : out std_logic);
   end component;
   
   component ND3
      port( A, B, C : in std_logic;  Z : out std_logic);
   end component;
   
   component FD1SQP
      port( CP, D, TE, TI : in std_logic;  Q : out std_logic);
   end component;
   
   component FD1Q
      port( CP, D : in std_logic;  Q : out std_logic);
   end component;
   
   component AN2
      port( A, B : in std_logic;  Z : out std_logic);
   end component;
   
   component BF1T1
      port( A : in std_logic;  Z : out std_logic);
   end component;
   
   component EN
      port( A, B : in std_logic;  Z : out std_logic);
   end component;
   
   component OR2
      port( A, B : in std_logic;  Z : out std_logic);
   end component;
   
   component AO2N
      port( A, B, C, D : in std_logic;  Z : out std_logic);
   end component;
   
   component IV4
      port( A : in std_logic;  Z : out std_logic);
   end component;
   
   component FD1
      port( CP, D : in std_logic;  Q, QN : out std_logic);
   end component;
   
   component FD1P
      port( CP, D : in std_logic;  Q, QN : out std_logic);
   end component;
   
   component FD1SP
      port( CP, D, TE, TI : in std_logic;  Q, QN : out std_logic);
   end component;
   
   component AO7A
      port( A, B, C : in std_logic;  Z : out std_logic);
   end component;
   
   component AO34
      port( A, B, C, D : in std_logic;  Z : out std_logic);
   end component;
   
   component AO6C
      port( A, B, C : in std_logic;  Z : out std_logic);
   end component;
   
   component ND2P
      port( A, B : in std_logic;  Z : out std_logic);
   end component;
   
   component MUX21X4
      port( A, B, S : in std_logic;  Z : out std_logic);
   end component;
   
   signal feed_in_STATE, feed_in_BITCOUNT_3, feed_in_REQUESTMP3, feed_MP3BYTE_0
      , feed_MP3BYTE_7, feed_STATE, feed_BITCOUNT_1, mp3o46_VALID, feed_STOPIT,
      ARG272_2, feed_MP3BYTE_6, mp3o_RST, ARG272_3, feed_BITCOUNT_0, n47_DATA, 
      feed106_BITCOUNT_2, feed_MP3BYTE_1, mp3o46_RST, feed_MP3BYTE_3, 
      mp3o_VALID, feed106_BITCOUNT_0, feed_MP3BYTE_4, feed_BITCOUNT_2, ARG272_1
      , feed_MP3BYTE_5, mp3o_DATA, feed_BITCOUNT_3, feed_REQUESTMP3, feed_RESET
      , feed_MP3BYTE_2, feed_in_STOPIT, feed_in_BITCOUNT_1, n646, n647, n648, 
      n649, n650, n651, n652, n653, n654, n655, n656, n657, n658, n659, n660, 
      n661, sub_100_minus_minus_carry_1, sub_100_minus_minus_carry_2, 
      sub_100_minus_minus_carry_3, n662, n663, n664, n665, n666, n667, n668, 
      n669, n670, n671, n672, n673, n674, n675, n676, n677, n678, n679, n680, 
      n681, n682, n683, n684, n685, n686, n687, n688, n689, n690, n691, n692, 
      n693, n694, n695, n696 : std_logic;

begin
   mp3o <= ( mp3o_RST, mp3o_DATA, mp3o_VALID );
   
   U98 : IVP port map( A => n679, Z => n682);
   U99 : ND2 port map( A => feed_REQUESTMP3, B => n681, Z => n673);
   U100 : ND2 port map( A => mp3i, B => n679, Z => n696);
   U101 : MUX21P port map( A => sub_100_minus_minus_carry_1, B => n694, S => 
                           n666, Z => feed106_BITCOUNT_0);
   U102 : MUX21P port map( A => n646, B => ARG272_2, S => n666, Z => 
                           feed106_BITCOUNT_2);
   U103 : AN3P port map( A => n671, B => rst, C => n664, Z => feed_in_STOPIT);
   U104 : OR2P port map( A => feed_STOPIT, B => stopit, Z => n671);
   U105 : ND2 port map( A => n670, B => n671, Z => n664);
   U106 : ND2 port map( A => feed_STATE, B => n664, Z => n669);
   U107 : IVP port map( A => rst, Z => n662);
   U108 : ND2 port map( A => n684, B => rst, Z => n663);
   U109 : IVP port map( A => n681, Z => n684);
   U110 : IVP port map( A => n669, Z => n695);
   U111 : IVP port map( A => n663, Z => n686);
   U112 : IVP port map( A => n47_DATA, Z => n658);
   U113 : ND4 port map( A => n657, B => rst, C => n664, D => n665, Z => 
                           n47_DATA);
   U114 : ND3 port map( A => n657, B => n664, C => n666, Z => n667);
   U115 : ND2 port map( A => n667, B => n47_DATA, Z => mp3o46_RST);
   U116 : IVP port map( A => feed_RESET, Z => n657);
   feed_reg_MP3BYTE_0 : FD1SQP port map( CP => clk, D => n655, TE => n666, TI 
                           => n661, Q => feed_MP3BYTE_0);
   feed_reg_MP3BYTE_1 : FD1SQP port map( CP => clk, D => n654, TE => n666, TI 
                           => n655, Q => feed_MP3BYTE_1);
   feed_reg_MP3BYTE_2 : FD1SQP port map( CP => clk, D => n653, TE => n666, TI 
                           => n654, Q => feed_MP3BYTE_2);
   feed_reg_MP3BYTE_3 : FD1SQP port map( CP => clk, D => n652, TE => n666, TI 
                           => n653, Q => feed_MP3BYTE_3);
   feed_reg_MP3BYTE_4 : FD1SQP port map( CP => clk, D => n651, TE => n666, TI 
                           => n652, Q => feed_MP3BYTE_4);
   feed_reg_MP3BYTE_5 : FD1SQP port map( CP => clk, D => n650, TE => n666, TI 
                           => n651, Q => feed_MP3BYTE_5);
   feed_reg_MP3BYTE_6 : FD1SQP port map( CP => clk, D => n649, TE => n666, TI 
                           => n650, Q => feed_MP3BYTE_6);
   feed_reg_MP3BYTE_7 : FD1SQP port map( CP => clk, D => n648, TE => n666, TI 
                           => n649, Q => feed_MP3BYTE_7);
   feed_reg_BITCOUNT_3 : FD1SQP port map( CP => clk, D => feed_in_BITCOUNT_3, 
                           TE => n666, TI => ARG272_3, Q => feed_BITCOUNT_3);
   U117 : IVP port map( A => feed_BITCOUNT_3, Z => n676);
   feed_reg_STOPIT : FD1Q port map( CP => clk, D => feed_in_STOPIT, Q => 
                           feed_STOPIT);
   feed_reg_STATE : FD1Q port map( CP => clk, D => feed_in_STATE, Q => 
                           feed_STATE);
   requestmp3_reg : FD1Q port map( CP => clk, D => n656, Q => requestmp3);
   mp3o_reg_VALID : FD1Q port map( CP => clk, D => mp3o46_VALID, Q => 
                           mp3o_VALID);
   mp3o_reg_RST : FD1Q port map( CP => clk, D => mp3o46_RST, Q => mp3o_RST);
   U118 : AN2 port map( A => feed_BITCOUNT_2, B => n647, Z => n646);
   U119 : AN2 port map( A => rst, B => n681, Z => n647);
   U120 : IVP port map( A => n665, Z => n666);
   U121 : IVP port map( A => n694, Z => sub_100_minus_minus_carry_1);
   U122 : ND2 port map( A => feed_BITCOUNT_0, B => n647, Z => n694);
   U123 : IVP port map( A => n674, Z => n670);
   U124 : ND4 port map( A => n675, B => n676, C => n677, D => n678, Z => n674);
   U125 : IVP port map( A => n693, Z => feed_in_BITCOUNT_1);
   U126 : ND2 port map( A => feed_BITCOUNT_1, B => n647, Z => n693);
   U127 : BF1T1 port map( A => n668, Z => n648);
   U128 : BF1T1 port map( A => n685, Z => n649);
   U129 : BF1T1 port map( A => n687, Z => n650);
   U130 : BF1T1 port map( A => n688, Z => n651);
   U131 : BF1T1 port map( A => n689, Z => n652);
   U132 : BF1T1 port map( A => n690, Z => n653);
   U133 : BF1T1 port map( A => n691, Z => n654);
   U134 : BF1T1 port map( A => n692, Z => n655);
   U135 : BF1T1 port map( A => feed_in_REQUESTMP3, Z => n656);
   U136 : EN port map( A => sub_100_minus_minus_carry_3, B => 
                           feed_in_BITCOUNT_3, Z => ARG272_3);
   U137 : OR2 port map( A => n646, B => sub_100_minus_minus_carry_2, Z => 
                           sub_100_minus_minus_carry_3);
   U138 : EN port map( A => sub_100_minus_minus_carry_2, B => n646, Z => 
                           ARG272_2);
   U139 : OR2 port map( A => feed_in_BITCOUNT_1, B => 
                           sub_100_minus_minus_carry_1, Z => 
                           sub_100_minus_minus_carry_2);
   U140 : EN port map( A => sub_100_minus_minus_carry_1, B => 
                           feed_in_BITCOUNT_1, Z => ARG272_1);
   U141 : AO2N port map( A => feed_MP3BYTE_7, B => n647, C => mp3byte(7), D => 
                           n686, Z => n668);
   U142 : AO2N port map( A => n668, B => mp3o46_VALID, C => mp3o_DATA, D => 
                           n658, Z => n660);
   U143 : IV4 port map( A => n667, Z => mp3o46_VALID);
   n659 <= '0';
   feed_reg_RESET : FD1 port map( CP => clk, D => n659, Q => feed_RESET, QN => 
                           open);
   mp3o_reg_DATA : FD1 port map( CP => clk, D => n660, Q => mp3o_DATA, QN => 
                           open);
   feed_reg_REQUESTMP3 : FD1P port map( CP => clk, D => n656, Q => 
                           feed_REQUESTMP3, QN => n680);
   n661 <= '0';
   feed_reg_BITCOUNT_0 : FD1P port map( CP => clk, D => feed106_BITCOUNT_0, Q 
                           => feed_BITCOUNT_0, QN => n677);
   feed_reg_BITCOUNT_1 : FD1SP port map( CP => clk, D => feed_in_BITCOUNT_1, TE
                           => n666, TI => ARG272_1, Q => feed_BITCOUNT_1, QN =>
                           n678);
   feed_reg_BITCOUNT_2 : FD1P port map( CP => clk, D => feed106_BITCOUNT_2, Q 
                           => feed_BITCOUNT_2, QN => n675);
   U146 : AO7A port map( A => feed_BITCOUNT_3, B => n662, C => n663, Z => 
                           feed_in_BITCOUNT_3);
   U147 : AO34 port map( A => n669, B => n670, C => n662, D => n663, Z => 
                           feed_in_STATE);
   U148 : AO6C port map( A => n672, B => n673, C => rst, Z => 
                           feed_in_REQUESTMP3);
   U149 : AO7A port map( A => n680, B => mp3i, C => takethismp3, Z => n679);
   U150 : ND2P port map( A => n682, B => n669, Z => n681);
   U151 : AO34 port map( A => n683, B => n646, C => feed_in_BITCOUNT_3, D => 
                           mp3i, Z => n665);
   U152 : AO2N port map( A => feed_MP3BYTE_6, B => n647, C => mp3byte(6), D => 
                           n686, Z => n685);
   U153 : AO2N port map( A => feed_MP3BYTE_5, B => n647, C => mp3byte(5), D => 
                           n686, Z => n687);
   U154 : AO2N port map( A => feed_MP3BYTE_4, B => n647, C => mp3byte(4), D => 
                           n686, Z => n688);
   U155 : AO2N port map( A => feed_MP3BYTE_3, B => n647, C => mp3byte(3), D => 
                           n686, Z => n689);
   U156 : AO2N port map( A => feed_MP3BYTE_2, B => n647, C => mp3byte(2), D => 
                           n686, Z => n690);
   U157 : AO2N port map( A => feed_MP3BYTE_1, B => n647, C => mp3byte(1), D => 
                           n686, Z => n691);
   U158 : AO2N port map( A => feed_MP3BYTE_0, B => n647, C => mp3byte(0), D => 
                           n686, Z => n692);
   U159 : ND2P port map( A => n693, B => n694, Z => n683);
   U160 : MUX21X4 port map( A => n696, B => n674, S => n695, Z => n672);

end SYN_FOOBAR;

library IEEE,MTC45000,MTC45100X,LIB_GENERATORS,STVLIB;

use IEEE.std_logic_1164.all;
use IEEE.std_logic_arith.all;
use MTC45000.VCOMPONENTS.all;
use MTC45100X.VCOMPONENTS.all;
use LIB_GENERATORS.PCK_GENERATORS.all;
use STVLIB.ST_TIMING.all;
use STVLIB.ST_VSS.all;

entity mmu_DW01_inc_32_0 is

   port( A : in std_logic_vector (31 downto 0);  SUM : out std_logic_vector (31
         downto 0));

end mmu_DW01_inc_32_0;

architecture SYN_rpl of mmu_DW01_inc_32_0 is

   component EN
      port( A, B : in std_logic;  Z : out std_logic);
   end component;
   
   component IVP
      port( A : in std_logic;  Z : out std_logic);
   end component;
   
   component HA01D1
      port( A, B : in std_logic;  CO, S : out std_logic);
   end component;
   
   signal carry_29, carry_15, carry_8, carry_20, carry_27, carry_12, carry_6, 
      carry_26, carry_13, carry_7, carry_14, carry_28, carry_21, carry_9, 
      carry_2, carry_31, carry_16, carry_23, carry_24, carry_18, carry_11, 
      carry_5, carry_25, carry_19, carry_4, carry_10, carry_30, carry_17, 
      carry_3, carry_22, n1 : std_logic;

begin
   
   U5 : EN port map( A => n1, B => A(31), Z => SUM(31));
   U6 : IVP port map( A => carry_31, Z => n1);
   U7 : IVP port map( A => A(0), Z => SUM(0));
   U1_1_3 : HA01D1 port map( A => A(3), B => carry_3, CO => carry_4, S => 
                           SUM(3));
   U1_1_4 : HA01D1 port map( A => A(4), B => carry_4, CO => carry_5, S => 
                           SUM(4));
   U1_1_10 : HA01D1 port map( A => A(10), B => carry_10, CO => carry_11, S => 
                           SUM(10));
   U1_1_19 : HA01D1 port map( A => A(19), B => carry_19, CO => carry_20, S => 
                           SUM(19));
   U1_1_22 : HA01D1 port map( A => A(22), B => carry_22, CO => carry_23, S => 
                           SUM(22));
   U1_1_25 : HA01D1 port map( A => A(25), B => carry_25, CO => carry_26, S => 
                           SUM(25));
   U1_1_17 : HA01D1 port map( A => A(17), B => carry_17, CO => carry_18, S => 
                           SUM(17));
   U1_1_30 : HA01D1 port map( A => A(30), B => carry_30, CO => carry_31, S => 
                           SUM(30));
   U1_1_1 : HA01D1 port map( A => A(1), B => A(0), CO => carry_2, S => SUM(1));
   U1_1_2 : HA01D1 port map( A => A(2), B => carry_2, CO => carry_3, S => 
                           SUM(2));
   U1_1_5 : HA01D1 port map( A => A(5), B => carry_5, CO => carry_6, S => 
                           SUM(5));
   U1_1_11 : HA01D1 port map( A => A(11), B => carry_11, CO => carry_12, S => 
                           SUM(11));
   U1_1_16 : HA01D1 port map( A => A(16), B => carry_16, CO => carry_17, S => 
                           SUM(16));
   U1_1_23 : HA01D1 port map( A => A(23), B => carry_23, CO => carry_24, S => 
                           SUM(23));
   U1_1_24 : HA01D1 port map( A => A(24), B => carry_24, CO => carry_25, S => 
                           SUM(24));
   U1_1_7 : HA01D1 port map( A => A(7), B => carry_7, CO => carry_8, S => 
                           SUM(7));
   U1_1_13 : HA01D1 port map( A => A(13), B => carry_13, CO => carry_14, S => 
                           SUM(13));
   U1_1_18 : HA01D1 port map( A => A(18), B => carry_18, CO => carry_19, S => 
                           SUM(18));
   U1_1_9 : HA01D1 port map( A => A(9), B => carry_9, CO => carry_10, S => 
                           SUM(9));
   U1_1_21 : HA01D1 port map( A => A(21), B => carry_21, CO => carry_22, S => 
                           SUM(21));
   U1_1_26 : HA01D1 port map( A => A(26), B => carry_26, CO => carry_27, S => 
                           SUM(26));
   U1_1_28 : HA01D1 port map( A => A(28), B => carry_28, CO => carry_29, S => 
                           SUM(28));
   U1_1_14 : HA01D1 port map( A => A(14), B => carry_14, CO => carry_15, S => 
                           SUM(14));
   U1_1_6 : HA01D1 port map( A => A(6), B => carry_6, CO => carry_7, S => 
                           SUM(6));
   U1_1_8 : HA01D1 port map( A => A(8), B => carry_8, CO => carry_9, S => 
                           SUM(8));
   U1_1_15 : HA01D1 port map( A => A(15), B => carry_15, CO => carry_16, S => 
                           SUM(15));
   U1_1_20 : HA01D1 port map( A => A(20), B => carry_20, CO => carry_21, S => 
                           SUM(20));
   U1_1_12 : HA01D1 port map( A => A(12), B => carry_12, CO => carry_13, S => 
                           SUM(12));
   U1_1_29 : HA01D1 port map( A => A(29), B => carry_29, CO => carry_30, S => 
                           SUM(29));
   U1_1_27 : HA01D1 port map( A => A(27), B => carry_27, CO => carry_28, S => 
                           SUM(27));

end SYN_rpl;

library IEEE,MTC45000,MTC45100X,LIB_GENERATORS,STVLIB;

use IEEE.std_logic_1164.all;
use IEEE.std_logic_arith.all;
use MTC45000.VCOMPONENTS.all;
use MTC45100X.VCOMPONENTS.all;
use LIB_GENERATORS.PCK_GENERATORS.all;
use STVLIB.ST_TIMING.all;
use STVLIB.ST_VSS.all;

entity mmu is

   port( clk : in std_logic;  halt : out std_logic;  rst : in std_logic;  uarti
         : out std_logic_vector (0 to 9);  uarto : in std_logic_vector (0 to 9)
         ;  cpu_addr : in std_logic_vector (15 downto 0);  cpu_in : out 
         std_logic_vector (7 downto 0);  cpu_out : in std_logic_vector (7 
         downto 0);  cpu_we, cpu_re : in std_logic;  ram_data_in : out 
         std_logic_vector (7 downto 0);  ram_data_out : in std_logic_vector (7 
         downto 0);  ram_we : out std_logic;  flashi : in std_logic_vector (0 
         to 7);  flasho : out std_logic_vector (0 to 30);  button_play, 
         button_stop, button_prev, button_next : in std_logic;  clock_rst, 
         clock_hold, clock_read : out std_logic;  clock_seconds, clock_minutes,
         clock_hours : in std_logic_vector (7 downto 0);  mp3i : in std_logic; 
         mp3o : out std_logic_vector (0 to 2);  dac_data_byteh, dac_data_bytel 
         : out std_logic_vector (7 downto 0);  dac_send_data : out std_logic;  
         dac_data_req : in std_logic);

end mmu;

architecture SYN_FNORD of mmu is

   component mp3uart
      port( clk, rst : in std_logic;  mp3byte : in std_logic_vector (7 downto 
            0);  takethismp3 : in std_logic;  requestmp3 : out std_logic;  
            stopit, mp3i : in std_logic;  mp3o : out std_logic_vector (0 to 2)
            );
   end component;
   
   component ND2
      port( A, B : in std_logic;  Z : out std_logic);
   end component;
   
   component MUX21P
      port( A, B, S : in std_logic;  Z : out std_logic);
   end component;
   
   component EO
      port( A, B : in std_logic;  Z : out std_logic);
   end component;
   
   component IVP
      port( A : in std_logic;  Z : out std_logic);
   end component;
   
   component NR2
      port( A, B : in std_logic;  Z : out std_logic);
   end component;
   
   component ND3
      port( A, B, C : in std_logic;  Z : out std_logic);
   end component;
   
   component AN3P
      port( A, B, C : in std_logic;  Z : out std_logic);
   end component;
   
   component AN4P
      port( A, B, C, D : in std_logic;  Z : out std_logic);
   end component;
   
   component ND5P
      port( A, B, C, D, E : in std_logic;  Z : out std_logic);
   end component;
   
   component FD1Q
      port( CP, D : in std_logic;  Q : out std_logic);
   end component;
   
   component FD1SQP
      port( CP, D, TE, TI : in std_logic;  Q : out std_logic);
   end component;
   
   component AN2
      port( A, B : in std_logic;  Z : out std_logic);
   end component;
   
   component AN5
      port( A, B, C, D, E : in std_logic;  Z : out std_logic);
   end component;
   
   component AN4
      port( A, B, C, D : in std_logic;  Z : out std_logic);
   end component;
   
   component AN3
      port( A, B, C : in std_logic;  Z : out std_logic);
   end component;
   
   component AO7CN
      port( A, B, C : in std_logic;  Z : out std_logic);
   end component;
   
   component NR6
      port( A, B, C, D, E, F : in std_logic;  Z : out std_logic);
   end component;
   
   component BF1T1
      port( A : in std_logic;  Z : out std_logic);
   end component;
   
   component ND2A
      port( A, B : in std_logic;  Z : out std_logic);
   end component;
   
   component BF1T2
      port( A : in std_logic;  Z : out std_logic);
   end component;
   
   component IV5
      port( A : in std_logic;  Z : out std_logic);
   end component;
   
   component AO28
      port( A, B, C, D : in std_logic;  Z : out std_logic);
   end component;
   
   component AN2P
      port( A, B : in std_logic;  Z : out std_logic);
   end component;
   
   component FD1
      port( CP, D : in std_logic;  Q, QN : out std_logic);
   end component;
   
   component FD1QX4
      port( CP, D : in std_logic;  Q : out std_logic);
   end component;
   
   component FD1P
      port( CP, D : in std_logic;  Q, QN : out std_logic);
   end component;
   
   component FD1SP
      port( CP, D, TE, TI : in std_logic;  Q, QN : out std_logic);
   end component;
   
   component mmu_DW01_inc_32_0
      port( A : in std_logic_vector (31 downto 0);  SUM : out std_logic_vector 
            (31 downto 0));
   end component;
   
   component AO2N
      port( A, B, C, D : in std_logic;  Z : out std_logic);
   end component;
   
   component AO7N
      port( A, B, C : in std_logic;  Z : out std_logic);
   end component;
   
   component AO7A
      port( A, B, C : in std_logic;  Z : out std_logic);
   end component;
   
   component AO25
      port( A, B, C, D, E : in std_logic;  Z : out std_logic);
   end component;
   
   component AO3A
      port( A, B, C, D : in std_logic;  Z : out std_logic);
   end component;
   
   component AO1N
      port( A, B, C, D : in std_logic;  Z : out std_logic);
   end component;
   
   component AO6C
      port( A, B, C : in std_logic;  Z : out std_logic);
   end component;
   
   component AO8
      port( A, B, C, D : in std_logic;  Z : out std_logic);
   end component;
   
   component AO2A
      port( A, B, C, D : in std_logic;  Z : out std_logic);
   end component;
   
   component OR8
      port( A, B, C, D, E, F, G, H : in std_logic;  Z : out std_logic);
   end component;
   
   component IV4
      port( A : in std_logic;  Z : out std_logic);
   end component;
   
   component ND3P
      port( A, B, C : in std_logic;  Z : out std_logic);
   end component;
   
   component AO17
      port( A, B, C, D : in std_logic;  Z : out std_logic);
   end component;
   
   component AO3C
      port( A, B, C, D : in std_logic;  Z : out std_logic);
   end component;
   
   component ND8P
      port( A, B, C, D, E, F, G, H : in std_logic;  Z : out std_logic);
   end component;
   
   component OR6
      port( A, B, C, D, E, F : in std_logic;  Z : out std_logic);
   end component;
   
   component AO3N
      port( A, B, C, D : in std_logic;  Z : out std_logic);
   end component;
   
   component AO6N
      port( A, B, C : in std_logic;  Z : out std_logic);
   end component;
   
   component AO6A
      port( A, B, C : in std_logic;  Z : out std_logic);
   end component;
   
   component AO29
      port( A, B, C, D, E : in std_logic;  Z : out std_logic);
   end component;
   
   component AO7C
      port( A, B, C : in std_logic;  Z : out std_logic);
   end component;
   
   signal mp3byte_2, buff_in_FLASHO_ADDR_18, b1530_FLASH_WRITE_CONFIRM_BIT, 
      buff_FLASHO_ADDR_16, b1453_PLAY_ADDR_11, b1530_FLASH_PLAY_ADDR_14, 
      buff_FLASH_PLAY_ADDR_28, buff_FLASH_STOP_ADDR_23, b1530_RAM_DATA_IN_4, 
      buff_in_DAC_DATA_BYTEH_1, buff_PLAY_ADDR_29, b_CPU_IN_7, 
      buff_FLASHO_ADDR_1, buff_FLASH_WRITE_ADDR_9, b1530_FLASH_WRITE_ADDR_10, 
      b1530_FLASH_PLAY_ADDR_6, b1530_PLAY_ADDR_10, b1530_MP3BYTE_3, 
      buff_in_MP3_DMA_STATE_0, buff_in_LCD_UART_DATA_5, buff_in_FLASHO_ADDR_11,
      buff_in_FLASHO_ADDR_1, buff_in_DAC_DATA_BYTEL_7, b1530_FLASH_STOP_ADDR_9,
      buff_FLASHO_WDATA_7, buff_FLASH_PLAY_ADDR_3, b1530_FLASH_WRITE_ADDR_9, 
      ARG3346_7, buff_FLASH_WRITE_ADDR_17, buff_PLAY_ADDR_15, 
      b1530_FLASH_PLAY_ADDR_28, b1530_FLASH_STOP_ADDR_23, 
      buff_FLASH_PLAY_ADDR_14, ARG3346_12, buff_LCD_UART_DATA_3, 
      buff_MP3_DMA_STATE_1, b1530_PLAY_ADDR_7, buff_CPU_IN_5, 
      buff_FLASH_PLAY_ADDR_21, ARG3346_27, b1530_FLASH_STOP_ADDR_31, 
      b1453_PLAY_ADDR_18, b1530_FLASH_STOP_ADDR_16, buff_PLAY_ADDR_20, 
      buff_DAC_DATA_BYTEL_0, b1530_PLAY_ADDR_19, b1530_FLASH_WRITE_ADDR_19, 
      buff_FLASH_STOP_ADDR_5, buff_FLASHO_ADDR_8, buff_FLASH_WRITE_ADDR_0, 
      b1530_PLAY_ADDR_25, b1530_FLASH_WRITE_ADDR_0, b1530_FLASH_STOP_ADDR_0, 
      buff_DAC_DATA_BYTEH_6, b1453_PLAY_ADDR_4, buff_FLASH_STOP_ADDR_16, 
      buff_in_LCD_UART_DATA_2, buff_in_FLASHO_WDATA_0, buff_in_FLASHO_ADDR_8, 
      buff_FLASH_STOP_ADDR_31, buff_RAM_DATA_IN_6, b1530_FLASH_PLAY_ADDR_21, 
      b1453_PLAY_ADDR_24, buff_PLAY_ADDR_2, buff_STATE_2, buff_MP3BYTE_2, 
      buff_FLASHO_WE, b1453_PLAY_ADDR_23, buff_PLAY_ADDR_5, buff_RAM_DATA_IN_1,
      b1530_FLASH_PLAY_ADDR_26, buff_CLOCK_HOLD, buff_FLASH_STOP_ADDR_11, 
      buff_in_FLASHO_WDATA_7, buff_MP3BYTE_5, b1530_PLAY_ADDR_9, 
      buff_DAC_DATA_BYTEH_1, b1530_FLASH_STOP_ADDR_7, b1530_FLASH_WRITE_ADDR_7,
      ARG3346_9, b1530_PLAY_ADDR_22, mp3byte_5, buff_in_FLASHO_ADDR_16, 
      buff_FLASH_WRITE_ADDR_19, b1453_PLAY_ADDR_3, buff_in_FLASHO_ADDR_6, 
      buff_DAC_DATA_BYTEL_7, buff_PLAY_ADDR_27, buff_FLASH_WRITE_ADDR_7, 
      buff_FLASH_STOP_ADDR_2, b1530_FLASH_PLAY_ADDR_8, buff_CPU_IN_2, 
      buff_FLASHO_ADDR_18, b1530_FLASH_STOP_ADDR_11, buff_FLASH_PLAY_ADDR_26, 
      buff_FLASH_PLAY_ADDR_13, ARG3346_20, buff_FLASH_STOP_ADDR_18, ARG3346_15,
      b1530_FLASH_STOP_ADDR_24, b1530_PLAY_ADDR_0, buff_in_STOPPED, 
      buff_LCD_UART_DATA_4, buff_PLAYSTATE_1, ARG3346_0, 
      buff_in_DAC_DATA_BYTEL_0, buff_FLASH_PLAY_ADDR_4, buff_FLASHO_WDATA_0, 
      b1530_MP3BYTE_4, buff_PLAY_ADDR_12, buff_FLASH_WRITE_ADDR_10, 
      buff_in_DAC_DATA_BYTEH_6, b_CPU_IN_0, b1530_PLAY_ADDR_17, 
      b1530_FLASH_PLAY_ADDR_1, b1530_FLASH_WRITE_ADDR_17, buff_FLASHO_ADDR_6, 
      b1530_PLAY_ADDR_30, buff_in_LCD_UART_DATA_3, buff_in_FLASHO_ADDR_17, 
      buff_in_FLASHO_EN, buff_FLASH_STOP_ADDR_24, b1530_RAM_DATA_IN_3, 
      ARG3346_29, b1453_PLAY_ADDR_31, buff_FLASHO_ADDR_11, 
      b1530_FLASH_PLAY_ADDR_13, b1453_PLAY_ADDR_16, b1530_FLASH_STOP_ADDR_18, 
      buff_CPU_IN_3, buff_FLASHO_ADDR_19, b1530_FLASH_STOP_ADDR_10, ARG3346_21,
      buff_FLASH_PLAY_ADDR_27, buff_PC_UART_ACK_RCV, buff_DAC_DATA_BYTEL_6, 
      buff_PLAY_ADDR_26, buff_FLASH_WRITE_ADDR_6, buff_FLASH_STOP_ADDR_3, 
      b1530_FLASH_PLAY_ADDR_9, buff_DAC_DATA_BYTEH_0, b1530_FLASH_STOP_ADDR_6, 
      ARG3346_8, b1530_PLAY_ADDR_23, b1530_FLASH_WRITE_ADDR_6, buff_STOPIT, 
      buff_FLASH_WRITE_ADDR_18, b1453_PLAY_ADDR_2, b1453_PLAY_ADDR_22, 
      buff_PLAY_ADDR_4, buff_RAM_DATA_IN_0, b1530_FLASH_PLAY_ADDR_27, 
      buff_FLASH_STOP_ADDR_10, buff_TAKETHISMP3, buff_in_FLASHO_WDATA_6, 
      buff_MP3BYTE_4, buff_STATE_4, b1530_PLAY_ADDR_8, mp3byte_4, 
      buff_FLASH_STOP_ADDR_25, b1530_RAM_DATA_IN_2, ARG3346_28, 
      b1453_PLAY_ADDR_30, buff_FLASHO_ADDR_10, b1530_FLASH_STOP_ADDR_19, 
      b1530_FLASH_PLAY_ADDR_12, b1453_PLAY_ADDR_17, buff_in_DAC_DATA_BYTEH_7, 
      b_CPU_IN_1, b1530_PLAY_ADDR_16, buff_CLOCK_READ, 
      b1530_FLASH_WRITE_ADDR_16, b1530_FLASH_PLAY_ADDR_0, buff_FLASHO_ADDR_7, 
      b1530_PLAY_ADDR_31, b_HALT, ARG3346_1, buff_in_DAC_DATA_BYTEL_1, 
      buff_FLASH_PLAY_ADDR_5, mp3byte_3, buff_in_FLASHO_ADDR_7, 
      buff_FLASHO_WDATA_1, b1530_MP3BYTE_5, buff_FLASH_WRITE_ADDR_11, 
      buff_PLAY_ADDR_13, buff_FLASH_PLAY_ADDR_12, buff_FLASH_STOP_ADDR_19, 
      ARG3346_14, buff_in_FLASHO_ADDR_0, b1530_FLASH_STOP_ADDR_25, 
      b1530_PLAY_ADDR_1, buff_PLAYSTATE_0, buff_LCD_UART_DATA_5, 
      b1530_FLASH_STOP_ADDR_22, b1530_FLASH_PLAY_ADDR_29, buff_LCD_UART_DATA_2,
      buff_FLASH_PLAY_ADDR_15, ARG3346_13, buff_MP3_DMA_STATE_0, 
      b1530_PLAY_ADDR_6, b1530_MP3BYTE_2, b1530_FLASH_STOP_ADDR_8, 
      buff_FLASHO_WDATA_6, mp3byte_1, buff_in_FLASHO_ADDR_19, 
      buff_in_DAC_DATA_BYTEL_6, buff_FLASH_PLAY_ADDR_2, ARG3346_6, 
      b1530_FLASH_WRITE_ADDR_8, buff_FLASH_WRITE_ADDR_16, buff_PLAY_ADDR_14, 
      buff_in_DAC_DATA_BYTEH_0, buff_PLAY_ADDR_28, b_CPU_IN_6, 
      buff_FLASHO_ADDR_0, buff_FLASH_WRITE_ADDR_8, buff_in_LCD_UART_DATA_4, 
      b1530_FLASH_PLAY_ADDR_7, b1530_FLASH_WRITE_ADDR_11, b1530_PLAY_ADDR_11, 
      b1453_PLAY_ADDR_10, b1530_FLASH_PLAY_ADDR_15, buff_FLASHO_ADDR_17, 
      buff_FLASH_STOP_ADDR_22, b1530_RAM_DATA_IN_5, buff_FLASH_PLAY_ADDR_29, 
      buff_FLASH_STOP_ADDR_17, buff_in_FLASHO_WDATA_1, buff_in_FLASHO_ADDR_9, 
      buff_RAM_DATA_IN_7, b1530_FLASH_PLAY_ADDR_20, b1453_PLAY_ADDR_25, 
      buff_PLAY_ADDR_3, buff_FLASH_STOP_ADDR_30, buff_STATE_3, buff_MP3BYTE_3, 
      buff_in_FLASHO_ADDR_10, b1530_FLASH_WRITE_ADDR_1, b1530_PLAY_ADDR_24, 
      b1530_FLASH_STOP_ADDR_1, buff_DAC_DATA_BYTEH_7, buff_LCD_UART_SEND, 
      buff_CLOCK_RST, b1453_PLAY_ADDR_5, buff_PLAY_ADDR_21, 
      buff_DAC_DATA_BYTEL_1, b1530_PLAY_ADDR_18, b1530_FLASH_WRITE_ADDR_18, 
      buff_FLASH_STOP_ADDR_4, buff_FLASHO_ADDR_9, buff_FLASH_WRITE_ADDR_1, 
      buff_in_FLASHO_OE, buff_CPU_IN_4, buff_FLASH_PLAY_ADDR_20, 
      b1530_FLASH_STOP_ADDR_30, ARG3346_26, b1530_FLASH_STOP_ADDR_17, 
      b1453_PLAY_ADDR_19, buff_FLASHO_ADDR_15, buff_FLASH_STOP_ADDR_20, 
      b1530_FLASH_PLAY_ADDR_30, b1530_RAM_DATA_IN_7, b1530_FLASH_PLAY_ADDR_17, 
      b1453_PLAY_ADDR_12, b1530_FLASH_WRITE_ADDR_13, b1530_FLASH_PLAY_ADDR_5, 
      b1530_PLAY_ADDR_13, buff_FLASHO_ADDR_2, b_CPU_IN_4, buff_in_RAM_WE, 
      buff_in_DAC_DATA_BYTEH_2, buff_FLASH_WRITE_ADDR_14, buff_PLAY_ADDR_16, 
      buff_PLAY_ADDR_31, buff_in_DAC_DATA_BYTEL_4, buff_FLASH_PLAY_ADDR_0, 
      ARG3346_4, b1530_MP3BYTE_0, stopit, buff_FLASHO_WDATA_4, 
      b1530_PLAY_ADDR_4, b1530_TAKETHISMP3, buff_in_FLASHO_ADDR_12, 
      buff_in_FLASHO_ADDR_2, buff_LCD_UART_DATA_0, ARG3346_11, 
      buff_FLASH_PLAY_ADDR_17, buff_PLAY_ADDR_8, buff_FLASH_PLAY_ADDR_30, 
      b1530_FLASH_STOP_ADDR_20, b1530_FLASH_STOP_ADDR_15, 
      buff_FLASH_STOP_ADDR_29, ARG3346_24, buff_FLASH_PLAY_ADDR_22, 
      buff_CPU_IN_6, buff_FLASH_STOP_ADDR_6, buff_FLASH_WRITE_ADDR_3, 
      buff_DAC_DATA_BYTEL_3, buff_PLAY_ADDR_23, b1453_PLAY_ADDR_7, 
      b1530_FLASH_STOP_ADDR_3, buff_DAC_DATA_BYTEH_5, b1530_PLAY_ADDR_26, 
      b1530_FLASH_WRITE_ADDR_3, mp3byte_6, requestmp3, buff_in_LCD_UART_DATA_6,
      buff_in_FLASHO_WDATA_3, buff_FLASH_PLAY_ADDR_9, buff_MP3BYTE_1, 
      buff_STATE_1, buff_PLAY_ADDR_1, b1530_FLASH_STOP_ADDR_29, 
      b1453_PLAY_ADDR_27, buff_RAM_DATA_IN_5, b1530_FLASH_PLAY_ADDR_22, 
      buff_FLASH_STOP_ADDR_15, ARG3346_18, buff_in_LCD_UART_DATA_1, 
      buff_in_FLASHO_WDATA_4, buff_MP3BYTE_6, buff_in_FLASHO_ADDR_15, 
      buff_FLASH_PLAY_ADDR_19, buff_FLASH_STOP_ADDR_12, buff_PLAY_ADDR_6, 
      buff_RAM_DATA_IN_2, b1530_FLASH_PLAY_ADDR_25, b1453_PLAY_ADDR_20, 
      buff_PLAY_ADDR_18, buff_FLASHO_OE, b1453_PLAY_ADDR_0, 
      b1530_FLASH_WRITE_ADDR_4, b1530_PLAY_ADDR_21, buff_DAC_DATA_BYTEH_2, 
      b1530_FLASH_STOP_ADDR_4, buff_FLASH_WRITE_ADDR_4, buff_FLASH_STOP_ADDR_1,
      buff_PLAY_ADDR_24, buff_in_CLOCK_RST, buff_DAC_DATA_BYTEL_4, 
      buff_FLASH_PLAY_ADDR_25, ARG3346_23, buff_in_PLAYSTATE_1, 
      b1530_FLASH_STOP_ADDR_12, b1530_FLASH_PLAY_ADDR_19, buff_in_FLASHO_ADDR_5
      , buff_CPU_IN_1, buff_LCD_UART_DATA_7, b1530_PLAY_ADDR_3, 
      b1530_FLASH_STOP_ADDR_27, b1453_PLAY_ADDR_29, buff_FLASH_PLAY_ADDR_10, 
      ARG3346_31, ARG3346_16, b1453_PLAY_ADDR_9, buff_FLASH_WRITE_ADDR_13, 
      buff_PLAY_ADDR_11, buff_FLASHO_WDATA_3, b1530_MP3BYTE_7, 
      buff_in_DAC_DATA_BYTEL_3, b1530_PLAY_ADDR_28, buff_FLASH_PLAY_ADDR_7, 
      ARG3346_3, buff_FLASH_STOP_ADDR_8, buff_in_LCD_UART_DATA_0, 
      buff_in_FLASHO_WDATA_5, buff_in_FLASHO_ADDR_14, buff_in_FLASHO_WE, 
      buff_FLASHO_ADDR_5, buff_in_DAC_DATA_BYTEH_5, b1530_PLAY_ADDR_14, 
      b1530_FLASH_PLAY_ADDR_2, b1530_FLASH_WRITE_ADDR_14, b_CPU_IN_3, 
      b1453_PLAY_ADDR_15, b1530_FLASH_PLAY_ADDR_10, buff_FLASHO_ADDR_12, 
      buff_FLASH_STOP_ADDR_27, b1530_RAM_DATA_IN_0, ARG3346_22, 
      buff_FLASH_PLAY_ADDR_24, b1530_FLASH_PLAY_ADDR_18, buff_in_PLAYSTATE_0, 
      b1530_FLASH_STOP_ADDR_13, buff_CPU_IN_0, buff_STOPPED, 
      buff_FLASH_STOP_ADDR_0, buff_FLASH_WRITE_ADDR_5, buff_PLAY_ADDR_25, 
      buff_DAC_DATA_BYTEL_5, buff_PLAY_ADDR_19, b1453_PLAY_ADDR_1, 
      b1530_PLAY_ADDR_20, buff_DAC_DATA_BYTEH_3, b1530_FLASH_WRITE_ADDR_5, 
      b1530_FLASH_STOP_ADDR_5, buff_MP3BYTE_7, buff_FLASH_PLAY_ADDR_18, 
      buff_FLASH_STOP_ADDR_13, buff_PLAY_ADDR_7, buff_RAM_DATA_IN_3, 
      b1530_FLASH_PLAY_ADDR_24, b1453_PLAY_ADDR_21, buff_FLASHO_ADDR_13, 
      b1453_PLAY_ADDR_14, b1530_FLASH_PLAY_ADDR_11, buff_FLASH_STOP_ADDR_26, 
      b1530_STOPIT, b1530_RAM_DATA_IN_1, buff_FLASHO_ADDR_4, 
      buff_FLASH_STOP_ADDR_9, b1530_PLAY_ADDR_15, buff_DAC_SEND_DATA, 
      b1530_FLASH_WRITE_ADDR_15, b1530_FLASH_PLAY_ADDR_3, mp3byte_7, 
      buff_in_DAC_DATA_BYTEH_4, b_CPU_IN_2, b1453_PLAY_ADDR_8, 
      buff_FLASH_WRITE_ADDR_12, buff_PLAY_ADDR_10, buff_in_FLASHO_ADDR_4, 
      buff_FLASHO_WDATA_2, b1530_MP3BYTE_6, buff_RAM_WE, 
      buff_in_DAC_DATA_BYTEL_2, b1530_PLAY_ADDR_29, ARG3346_2, 
      buff_FLASH_PLAY_ADDR_6, buff_LCD_UART_DATA_6, b1530_PLAY_ADDR_2, 
      b1453_PLAY_ADDR_28, ARG3346_30, buff_in_FLASHO_ADDR_3, 
      b1530_FLASH_STOP_ADDR_26, buff_FLASH_PLAY_ADDR_11, ARG3346_17, 
      b1530_PLAY_ADDR_5, buff_LCD_UART_DATA_1, b1530_FLASHO_EN, 
      buff_FLASH_PLAY_ADDR_16, buff_FLASH_PLAY_ADDR_31, ARG3346_10, 
      b1530_FLASH_STOP_ADDR_21, buff_PLAY_ADDR_17, buff_PLAY_ADDR_9, 
      buff_FLASH_WRITE_ADDR_15, mp3byte_0, buff_PLAY_ADDR_30, 
      buff_in_DAC_DATA_BYTEL_5, buff_FLASH_PLAY_ADDR_1, ARG3346_5, 
      buff_FLASHO_WDATA_5, b1530_MP3BYTE_1, takethismp3, 
      b1530_FLASH_PLAY_ADDR_4, b1530_FLASH_WRITE_ADDR_12, b1530_PLAY_ADDR_12, 
      buff_FLASHO_ADDR_3, buff_in_LCD_UART_DATA_7, buff_in_FLASHO_WDATA_2, 
      b_CPU_IN_5, buff_in_DAC_DATA_BYTEH_3, buff_FLASH_STOP_ADDR_21, 
      b1530_RAM_DATA_IN_6, b1530_FLASH_PLAY_ADDR_31, buff_FLASHO_ADDR_14, 
      b1530_FLASH_PLAY_ADDR_16, b1453_PLAY_ADDR_13, buff_MP3BYTE_0, 
      buff_STATE_0, buff_PLAY_ADDR_0, b1453_PLAY_ADDR_26, buff_RAM_DATA_IN_4, 
      b1530_FLASH_PLAY_ADDR_23, buff_FLASH_STOP_ADDR_14, 
      b1530_FLASH_STOP_ADDR_28, ARG3346_19, b1453_PLAY_ADDR_6, 
      b1530_FLASH_STOP_ADDR_2, buff_DAC_DATA_BYTEH_4, b1530_FLASH_WRITE_ADDR_2,
      b1530_PLAY_ADDR_27, buff_FLASH_PLAY_ADDR_8, buff_FLASH_STOP_ADDR_7, 
      buff_FLASH_WRITE_ADDR_2, buff_in_FLASHO_ADDR_13, buff_DAC_DATA_BYTEL_2, 
      buff_PLAY_ADDR_22, b1530_FLASH_STOP_ADDR_14, buff_FLASH_PLAY_ADDR_23, 
      buff_FLASH_STOP_ADDR_28, ARG3346_25, buff_CPU_IN_7, n6749, n6750, n6751, 
      n6752, n6753, n6754, n6755, n6756, n6757, n6758, n6759, n6760, n6761, 
      n6762, n6763, n6764, n6765, n6766, n6767, n6768, n6769, n6770, n6771, 
      n6772, n6773, n6774, n6775, n6776, n6777, n6778, n6779, n6780, n6781, 
      n6782, n6783, n6784, n6785, n6786, n6787, n6788, n6789, n6790, n6791, 
      n6792, n6793, n6794, n6795, n6796, n6797, n6798, n6799, n6800, n6801, 
      n6802, n6803, n6804, n6805, n6806, n6807, n6808, n6809, n6810, n6811, 
      n6812, n6813, n6814, n6815, n6816, n6817, n6818, n6819, n6820, n6821, 
      n6822, n6823, n6824, n6825, n6826, n6827, n6828, n6829, n6830, n6831, 
      n6832, n6833, n6834, n6835, n6836, n6837, n6838, n6839, n6840, n6841, 
      n6842, n6843, n6844, n6845, n6846, n6847, n6848, n6849, n6850, n6851, 
      n6852, n6853, n6854, n6855, n6856, n6857, n6858, n6859, n6860, n6861, 
      n6862, n6863, n6864, n6865, n6866, n6867, n6868, n6869, n6870, n6871, 
      n6872, n6873, n6874, n6875, n6876, n6877, n6878, n6879, n6880, n6881, 
      n6882, n6883, n6884, n6885, n6886, n6887, n6888, n6889, n6890, n6891, 
      n6892, n6893, n6894, n6895, n6896, n6897, n6898, n6899, n6900, n6901, 
      n6902, n6903, n6904, n6905, n6906, n6907, n6908, n6909, n6910, n6911, 
      n6912, n6913, n6914, n6915, n6916, n6917, n6918, n6919, n6920, n6921, 
      n6922, n6923, n6924, n6925, n6926, n6927, n6928, n6929, n6930, n6931, 
      n6932, n6933, n6934, n6935, n6936, n6937, n6938, n6939, n6940, n6941, 
      n6942, n6943, n6944, n6945, n6946, n6947, n6948, n6949, n6950, n6951, 
      n6952, n6953, n6954, n6955, n6956, n6957, n6958, n6959, n6960, n6961, 
      n6962, n6963, n6964, n6965, n6966, n6967, n6968, n6969, n6970, n6971, 
      n6972, n6973, n6974, n6975, n6976, n6977, n6978, n6979, n6980, n6981, 
      n6982, n6983, n6984, n6985, n6986, n6987, n6988, n6989, n6990, n6991, 
      n6992, n6993, n6994, n6995, n6996, n6997, n6998, n6999, n7000, n7001, 
      n7002, n7003, n7004, n7005, n7006, n7007, n7008, n7009, n7010, n7011, 
      n7012, n7013, n7014, n7015, n7016, n7017, n7018, n7019, n7020, n7021, 
      n7022, n7023, n7024, n7025, n7026, n7027, n7028, n7029, n7030, n7031, 
      n7032, n7033, n7034, n7035, n7036, n7037, n7038, n7039, n7040, n7041, 
      n7042, n7043, n7044, n7045, n7046, n7047, n7048, n7049, n7050, n7051, 
      n7052, n7053, n7054, n7055, n7056, n7057, n7058, n7059, n7060, n7061, 
      n7062, n7063, n7064, n7065, n7066, n7067, n7068, n7069, n7070, n7071, 
      n7072, n7073, n7074, n7075, n7076, n7077, n7078, n7079, n7080, n7081, 
      n7082, n7083, n7084, n7085, n7086, n7087, n7088, n7089, n7090, n7091, 
      n7092, n7093, n7094, n7095, n7096, n7097, n7098, n7099, n7100, n7101, 
      n7102, n7103, n7104, n7105, n7106, n7107, n7108, n7109, n7110, n7111, 
      n7112, n7113, n7114, n7115, n7116, n7117, n7118, n7119, n7120, n7121, 
      n7122, n7123, n7124, n7125, n7126, n7127, n7128, n7129, n7130, n7131, 
      n7132, n7133, n7134, n7135, n7136, n7137, n7138, n7139, n7140, n7141, 
      n7142, n7143, n7144, n7145, n7146, n7147, n7148, n7149, n7150, n7151, 
      n7152, n7153, n7154, n7155, n7156, n7157, n7158, n7159, n7160, n7161, 
      n7162, n7163, n7164, n7165, n7166, n7167, n7168, n7169, n7170, n7171, 
      n7172, n7173, n7174, n7175, n7176, n7177, n7178, n7179, n7180, n7181, 
      n7182, n7183, n7184, n7185, n7186, n7187, n7188, n7189, n7190, n7191, 
      n7192, n7193, n7194, n7195, n7196, n7197, n7198, n7199, n7200, n7201, 
      n7202, n7203, n7204, n7205, n7206, n7207, n7208, n7209, n7210, n7211, 
      n7212, n7213, n7214, n7215, n7216, n7217, n7218, n7219, n7220, n7221, 
      n7222, n7223, n7224, n7225, n7226, n7227, n7228, n7229, n7230, n7231, 
      n7232, n7233, n7234, n7235, n7236, n7237, n7238, n7239, n7240, n7241, 
      n7242, n7243, n7244, n7245, n7246, n7247, n7248, n7249, n7250, n7251, 
      n7252, n7253, n7254, n7255, n7256, n7257, n7258, n7259, n7260, n7261, 
      n7262, n7263, n7264, n7265, n7266, n7267, n7268, n7269, n7270, n7271, 
      n7272, n7273, n7274, n7275, n7276, n7277, n7278, n7279, n7280, n7281, 
      n7282, n7283, n7284, n7285, n7286, n7287, n7288, n7289, n7290, n7291, 
      n7292, n7293, n7294, n7295, n7296, n7297, n7298, n7299, n7300, n7301, 
      n7302, n7303, n7304, n7305, n7306, n7307, n7308, n7309, n7310, n7311, 
      n7312, n7313, n7314, n7315, n7316, n7317, n7318, n7319, n7320, n7321, 
      n7322, n7323, n7324, n7325, n7326, n7327, n7328, n7329, n7330, n7331, 
      n7332, n7333, n7334, n7335, n7336, n7337, n7338, n7339, n7340, n7341, 
      n7342, n7343, n7344, n7345, n7346, n7347, n7348, n7349, n7350, n7351, 
      n7352, n7353, n7354, n7355, n7356, n7357, n7358, n7359, n7360, n7361, 
      n7362, n7363, n7364, n7365, n7366, n7367, n7368, n7369, n7370, n7371, 
      n7372, n7373, n7374, n7375, n7376, n7377, n7378, n7379, n7380, n7381, 
      n7382, n7383, n7384, n7385, n7386, n7387, n7388, n7389, n7390, n7391, 
      n7392, n7393, n7394, n7395, n7396, n7397, n7398, n7399, n7400, n7401, 
      n7402, n7403, n7404, n7405, n7406, n7407, n7408, n7409, n7410, n7411, 
      n7412, n7413, n7414, n7415, n7416, n7417, n7418, n7419, n7420, n7421, 
      n7422, n7423, n7424, n7425, n7426, n7427, n7428, n7429, n7430, n7431, 
      n7432, n7433, n7434, n7435, n7436, n7437, n7438, n7439, n7440, n7441, 
      n7442, n7443, n7444, n7445, n7446, n7447, n7448, n7449, n7450, n7451, 
      n7452, n7453, n7454, n7455, n7456, n7457, n7458, n7459, n7460, n7461, 
      n7462, n7463, n7464, n7465, n7466, n7467, n7468, n7469, n7470, n7471, 
      n7472, n7473, n7474, n7475, n7476, n7477, n7478, n7479, n7480, n7481, 
      n7482, n7483, n7484, n7485, n7486, n7487, n7488, n7489, n7490, n7491, 
      n7492, n7493, n7494, n7495, n7496, n7497, n7498, n7499, n7500, n7501, 
      n7502, n7503, n7504, n7505, n7506, n7507, n7508, n7509, n7510, n7511, 
      n7512, n7513, n7514, n7515, n7516, n7517, n7518, n7519, n7520, n7521, 
      n7522, n7523, n7524, n7525, n7526, n7527, n7528, n7529, n7530, n7531, 
      n7532, n7533, n7534, n7535, n7536, n7537 : std_logic;

begin
   halt <= b_HALT;
   cpu_in <= ( b_CPU_IN_7, b_CPU_IN_6, b_CPU_IN_5, b_CPU_IN_4, b_CPU_IN_3, 
      b_CPU_IN_2, b_CPU_IN_1, b_CPU_IN_0 );
   
   mr_mp3uart : mp3uart port map( clk => clk, rst => rst, mp3byte(7) => 
                           mp3byte_7, mp3byte(6) => mp3byte_6, mp3byte(5) => 
                           mp3byte_5, mp3byte(4) => mp3byte_4, mp3byte(3) => 
                           mp3byte_3, mp3byte(2) => mp3byte_2, mp3byte(1) => 
                           mp3byte_1, mp3byte(0) => mp3byte_0, takethismp3 => 
                           takethismp3, requestmp3 => requestmp3, stopit => 
                           stopit, mp3i => mp3i, mp3o(0) => mp3o(0), mp3o(1) =>
                           mp3o(1), mp3o(2) => mp3o(2));
   U725 : ND2 port map( A => cpu_addr(4), B => cpu_addr(1), Z => n7537);
   U726 : MUX21P port map( A => n7527, B => cpu_addr(5), S => cpu_addr(4), Z =>
                           n7168);
   U727 : MUX21P port map( A => n7537, B => n7174, S => cpu_addr(3), Z => n7170
                           );
   U728 : EO port map( A => n7239, B => n7240, Z => n7238);
   U729 : EO port map( A => n7236, B => n7237, Z => n7235);
   U730 : EO port map( A => n7245, B => n7246, Z => n7244);
   U731 : EO port map( A => n7242, B => n7243, Z => n7241);
   U732 : EO port map( A => n7251, B => n7252, Z => n7250);
   U733 : EO port map( A => n7248, B => n7249, Z => n7247);
   U734 : EO port map( A => n7257, B => n7258, Z => n7256);
   U735 : EO port map( A => n7254, B => n7255, Z => n7253);
   U736 : EO port map( A => n7215, B => n7216, Z => n7214);
   U737 : EO port map( A => n7212, B => n7213, Z => n7211);
   U738 : EO port map( A => n7221, B => n7222, Z => n7220);
   U739 : EO port map( A => n7218, B => n7219, Z => n7217);
   U740 : EO port map( A => n7227, B => n7228, Z => n7226);
   U741 : EO port map( A => n7224, B => n7225, Z => n7223);
   U742 : IVP port map( A => ARG3346_0, Z => n7233);
   U743 : EO port map( A => n7233, B => n7234, Z => n7232);
   U744 : EO port map( A => n7230, B => n7231, Z => n7229);
   U745 : NR2 port map( A => n7392, B => n7405, Z => n7489);
   U746 : ND2 port map( A => n6789, B => n7321, Z => n7405);
   U747 : ND3 port map( A => n7397, B => n7321, C => n7398, Z => n7409);
   U748 : ND3 port map( A => n7393, B => n7394, C => n7395, Z => n7392);
   U749 : IVP port map( A => n7386, Z => n7390);
   U750 : ND3 port map( A => n7387, B => n7388, C => n7389, Z => n7386);
   U751 : MUX21P port map( A => n7167, B => n7171, S => cpu_addr(2), Z => n7381
                           );
   U752 : NR2 port map( A => n6796, B => n7166, Z => n7165);
   U753 : ND2 port map( A => n6769, B => n6764, Z => n7342);
   U754 : ND2 port map( A => buff_STATE_4, B => buff_STATE_1, Z => n7358);
   U755 : EO port map( A => n7161, B => flashi(1), Z => n7307);
   U756 : EO port map( A => n7284, B => n7285, Z => n7283);
   U757 : EO port map( A => n7287, B => n7288, Z => n7286);
   U758 : EO port map( A => n7290, B => n7291, Z => n7289);
   U759 : EO port map( A => n7293, B => n7294, Z => n7292);
   U760 : EO port map( A => n7296, B => n7297, Z => n7295);
   U761 : EO port map( A => n7299, B => n7300, Z => n7298);
   U762 : EO port map( A => n7305, B => n7306, Z => n7304);
   U763 : EO port map( A => n7302, B => n7303, Z => n7301);
   U764 : EO port map( A => n7260, B => n7261, Z => n7259);
   U765 : EO port map( A => n7263, B => n7264, Z => n7262);
   U766 : EO port map( A => n7266, B => n7267, Z => n7265);
   U767 : EO port map( A => n7269, B => n7270, Z => n7268);
   U768 : EO port map( A => n7272, B => n7273, Z => n7271);
   U769 : EO port map( A => n7275, B => n7276, Z => n7274);
   U770 : EO port map( A => n7281, B => n7282, Z => n7280);
   U771 : EO port map( A => n7278, B => n7279, Z => n7277);
   U772 : ND3 port map( A => n6789, B => n7397, C => n7398, Z => n7396);
   U773 : IVP port map( A => n7392, Z => n7398);
   U774 : ND2 port map( A => n7319, B => n7318, Z => n7371);
   U775 : ND2 port map( A => n7519, B => n7330, Z => n7362);
   U776 : ND2 port map( A => n7210, B => n7359, Z => n7331);
   U777 : IVP port map( A => n7331, Z => n7519);
   U778 : ND2 port map( A => n7423, B => cpu_re, Z => n7450);
   U779 : ND2 port map( A => n6764, B => n6765, Z => n7328);
   U780 : ND2 port map( A => n6763, B => n6772, Z => n7453);
   U781 : ND2 port map( A => n7429, B => n6760, Z => n7452);
   U782 : ND2 port map( A => n6777, B => cpu_addr(2), Z => n7372);
   U783 : ND2 port map( A => n6758, B => n6761, Z => n7454);
   U784 : ND2 port map( A => n7316, B => n7315, Z => n7339);
   U785 : IVP port map( A => n7397, Z => n7197);
   U786 : ND2 port map( A => n6776, B => n6762, Z => n7397);
   U787 : ND3 port map( A => n7366, B => n6782, C => n7514, Z => n7163);
   U788 : ND2 port map( A => n7528, B => n7093, Z => n7139);
   U789 : IVP port map( A => n7337, Z => n7462);
   U790 : ND2 port map( A => n7142, B => n7338, Z => n7337);
   U791 : ND2 port map( A => buff_PLAYSTATE_0, B => n7530, Z => n7531);
   U792 : ND2 port map( A => n6790, B => n7418, Z => n7138);
   U793 : IVP port map( A => n7425, Z => n7526);
   U794 : ND3 port map( A => cpu_out(5), B => n7335, C => n7142, Z => n7425);
   U795 : AN3P port map( A => n7355, B => n7086, C => n6803, Z => n7160);
   U796 : ND2 port map( A => n6759, B => n6758, Z => n7391);
   U797 : NR2 port map( A => n7386, B => n7409, Z => n7515);
   U798 : ND2 port map( A => n6759, B => n6775, Z => n7389);
   U799 : ND2 port map( A => n6759, B => n7322, Z => n7388);
   U800 : ND2 port map( A => n6759, B => n6760, Z => n7387);
   U801 : NR2 port map( A => n7153, B => n7157, Z => n7516);
   U802 : IVP port map( A => n7388, Z => n7153);
   U803 : NR2 port map( A => n6992, B => n7199, Z => n7457);
   U804 : ND2 port map( A => n6776, B => n6772, Z => n7395);
   U805 : IVP port map( A => n7395, Z => n7199);
   U806 : IVP port map( A => n7405, Z => n7406);
   U807 : AN3P port map( A => n7376, B => n7375, C => n6794, Z => n7458);
   U808 : ND2 port map( A => n6774, B => n6772, Z => n7375);
   U809 : ND2 port map( A => n6763, B => n6771, Z => n7377);
   U810 : AN3P port map( A => n7379, B => n7378, C => n6811, Z => n7517);
   U811 : IVP port map( A => n7409, Z => n7410);
   U812 : ND2 port map( A => n6763, B => n6762, Z => n7378);
   U813 : ND2 port map( A => n6774, B => n6773, Z => n7379);
   U814 : ND3 port map( A => n6803, B => n6804, C => n6802, Z => n7523);
   U815 : ND2 port map( A => buff_FLASH_WRITE_ADDR_0, B => n7451, Z => n7488);
   U816 : ND2 port map( A => buff_FLASH_WRITE_ADDR_1, B => n7451, Z => n7487);
   U817 : ND2 port map( A => buff_FLASH_WRITE_ADDR_2, B => n7451, Z => n7485);
   U818 : ND2 port map( A => buff_FLASH_WRITE_ADDR_3, B => n7451, Z => n7484);
   U819 : ND2 port map( A => buff_FLASH_WRITE_ADDR_4, B => n7451, Z => n7483);
   U820 : ND2 port map( A => buff_FLASH_WRITE_ADDR_5, B => n7451, Z => n7482);
   U821 : ND2 port map( A => buff_FLASH_WRITE_ADDR_6, B => n7451, Z => n7481);
   U822 : ND2 port map( A => buff_FLASH_WRITE_ADDR_7, B => n7451, Z => n7480);
   U823 : ND2 port map( A => buff_FLASH_WRITE_ADDR_8, B => n7451, Z => n7479);
   U824 : ND2 port map( A => buff_FLASH_WRITE_ADDR_9, B => n7451, Z => n7478);
   U825 : ND2 port map( A => buff_FLASH_WRITE_ADDR_10, B => n7451, Z => n7486);
   U826 : ND2 port map( A => n6806, B => n6780, Z => n7532);
   U827 : ND2 port map( A => n6806, B => n7366, Z => n7533);
   U828 : ND3 port map( A => n6780, B => n7016, C => n6781, Z => n7363);
   U829 : ND2 port map( A => n6790, B => n7182, Z => n7447);
   U830 : IVP port map( A => n7396, Z => n7428);
   U831 : IVP port map( A => n7399, Z => n7407);
   U832 : ND3 port map( A => n6783, B => n7208, C => n6788, Z => n7399);
   U833 : ND2 port map( A => n6767, B => n6769, Z => n7353);
   U834 : ND2 port map( A => buff_STATE_1, B => buff_STATE_0, Z => n7340);
   U835 : ND2 port map( A => n6803, B => n6780, Z => n7521);
   U836 : IVP port map( A => n7382, Z => n7187);
   U837 : ND2 port map( A => n6775, B => n7373, Z => n7382);
   U838 : IVP port map( A => n7347, Z => n7472);
   U839 : ND2 port map( A => n6767, B => n6765, Z => n7347);
   U840 : ND2 port map( A => n7446, B => n6796, Z => n7445);
   U841 : ND2 port map( A => n6767, B => n6770, Z => n7346);
   U842 : ND3 port map( A => n7353, B => n7342, C => n7348, Z => n7422);
   U843 : ND2 port map( A => n7350, B => n7351, Z => n7349);
   U844 : ND2 port map( A => n6768, B => n6769, Z => n7350);
   U845 : AN4P port map( A => n7348, B => n7354, C => n7343, D => n7341, Z => 
                           n7464);
   U846 : ND2 port map( A => n6766, B => n6769, Z => n7348);
   U847 : ND2 port map( A => n6766, B => n6770, Z => n7354);
   U848 : ND2 port map( A => n6768, B => n6765, Z => n7343);
   U849 : ND3 port map( A => n7327, B => n7325, C => n7440, Z => n7341);
   U850 : IVP port map( A => n7343, Z => n7473);
   U851 : ND2 port map( A => n7370, B => n7142, Z => n7369);
   U852 : IVP port map( A => n7338, Z => n7370);
   U853 : ND2 port map( A => n7367, B => n7368, Z => n7338);
   U854 : ND2 port map( A => n7351, B => n7357, Z => n7463);
   U855 : ND2 port map( A => n6766, B => n6765, Z => n7351);
   U856 : ND3 port map( A => n7346, B => n7347, C => n7348, Z => n7345);
   U857 : ND2 port map( A => buff_STATE_4, B => n6765, Z => n7086);
   U858 : ND2 port map( A => buff_STATE_4, B => buff_STATE_0, Z => n7344);
   U859 : IVP port map( A => n7086, Z => n7471);
   U860 : ND2 port map( A => n7360, B => n7356, Z => n7436);
   U861 : ND2 port map( A => n6766, B => n7440, Z => n7360);
   U862 : IVP port map( A => n7340, Z => n7440);
   U863 : ND2 port map( A => n6767, B => n7440, Z => n7356);
   U864 : ND2 port map( A => n7333, B => n7309, Z => n7166);
   U865 : ND5P port map( A => n7310, B => n7311, C => n7312, D => n7313, E => 
                           n7314, Z => n7309);
   U866 : IVP port map( A => n7309, Z => n7316);
   U867 : AN3P port map( A => n6778, B => n7355, C => n7166, Z => n7205);
   U868 : IVP port map( A => n7358, Z => n7417);
   U869 : IVP port map( A => n7345, Z => n7357);
   U870 : ND2 port map( A => n7137, B => n7413, Z => n7141);
   U871 : ND2 port map( A => cpu_we, B => n7443, Z => n7118);
   U872 : ND2 port map( A => n7423, B => n7333, Z => n7365);
   U873 : ND2 port map( A => n7429, B => n7322, Z => n7384);
   U874 : IVP port map( A => n7372, Z => n7429);
   U875 : ND2 port map( A => n6776, B => n6773, Z => n7383);
   U876 : ND2 port map( A => n7518, B => n7137, Z => n7093);
   U877 : IVP port map( A => n7413, Z => n7518);
   U878 : ND2 port map( A => n7322, B => n6761, Z => n7321);
   U879 : ND2 port map( A => n6773, B => n7320, Z => n7172);
   U880 : AN3P port map( A => buff_PLAYSTATE_0, B => n7424, C => n7336, Z => 
                           n7143);
   U881 : ND2 port map( A => n7335, B => n7408, Z => n7424);
   U882 : IVP port map( A => n7424, Z => n7529);
   U883 : ND3 port map( A => n7400, B => n7401, C => n7402, Z => n7179);
   U884 : ND2 port map( A => n6770, B => n6764, Z => n7401);
   U885 : IVP port map( A => n7364, Z => n7402);
   U886 : ND3 port map( A => n6782, B => n7365, C => n7366, Z => n7364);
   U887 : IVP port map( A => n7363, Z => n7366);
   U888 : ND2 port map( A => n7373, B => n6760, Z => n7200);
   U889 : IVP port map( A => n7371, Z => n7373);
   U890 : ND2 port map( A => n7334, B => n7210, Z => n7180);
   U891 : IVP port map( A => n7332, Z => n7334);
   U892 : ND2 port map( A => n7333, B => n6752, Z => n7332);
   U893 : IVP port map( A => n7173, Z => n7319);
   U894 : ND3 port map( A => n7174, B => n7317, C => n6753, Z => n7173);
   U895 : ND2 port map( A => buff_CPU_IN_6, B => n7535, Z => n7097);
   U896 : IVP port map( A => n7362, Z => n7444);
   U897 : IVP port map( A => n7329, Z => n7333);
   U898 : ND2 port map( A => n7330, B => n7331, Z => n7329);
   U899 : IVP port map( A => n7449, Z => n7534);
   U900 : IVP port map( A => n7453, Z => n7495);
   U901 : ND2 port map( A => n7330, B => cpu_re, Z => n7400);
   U902 : IVP port map( A => n7328, Z => n7330);
   U903 : IVP port map( A => n7361, Z => n7442);
   U904 : ND2 port map( A => n6768, B => n6770, Z => n7361);
   U905 : ND3 port map( A => n7441, B => cpu_re, C => n7423, Z => n7455);
   U906 : IVP port map( A => n7401, Z => n7441);
   U907 : IVP port map( A => n7339, Z => n7423);
   U908 : IVP port map( A => n7118, Z => n7164);
   U909 : IVP port map( A => n7141, Z => n7140);
   U910 : IVP port map( A => ARG3346_1, Z => n7230);
   U911 : IVP port map( A => ARG3346_2, Z => n7227);
   U912 : IVP port map( A => ARG3346_3, Z => n7224);
   U913 : IVP port map( A => ARG3346_4, Z => n7221);
   U914 : IVP port map( A => ARG3346_5, Z => n7218);
   U915 : IVP port map( A => ARG3346_6, Z => n7215);
   U916 : IVP port map( A => ARG3346_7, Z => n7212);
   U917 : IVP port map( A => ARG3346_8, Z => n7257);
   U918 : IVP port map( A => ARG3346_9, Z => n7254);
   U919 : IVP port map( A => ARG3346_10, Z => n7251);
   U920 : IVP port map( A => ARG3346_11, Z => n7248);
   U921 : IVP port map( A => ARG3346_12, Z => n7245);
   U922 : IVP port map( A => ARG3346_13, Z => n7242);
   U923 : IVP port map( A => ARG3346_14, Z => n7239);
   U924 : IVP port map( A => ARG3346_15, Z => n7236);
   U925 : IVP port map( A => ARG3346_16, Z => n7281);
   U926 : IVP port map( A => ARG3346_17, Z => n7278);
   U927 : IVP port map( A => ARG3346_18, Z => n7275);
   U928 : IVP port map( A => ARG3346_19, Z => n7272);
   U929 : IVP port map( A => ARG3346_20, Z => n7269);
   U930 : IVP port map( A => ARG3346_21, Z => n7266);
   U931 : IVP port map( A => ARG3346_22, Z => n7263);
   U932 : IVP port map( A => ARG3346_23, Z => n7260);
   U933 : IVP port map( A => ARG3346_24, Z => n7305);
   U934 : IVP port map( A => ARG3346_25, Z => n7302);
   U935 : IVP port map( A => ARG3346_26, Z => n7299);
   U936 : IVP port map( A => ARG3346_27, Z => n7296);
   U937 : IVP port map( A => ARG3346_28, Z => n7293);
   U938 : IVP port map( A => ARG3346_29, Z => n7290);
   U939 : IVP port map( A => ARG3346_30, Z => n7287);
   U940 : IVP port map( A => ARG3346_31, Z => n7284);
   U941 : AN3P port map( A => n7089, B => rst, C => n7088, Z => 
                           buff_in_PLAYSTATE_0);
   U942 : AN3P port map( A => rst, B => n7087, C => n7088, Z => 
                           buff_in_PLAYSTATE_1);
   U943 : ND2 port map( A => n7528, B => n7141, Z => n7088);
   U944 : IVP port map( A => n7138, Z => n7528);
   U945 : IVP port map( A => n7087, Z => n7439);
   U946 : IVP port map( A => n7391, Z => n7159);
   U947 : IVP port map( A => n7389, Z => n7157);
   U948 : IVP port map( A => n7387, Z => n7155);
   U949 : ND2 port map( A => n6757, B => n6760, Z => n7393);
   U950 : IVP port map( A => n7393, Z => n6983);
   U951 : IVP port map( A => n7172, Z => n7322);
   U952 : ND2 port map( A => n6757, B => n7322, Z => n7394);
   U953 : IVP port map( A => n7394, Z => n6992);
   U954 : ND2 port map( A => n6774, B => n6771, Z => n7376);
   U955 : IVP port map( A => n7376, Z => n6994);
   U956 : ND2 port map( A => cpu_out(0), B => n7336, Z => n7194);
   U957 : ND2 port map( A => cpu_out(1), B => n7336, Z => n7193);
   U958 : ND2 port map( A => cpu_out(2), B => n7336, Z => n7192);
   U959 : ND2 port map( A => cpu_out(3), B => n7336, Z => n7191);
   U960 : ND2 port map( A => cpu_out(4), B => n7336, Z => n7190);
   U961 : ND2 port map( A => n6774, B => n6762, Z => n7374);
   U962 : IVP port map( A => n7374, Z => n6996);
   U963 : IVP port map( A => n7375, Z => n7152);
   U964 : IVP port map( A => n7379, Z => n7150);
   U965 : IVP port map( A => n7377, Z => n7148);
   U966 : IVP port map( A => n7194, Z => n6982);
   U967 : IVP port map( A => n7193, Z => n6984);
   U968 : IVP port map( A => n7192, Z => n6985);
   U969 : IVP port map( A => n7191, Z => n6986);
   U970 : IVP port map( A => n7190, Z => n6987);
   U971 : IVP port map( A => n7378, Z => n7146);
   U972 : IVP port map( A => n7523, Z => n7085);
   U973 : IVP port map( A => b1453_PLAY_ADDR_0, Z => n7084);
   U974 : IVP port map( A => b1453_PLAY_ADDR_1, Z => n7081);
   U975 : IVP port map( A => b1453_PLAY_ADDR_2, Z => n7078);
   U976 : IVP port map( A => b1453_PLAY_ADDR_3, Z => n7075);
   U977 : IVP port map( A => b1453_PLAY_ADDR_4, Z => n7072);
   U978 : IVP port map( A => b1453_PLAY_ADDR_5, Z => n7069);
   U979 : IVP port map( A => b1453_PLAY_ADDR_6, Z => n7066);
   U980 : IVP port map( A => b1453_PLAY_ADDR_7, Z => n7063);
   U981 : IVP port map( A => b1453_PLAY_ADDR_8, Z => n7060);
   U982 : IVP port map( A => b1453_PLAY_ADDR_9, Z => n7057);
   U983 : IVP port map( A => b1453_PLAY_ADDR_10, Z => n7054);
   U984 : IVP port map( A => b1453_PLAY_ADDR_11, Z => n7051);
   U985 : IVP port map( A => b1453_PLAY_ADDR_12, Z => n7048);
   U986 : IVP port map( A => b1453_PLAY_ADDR_13, Z => n7045);
   U987 : IVP port map( A => b1453_PLAY_ADDR_14, Z => n7042);
   U988 : IVP port map( A => b1453_PLAY_ADDR_15, Z => n7039);
   U989 : IVP port map( A => n7038, Z => n7031);
   U990 : ND2 port map( A => n7451, B => cpu_out(0), Z => n7028);
   U991 : ND2 port map( A => n7451, B => cpu_out(1), Z => n7026);
   U992 : ND2 port map( A => n7451, B => cpu_out(2), Z => n7024);
   U993 : ND2 port map( A => n7451, B => cpu_out(3), Z => n7022);
   U994 : IVP port map( A => n7356, Z => n7477);
   U995 : IVP port map( A => n7348, Z => n7476);
   U996 : ND2 port map( A => n7451, B => cpu_out(6), Z => n7015);
   U997 : IVP port map( A => n7360, Z => n7451);
   U998 : IVP port map( A => n7427, Z => n7003);
   U999 : ND2 port map( A => buff_MP3_DMA_STATE_1, B => n7412, Z => n7427);
   U1000 : ND3 port map( A => n7420, B => rst, C => n7448, Z => n7004);
   U1001 : IVP port map( A => n7418, Z => n7420);
   U1002 : IVP port map( A => n7437, Z => n7448);
   U1003 : IVP port map( A => n7004, Z => n7030);
   U1004 : IVP port map( A => n7182, Z => n7137);
   U1005 : IVP port map( A => n7354, Z => n7466);
   U1006 : IVP port map( A => n7344, Z => n7467);
   U1007 : IVP port map( A => n7350, Z => n7468);
   U1008 : IVP port map( A => n7346, Z => n7469);
   U1009 : IVP port map( A => n7445, Z => n7470);
   U1010 : ND2 port map( A => cpu_out(7), B => n7421, Z => n7209);
   U1011 : IVP port map( A => n7369, Z => n7421);
   U1012 : IVP port map( A => n7349, Z => n7355);
   U1013 : IVP port map( A => n7002, Z => n7438);
   U1014 : ND2 port map( A => n6760, B => n6761, Z => n7208);
   U1015 : IVP port map( A => n7352, Z => n7016);
   U1016 : IVP port map( A => n7416, Z => n7206);
   U1017 : IVP port map( A => n7166, Z => n7446);
   U1018 : IVP port map( A => n7365, Z => n7443);
   U1019 : IVP port map( A => n7186, Z => n6990);
   U1020 : ND2 port map( A => cpu_out(7), B => n7336, Z => n7186);
   U1021 : IVP port map( A => n7188, Z => n6989);
   U1022 : ND2 port map( A => cpu_out(6), B => n7336, Z => n7188);
   U1023 : IVP port map( A => n7321, Z => n7142);
   U1024 : IVP port map( A => n7093, Z => n7144);
   U1025 : IVP port map( A => n7385, Z => n7090);
   U1026 : ND2 port map( A => n6775, B => n6761, Z => n7385);
   U1027 : IVP port map( A => n7189, Z => n6988);
   U1028 : ND2 port map( A => cpu_out(5), B => n7336, Z => n7189);
   U1029 : IVP port map( A => n7180, Z => n7336);
   U1030 : IVP port map( A => n7179, Z => n7201);
   U1031 : IVP port map( A => rst, Z => n7001);
   flasho_reg_EN : FD1Q port map( CP => clk, D => n6958, Q => flasho(30));
   flasho_reg_OE : FD1Q port map( CP => clk, D => buff_in_FLASHO_OE, Q => 
                           flasho(29));
   flasho_reg_WE : FD1Q port map( CP => clk, D => n6957, Q => flasho(28));
   flasho_reg_ADDR_0 : FD1Q port map( CP => clk, D => buff_in_FLASHO_ADDR_0, Q 
                           => flasho(27));
   flasho_reg_ADDR_1 : FD1Q port map( CP => clk, D => buff_in_FLASHO_ADDR_1, Q 
                           => flasho(26));
   flasho_reg_ADDR_2 : FD1Q port map( CP => clk, D => buff_in_FLASHO_ADDR_2, Q 
                           => flasho(25));
   flasho_reg_ADDR_3 : FD1Q port map( CP => clk, D => buff_in_FLASHO_ADDR_3, Q 
                           => flasho(24));
   flasho_reg_ADDR_4 : FD1Q port map( CP => clk, D => buff_in_FLASHO_ADDR_4, Q 
                           => flasho(23));
   flasho_reg_ADDR_5 : FD1Q port map( CP => clk, D => buff_in_FLASHO_ADDR_5, Q 
                           => flasho(22));
   flasho_reg_ADDR_6 : FD1Q port map( CP => clk, D => buff_in_FLASHO_ADDR_6, Q 
                           => flasho(21));
   flasho_reg_ADDR_7 : FD1Q port map( CP => clk, D => buff_in_FLASHO_ADDR_7, Q 
                           => flasho(20));
   flasho_reg_ADDR_8 : FD1Q port map( CP => clk, D => buff_in_FLASHO_ADDR_8, Q 
                           => flasho(19));
   flasho_reg_ADDR_9 : FD1Q port map( CP => clk, D => buff_in_FLASHO_ADDR_9, Q 
                           => flasho(18));
   flasho_reg_ADDR_10 : FD1Q port map( CP => clk, D => buff_in_FLASHO_ADDR_10, 
                           Q => flasho(17));
   flasho_reg_ADDR_11 : FD1Q port map( CP => clk, D => buff_in_FLASHO_ADDR_11, 
                           Q => flasho(16));
   flasho_reg_ADDR_12 : FD1Q port map( CP => clk, D => buff_in_FLASHO_ADDR_12, 
                           Q => flasho(15));
   flasho_reg_ADDR_13 : FD1Q port map( CP => clk, D => buff_in_FLASHO_ADDR_13, 
                           Q => flasho(14));
   flasho_reg_ADDR_14 : FD1Q port map( CP => clk, D => buff_in_FLASHO_ADDR_14, 
                           Q => flasho(13));
   flasho_reg_ADDR_15 : FD1Q port map( CP => clk, D => buff_in_FLASHO_ADDR_15, 
                           Q => flasho(12));
   flasho_reg_ADDR_16 : FD1Q port map( CP => clk, D => buff_in_FLASHO_ADDR_16, 
                           Q => flasho(11));
   flasho_reg_ADDR_17 : FD1Q port map( CP => clk, D => buff_in_FLASHO_ADDR_17, 
                           Q => flasho(10));
   flasho_reg_ADDR_18 : FD1Q port map( CP => clk, D => buff_in_FLASHO_ADDR_18, 
                           Q => flasho(9));
   flasho_reg_ADDR_19 : FD1Q port map( CP => clk, D => buff_in_FLASHO_ADDR_19, 
                           Q => flasho(8));
   flasho_reg_WDATA_0 : FD1Q port map( CP => clk, D => buff_in_FLASHO_WDATA_0, 
                           Q => flasho(7));
   flasho_reg_WDATA_1 : FD1Q port map( CP => clk, D => buff_in_FLASHO_WDATA_1, 
                           Q => flasho(6));
   flasho_reg_WDATA_2 : FD1Q port map( CP => clk, D => buff_in_FLASHO_WDATA_2, 
                           Q => flasho(5));
   flasho_reg_WDATA_3 : FD1Q port map( CP => clk, D => buff_in_FLASHO_WDATA_3, 
                           Q => flasho(4));
   flasho_reg_WDATA_4 : FD1Q port map( CP => clk, D => buff_in_FLASHO_WDATA_4, 
                           Q => flasho(3));
   flasho_reg_WDATA_5 : FD1Q port map( CP => clk, D => buff_in_FLASHO_WDATA_5, 
                           Q => flasho(2));
   flasho_reg_WDATA_6 : FD1Q port map( CP => clk, D => buff_in_FLASHO_WDATA_6, 
                           Q => flasho(1));
   flasho_reg_WDATA_7 : FD1Q port map( CP => clk, D => buff_in_FLASHO_WDATA_7, 
                           Q => flasho(0));
   uarti_reg_ACK_RCV : FD1SQP port map( CP => clk, D => rst, TE => n6925, TI =>
                           n6967, Q => uarti(9));
   uarti_reg_SEND : FD1SQP port map( CP => clk, D => rst, TE => n6924, TI => 
                           n6968, Q => uarti(8));
   uarti_reg_DATA_0 : FD1Q port map( CP => clk, D => n6923, Q => uarti(7));
   uarti_reg_DATA_1 : FD1Q port map( CP => clk, D => n6922, Q => uarti(6));
   uarti_reg_DATA_2 : FD1Q port map( CP => clk, D => n6921, Q => uarti(5));
   uarti_reg_DATA_3 : FD1Q port map( CP => clk, D => n6920, Q => uarti(4));
   uarti_reg_DATA_4 : FD1Q port map( CP => clk, D => n6919, Q => uarti(3));
   uarti_reg_DATA_5 : FD1Q port map( CP => clk, D => n6918, Q => uarti(2));
   uarti_reg_DATA_6 : FD1Q port map( CP => clk, D => n6917, Q => uarti(1));
   uarti_reg_DATA_7 : FD1Q port map( CP => clk, D => n6916, Q => uarti(0));
   mp3byte_reg_7 : FD1Q port map( CP => clk, D => n6915, Q => mp3byte_7);
   mp3byte_reg_6 : FD1Q port map( CP => clk, D => n6913, Q => mp3byte_6);
   mp3byte_reg_5 : FD1Q port map( CP => clk, D => n6912, Q => mp3byte_5);
   mp3byte_reg_4 : FD1Q port map( CP => clk, D => n6910, Q => mp3byte_4);
   mp3byte_reg_3 : FD1Q port map( CP => clk, D => n6908, Q => mp3byte_3);
   mp3byte_reg_2 : FD1Q port map( CP => clk, D => n6906, Q => mp3byte_2);
   mp3byte_reg_1 : FD1Q port map( CP => clk, D => n6904, Q => mp3byte_1);
   mp3byte_reg_0 : FD1Q port map( CP => clk, D => n6902, Q => mp3byte_0);
   dac_data_byteh_reg_6 : FD1Q port map( CP => clk, D => n6899, Q => 
                           dac_data_byteh(6));
   dac_data_byteh_reg_5 : FD1Q port map( CP => clk, D => n6898, Q => 
                           dac_data_byteh(5));
   dac_data_byteh_reg_4 : FD1Q port map( CP => clk, D => n6897, Q => 
                           dac_data_byteh(4));
   dac_data_byteh_reg_3 : FD1Q port map( CP => clk, D => n6896, Q => 
                           dac_data_byteh(3));
   dac_data_byteh_reg_2 : FD1Q port map( CP => clk, D => n6895, Q => 
                           dac_data_byteh(2));
   dac_data_byteh_reg_1 : FD1Q port map( CP => clk, D => n6894, Q => 
                           dac_data_byteh(1));
   dac_data_byteh_reg_0 : FD1Q port map( CP => clk, D => n6893, Q => 
                           dac_data_byteh(0));
   dac_data_bytel_reg_7 : FD1Q port map( CP => clk, D => n6892, Q => 
                           dac_data_bytel(7));
   dac_data_bytel_reg_6 : FD1Q port map( CP => clk, D => n6891, Q => 
                           dac_data_bytel(6));
   dac_data_bytel_reg_5 : FD1Q port map( CP => clk, D => n6890, Q => 
                           dac_data_bytel(5));
   dac_data_bytel_reg_4 : FD1Q port map( CP => clk, D => n6889, Q => 
                           dac_data_bytel(4));
   dac_data_bytel_reg_3 : FD1Q port map( CP => clk, D => n6888, Q => 
                           dac_data_bytel(3));
   dac_data_bytel_reg_2 : FD1Q port map( CP => clk, D => n6887, Q => 
                           dac_data_bytel(2));
   dac_data_bytel_reg_1 : FD1Q port map( CP => clk, D => n6886, Q => 
                           dac_data_bytel(1));
   dac_data_bytel_reg_0 : FD1Q port map( CP => clk, D => n6885, Q => 
                           dac_data_bytel(0));
   buff_reg_DAC_DATA_BYTEL_0 : FD1Q port map( CP => clk, D => n6885, Q => 
                           buff_DAC_DATA_BYTEL_0);
   buff_reg_DAC_DATA_BYTEL_1 : FD1Q port map( CP => clk, D => n6886, Q => 
                           buff_DAC_DATA_BYTEL_1);
   buff_reg_DAC_DATA_BYTEL_2 : FD1Q port map( CP => clk, D => n6887, Q => 
                           buff_DAC_DATA_BYTEL_2);
   buff_reg_DAC_DATA_BYTEL_3 : FD1Q port map( CP => clk, D => n6888, Q => 
                           buff_DAC_DATA_BYTEL_3);
   buff_reg_DAC_DATA_BYTEL_4 : FD1Q port map( CP => clk, D => n6889, Q => 
                           buff_DAC_DATA_BYTEL_4);
   buff_reg_DAC_DATA_BYTEL_5 : FD1Q port map( CP => clk, D => n6890, Q => 
                           buff_DAC_DATA_BYTEL_5);
   buff_reg_DAC_DATA_BYTEL_6 : FD1Q port map( CP => clk, D => n6891, Q => 
                           buff_DAC_DATA_BYTEL_6);
   buff_reg_DAC_DATA_BYTEL_7 : FD1Q port map( CP => clk, D => n6892, Q => 
                           buff_DAC_DATA_BYTEL_7);
   buff_reg_DAC_DATA_BYTEH_0 : FD1Q port map( CP => clk, D => n6893, Q => 
                           buff_DAC_DATA_BYTEH_0);
   buff_reg_DAC_DATA_BYTEH_1 : FD1Q port map( CP => clk, D => n6894, Q => 
                           buff_DAC_DATA_BYTEH_1);
   buff_reg_DAC_DATA_BYTEH_2 : FD1Q port map( CP => clk, D => n6895, Q => 
                           buff_DAC_DATA_BYTEH_2);
   buff_reg_DAC_DATA_BYTEH_3 : FD1Q port map( CP => clk, D => n6896, Q => 
                           buff_DAC_DATA_BYTEH_3);
   buff_reg_DAC_DATA_BYTEH_4 : FD1Q port map( CP => clk, D => n6897, Q => 
                           buff_DAC_DATA_BYTEH_4);
   buff_reg_DAC_DATA_BYTEH_5 : FD1Q port map( CP => clk, D => n6898, Q => 
                           buff_DAC_DATA_BYTEH_5);
   buff_reg_DAC_DATA_BYTEH_6 : FD1Q port map( CP => clk, D => n6899, Q => 
                           buff_DAC_DATA_BYTEH_6);
   buff_reg_DAC_DATA_BYTEH_7 : FD1Q port map( CP => clk, D => n6900, Q => 
                           buff_DAC_DATA_BYTEH_7);
   buff_reg_RAM_WE : FD1Q port map( CP => clk, D => n6884, Q => buff_RAM_WE);
   buff_reg_RAM_DATA_IN_0 : FD1Q port map( CP => clk, D => n6926, Q => 
                           buff_RAM_DATA_IN_0);
   buff_reg_RAM_DATA_IN_1 : FD1Q port map( CP => clk, D => n6927, Q => 
                           buff_RAM_DATA_IN_1);
   buff_reg_RAM_DATA_IN_2 : FD1Q port map( CP => clk, D => n6928, Q => 
                           buff_RAM_DATA_IN_2);
   buff_reg_RAM_DATA_IN_3 : FD1Q port map( CP => clk, D => n6929, Q => 
                           buff_RAM_DATA_IN_3);
   buff_reg_RAM_DATA_IN_4 : FD1Q port map( CP => clk, D => n6930, Q => 
                           buff_RAM_DATA_IN_4);
   buff_reg_RAM_DATA_IN_5 : FD1Q port map( CP => clk, D => n6931, Q => 
                           buff_RAM_DATA_IN_5);
   buff_reg_RAM_DATA_IN_6 : FD1Q port map( CP => clk, D => n6932, Q => 
                           buff_RAM_DATA_IN_6);
   buff_reg_RAM_DATA_IN_7 : FD1Q port map( CP => clk, D => n6933, Q => 
                           buff_RAM_DATA_IN_7);
   buff_reg_CPU_IN_0 : FD1Q port map( CP => clk, D => b_CPU_IN_0, Q => 
                           buff_CPU_IN_0);
   buff_reg_CPU_IN_1 : FD1Q port map( CP => clk, D => b_CPU_IN_1, Q => 
                           buff_CPU_IN_1);
   buff_reg_CPU_IN_2 : FD1Q port map( CP => clk, D => b_CPU_IN_2, Q => 
                           buff_CPU_IN_2);
   buff_reg_CPU_IN_3 : FD1Q port map( CP => clk, D => b_CPU_IN_3, Q => 
                           buff_CPU_IN_3);
   buff_reg_CPU_IN_4 : FD1Q port map( CP => clk, D => b_CPU_IN_4, Q => 
                           buff_CPU_IN_4);
   buff_reg_CPU_IN_5 : FD1Q port map( CP => clk, D => b_CPU_IN_5, Q => 
                           buff_CPU_IN_5);
   buff_reg_CPU_IN_6 : FD1Q port map( CP => clk, D => n6877, Q => buff_CPU_IN_6
                           );
   buff_reg_CPU_IN_7 : FD1Q port map( CP => clk, D => b_CPU_IN_7, Q => 
                           buff_CPU_IN_7);
   buff_reg_MP3BYTE_0 : FD1Q port map( CP => clk, D => n6902, Q => 
                           buff_MP3BYTE_0);
   buff_reg_MP3BYTE_1 : FD1Q port map( CP => clk, D => n6904, Q => 
                           buff_MP3BYTE_1);
   buff_reg_MP3BYTE_2 : FD1Q port map( CP => clk, D => n6906, Q => 
                           buff_MP3BYTE_2);
   buff_reg_MP3BYTE_3 : FD1Q port map( CP => clk, D => n6908, Q => 
                           buff_MP3BYTE_3);
   buff_reg_MP3BYTE_4 : FD1Q port map( CP => clk, D => n6910, Q => 
                           buff_MP3BYTE_4);
   buff_reg_MP3BYTE_5 : FD1Q port map( CP => clk, D => n6912, Q => 
                           buff_MP3BYTE_5);
   buff_reg_MP3BYTE_6 : FD1Q port map( CP => clk, D => n6913, Q => 
                           buff_MP3BYTE_6);
   buff_reg_MP3BYTE_7 : FD1Q port map( CP => clk, D => n6915, Q => 
                           buff_MP3BYTE_7);
   buff_reg_PLAY_ADDR_0 : FD1Q port map( CP => clk, D => b1530_PLAY_ADDR_0, Q 
                           => buff_PLAY_ADDR_0);
   buff_reg_PLAY_ADDR_1 : FD1Q port map( CP => clk, D => b1530_PLAY_ADDR_1, Q 
                           => buff_PLAY_ADDR_1);
   buff_reg_PLAY_ADDR_2 : FD1Q port map( CP => clk, D => b1530_PLAY_ADDR_2, Q 
                           => buff_PLAY_ADDR_2);
   buff_reg_PLAY_ADDR_3 : FD1Q port map( CP => clk, D => b1530_PLAY_ADDR_3, Q 
                           => buff_PLAY_ADDR_3);
   buff_reg_PLAY_ADDR_4 : FD1Q port map( CP => clk, D => b1530_PLAY_ADDR_4, Q 
                           => buff_PLAY_ADDR_4);
   buff_reg_PLAY_ADDR_5 : FD1Q port map( CP => clk, D => b1530_PLAY_ADDR_5, Q 
                           => buff_PLAY_ADDR_5);
   buff_reg_PLAY_ADDR_6 : FD1Q port map( CP => clk, D => b1530_PLAY_ADDR_6, Q 
                           => buff_PLAY_ADDR_6);
   buff_reg_PLAY_ADDR_7 : FD1Q port map( CP => clk, D => b1530_PLAY_ADDR_7, Q 
                           => buff_PLAY_ADDR_7);
   buff_reg_PLAY_ADDR_8 : FD1Q port map( CP => clk, D => b1530_PLAY_ADDR_8, Q 
                           => buff_PLAY_ADDR_8);
   buff_reg_PLAY_ADDR_9 : FD1Q port map( CP => clk, D => b1530_PLAY_ADDR_9, Q 
                           => buff_PLAY_ADDR_9);
   buff_reg_PLAY_ADDR_10 : FD1Q port map( CP => clk, D => b1530_PLAY_ADDR_10, Q
                           => buff_PLAY_ADDR_10);
   buff_reg_PLAY_ADDR_11 : FD1Q port map( CP => clk, D => b1530_PLAY_ADDR_11, Q
                           => buff_PLAY_ADDR_11);
   buff_reg_PLAY_ADDR_12 : FD1Q port map( CP => clk, D => b1530_PLAY_ADDR_12, Q
                           => buff_PLAY_ADDR_12);
   buff_reg_PLAY_ADDR_13 : FD1Q port map( CP => clk, D => b1530_PLAY_ADDR_13, Q
                           => buff_PLAY_ADDR_13);
   buff_reg_PLAY_ADDR_14 : FD1Q port map( CP => clk, D => b1530_PLAY_ADDR_14, Q
                           => buff_PLAY_ADDR_14);
   buff_reg_PLAY_ADDR_15 : FD1Q port map( CP => clk, D => b1530_PLAY_ADDR_15, Q
                           => buff_PLAY_ADDR_15);
   buff_reg_PLAY_ADDR_16 : FD1Q port map( CP => clk, D => b1530_PLAY_ADDR_16, Q
                           => buff_PLAY_ADDR_16);
   buff_reg_PLAY_ADDR_17 : FD1Q port map( CP => clk, D => b1530_PLAY_ADDR_17, Q
                           => buff_PLAY_ADDR_17);
   buff_reg_PLAY_ADDR_18 : FD1Q port map( CP => clk, D => b1530_PLAY_ADDR_18, Q
                           => buff_PLAY_ADDR_18);
   buff_reg_PLAY_ADDR_19 : FD1Q port map( CP => clk, D => b1530_PLAY_ADDR_19, Q
                           => buff_PLAY_ADDR_19);
   buff_reg_PLAY_ADDR_20 : FD1Q port map( CP => clk, D => b1530_PLAY_ADDR_20, Q
                           => buff_PLAY_ADDR_20);
   buff_reg_PLAY_ADDR_21 : FD1Q port map( CP => clk, D => b1530_PLAY_ADDR_21, Q
                           => buff_PLAY_ADDR_21);
   buff_reg_PLAY_ADDR_22 : FD1Q port map( CP => clk, D => b1530_PLAY_ADDR_22, Q
                           => buff_PLAY_ADDR_22);
   buff_reg_PLAY_ADDR_23 : FD1Q port map( CP => clk, D => b1530_PLAY_ADDR_23, Q
                           => buff_PLAY_ADDR_23);
   buff_reg_PLAY_ADDR_24 : FD1Q port map( CP => clk, D => b1530_PLAY_ADDR_24, Q
                           => buff_PLAY_ADDR_24);
   buff_reg_PLAY_ADDR_25 : FD1Q port map( CP => clk, D => b1530_PLAY_ADDR_25, Q
                           => buff_PLAY_ADDR_25);
   buff_reg_PLAY_ADDR_26 : FD1Q port map( CP => clk, D => b1530_PLAY_ADDR_26, Q
                           => buff_PLAY_ADDR_26);
   buff_reg_PLAY_ADDR_27 : FD1Q port map( CP => clk, D => b1530_PLAY_ADDR_27, Q
                           => buff_PLAY_ADDR_27);
   buff_reg_PLAY_ADDR_28 : FD1Q port map( CP => clk, D => b1530_PLAY_ADDR_28, Q
                           => buff_PLAY_ADDR_28);
   buff_reg_PLAY_ADDR_29 : FD1Q port map( CP => clk, D => b1530_PLAY_ADDR_29, Q
                           => buff_PLAY_ADDR_29);
   buff_reg_PLAY_ADDR_30 : FD1Q port map( CP => clk, D => b1530_PLAY_ADDR_30, Q
                           => buff_PLAY_ADDR_30);
   buff_reg_PLAY_ADDR_31 : FD1Q port map( CP => clk, D => b1530_PLAY_ADDR_31, Q
                           => buff_PLAY_ADDR_31);
   buff_reg_FLASH_WRITE_ADDR_0 : FD1Q port map( CP => clk, D => n6872, Q => 
                           buff_FLASH_WRITE_ADDR_0);
   buff_reg_FLASH_WRITE_ADDR_1 : FD1Q port map( CP => clk, D => n6871, Q => 
                           buff_FLASH_WRITE_ADDR_1);
   buff_reg_FLASH_WRITE_ADDR_2 : FD1Q port map( CP => clk, D => n6870, Q => 
                           buff_FLASH_WRITE_ADDR_2);
   buff_reg_FLASH_WRITE_ADDR_3 : FD1Q port map( CP => clk, D => n6869, Q => 
                           buff_FLASH_WRITE_ADDR_3);
   buff_reg_FLASH_WRITE_ADDR_4 : FD1Q port map( CP => clk, D => n6868, Q => 
                           buff_FLASH_WRITE_ADDR_4);
   buff_reg_FLASH_WRITE_ADDR_5 : FD1Q port map( CP => clk, D => n6867, Q => 
                           buff_FLASH_WRITE_ADDR_5);
   buff_reg_FLASH_WRITE_ADDR_6 : FD1Q port map( CP => clk, D => n6866, Q => 
                           buff_FLASH_WRITE_ADDR_6);
   buff_reg_FLASH_WRITE_ADDR_7 : FD1Q port map( CP => clk, D => n6865, Q => 
                           buff_FLASH_WRITE_ADDR_7);
   buff_reg_FLASH_WRITE_ADDR_8 : FD1Q port map( CP => clk, D => n6864, Q => 
                           buff_FLASH_WRITE_ADDR_8);
   buff_reg_FLASH_WRITE_ADDR_9 : FD1Q port map( CP => clk, D => n6863, Q => 
                           buff_FLASH_WRITE_ADDR_9);
   buff_reg_FLASH_WRITE_ADDR_10 : FD1Q port map( CP => clk, D => n6862, Q => 
                           buff_FLASH_WRITE_ADDR_10);
   buff_reg_FLASH_WRITE_ADDR_11 : FD1Q port map( CP => clk, D => n6861, Q => 
                           buff_FLASH_WRITE_ADDR_11);
   buff_reg_FLASH_WRITE_ADDR_12 : FD1Q port map( CP => clk, D => n6860, Q => 
                           buff_FLASH_WRITE_ADDR_12);
   buff_reg_FLASH_WRITE_ADDR_13 : FD1Q port map( CP => clk, D => n6859, Q => 
                           buff_FLASH_WRITE_ADDR_13);
   buff_reg_FLASH_WRITE_ADDR_14 : FD1Q port map( CP => clk, D => n6858, Q => 
                           buff_FLASH_WRITE_ADDR_14);
   buff_reg_FLASH_WRITE_ADDR_15 : FD1Q port map( CP => clk, D => n6857, Q => 
                           buff_FLASH_WRITE_ADDR_15);
   buff_reg_FLASH_WRITE_ADDR_16 : FD1Q port map( CP => clk, D => n6856, Q => 
                           buff_FLASH_WRITE_ADDR_16);
   buff_reg_FLASH_WRITE_ADDR_17 : FD1Q port map( CP => clk, D => n6855, Q => 
                           buff_FLASH_WRITE_ADDR_17);
   buff_reg_FLASH_WRITE_ADDR_18 : FD1Q port map( CP => clk, D => n6854, Q => 
                           buff_FLASH_WRITE_ADDR_18);
   buff_reg_FLASH_WRITE_ADDR_19 : FD1Q port map( CP => clk, D => n6853, Q => 
                           buff_FLASH_WRITE_ADDR_19);
   buff_reg_FLASH_PLAY_ADDR_0 : FD1Q port map( CP => clk, D => n6852, Q => 
                           buff_FLASH_PLAY_ADDR_0);
   buff_reg_FLASH_PLAY_ADDR_1 : FD1Q port map( CP => clk, D => n6851, Q => 
                           buff_FLASH_PLAY_ADDR_1);
   buff_reg_FLASH_PLAY_ADDR_2 : FD1Q port map( CP => clk, D => n6850, Q => 
                           buff_FLASH_PLAY_ADDR_2);
   buff_reg_FLASH_PLAY_ADDR_3 : FD1Q port map( CP => clk, D => n6849, Q => 
                           buff_FLASH_PLAY_ADDR_3);
   buff_reg_FLASH_PLAY_ADDR_4 : FD1Q port map( CP => clk, D => n6848, Q => 
                           buff_FLASH_PLAY_ADDR_4);
   buff_reg_FLASH_PLAY_ADDR_5 : FD1Q port map( CP => clk, D => n6847, Q => 
                           buff_FLASH_PLAY_ADDR_5);
   buff_reg_FLASH_PLAY_ADDR_6 : FD1Q port map( CP => clk, D => n6846, Q => 
                           buff_FLASH_PLAY_ADDR_6);
   buff_reg_FLASH_PLAY_ADDR_7 : FD1Q port map( CP => clk, D => n6845, Q => 
                           buff_FLASH_PLAY_ADDR_7);
   buff_reg_FLASH_PLAY_ADDR_8 : FD1Q port map( CP => clk, D => n6844, Q => 
                           buff_FLASH_PLAY_ADDR_8);
   buff_reg_FLASH_PLAY_ADDR_9 : FD1Q port map( CP => clk, D => n6843, Q => 
                           buff_FLASH_PLAY_ADDR_9);
   buff_reg_FLASH_PLAY_ADDR_10 : FD1Q port map( CP => clk, D => n6842, Q => 
                           buff_FLASH_PLAY_ADDR_10);
   buff_reg_FLASH_PLAY_ADDR_11 : FD1Q port map( CP => clk, D => n6841, Q => 
                           buff_FLASH_PLAY_ADDR_11);
   buff_reg_FLASH_PLAY_ADDR_12 : FD1Q port map( CP => clk, D => n6840, Q => 
                           buff_FLASH_PLAY_ADDR_12);
   buff_reg_FLASH_PLAY_ADDR_13 : FD1Q port map( CP => clk, D => n6839, Q => 
                           buff_FLASH_PLAY_ADDR_13);
   buff_reg_FLASH_PLAY_ADDR_14 : FD1Q port map( CP => clk, D => n6838, Q => 
                           buff_FLASH_PLAY_ADDR_14);
   buff_reg_FLASH_PLAY_ADDR_15 : FD1Q port map( CP => clk, D => n6837, Q => 
                           buff_FLASH_PLAY_ADDR_15);
   buff_reg_FLASH_PLAY_ADDR_16 : FD1Q port map( CP => clk, D => n6836, Q => 
                           buff_FLASH_PLAY_ADDR_16);
   buff_reg_FLASH_PLAY_ADDR_17 : FD1Q port map( CP => clk, D => n6835, Q => 
                           buff_FLASH_PLAY_ADDR_17);
   buff_reg_FLASH_PLAY_ADDR_18 : FD1Q port map( CP => clk, D => n6834, Q => 
                           buff_FLASH_PLAY_ADDR_18);
   buff_reg_FLASH_PLAY_ADDR_19 : FD1Q port map( CP => clk, D => n6833, Q => 
                           buff_FLASH_PLAY_ADDR_19);
   buff_reg_FLASH_PLAY_ADDR_20 : FD1Q port map( CP => clk, D => n6832, Q => 
                           buff_FLASH_PLAY_ADDR_20);
   buff_reg_FLASH_PLAY_ADDR_21 : FD1Q port map( CP => clk, D => n6831, Q => 
                           buff_FLASH_PLAY_ADDR_21);
   buff_reg_FLASH_PLAY_ADDR_22 : FD1Q port map( CP => clk, D => n6830, Q => 
                           buff_FLASH_PLAY_ADDR_22);
   buff_reg_FLASH_PLAY_ADDR_23 : FD1Q port map( CP => clk, D => n6829, Q => 
                           buff_FLASH_PLAY_ADDR_23);
   buff_reg_FLASH_PLAY_ADDR_24 : FD1Q port map( CP => clk, D => n6828, Q => 
                           buff_FLASH_PLAY_ADDR_24);
   buff_reg_FLASH_PLAY_ADDR_25 : FD1Q port map( CP => clk, D => n6827, Q => 
                           buff_FLASH_PLAY_ADDR_25);
   buff_reg_FLASH_PLAY_ADDR_26 : FD1Q port map( CP => clk, D => n6826, Q => 
                           buff_FLASH_PLAY_ADDR_26);
   buff_reg_FLASH_PLAY_ADDR_27 : FD1Q port map( CP => clk, D => n6825, Q => 
                           buff_FLASH_PLAY_ADDR_27);
   buff_reg_FLASH_PLAY_ADDR_28 : FD1Q port map( CP => clk, D => n6824, Q => 
                           buff_FLASH_PLAY_ADDR_28);
   buff_reg_FLASH_PLAY_ADDR_29 : FD1Q port map( CP => clk, D => n6823, Q => 
                           buff_FLASH_PLAY_ADDR_29);
   buff_reg_FLASH_PLAY_ADDR_30 : FD1Q port map( CP => clk, D => n6822, Q => 
                           buff_FLASH_PLAY_ADDR_30);
   buff_reg_FLASH_PLAY_ADDR_31 : FD1Q port map( CP => clk, D => n6821, Q => 
                           buff_FLASH_PLAY_ADDR_31);
   buff_reg_FLASHO_WE : FD1Q port map( CP => clk, D => n6957, Q => 
                           buff_FLASHO_WE);
   buff_reg_FLASHO_ADDR_0 : FD1Q port map( CP => clk, D => 
                           buff_in_FLASHO_ADDR_0, Q => buff_FLASHO_ADDR_0);
   buff_reg_FLASHO_ADDR_1 : FD1Q port map( CP => clk, D => 
                           buff_in_FLASHO_ADDR_1, Q => buff_FLASHO_ADDR_1);
   buff_reg_FLASHO_ADDR_2 : FD1Q port map( CP => clk, D => 
                           buff_in_FLASHO_ADDR_2, Q => buff_FLASHO_ADDR_2);
   buff_reg_FLASHO_ADDR_3 : FD1Q port map( CP => clk, D => 
                           buff_in_FLASHO_ADDR_3, Q => buff_FLASHO_ADDR_3);
   buff_reg_FLASHO_ADDR_4 : FD1Q port map( CP => clk, D => 
                           buff_in_FLASHO_ADDR_4, Q => buff_FLASHO_ADDR_4);
   buff_reg_FLASHO_ADDR_5 : FD1Q port map( CP => clk, D => 
                           buff_in_FLASHO_ADDR_5, Q => buff_FLASHO_ADDR_5);
   buff_reg_FLASHO_ADDR_6 : FD1Q port map( CP => clk, D => 
                           buff_in_FLASHO_ADDR_6, Q => buff_FLASHO_ADDR_6);
   buff_reg_FLASHO_ADDR_7 : FD1Q port map( CP => clk, D => 
                           buff_in_FLASHO_ADDR_7, Q => buff_FLASHO_ADDR_7);
   buff_reg_FLASHO_ADDR_8 : FD1Q port map( CP => clk, D => 
                           buff_in_FLASHO_ADDR_8, Q => buff_FLASHO_ADDR_8);
   buff_reg_FLASHO_ADDR_9 : FD1Q port map( CP => clk, D => 
                           buff_in_FLASHO_ADDR_9, Q => buff_FLASHO_ADDR_9);
   buff_reg_FLASHO_ADDR_10 : FD1Q port map( CP => clk, D => 
                           buff_in_FLASHO_ADDR_10, Q => buff_FLASHO_ADDR_10);
   buff_reg_FLASHO_ADDR_11 : FD1Q port map( CP => clk, D => 
                           buff_in_FLASHO_ADDR_11, Q => buff_FLASHO_ADDR_11);
   buff_reg_FLASHO_ADDR_12 : FD1Q port map( CP => clk, D => 
                           buff_in_FLASHO_ADDR_12, Q => buff_FLASHO_ADDR_12);
   buff_reg_FLASHO_ADDR_13 : FD1Q port map( CP => clk, D => 
                           buff_in_FLASHO_ADDR_13, Q => buff_FLASHO_ADDR_13);
   buff_reg_FLASHO_ADDR_14 : FD1Q port map( CP => clk, D => 
                           buff_in_FLASHO_ADDR_14, Q => buff_FLASHO_ADDR_14);
   buff_reg_FLASHO_ADDR_15 : FD1Q port map( CP => clk, D => 
                           buff_in_FLASHO_ADDR_15, Q => buff_FLASHO_ADDR_15);
   buff_reg_FLASHO_ADDR_16 : FD1Q port map( CP => clk, D => 
                           buff_in_FLASHO_ADDR_16, Q => buff_FLASHO_ADDR_16);
   buff_reg_FLASHO_ADDR_17 : FD1Q port map( CP => clk, D => 
                           buff_in_FLASHO_ADDR_17, Q => buff_FLASHO_ADDR_17);
   buff_reg_FLASHO_ADDR_18 : FD1Q port map( CP => clk, D => 
                           buff_in_FLASHO_ADDR_18, Q => buff_FLASHO_ADDR_18);
   buff_reg_FLASHO_ADDR_19 : FD1Q port map( CP => clk, D => 
                           buff_in_FLASHO_ADDR_19, Q => buff_FLASHO_ADDR_19);
   buff_reg_FLASHO_WDATA_0 : FD1Q port map( CP => clk, D => 
                           buff_in_FLASHO_WDATA_0, Q => buff_FLASHO_WDATA_0);
   buff_reg_FLASHO_WDATA_1 : FD1Q port map( CP => clk, D => 
                           buff_in_FLASHO_WDATA_1, Q => buff_FLASHO_WDATA_1);
   buff_reg_FLASHO_WDATA_2 : FD1Q port map( CP => clk, D => 
                           buff_in_FLASHO_WDATA_2, Q => buff_FLASHO_WDATA_2);
   buff_reg_FLASHO_WDATA_3 : FD1Q port map( CP => clk, D => 
                           buff_in_FLASHO_WDATA_3, Q => buff_FLASHO_WDATA_3);
   buff_reg_FLASHO_WDATA_4 : FD1Q port map( CP => clk, D => 
                           buff_in_FLASHO_WDATA_4, Q => buff_FLASHO_WDATA_4);
   buff_reg_FLASHO_WDATA_5 : FD1Q port map( CP => clk, D => 
                           buff_in_FLASHO_WDATA_5, Q => buff_FLASHO_WDATA_5);
   buff_reg_FLASHO_WDATA_6 : FD1Q port map( CP => clk, D => 
                           buff_in_FLASHO_WDATA_6, Q => buff_FLASHO_WDATA_6);
   buff_reg_LCD_UART_DATA_0 : FD1Q port map( CP => clk, D => n6923, Q => 
                           buff_LCD_UART_DATA_0);
   buff_reg_LCD_UART_DATA_1 : FD1Q port map( CP => clk, D => n6922, Q => 
                           buff_LCD_UART_DATA_1);
   buff_reg_LCD_UART_DATA_2 : FD1Q port map( CP => clk, D => n6921, Q => 
                           buff_LCD_UART_DATA_2);
   buff_reg_LCD_UART_DATA_3 : FD1Q port map( CP => clk, D => n6920, Q => 
                           buff_LCD_UART_DATA_3);
   buff_reg_LCD_UART_DATA_4 : FD1Q port map( CP => clk, D => n6919, Q => 
                           buff_LCD_UART_DATA_4);
   buff_reg_LCD_UART_DATA_5 : FD1Q port map( CP => clk, D => n6918, Q => 
                           buff_LCD_UART_DATA_5);
   buff_reg_LCD_UART_DATA_6 : FD1Q port map( CP => clk, D => n6917, Q => 
                           buff_LCD_UART_DATA_6);
   buff_reg_LCD_UART_DATA_7 : FD1Q port map( CP => clk, D => n6916, Q => 
                           buff_LCD_UART_DATA_7);
   clock_rst_reg : FD1Q port map( CP => clk, D => buff_in_CLOCK_RST, Q => 
                           clock_rst);
   clock_hold_reg : FD1SQP port map( CP => clk, D => n6976, TE => n7524, TI => 
                           n6977, Q => clock_hold);
   takethismp3_reg : FD1Q port map( CP => clk, D => n6817, Q => takethismp3);
   dac_send_data_reg : FD1SQP port map( CP => clk, D => rst, TE => n6816, TI =>
                           n6978, Q => dac_send_data);
   stopit_reg : FD1Q port map( CP => clk, D => n6815, Q => stopit);
   clock_read_reg : FD1SQP port map( CP => clk, D => n6979, TE => n7525, TI => 
                           n6980, Q => clock_read);
   U1032 : IVP port map( A => cpu_out(7), Z => n7404);
   U1033 : IVP port map( A => cpu_out(5), Z => n7408);
   U1034 : IVP port map( A => cpu_out(4), Z => n7335);
   U1035 : IVP port map( A => cpu_addr(15), Z => n7315);
   U1036 : IVP port map( A => cpu_addr(14), Z => n7313);
   U1037 : IVP port map( A => cpu_addr(13), Z => n7314);
   U1038 : IVP port map( A => cpu_addr(12), Z => n7312);
   U1039 : IVP port map( A => cpu_addr(11), Z => n7310);
   U1040 : IVP port map( A => cpu_addr(10), Z => n7311);
   U1041 : IVP port map( A => cpu_addr(5), Z => n7174);
   U1042 : IVP port map( A => cpu_addr(4), Z => n7317);
   U1043 : IVP port map( A => cpu_addr(3), Z => n7320);
   U1044 : IVP port map( A => cpu_addr(2), Z => n7318);
   U1045 : IVP port map( A => cpu_addr(1), Z => n7169);
   U1046 : IVP port map( A => cpu_addr(0), Z => n7308);
   U1047 : IVP port map( A => cpu_we, Z => n7359);
   U1048 : IVP port map( A => cpu_re, Z => n7210);
   U1049 : AN2 port map( A => cpu_addr(15), B => n7316, Z => n6752);
   U1050 : AN5 port map( A => n7175, B => n7176, C => n7177, D => n7178, E => 
                           n6752, Z => n6753);
   U1051 : AN2 port map( A => n6763, B => n6773, Z => n6754);
   U1052 : AN2 port map( A => n6757, B => n6775, Z => n6755);
   U1053 : AN2 port map( A => cpu_out(5), B => n7421, Z => n6756);
   U1054 : AN2 port map( A => n6777, B => n7318, Z => n6757);
   U1055 : AN2 port map( A => n6771, B => n7320, Z => n6758);
   U1056 : AN4 port map( A => n7317, B => n7318, C => cpu_addr(5), D => n6753, 
                           Z => n6759);
   U1057 : AN2 port map( A => n6772, B => n7320, Z => n6760);
   U1058 : AN2 port map( A => cpu_addr(2), B => n7319, Z => n6761);
   U1059 : AN2 port map( A => cpu_addr(1), B => n7308, Z => n6762);
   U1060 : AN2 port map( A => cpu_addr(3), B => n7373, Z => n6763);
   U1061 : AN3 port map( A => n7325, B => n7326, C => n7327, Z => n6764);
   U1062 : AN2 port map( A => n7323, B => n7324, Z => n6765);
   U1063 : AN2 port map( A => buff_STATE_3, B => buff_STATE_2, Z => n6766);
   U1064 : AN2 port map( A => buff_STATE_3, B => n7327, Z => n6767);
   U1065 : AN2 port map( A => buff_STATE_2, B => n7325, Z => n6768);
   U1066 : AN2 port map( A => buff_STATE_1, B => n7323, Z => n6769);
   U1067 : AN2 port map( A => buff_STATE_0, B => n7324, Z => n6770);
   U1068 : AN2 port map( A => cpu_addr(1), B => cpu_addr(0), Z => n6771);
   U1069 : AN2 port map( A => cpu_addr(0), B => n7169, Z => n6772);
   U1070 : AN2 port map( A => n7169, B => n7308, Z => n6773);
   U1071 : AN2 port map( A => cpu_addr(3), B => n6761, Z => n6774);
   U1072 : AN2 port map( A => n6762, B => n7320, Z => n6775);
   U1073 : AN2 port map( A => cpu_addr(3), B => n6757, Z => n6776);
   U1074 : AN3 port map( A => cpu_addr(4), B => n7174, C => n6753, Z => n6777);
   U1075 : AN2 port map( A => n7086, B => n7344, Z => n6778);
   U1076 : AN3 port map( A => n7341, B => n7342, C => n7343, Z => n6779);
   U1077 : AN3 port map( A => n6778, B => n7358, C => n6779, Z => n6780);
   U1078 : AN3 port map( A => n7355, B => n7356, C => n7357, Z => n6781);
   U1079 : AN4 port map( A => n7360, B => n7361, C => n7362, D => n7166, Z => 
                           n6782);
   U1080 : AN4 port map( A => n7383, B => n7384, C => n7385, D => n7200, Z => 
                           n6783);
   U1081 : AN2 port map( A => n7380, B => n7381, Z => n6784);
   U1082 : AN3 port map( A => n7377, B => n7378, C => n7379, Z => n6785);
   U1083 : AN3 port map( A => n7374, B => n7375, C => n7376, Z => n6786);
   U1084 : AN2 port map( A => n6785, B => n6786, Z => n6787);
   U1085 : AN3 port map( A => n6784, B => n7382, C => n6787, Z => n6788);
   U1086 : AN2 port map( A => n7390, B => n7391, Z => n6789);
   U1087 : AN2 port map( A => n7183, B => n7419, Z => n6790);
   U1088 : AN3 port map( A => n7406, B => n7397, C => n7407, Z => n6791);
   U1089 : AN2 port map( A => n6791, B => n7393, Z => n6792);
   U1090 : AN5 port map( A => n6784, B => n7208, C => n6783, D => n7410, E => 
                           n6789, Z => n6793);
   U1091 : AN2 port map( A => n6785, B => n7382, Z => n6794);
   U1092 : AN3 port map( A => n6794, B => n7374, C => n6793, Z => n6795);
   U1093 : AN2 port map( A => n7420, B => cpu_re, Z => n6796);
   U1094 : AO7CN port map( A => n7180, B => n7208, C => n7434, Z => n6797);
   U1095 : AO7CN port map( A => n7180, B => n7209, C => n7432, Z => n6798);
   U1096 : AN4 port map( A => n7208, B => n7321, C => n7428, D => n6788, Z => 
                           n6799);
   U1097 : AN3 port map( A => n7385, B => n7200, C => n6799, Z => n6800);
   U1098 : AN3 port map( A => n7383, B => n7384, C => n6799, Z => n6801);
   U1099 : AN5 port map( A => n7360, B => n7356, C => n6779, D => n7016, E => 
                           n7357, Z => n6802);
   U1100 : AN3 port map( A => n7361, B => n7328, C => n7401, Z => n6803);
   U1101 : AN2 port map( A => n7344, B => n7358, Z => n6804);
   U1102 : AN2 port map( A => n7355, B => n7346, Z => n6805);
   U1103 : NR6 port map( A => n7441, B => n7442, C => n7443, D => n7334, E => 
                           n7444, F => n7165, Z => n6806);
   U1104 : AN2 port map( A => n6801, B => n7200, Z => n6807);
   U1105 : AN3 port map( A => cpu_re, B => n7316, C => n7339, Z => n6808);
   U1106 : AN3 port map( A => n7410, B => n7391, C => n7407, Z => n6809);
   U1107 : AN2 port map( A => n6809, B => n7387, Z => n6810);
   U1108 : AN2 port map( A => n6786, B => n7382, Z => n6811);
   U1109 : AN3 port map( A => n6811, B => n7377, C => n6793, Z => n6812);
   U1110 : AN2 port map( A => n6756, B => n7336, Z => n6813);
   U1111 : AO7CN port map( A => n7206, B => n7323, C => n7431, Z => n6814);
   U1112 : BF1T1 port map( A => b1530_STOPIT, Z => n6815);
   U1113 : BF1T1 port map( A => n7136, Z => n6816);
   U1114 : ND2A port map( A => buff_TAKETHISMP3, B => n7141, Z => 
                           b1530_TAKETHISMP3);
   U1115 : BF1T1 port map( A => b1530_TAKETHISMP3, Z => n6817);
   U1116 : IVP port map( A => n7435, Z => n7000);
   U1117 : BF1T1 port map( A => n7000, Z => n6818);
   U1118 : BF1T1 port map( A => n6814, Z => n6819);
   U1119 : ND2 port map( A => buff_MP3_DMA_STATE_0, B => buff_MP3_DMA_STATE_1, 
                           Z => n7182);
   U1120 : BF1T1 port map( A => n7182, Z => n6820);
   U1121 : BF1T1 port map( A => b1530_FLASH_PLAY_ADDR_31, Z => n6821);
   U1122 : BF1T1 port map( A => b1530_FLASH_PLAY_ADDR_30, Z => n6822);
   U1123 : BF1T1 port map( A => b1530_FLASH_PLAY_ADDR_29, Z => n6823);
   U1124 : BF1T1 port map( A => b1530_FLASH_PLAY_ADDR_28, Z => n6824);
   U1125 : BF1T1 port map( A => b1530_FLASH_PLAY_ADDR_27, Z => n6825);
   U1126 : BF1T1 port map( A => b1530_FLASH_PLAY_ADDR_26, Z => n6826);
   U1127 : BF1T1 port map( A => b1530_FLASH_PLAY_ADDR_25, Z => n6827);
   U1128 : BF1T1 port map( A => b1530_FLASH_PLAY_ADDR_24, Z => n6828);
   U1129 : BF1T1 port map( A => b1530_FLASH_PLAY_ADDR_23, Z => n6829);
   U1130 : BF1T1 port map( A => b1530_FLASH_PLAY_ADDR_22, Z => n6830);
   U1131 : BF1T1 port map( A => b1530_FLASH_PLAY_ADDR_21, Z => n6831);
   U1132 : BF1T1 port map( A => b1530_FLASH_PLAY_ADDR_20, Z => n6832);
   U1133 : BF1T1 port map( A => b1530_FLASH_PLAY_ADDR_19, Z => n6833);
   U1134 : BF1T1 port map( A => b1530_FLASH_PLAY_ADDR_18, Z => n6834);
   U1135 : BF1T1 port map( A => b1530_FLASH_PLAY_ADDR_17, Z => n6835);
   U1136 : BF1T1 port map( A => b1530_FLASH_PLAY_ADDR_16, Z => n6836);
   U1137 : BF1T1 port map( A => b1530_FLASH_PLAY_ADDR_15, Z => n6837);
   U1138 : BF1T1 port map( A => b1530_FLASH_PLAY_ADDR_14, Z => n6838);
   U1139 : BF1T1 port map( A => b1530_FLASH_PLAY_ADDR_13, Z => n6839);
   U1140 : BF1T1 port map( A => b1530_FLASH_PLAY_ADDR_12, Z => n6840);
   U1141 : BF1T1 port map( A => b1530_FLASH_PLAY_ADDR_11, Z => n6841);
   U1142 : BF1T1 port map( A => b1530_FLASH_PLAY_ADDR_10, Z => n6842);
   U1143 : BF1T1 port map( A => b1530_FLASH_PLAY_ADDR_9, Z => n6843);
   U1144 : BF1T1 port map( A => b1530_FLASH_PLAY_ADDR_8, Z => n6844);
   U1145 : BF1T1 port map( A => b1530_FLASH_PLAY_ADDR_7, Z => n6845);
   U1146 : BF1T1 port map( A => b1530_FLASH_PLAY_ADDR_6, Z => n6846);
   U1147 : BF1T1 port map( A => b1530_FLASH_PLAY_ADDR_5, Z => n6847);
   U1148 : BF1T1 port map( A => b1530_FLASH_PLAY_ADDR_4, Z => n6848);
   U1149 : BF1T1 port map( A => b1530_FLASH_PLAY_ADDR_3, Z => n6849);
   U1150 : BF1T1 port map( A => b1530_FLASH_PLAY_ADDR_2, Z => n6850);
   U1151 : BF1T1 port map( A => b1530_FLASH_PLAY_ADDR_1, Z => n6851);
   U1152 : BF1T1 port map( A => b1530_FLASH_PLAY_ADDR_0, Z => n6852);
   U1153 : BF1T1 port map( A => b1530_FLASH_WRITE_ADDR_19, Z => n6853);
   U1154 : BF1T1 port map( A => b1530_FLASH_WRITE_ADDR_18, Z => n6854);
   U1155 : BF1T1 port map( A => b1530_FLASH_WRITE_ADDR_17, Z => n6855);
   U1156 : BF1T1 port map( A => b1530_FLASH_WRITE_ADDR_16, Z => n6856);
   U1157 : BF1T1 port map( A => b1530_FLASH_WRITE_ADDR_15, Z => n6857);
   U1158 : BF1T1 port map( A => b1530_FLASH_WRITE_ADDR_14, Z => n6858);
   U1159 : BF1T1 port map( A => b1530_FLASH_WRITE_ADDR_13, Z => n6859);
   U1160 : BF1T1 port map( A => b1530_FLASH_WRITE_ADDR_12, Z => n6860);
   U1161 : BF1T1 port map( A => b1530_FLASH_WRITE_ADDR_11, Z => n6861);
   U1162 : BF1T1 port map( A => b1530_FLASH_WRITE_ADDR_10, Z => n6862);
   U1163 : BF1T1 port map( A => b1530_FLASH_WRITE_ADDR_9, Z => n6863);
   U1164 : BF1T1 port map( A => b1530_FLASH_WRITE_ADDR_8, Z => n6864);
   U1165 : BF1T1 port map( A => b1530_FLASH_WRITE_ADDR_7, Z => n6865);
   U1166 : BF1T1 port map( A => b1530_FLASH_WRITE_ADDR_6, Z => n6866);
   U1167 : BF1T1 port map( A => b1530_FLASH_WRITE_ADDR_5, Z => n6867);
   U1168 : BF1T1 port map( A => b1530_FLASH_WRITE_ADDR_4, Z => n6868);
   U1169 : BF1T1 port map( A => b1530_FLASH_WRITE_ADDR_3, Z => n6869);
   U1170 : BF1T1 port map( A => b1530_FLASH_WRITE_ADDR_2, Z => n6870);
   U1171 : BF1T1 port map( A => b1530_FLASH_WRITE_ADDR_1, Z => n6871);
   U1172 : BF1T1 port map( A => b1530_FLASH_WRITE_ADDR_0, Z => n6872);
   U1173 : BF1T1 port map( A => n6874, Z => n6873);
   U1174 : BF1T1 port map( A => b1530_FLASH_WRITE_CONFIRM_BIT, Z => n6874);
   U1175 : BF1T1 port map( A => buff_in_STOPPED, Z => n6875);
   U1176 : ND2 port map( A => buff_CPU_IN_7, B => n7535, Z => n7095);
   U1177 : BF1T1 port map( A => n7095, Z => n6876);
   U1178 : BF1T1 port map( A => b_CPU_IN_6, Z => n6877);
   U1179 : ND2 port map( A => buff_CPU_IN_5, B => n7535, Z => n7100);
   U1180 : BF1T1 port map( A => n7100, Z => n6878);
   U1181 : ND2 port map( A => buff_CPU_IN_4, B => n7535, Z => n7103);
   U1182 : BF1T1 port map( A => n7103, Z => n6879);
   U1183 : ND2 port map( A => buff_CPU_IN_3, B => n7536, Z => n7106);
   U1184 : BF1T1 port map( A => n7106, Z => n6880);
   U1185 : ND2 port map( A => buff_CPU_IN_2, B => n7536, Z => n7109);
   U1186 : BF1T1 port map( A => n7109, Z => n6881);
   U1187 : ND2 port map( A => buff_CPU_IN_1, B => n7536, Z => n7112);
   U1188 : BF1T1 port map( A => n7112, Z => n6882);
   U1189 : ND2 port map( A => buff_CPU_IN_0, B => n7536, Z => n7115);
   U1190 : BF1T1 port map( A => n7115, Z => n6883);
   U1191 : BF1T1 port map( A => buff_in_RAM_WE, Z => n6884);
   U1192 : NR2 port map( A => n7135, B => n7001, Z => buff_in_DAC_DATA_BYTEL_0)
                           ;
   U1193 : BF1T1 port map( A => buff_in_DAC_DATA_BYTEL_0, Z => n6885);
   U1194 : NR2 port map( A => n7134, B => n7001, Z => buff_in_DAC_DATA_BYTEL_1)
                           ;
   U1195 : BF1T1 port map( A => buff_in_DAC_DATA_BYTEL_1, Z => n6886);
   U1196 : NR2 port map( A => n7133, B => n7001, Z => buff_in_DAC_DATA_BYTEL_2)
                           ;
   U1197 : BF1T1 port map( A => buff_in_DAC_DATA_BYTEL_2, Z => n6887);
   U1198 : NR2 port map( A => n7132, B => n7001, Z => buff_in_DAC_DATA_BYTEL_3)
                           ;
   U1199 : BF1T1 port map( A => buff_in_DAC_DATA_BYTEL_3, Z => n6888);
   U1200 : NR2 port map( A => n7131, B => n7001, Z => buff_in_DAC_DATA_BYTEL_4)
                           ;
   U1201 : BF1T1 port map( A => buff_in_DAC_DATA_BYTEL_4, Z => n6889);
   U1202 : NR2 port map( A => n7130, B => n7001, Z => buff_in_DAC_DATA_BYTEL_5)
                           ;
   U1203 : BF1T1 port map( A => buff_in_DAC_DATA_BYTEL_5, Z => n6890);
   U1204 : NR2 port map( A => n7129, B => n7001, Z => buff_in_DAC_DATA_BYTEL_6)
                           ;
   U1205 : BF1T1 port map( A => buff_in_DAC_DATA_BYTEL_6, Z => n6891);
   U1206 : NR2 port map( A => n7128, B => n7001, Z => buff_in_DAC_DATA_BYTEL_7)
                           ;
   U1207 : BF1T1 port map( A => buff_in_DAC_DATA_BYTEL_7, Z => n6892);
   U1208 : NR2 port map( A => n7127, B => n7001, Z => buff_in_DAC_DATA_BYTEH_0)
                           ;
   U1209 : BF1T1 port map( A => buff_in_DAC_DATA_BYTEH_0, Z => n6893);
   U1210 : NR2 port map( A => n7126, B => n7001, Z => buff_in_DAC_DATA_BYTEH_1)
                           ;
   U1211 : BF1T1 port map( A => buff_in_DAC_DATA_BYTEH_1, Z => n6894);
   U1212 : NR2 port map( A => n7125, B => n7001, Z => buff_in_DAC_DATA_BYTEH_2)
                           ;
   U1213 : BF1T1 port map( A => buff_in_DAC_DATA_BYTEH_2, Z => n6895);
   U1214 : NR2 port map( A => n7124, B => n7001, Z => buff_in_DAC_DATA_BYTEH_3)
                           ;
   U1215 : BF1T1 port map( A => buff_in_DAC_DATA_BYTEH_3, Z => n6896);
   U1216 : NR2 port map( A => n7123, B => n7001, Z => buff_in_DAC_DATA_BYTEH_4)
                           ;
   U1217 : BF1T1 port map( A => buff_in_DAC_DATA_BYTEH_4, Z => n6897);
   U1218 : NR2 port map( A => n7122, B => n7001, Z => buff_in_DAC_DATA_BYTEH_5)
                           ;
   U1219 : BF1T1 port map( A => buff_in_DAC_DATA_BYTEH_5, Z => n6898);
   U1220 : NR2 port map( A => n7121, B => n7001, Z => buff_in_DAC_DATA_BYTEH_6)
                           ;
   U1221 : BF1T1 port map( A => buff_in_DAC_DATA_BYTEH_6, Z => n6899);
   U1222 : NR2 port map( A => n7120, B => n7001, Z => buff_in_DAC_DATA_BYTEH_7)
                           ;
   U1223 : BF1T1 port map( A => buff_in_DAC_DATA_BYTEH_7, Z => n6900);
   U1224 : BF1T2 port map( A => flashi(7), Z => n6901);
   U1225 : BF1T1 port map( A => b1530_MP3BYTE_0, Z => n6902);
   U1226 : BF1T2 port map( A => flashi(6), Z => n6903);
   U1227 : BF1T1 port map( A => b1530_MP3BYTE_1, Z => n6904);
   U1228 : BF1T2 port map( A => flashi(5), Z => n6905);
   U1229 : BF1T1 port map( A => b1530_MP3BYTE_2, Z => n6906);
   U1230 : BF1T2 port map( A => flashi(4), Z => n6907);
   U1231 : BF1T1 port map( A => b1530_MP3BYTE_3, Z => n6908);
   U1232 : BF1T2 port map( A => flashi(3), Z => n6909);
   U1233 : BF1T1 port map( A => b1530_MP3BYTE_4, Z => n6910);
   U1234 : BF1T2 port map( A => flashi(2), Z => n6911);
   U1235 : BF1T1 port map( A => b1530_MP3BYTE_5, Z => n6912);
   U1236 : BF1T1 port map( A => b1530_MP3BYTE_6, Z => n6913);
   U1237 : BF1T2 port map( A => flashi(0), Z => n6914);
   U1238 : BF1T1 port map( A => b1530_MP3BYTE_7, Z => n6915);
   U1239 : NR2 port map( A => n7006, B => n7001, Z => buff_in_LCD_UART_DATA_7);
   U1240 : BF1T1 port map( A => buff_in_LCD_UART_DATA_7, Z => n6916);
   U1241 : NR2 port map( A => n7007, B => n7001, Z => buff_in_LCD_UART_DATA_6);
   U1242 : BF1T1 port map( A => buff_in_LCD_UART_DATA_6, Z => n6917);
   U1243 : NR2 port map( A => n7008, B => n7001, Z => buff_in_LCD_UART_DATA_5);
   U1244 : BF1T1 port map( A => buff_in_LCD_UART_DATA_5, Z => n6918);
   U1245 : NR2 port map( A => n7009, B => n7001, Z => buff_in_LCD_UART_DATA_4);
   U1246 : BF1T1 port map( A => buff_in_LCD_UART_DATA_4, Z => n6919);
   U1247 : NR2 port map( A => n7010, B => n7001, Z => buff_in_LCD_UART_DATA_3);
   U1248 : BF1T1 port map( A => buff_in_LCD_UART_DATA_3, Z => n6920);
   U1249 : NR2 port map( A => n7011, B => n7001, Z => buff_in_LCD_UART_DATA_2);
   U1250 : BF1T1 port map( A => buff_in_LCD_UART_DATA_2, Z => n6921);
   U1251 : NR2 port map( A => n7012, B => n7001, Z => buff_in_LCD_UART_DATA_1);
   U1252 : BF1T1 port map( A => buff_in_LCD_UART_DATA_1, Z => n6922);
   U1253 : NR2 port map( A => n7013, B => n7001, Z => buff_in_LCD_UART_DATA_0);
   U1254 : BF1T1 port map( A => buff_in_LCD_UART_DATA_0, Z => n6923);
   U1255 : BF1T1 port map( A => n7005, Z => n6924);
   U1256 : BF1T1 port map( A => n7014, Z => n6925);
   U1257 : BF1T1 port map( A => b1530_RAM_DATA_IN_0, Z => n6926);
   U1258 : BF1T1 port map( A => b1530_RAM_DATA_IN_1, Z => n6927);
   U1259 : BF1T1 port map( A => b1530_RAM_DATA_IN_2, Z => n6928);
   U1260 : BF1T1 port map( A => b1530_RAM_DATA_IN_3, Z => n6929);
   U1261 : BF1T1 port map( A => b1530_RAM_DATA_IN_4, Z => n6930);
   U1262 : BF1T1 port map( A => b1530_RAM_DATA_IN_5, Z => n6931);
   U1263 : BF1T1 port map( A => b1530_RAM_DATA_IN_6, Z => n6932);
   U1264 : BF1T1 port map( A => b1530_RAM_DATA_IN_7, Z => n6933);
   U1265 : IV5 port map( A => n7520, Z => buff_in_FLASHO_WDATA_7);
   U1266 : ND2 port map( A => buff_FLASHO_WDATA_6, B => n7521, Z => n7017);
   U1267 : BF1T1 port map( A => n7017, Z => n6934);
   U1268 : AO28 port map( A => n7015, B => n7016, C => n6934, D => n7001, Z => 
                           buff_in_FLASHO_WDATA_6);
   U1269 : ND2 port map( A => buff_FLASHO_WDATA_5, B => n7521, Z => n7019);
   U1270 : BF1T1 port map( A => n7019, Z => n6935);
   U1271 : AO28 port map( A => n7018, B => n6805, C => n6935, D => n7001, Z => 
                           buff_in_FLASHO_WDATA_5);
   U1272 : ND2 port map( A => buff_FLASHO_WDATA_4, B => n7521, Z => n7021);
   U1273 : BF1T1 port map( A => n7021, Z => n6936);
   U1274 : AO28 port map( A => n7020, B => n7016, C => n6936, D => n7001, Z => 
                           buff_in_FLASHO_WDATA_4);
   U1275 : ND2 port map( A => buff_FLASHO_WDATA_3, B => n7521, Z => n7023);
   U1276 : BF1T1 port map( A => n7023, Z => n6937);
   U1277 : AO28 port map( A => n7022, B => n6805, C => n6937, D => n7001, Z => 
                           buff_in_FLASHO_WDATA_3);
   U1278 : ND2 port map( A => buff_FLASHO_WDATA_2, B => n7521, Z => n7025);
   U1279 : BF1T1 port map( A => n7025, Z => n6938);
   U1280 : AO28 port map( A => n7024, B => n7016, C => n6938, D => n7001, Z => 
                           buff_in_FLASHO_WDATA_2);
   U1281 : ND2 port map( A => buff_FLASHO_WDATA_1, B => n7521, Z => n7027);
   U1282 : BF1T1 port map( A => n7027, Z => n6939);
   U1283 : AO28 port map( A => n7026, B => n6805, C => n6939, D => n7001, Z => 
                           buff_in_FLASHO_WDATA_1);
   U1284 : ND2 port map( A => buff_FLASHO_WDATA_0, B => n7521, Z => n7029);
   U1285 : BF1T1 port map( A => n7029, Z => n6940);
   U1286 : AO28 port map( A => n7028, B => n7016, C => n6940, D => n7001, Z => 
                           buff_in_FLASHO_WDATA_0);
   U1287 : ND2 port map( A => buff_FLASHO_ADDR_15, B => n7533, Z => n7037);
   U1288 : BF1T1 port map( A => n7037, Z => n6941);
   U1289 : ND2 port map( A => buff_FLASHO_ADDR_14, B => n7533, Z => n7041);
   U1290 : BF1T1 port map( A => n7041, Z => n6942);
   U1291 : ND2 port map( A => buff_FLASHO_ADDR_13, B => n7533, Z => n7044);
   U1292 : BF1T1 port map( A => n7044, Z => n6943);
   U1293 : ND2 port map( A => buff_FLASHO_ADDR_12, B => n7533, Z => n7047);
   U1294 : BF1T1 port map( A => n7047, Z => n6944);
   U1295 : ND2 port map( A => buff_FLASHO_ADDR_11, B => n7532, Z => n7050);
   U1296 : BF1T1 port map( A => n7050, Z => n6945);
   U1297 : ND2 port map( A => buff_FLASHO_ADDR_10, B => n7532, Z => n7052);
   U1298 : BF1T1 port map( A => n7052, Z => n6946);
   U1299 : ND2 port map( A => buff_FLASHO_ADDR_9, B => n7532, Z => n7055);
   U1300 : BF1T1 port map( A => n7055, Z => n6947);
   U1301 : ND2 port map( A => buff_FLASHO_ADDR_8, B => n7532, Z => n7058);
   U1302 : BF1T1 port map( A => n7058, Z => n6948);
   U1303 : ND2 port map( A => buff_FLASHO_ADDR_7, B => n7532, Z => n7061);
   U1304 : BF1T1 port map( A => n7061, Z => n6949);
   U1305 : ND2 port map( A => buff_FLASHO_ADDR_6, B => n7532, Z => n7064);
   U1306 : BF1T1 port map( A => n7064, Z => n6950);
   U1307 : ND2 port map( A => buff_FLASHO_ADDR_5, B => n7532, Z => n7067);
   U1308 : BF1T1 port map( A => n7067, Z => n6951);
   U1309 : ND2 port map( A => buff_FLASHO_ADDR_4, B => n7532, Z => n7070);
   U1310 : BF1T1 port map( A => n7070, Z => n6952);
   U1311 : ND2 port map( A => buff_FLASHO_ADDR_3, B => n7532, Z => n7073);
   U1312 : BF1T1 port map( A => n7073, Z => n6953);
   U1313 : ND2 port map( A => buff_FLASHO_ADDR_2, B => n7532, Z => n7076);
   U1314 : BF1T1 port map( A => n7076, Z => n6954);
   U1315 : ND2 port map( A => buff_FLASHO_ADDR_1, B => n7532, Z => n7079);
   U1316 : BF1T1 port map( A => n7079, Z => n6955);
   U1317 : ND2 port map( A => buff_FLASHO_ADDR_0, B => n7532, Z => n7082);
   U1318 : BF1T1 port map( A => n7082, Z => n6956);
   U1319 : BF1T1 port map( A => buff_in_FLASHO_WE, Z => n6957);
   U1320 : IV5 port map( A => n7522, Z => buff_in_FLASHO_OE);
   U1321 : BF1T1 port map( A => buff_in_FLASHO_EN, Z => n6958);
   U1322 : AN2P port map( A => b1530_FLASHO_EN, B => rst, Z => 
                           buff_in_FLASHO_EN);
   n6959 <= '0';
   n6960 <= '0';
   n6961 <= '0';
   n6962 <= '0';
   n6963 <= '0';
   n6964 <= '0';
   n6965 <= '0';
   n6966 <= '0';
   buff_reg_DAC_SEND_DATA : FD1 port map( CP => clk, D => n6966, Q => 
                           buff_DAC_SEND_DATA, QN => n6751);
   buff_reg_STOPIT : FD1 port map( CP => clk, D => n6965, Q => buff_STOPIT, QN 
                           => open);
   buff_reg_TAKETHISMP3 : FD1 port map( CP => clk, D => n6964, Q => 
                           buff_TAKETHISMP3, QN => open);
   buff_reg_CLOCK_READ : FD1 port map( CP => clk, D => n6963, Q => 
                           buff_CLOCK_READ, QN => open);
   buff_reg_CLOCK_HOLD : FD1 port map( CP => clk, D => n6962, Q => 
                           buff_CLOCK_HOLD, QN => open);
   buff_reg_CLOCK_RST : FD1 port map( CP => clk, D => n6961, Q => 
                           buff_CLOCK_RST, QN => open);
   buff_reg_PC_UART_ACK_RCV : FD1 port map( CP => clk, D => n6960, Q => 
                           buff_PC_UART_ACK_RCV, QN => n6749);
   buff_reg_LCD_UART_SEND : FD1 port map( CP => clk, D => n6959, Q => 
                           buff_LCD_UART_SEND, QN => n6750);
   ram_data_in_reg_7 : FD1QX4 port map( CP => clk, D => n6933, Q => 
                           ram_data_in(7));
   ram_data_in_reg_6 : FD1QX4 port map( CP => clk, D => n6932, Q => 
                           ram_data_in(6));
   ram_data_in_reg_5 : FD1QX4 port map( CP => clk, D => n6931, Q => 
                           ram_data_in(5));
   ram_data_in_reg_4 : FD1QX4 port map( CP => clk, D => n6930, Q => 
                           ram_data_in(4));
   ram_data_in_reg_3 : FD1QX4 port map( CP => clk, D => n6929, Q => 
                           ram_data_in(3));
   ram_data_in_reg_2 : FD1QX4 port map( CP => clk, D => n6928, Q => 
                           ram_data_in(2));
   ram_data_in_reg_1 : FD1QX4 port map( CP => clk, D => n6927, Q => 
                           ram_data_in(1));
   ram_data_in_reg_0 : FD1QX4 port map( CP => clk, D => n6926, Q => 
                           ram_data_in(0));
   n6967 <= '0';
   n6968 <= '0';
   dac_data_byteh_reg_7 : FD1QX4 port map( CP => clk, D => n6900, Q => 
                           dac_data_byteh(7));
   buff_reg_STOPPED : FD1P port map( CP => clk, D => n6875, Q => buff_STOPPED, 
                           QN => n7403);
   buff_reg_PLAYSTATE_0 : FD1P port map( CP => clk, D => buff_in_PLAYSTATE_0, Q
                           => buff_PLAYSTATE_0, QN => n7367);
   buff_reg_PLAYSTATE_1 : FD1P port map( CP => clk, D => buff_in_PLAYSTATE_1, Q
                           => buff_PLAYSTATE_1, QN => n7368);
   buff_reg_FLASH_WRITE_CONFIRM_BIT : FD1P port map( CP => clk, D => n6873, Q 
                           => open, QN => n7161);
   buff_reg_FLASH_STOP_ADDR_0 : FD1QX4 port map( CP => clk, D => 
                           b1530_FLASH_STOP_ADDR_0, Q => buff_FLASH_STOP_ADDR_0
                           );
   buff_reg_FLASH_STOP_ADDR_1 : FD1QX4 port map( CP => clk, D => 
                           b1530_FLASH_STOP_ADDR_1, Q => buff_FLASH_STOP_ADDR_1
                           );
   buff_reg_FLASH_STOP_ADDR_2 : FD1QX4 port map( CP => clk, D => 
                           b1530_FLASH_STOP_ADDR_2, Q => buff_FLASH_STOP_ADDR_2
                           );
   buff_reg_FLASH_STOP_ADDR_3 : FD1QX4 port map( CP => clk, D => 
                           b1530_FLASH_STOP_ADDR_3, Q => buff_FLASH_STOP_ADDR_3
                           );
   buff_reg_FLASH_STOP_ADDR_4 : FD1QX4 port map( CP => clk, D => 
                           b1530_FLASH_STOP_ADDR_4, Q => buff_FLASH_STOP_ADDR_4
                           );
   buff_reg_FLASH_STOP_ADDR_5 : FD1QX4 port map( CP => clk, D => 
                           b1530_FLASH_STOP_ADDR_5, Q => buff_FLASH_STOP_ADDR_5
                           );
   buff_reg_FLASH_STOP_ADDR_6 : FD1QX4 port map( CP => clk, D => 
                           b1530_FLASH_STOP_ADDR_6, Q => buff_FLASH_STOP_ADDR_6
                           );
   buff_reg_FLASH_STOP_ADDR_7 : FD1QX4 port map( CP => clk, D => 
                           b1530_FLASH_STOP_ADDR_7, Q => buff_FLASH_STOP_ADDR_7
                           );
   buff_reg_FLASH_STOP_ADDR_8 : FD1QX4 port map( CP => clk, D => 
                           b1530_FLASH_STOP_ADDR_8, Q => buff_FLASH_STOP_ADDR_8
                           );
   buff_reg_FLASH_STOP_ADDR_9 : FD1QX4 port map( CP => clk, D => 
                           b1530_FLASH_STOP_ADDR_9, Q => buff_FLASH_STOP_ADDR_9
                           );
   buff_reg_FLASH_STOP_ADDR_10 : FD1QX4 port map( CP => clk, D => 
                           b1530_FLASH_STOP_ADDR_10, Q => 
                           buff_FLASH_STOP_ADDR_10);
   buff_reg_FLASH_STOP_ADDR_11 : FD1QX4 port map( CP => clk, D => 
                           b1530_FLASH_STOP_ADDR_11, Q => 
                           buff_FLASH_STOP_ADDR_11);
   buff_reg_FLASH_STOP_ADDR_12 : FD1QX4 port map( CP => clk, D => 
                           b1530_FLASH_STOP_ADDR_12, Q => 
                           buff_FLASH_STOP_ADDR_12);
   buff_reg_FLASH_STOP_ADDR_13 : FD1QX4 port map( CP => clk, D => 
                           b1530_FLASH_STOP_ADDR_13, Q => 
                           buff_FLASH_STOP_ADDR_13);
   buff_reg_FLASH_STOP_ADDR_14 : FD1QX4 port map( CP => clk, D => 
                           b1530_FLASH_STOP_ADDR_14, Q => 
                           buff_FLASH_STOP_ADDR_14);
   buff_reg_FLASH_STOP_ADDR_15 : FD1QX4 port map( CP => clk, D => 
                           b1530_FLASH_STOP_ADDR_15, Q => 
                           buff_FLASH_STOP_ADDR_15);
   buff_reg_FLASH_STOP_ADDR_16 : FD1QX4 port map( CP => clk, D => 
                           b1530_FLASH_STOP_ADDR_16, Q => 
                           buff_FLASH_STOP_ADDR_16);
   buff_reg_FLASH_STOP_ADDR_17 : FD1QX4 port map( CP => clk, D => 
                           b1530_FLASH_STOP_ADDR_17, Q => 
                           buff_FLASH_STOP_ADDR_17);
   buff_reg_FLASH_STOP_ADDR_18 : FD1QX4 port map( CP => clk, D => 
                           b1530_FLASH_STOP_ADDR_18, Q => 
                           buff_FLASH_STOP_ADDR_18);
   buff_reg_FLASH_STOP_ADDR_19 : FD1QX4 port map( CP => clk, D => 
                           b1530_FLASH_STOP_ADDR_19, Q => 
                           buff_FLASH_STOP_ADDR_19);
   buff_reg_FLASH_STOP_ADDR_20 : FD1QX4 port map( CP => clk, D => 
                           b1530_FLASH_STOP_ADDR_20, Q => 
                           buff_FLASH_STOP_ADDR_20);
   buff_reg_FLASH_STOP_ADDR_21 : FD1QX4 port map( CP => clk, D => 
                           b1530_FLASH_STOP_ADDR_21, Q => 
                           buff_FLASH_STOP_ADDR_21);
   buff_reg_FLASH_STOP_ADDR_22 : FD1QX4 port map( CP => clk, D => 
                           b1530_FLASH_STOP_ADDR_22, Q => 
                           buff_FLASH_STOP_ADDR_22);
   buff_reg_FLASH_STOP_ADDR_23 : FD1QX4 port map( CP => clk, D => 
                           b1530_FLASH_STOP_ADDR_23, Q => 
                           buff_FLASH_STOP_ADDR_23);
   buff_reg_FLASH_STOP_ADDR_24 : FD1QX4 port map( CP => clk, D => 
                           b1530_FLASH_STOP_ADDR_24, Q => 
                           buff_FLASH_STOP_ADDR_24);
   buff_reg_FLASH_STOP_ADDR_25 : FD1QX4 port map( CP => clk, D => 
                           b1530_FLASH_STOP_ADDR_25, Q => 
                           buff_FLASH_STOP_ADDR_25);
   buff_reg_FLASH_STOP_ADDR_26 : FD1QX4 port map( CP => clk, D => 
                           b1530_FLASH_STOP_ADDR_26, Q => 
                           buff_FLASH_STOP_ADDR_26);
   buff_reg_FLASH_STOP_ADDR_27 : FD1QX4 port map( CP => clk, D => 
                           b1530_FLASH_STOP_ADDR_27, Q => 
                           buff_FLASH_STOP_ADDR_27);
   buff_reg_FLASH_STOP_ADDR_28 : FD1QX4 port map( CP => clk, D => 
                           b1530_FLASH_STOP_ADDR_28, Q => 
                           buff_FLASH_STOP_ADDR_28);
   buff_reg_FLASH_STOP_ADDR_29 : FD1QX4 port map( CP => clk, D => 
                           b1530_FLASH_STOP_ADDR_29, Q => 
                           buff_FLASH_STOP_ADDR_29);
   buff_reg_FLASH_STOP_ADDR_30 : FD1QX4 port map( CP => clk, D => 
                           b1530_FLASH_STOP_ADDR_30, Q => 
                           buff_FLASH_STOP_ADDR_30);
   buff_reg_FLASH_STOP_ADDR_31 : FD1QX4 port map( CP => clk, D => 
                           b1530_FLASH_STOP_ADDR_31, Q => 
                           buff_FLASH_STOP_ADDR_31);
   buff_reg_FLASHO_EN : FD1QX4 port map( CP => clk, D => n6958, Q => 
                           b1530_FLASHO_EN);
   buff_reg_FLASHO_OE : FD1QX4 port map( CP => clk, D => buff_in_FLASHO_OE, Q 
                           => buff_FLASHO_OE);
   buff_reg_FLASHO_WDATA_7 : FD1QX4 port map( CP => clk, D => 
                           buff_in_FLASHO_WDATA_7, Q => buff_FLASHO_WDATA_7);
   buff_reg_MP3_DMA_STATE_0 : FD1P port map( CP => clk, D => 
                           buff_in_MP3_DMA_STATE_0, Q => buff_MP3_DMA_STATE_0, 
                           QN => n7412);
   buff_reg_MP3_DMA_STATE_1 : FD1SP port map( CP => clk, D => rst, TE => n7183,
                           TI => n6969, Q => buff_MP3_DMA_STATE_1, QN => n7411)
                           ;
   n6969 <= '0';
   buff_reg_MP3_DMA_STATE_2 : FD1SP port map( CP => clk, D => rst, TE => n6820,
                           TI => n6970, Q => open, QN => n7419);
   n6970 <= '0';
   buff_reg_STATE_0 : FD1SP port map( CP => clk, D => rst, TE => n6819, TI => 
                           n6971, Q => buff_STATE_0, QN => n7323);
   n6971 <= '0';
   buff_reg_STATE_1 : FD1SP port map( CP => clk, D => rst, TE => n6798, TI => 
                           n6972, Q => buff_STATE_1, QN => n7324);
   n6972 <= '0';
   buff_reg_STATE_2 : FD1SP port map( CP => clk, D => n6973, TE => rst, TI => 
                           n7002, Q => buff_STATE_2, QN => n7327);
   n6973 <= '0';
   buff_reg_STATE_3 : FD1SP port map( CP => clk, D => rst, TE => n6797, TI => 
                           n6974, Q => buff_STATE_3, QN => n7325);
   n6974 <= '0';
   buff_reg_STATE_4 : FD1SP port map( CP => clk, D => rst, TE => n6818, TI => 
                           n6975, Q => buff_STATE_4, QN => n7326);
   n6975 <= '0';
   buff_reg_HALT : FD1P port map( CP => clk, D => b_HALT, Q => open, QN => 
                           n7207);
   n6976 <= '1';
   n6977 <= '0';
   ram_we_reg : FD1QX4 port map( CP => clk, D => n6884, Q => ram_we);
   n6978 <= '0';
   n6979 <= '1';
   n6980 <= '0';
   add_559_plus_plus : mmu_DW01_inc_32_0 port map( A(31) => b1453_PLAY_ADDR_31,
                           A(30) => b1453_PLAY_ADDR_30, A(29) => 
                           b1453_PLAY_ADDR_29, A(28) => b1453_PLAY_ADDR_28, 
                           A(27) => b1453_PLAY_ADDR_27, A(26) => 
                           b1453_PLAY_ADDR_26, A(25) => b1453_PLAY_ADDR_25, 
                           A(24) => b1453_PLAY_ADDR_24, A(23) => 
                           b1453_PLAY_ADDR_23, A(22) => b1453_PLAY_ADDR_22, 
                           A(21) => b1453_PLAY_ADDR_21, A(20) => 
                           b1453_PLAY_ADDR_20, A(19) => b1453_PLAY_ADDR_19, 
                           A(18) => b1453_PLAY_ADDR_18, A(17) => 
                           b1453_PLAY_ADDR_17, A(16) => b1453_PLAY_ADDR_16, 
                           A(15) => b1453_PLAY_ADDR_15, A(14) => 
                           b1453_PLAY_ADDR_14, A(13) => b1453_PLAY_ADDR_13, 
                           A(12) => b1453_PLAY_ADDR_12, A(11) => 
                           b1453_PLAY_ADDR_11, A(10) => b1453_PLAY_ADDR_10, 
                           A(9) => b1453_PLAY_ADDR_9, A(8) => b1453_PLAY_ADDR_8
                           , A(7) => b1453_PLAY_ADDR_7, A(6) => 
                           b1453_PLAY_ADDR_6, A(5) => b1453_PLAY_ADDR_5, A(4) 
                           => b1453_PLAY_ADDR_4, A(3) => b1453_PLAY_ADDR_3, 
                           A(2) => b1453_PLAY_ADDR_2, A(1) => b1453_PLAY_ADDR_1
                           , A(0) => b1453_PLAY_ADDR_0, SUM(31) => ARG3346_31, 
                           SUM(30) => ARG3346_30, SUM(29) => ARG3346_29, 
                           SUM(28) => ARG3346_28, SUM(27) => ARG3346_27, 
                           SUM(26) => ARG3346_26, SUM(25) => ARG3346_25, 
                           SUM(24) => ARG3346_24, SUM(23) => ARG3346_23, 
                           SUM(22) => ARG3346_22, SUM(21) => ARG3346_21, 
                           SUM(20) => ARG3346_20, SUM(19) => ARG3346_19, 
                           SUM(18) => ARG3346_18, SUM(17) => ARG3346_17, 
                           SUM(16) => ARG3346_16, SUM(15) => ARG3346_15, 
                           SUM(14) => ARG3346_14, SUM(13) => ARG3346_13, 
                           SUM(12) => ARG3346_12, SUM(11) => ARG3346_11, 
                           SUM(10) => ARG3346_10, SUM(9) => ARG3346_9, SUM(8) 
                           => ARG3346_8, SUM(7) => ARG3346_7, SUM(6) => 
                           ARG3346_6, SUM(5) => ARG3346_5, SUM(4) => ARG3346_4,
                           SUM(3) => ARG3346_3, SUM(2) => ARG3346_2, SUM(1) => 
                           ARG3346_1, SUM(0) => ARG3346_0);
   U1345 : AO2N port map( A => buff_FLASH_STOP_ADDR_0, B => n6981, C => n6982, 
                           D => n6983, Z => b1530_FLASH_STOP_ADDR_0);
   U1346 : AO2N port map( A => buff_FLASH_STOP_ADDR_1, B => n6981, C => n6984, 
                           D => n6983, Z => b1530_FLASH_STOP_ADDR_1);
   U1347 : AO2N port map( A => buff_FLASH_STOP_ADDR_2, B => n6981, C => n6985, 
                           D => n6983, Z => b1530_FLASH_STOP_ADDR_2);
   U1348 : AO2N port map( A => buff_FLASH_STOP_ADDR_3, B => n6981, C => n6986, 
                           D => n6983, Z => b1530_FLASH_STOP_ADDR_3);
   U1349 : AO2N port map( A => buff_FLASH_STOP_ADDR_4, B => n6981, C => n6983, 
                           D => n6987, Z => b1530_FLASH_STOP_ADDR_4);
   U1350 : AO2N port map( A => buff_FLASH_STOP_ADDR_5, B => n6981, C => n6988, 
                           D => n6983, Z => b1530_FLASH_STOP_ADDR_5);
   U1351 : AO2N port map( A => buff_FLASH_STOP_ADDR_6, B => n6981, C => n6989, 
                           D => n6983, Z => b1530_FLASH_STOP_ADDR_6);
   U1352 : AO2N port map( A => buff_FLASH_STOP_ADDR_7, B => n6981, C => n6983, 
                           D => n6990, Z => b1530_FLASH_STOP_ADDR_7);
   U1353 : AO2N port map( A => buff_FLASH_STOP_ADDR_8, B => n6991, C => n6992, 
                           D => n6982, Z => b1530_FLASH_STOP_ADDR_8);
   U1354 : AO2N port map( A => buff_FLASH_STOP_ADDR_9, B => n6991, C => n6992, 
                           D => n6984, Z => b1530_FLASH_STOP_ADDR_9);
   U1355 : AO2N port map( A => buff_FLASH_STOP_ADDR_10, B => n6991, C => n6992,
                           D => n6985, Z => b1530_FLASH_STOP_ADDR_10);
   U1356 : AO2N port map( A => buff_FLASH_STOP_ADDR_11, B => n6991, C => n6992,
                           D => n6986, Z => b1530_FLASH_STOP_ADDR_11);
   U1357 : AO2N port map( A => buff_FLASH_STOP_ADDR_12, B => n6991, C => n6992,
                           D => n6987, Z => b1530_FLASH_STOP_ADDR_12);
   U1358 : AO2N port map( A => buff_FLASH_STOP_ADDR_13, B => n6991, C => n6992,
                           D => n6988, Z => b1530_FLASH_STOP_ADDR_13);
   U1359 : AO2N port map( A => buff_FLASH_STOP_ADDR_14, B => n6991, C => n6992,
                           D => n6989, Z => b1530_FLASH_STOP_ADDR_14);
   U1360 : AO2N port map( A => buff_FLASH_STOP_ADDR_15, B => n6991, C => n6992,
                           D => n6990, Z => b1530_FLASH_STOP_ADDR_15);
   U1361 : AO2N port map( A => buff_FLASH_STOP_ADDR_16, B => n6993, C => n6994,
                           D => n6982, Z => b1530_FLASH_STOP_ADDR_16);
   U1362 : AO2N port map( A => buff_FLASH_STOP_ADDR_17, B => n6993, C => n6994,
                           D => n6984, Z => b1530_FLASH_STOP_ADDR_17);
   U1363 : AO2N port map( A => buff_FLASH_STOP_ADDR_18, B => n6993, C => n6994,
                           D => n6985, Z => b1530_FLASH_STOP_ADDR_18);
   U1364 : AO2N port map( A => buff_FLASH_STOP_ADDR_19, B => n6993, C => n6994,
                           D => n6986, Z => b1530_FLASH_STOP_ADDR_19);
   U1365 : AO2N port map( A => buff_FLASH_STOP_ADDR_20, B => n6993, C => n6994,
                           D => n6987, Z => b1530_FLASH_STOP_ADDR_20);
   U1366 : AO2N port map( A => buff_FLASH_STOP_ADDR_21, B => n6993, C => n6994,
                           D => n6988, Z => b1530_FLASH_STOP_ADDR_21);
   U1367 : AO2N port map( A => buff_FLASH_STOP_ADDR_22, B => n6993, C => n6994,
                           D => n6989, Z => b1530_FLASH_STOP_ADDR_22);
   U1368 : AO2N port map( A => buff_FLASH_STOP_ADDR_23, B => n6993, C => n6994,
                           D => n6990, Z => b1530_FLASH_STOP_ADDR_23);
   U1369 : AO2N port map( A => buff_FLASH_STOP_ADDR_24, B => n6995, C => n6996,
                           D => n6982, Z => b1530_FLASH_STOP_ADDR_24);
   U1370 : AO2N port map( A => buff_FLASH_STOP_ADDR_25, B => n6995, C => n6996,
                           D => n6984, Z => b1530_FLASH_STOP_ADDR_25);
   U1371 : AO2N port map( A => buff_FLASH_STOP_ADDR_26, B => n6995, C => n6996,
                           D => n6985, Z => b1530_FLASH_STOP_ADDR_26);
   U1372 : AO2N port map( A => buff_FLASH_STOP_ADDR_27, B => n6995, C => n6996,
                           D => n6986, Z => b1530_FLASH_STOP_ADDR_27);
   U1373 : AO2N port map( A => buff_FLASH_STOP_ADDR_28, B => n6995, C => n6996,
                           D => n6987, Z => b1530_FLASH_STOP_ADDR_28);
   U1374 : AO2N port map( A => buff_FLASH_STOP_ADDR_29, B => n6995, C => n6996,
                           D => n6988, Z => b1530_FLASH_STOP_ADDR_29);
   U1375 : AO2N port map( A => buff_FLASH_STOP_ADDR_30, B => n6995, C => n6996,
                           D => n6989, Z => b1530_FLASH_STOP_ADDR_30);
   U1376 : AO2N port map( A => buff_FLASH_STOP_ADDR_31, B => n6995, C => n6996,
                           D => n6990, Z => b1530_FLASH_STOP_ADDR_31);
   U1377 : AO2N port map( A => buff_PLAY_ADDR_31, B => n6997, C => 
                           buff_FLASH_PLAY_ADDR_31, D => n6813, Z => 
                           b1453_PLAY_ADDR_31);
   U1378 : AO2N port map( A => buff_PLAY_ADDR_30, B => n6997, C => 
                           buff_FLASH_PLAY_ADDR_30, D => n6813, Z => 
                           b1453_PLAY_ADDR_30);
   U1379 : AO2N port map( A => buff_PLAY_ADDR_29, B => n6997, C => 
                           buff_FLASH_PLAY_ADDR_29, D => n6813, Z => 
                           b1453_PLAY_ADDR_29);
   U1380 : AO2N port map( A => buff_PLAY_ADDR_28, B => n6997, C => 
                           buff_FLASH_PLAY_ADDR_28, D => n6813, Z => 
                           b1453_PLAY_ADDR_28);
   U1381 : AO2N port map( A => buff_PLAY_ADDR_27, B => n6997, C => 
                           buff_FLASH_PLAY_ADDR_27, D => n6813, Z => 
                           b1453_PLAY_ADDR_27);
   U1382 : AO2N port map( A => buff_PLAY_ADDR_26, B => n6997, C => 
                           buff_FLASH_PLAY_ADDR_26, D => n6813, Z => 
                           b1453_PLAY_ADDR_26);
   U1383 : AO2N port map( A => buff_PLAY_ADDR_25, B => n6997, C => 
                           buff_FLASH_PLAY_ADDR_25, D => n6813, Z => 
                           b1453_PLAY_ADDR_25);
   U1384 : AO2N port map( A => buff_PLAY_ADDR_24, B => n6997, C => 
                           buff_FLASH_PLAY_ADDR_24, D => n6813, Z => 
                           b1453_PLAY_ADDR_24);
   U1385 : AO2N port map( A => buff_PLAY_ADDR_23, B => n6997, C => 
                           buff_FLASH_PLAY_ADDR_23, D => n6813, Z => 
                           b1453_PLAY_ADDR_23);
   U1386 : AO2N port map( A => buff_PLAY_ADDR_22, B => n6997, C => 
                           buff_FLASH_PLAY_ADDR_22, D => n6813, Z => 
                           b1453_PLAY_ADDR_22);
   U1387 : AO2N port map( A => buff_PLAY_ADDR_21, B => n6997, C => 
                           buff_FLASH_PLAY_ADDR_21, D => n6813, Z => 
                           b1453_PLAY_ADDR_21);
   U1388 : AO2N port map( A => buff_PLAY_ADDR_20, B => n6997, C => 
                           buff_FLASH_PLAY_ADDR_20, D => n6813, Z => 
                           b1453_PLAY_ADDR_20);
   U1389 : AO2N port map( A => buff_PLAY_ADDR_19, B => n6997, C => 
                           buff_FLASH_PLAY_ADDR_19, D => n6813, Z => 
                           b1453_PLAY_ADDR_19);
   U1390 : AO2N port map( A => buff_PLAY_ADDR_18, B => n6997, C => 
                           buff_FLASH_PLAY_ADDR_18, D => n6813, Z => 
                           b1453_PLAY_ADDR_18);
   U1391 : AO2N port map( A => buff_PLAY_ADDR_17, B => n6997, C => 
                           buff_FLASH_PLAY_ADDR_17, D => n6813, Z => 
                           b1453_PLAY_ADDR_17);
   U1392 : AO2N port map( A => buff_PLAY_ADDR_16, B => n6997, C => 
                           buff_FLASH_PLAY_ADDR_16, D => n6813, Z => 
                           b1453_PLAY_ADDR_16);
   U1393 : AO2N port map( A => buff_PLAY_ADDR_15, B => n6997, C => 
                           buff_FLASH_PLAY_ADDR_15, D => n6813, Z => 
                           b1453_PLAY_ADDR_15);
   U1394 : AO2N port map( A => buff_PLAY_ADDR_14, B => n6997, C => 
                           buff_FLASH_PLAY_ADDR_14, D => n6813, Z => 
                           b1453_PLAY_ADDR_14);
   U1395 : AO2N port map( A => buff_PLAY_ADDR_13, B => n6997, C => 
                           buff_FLASH_PLAY_ADDR_13, D => n6813, Z => 
                           b1453_PLAY_ADDR_13);
   U1396 : AO2N port map( A => buff_PLAY_ADDR_12, B => n6997, C => 
                           buff_FLASH_PLAY_ADDR_12, D => n6813, Z => 
                           b1453_PLAY_ADDR_12);
   U1397 : AO2N port map( A => buff_PLAY_ADDR_11, B => n6997, C => 
                           buff_FLASH_PLAY_ADDR_11, D => n6813, Z => 
                           b1453_PLAY_ADDR_11);
   U1398 : AO2N port map( A => buff_PLAY_ADDR_10, B => n6997, C => 
                           buff_FLASH_PLAY_ADDR_10, D => n6813, Z => 
                           b1453_PLAY_ADDR_10);
   U1399 : AO2N port map( A => buff_PLAY_ADDR_9, B => n6997, C => 
                           buff_FLASH_PLAY_ADDR_9, D => n6813, Z => 
                           b1453_PLAY_ADDR_9);
   U1400 : AO2N port map( A => buff_PLAY_ADDR_8, B => n6997, C => 
                           buff_FLASH_PLAY_ADDR_8, D => n6813, Z => 
                           b1453_PLAY_ADDR_8);
   U1401 : AO2N port map( A => buff_PLAY_ADDR_7, B => n6997, C => 
                           buff_FLASH_PLAY_ADDR_7, D => n6813, Z => 
                           b1453_PLAY_ADDR_7);
   U1402 : AO2N port map( A => buff_PLAY_ADDR_6, B => n6997, C => 
                           buff_FLASH_PLAY_ADDR_6, D => n6813, Z => 
                           b1453_PLAY_ADDR_6);
   U1403 : AO2N port map( A => buff_PLAY_ADDR_5, B => n6997, C => 
                           buff_FLASH_PLAY_ADDR_5, D => n6813, Z => 
                           b1453_PLAY_ADDR_5);
   U1404 : AO2N port map( A => buff_PLAY_ADDR_4, B => n6997, C => 
                           buff_FLASH_PLAY_ADDR_4, D => n6813, Z => 
                           b1453_PLAY_ADDR_4);
   U1405 : AO2N port map( A => buff_PLAY_ADDR_3, B => n6997, C => 
                           buff_FLASH_PLAY_ADDR_3, D => n6813, Z => 
                           b1453_PLAY_ADDR_3);
   U1406 : AO2N port map( A => buff_PLAY_ADDR_2, B => n6997, C => 
                           buff_FLASH_PLAY_ADDR_2, D => n6813, Z => 
                           b1453_PLAY_ADDR_2);
   U1407 : AO2N port map( A => buff_PLAY_ADDR_1, B => n6997, C => 
                           buff_FLASH_PLAY_ADDR_1, D => n6813, Z => 
                           b1453_PLAY_ADDR_1);
   U1408 : AO2N port map( A => buff_PLAY_ADDR_0, B => n6997, C => 
                           buff_FLASH_PLAY_ADDR_0, D => n6813, Z => 
                           b1453_PLAY_ADDR_0);
   U1409 : AO7N port map( A => n6998, B => n6999, C => rst, Z => b_HALT);
   U1410 : AO7A port map( A => n7003, B => n7001, C => n7004, Z => 
                           buff_in_MP3_DMA_STATE_0);
   U1411 : AO2N port map( A => n7030, B => b1453_PLAY_ADDR_19, C => n7031, D =>
                           n7032, Z => buff_in_FLASHO_ADDR_19);
   U1412 : AO2N port map( A => n7030, B => b1453_PLAY_ADDR_18, C => n7031, D =>
                           n7033, Z => buff_in_FLASHO_ADDR_18);
   U1413 : AO2N port map( A => n7030, B => b1453_PLAY_ADDR_17, C => n7031, D =>
                           n7034, Z => buff_in_FLASHO_ADDR_17);
   U1414 : AO2N port map( A => n7030, B => b1453_PLAY_ADDR_16, C => n7031, D =>
                           n7035, Z => buff_in_FLASHO_ADDR_16);
   U1415 : AO25 port map( A => n7036, B => n6941, C => n7038, D => n7039, E => 
                           n7004, Z => buff_in_FLASHO_ADDR_15);
   U1416 : AO25 port map( A => n7040, B => n6942, C => n7038, D => n7042, E => 
                           n7004, Z => buff_in_FLASHO_ADDR_14);
   U1417 : AO25 port map( A => n7043, B => n6943, C => n7038, D => n7045, E => 
                           n7004, Z => buff_in_FLASHO_ADDR_13);
   U1418 : AO25 port map( A => n7046, B => n6944, C => n7038, D => n7048, E => 
                           n7004, Z => buff_in_FLASHO_ADDR_12);
   U1419 : AO25 port map( A => n7049, B => n6945, C => n7038, D => n7051, E => 
                           n7004, Z => buff_in_FLASHO_ADDR_11);
   U1420 : AO25 port map( A => n6946, B => n7053, C => n7038, D => n7054, E => 
                           n7004, Z => buff_in_FLASHO_ADDR_10);
   U1421 : AO25 port map( A => n6947, B => n7056, C => n7038, D => n7057, E => 
                           n7004, Z => buff_in_FLASHO_ADDR_9);
   U1422 : AO25 port map( A => n6948, B => n7059, C => n7038, D => n7060, E => 
                           n7004, Z => buff_in_FLASHO_ADDR_8);
   U1423 : AO25 port map( A => n6949, B => n7062, C => n7038, D => n7063, E => 
                           n7004, Z => buff_in_FLASHO_ADDR_7);
   U1424 : AO25 port map( A => n6950, B => n7065, C => n7038, D => n7066, E => 
                           n7004, Z => buff_in_FLASHO_ADDR_6);
   U1425 : AO25 port map( A => n6951, B => n7068, C => n7038, D => n7069, E => 
                           n7004, Z => buff_in_FLASHO_ADDR_5);
   U1426 : AO25 port map( A => n6952, B => n7071, C => n7038, D => n7072, E => 
                           n7004, Z => buff_in_FLASHO_ADDR_4);
   U1427 : AO25 port map( A => n6953, B => n7074, C => n7038, D => n7075, E => 
                           n7004, Z => buff_in_FLASHO_ADDR_3);
   U1428 : AO25 port map( A => n6954, B => n7077, C => n7038, D => n7078, E => 
                           n7004, Z => buff_in_FLASHO_ADDR_2);
   U1429 : AO25 port map( A => n6955, B => n7080, C => n7038, D => n7081, E => 
                           n7004, Z => buff_in_FLASHO_ADDR_1);
   U1430 : AO25 port map( A => n6956, B => n7083, C => n7038, D => n7084, E => 
                           n7004, Z => buff_in_FLASHO_ADDR_0);
   U1431 : AO3A port map( A => buff_FLASHO_WE, B => n7085, C => rst, D => n7086
                           , Z => buff_in_FLASHO_WE);
   U1432 : AO1N port map( A => n7090, B => n6990, C => n7001, D => n7091, Z => 
                           buff_in_CLOCK_RST);
   U1433 : AO6C port map( A => n7092, B => n7093, C => rst, Z => 
                           buff_in_STOPPED);
   U1434 : AO8 port map( A => n7094, B => n6876, C => n7096, D => n7001, Z => 
                           b_CPU_IN_7);
   U1435 : AO8 port map( A => n7097, B => n7098, C => n7099, D => n7001, Z => 
                           b_CPU_IN_6);
   U1436 : AO8 port map( A => n6878, B => n7101, C => n7102, D => n7001, Z => 
                           b_CPU_IN_5);
   U1437 : AO8 port map( A => n6879, B => n7104, C => n7105, D => n7001, Z => 
                           b_CPU_IN_4);
   U1438 : AO8 port map( A => n6880, B => n7107, C => n7108, D => n7001, Z => 
                           b_CPU_IN_3);
   U1439 : AO8 port map( A => n6881, B => n7110, C => n7111, D => n7001, Z => 
                           b_CPU_IN_2);
   U1440 : AO8 port map( A => n6882, B => n7113, C => n7114, D => n7001, Z => 
                           b_CPU_IN_1);
   U1441 : AO8 port map( A => n6883, B => n7116, C => n7117, D => n7001, Z => 
                           b_CPU_IN_0);
   U1442 : AO6C port map( A => n7118, B => n7119, C => rst, Z => buff_in_RAM_WE
                           );
   U1443 : AO2N port map( A => n7137, B => ARG3346_31, C => b1453_PLAY_ADDR_31,
                           D => n7138, Z => b1530_PLAY_ADDR_31);
   U1444 : AO2N port map( A => n7137, B => ARG3346_30, C => b1453_PLAY_ADDR_30,
                           D => n7138, Z => b1530_PLAY_ADDR_30);
   U1445 : AO2N port map( A => n7137, B => ARG3346_29, C => b1453_PLAY_ADDR_29,
                           D => n7138, Z => b1530_PLAY_ADDR_29);
   U1446 : AO2N port map( A => n7137, B => ARG3346_28, C => b1453_PLAY_ADDR_28,
                           D => n7138, Z => b1530_PLAY_ADDR_28);
   U1447 : AO2N port map( A => n7137, B => ARG3346_27, C => b1453_PLAY_ADDR_27,
                           D => n7138, Z => b1530_PLAY_ADDR_27);
   U1448 : AO2N port map( A => n7137, B => ARG3346_26, C => b1453_PLAY_ADDR_26,
                           D => n7138, Z => b1530_PLAY_ADDR_26);
   U1449 : AO2N port map( A => n7137, B => ARG3346_25, C => b1453_PLAY_ADDR_25,
                           D => n7138, Z => b1530_PLAY_ADDR_25);
   U1450 : AO2N port map( A => n7137, B => ARG3346_24, C => b1453_PLAY_ADDR_24,
                           D => n7138, Z => b1530_PLAY_ADDR_24);
   U1451 : AO2N port map( A => n7137, B => ARG3346_23, C => b1453_PLAY_ADDR_23,
                           D => n7138, Z => b1530_PLAY_ADDR_23);
   U1452 : AO2N port map( A => n7137, B => ARG3346_22, C => b1453_PLAY_ADDR_22,
                           D => n7138, Z => b1530_PLAY_ADDR_22);
   U1453 : AO2N port map( A => n7137, B => ARG3346_21, C => b1453_PLAY_ADDR_21,
                           D => n7138, Z => b1530_PLAY_ADDR_21);
   U1454 : AO2N port map( A => n7137, B => ARG3346_20, C => b1453_PLAY_ADDR_20,
                           D => n7138, Z => b1530_PLAY_ADDR_20);
   U1455 : AO2N port map( A => n7137, B => ARG3346_19, C => b1453_PLAY_ADDR_19,
                           D => n7138, Z => b1530_PLAY_ADDR_19);
   U1456 : AO2N port map( A => n7137, B => ARG3346_18, C => b1453_PLAY_ADDR_18,
                           D => n7138, Z => b1530_PLAY_ADDR_18);
   U1457 : AO2N port map( A => n7137, B => ARG3346_17, C => b1453_PLAY_ADDR_17,
                           D => n7138, Z => b1530_PLAY_ADDR_17);
   U1458 : AO2N port map( A => n7137, B => ARG3346_16, C => b1453_PLAY_ADDR_16,
                           D => n7138, Z => b1530_PLAY_ADDR_16);
   U1459 : AO2N port map( A => n7137, B => ARG3346_15, C => b1453_PLAY_ADDR_15,
                           D => n7138, Z => b1530_PLAY_ADDR_15);
   U1460 : AO2N port map( A => n7137, B => ARG3346_14, C => b1453_PLAY_ADDR_14,
                           D => n7138, Z => b1530_PLAY_ADDR_14);
   U1461 : AO2N port map( A => n7137, B => ARG3346_13, C => b1453_PLAY_ADDR_13,
                           D => n7138, Z => b1530_PLAY_ADDR_13);
   U1462 : AO2N port map( A => n7137, B => ARG3346_12, C => b1453_PLAY_ADDR_12,
                           D => n7138, Z => b1530_PLAY_ADDR_12);
   U1463 : AO2N port map( A => n7137, B => ARG3346_11, C => b1453_PLAY_ADDR_11,
                           D => n7138, Z => b1530_PLAY_ADDR_11);
   U1464 : AO2N port map( A => n7137, B => ARG3346_10, C => b1453_PLAY_ADDR_10,
                           D => n7138, Z => b1530_PLAY_ADDR_10);
   U1465 : AO2N port map( A => n7137, B => ARG3346_9, C => b1453_PLAY_ADDR_9, D
                           => n7138, Z => b1530_PLAY_ADDR_9);
   U1466 : AO2N port map( A => n7137, B => ARG3346_8, C => b1453_PLAY_ADDR_8, D
                           => n7138, Z => b1530_PLAY_ADDR_8);
   U1467 : AO2N port map( A => n7137, B => ARG3346_7, C => b1453_PLAY_ADDR_7, D
                           => n7138, Z => b1530_PLAY_ADDR_7);
   U1468 : AO2N port map( A => n7137, B => ARG3346_6, C => b1453_PLAY_ADDR_6, D
                           => n7138, Z => b1530_PLAY_ADDR_6);
   U1469 : AO2N port map( A => n7137, B => ARG3346_5, C => b1453_PLAY_ADDR_5, D
                           => n7138, Z => b1530_PLAY_ADDR_5);
   U1470 : AO2N port map( A => n7137, B => ARG3346_4, C => b1453_PLAY_ADDR_4, D
                           => n7138, Z => b1530_PLAY_ADDR_4);
   U1471 : AO2N port map( A => n7137, B => ARG3346_3, C => b1453_PLAY_ADDR_3, D
                           => n7138, Z => b1530_PLAY_ADDR_3);
   U1472 : AO2N port map( A => n7137, B => ARG3346_2, C => b1453_PLAY_ADDR_2, D
                           => n7138, Z => b1530_PLAY_ADDR_2);
   U1473 : AO2N port map( A => n7137, B => ARG3346_1, C => b1453_PLAY_ADDR_1, D
                           => n7138, Z => b1530_PLAY_ADDR_1);
   U1474 : AO2N port map( A => n7137, B => ARG3346_0, C => b1453_PLAY_ADDR_0, D
                           => n7138, Z => b1530_PLAY_ADDR_0);
   U1475 : AO2N port map( A => buff_MP3BYTE_7, B => n7139, C => n7140, D => 
                           n6914, Z => b1530_MP3BYTE_7);
   U1476 : AO2N port map( A => buff_MP3BYTE_6, B => n7139, C => n7140, D => 
                           flashi(1), Z => b1530_MP3BYTE_6);
   U1477 : AO2N port map( A => buff_MP3BYTE_5, B => n7139, C => n7140, D => 
                           n6911, Z => b1530_MP3BYTE_5);
   U1478 : AO2N port map( A => buff_MP3BYTE_4, B => n7139, C => n7140, D => 
                           n6909, Z => b1530_MP3BYTE_4);
   U1479 : AO2N port map( A => buff_MP3BYTE_3, B => n7139, C => n7140, D => 
                           n6907, Z => b1530_MP3BYTE_3);
   U1480 : AO2N port map( A => buff_MP3BYTE_2, B => n7139, C => n7140, D => 
                           n6905, Z => b1530_MP3BYTE_2);
   U1481 : AO2N port map( A => buff_MP3BYTE_1, B => n7139, C => n7140, D => 
                           n6903, Z => b1530_MP3BYTE_1);
   U1482 : AO2N port map( A => buff_MP3BYTE_0, B => n7139, C => n7140, D => 
                           n6901, Z => b1530_MP3BYTE_0);
   U1483 : AO1N port map( A => n7142, B => n7143, C => buff_STOPIT, D => n7144,
                           Z => b1530_STOPIT);
   U1484 : AO2N port map( A => buff_FLASH_PLAY_ADDR_31, B => n7145, C => n7146,
                           D => n6990, Z => b1530_FLASH_PLAY_ADDR_31);
   U1485 : AO2N port map( A => buff_FLASH_PLAY_ADDR_30, B => n7145, C => n7146,
                           D => n6989, Z => b1530_FLASH_PLAY_ADDR_30);
   U1486 : AO2N port map( A => buff_FLASH_PLAY_ADDR_29, B => n7145, C => n7146,
                           D => n6988, Z => b1530_FLASH_PLAY_ADDR_29);
   U1487 : AO2N port map( A => buff_FLASH_PLAY_ADDR_28, B => n7145, C => n7146,
                           D => n6987, Z => b1530_FLASH_PLAY_ADDR_28);
   U1488 : AO2N port map( A => buff_FLASH_PLAY_ADDR_27, B => n7145, C => n7146,
                           D => n6986, Z => b1530_FLASH_PLAY_ADDR_27);
   U1489 : AO2N port map( A => buff_FLASH_PLAY_ADDR_26, B => n7145, C => n7146,
                           D => n6985, Z => b1530_FLASH_PLAY_ADDR_26);
   U1490 : AO2N port map( A => buff_FLASH_PLAY_ADDR_25, B => n7145, C => n7146,
                           D => n6984, Z => b1530_FLASH_PLAY_ADDR_25);
   U1491 : AO2N port map( A => buff_FLASH_PLAY_ADDR_24, B => n7145, C => n7146,
                           D => n6982, Z => b1530_FLASH_PLAY_ADDR_24);
   U1492 : AO2N port map( A => buff_FLASH_PLAY_ADDR_23, B => n7147, C => n7148,
                           D => n6990, Z => b1530_FLASH_PLAY_ADDR_23);
   U1493 : AO2N port map( A => buff_FLASH_PLAY_ADDR_22, B => n7147, C => n7148,
                           D => n6989, Z => b1530_FLASH_PLAY_ADDR_22);
   U1494 : AO2N port map( A => buff_FLASH_PLAY_ADDR_21, B => n7147, C => n7148,
                           D => n6988, Z => b1530_FLASH_PLAY_ADDR_21);
   U1495 : AO2N port map( A => buff_FLASH_PLAY_ADDR_20, B => n7147, C => n7148,
                           D => n6987, Z => b1530_FLASH_PLAY_ADDR_20);
   U1496 : AO2N port map( A => buff_FLASH_PLAY_ADDR_19, B => n7147, C => n7148,
                           D => n6986, Z => b1530_FLASH_PLAY_ADDR_19);
   U1497 : AO2N port map( A => buff_FLASH_PLAY_ADDR_18, B => n7147, C => n7148,
                           D => n6985, Z => b1530_FLASH_PLAY_ADDR_18);
   U1498 : AO2N port map( A => buff_FLASH_PLAY_ADDR_17, B => n7147, C => n7148,
                           D => n6984, Z => b1530_FLASH_PLAY_ADDR_17);
   U1499 : AO2N port map( A => buff_FLASH_PLAY_ADDR_16, B => n7147, C => n7148,
                           D => n6982, Z => b1530_FLASH_PLAY_ADDR_16);
   U1500 : AO2N port map( A => buff_FLASH_PLAY_ADDR_15, B => n7149, C => n7150,
                           D => n6990, Z => b1530_FLASH_PLAY_ADDR_15);
   U1501 : AO2N port map( A => buff_FLASH_PLAY_ADDR_14, B => n7149, C => n7150,
                           D => n6989, Z => b1530_FLASH_PLAY_ADDR_14);
   U1502 : AO2N port map( A => buff_FLASH_PLAY_ADDR_13, B => n7149, C => n7150,
                           D => n6988, Z => b1530_FLASH_PLAY_ADDR_13);
   U1503 : AO2N port map( A => buff_FLASH_PLAY_ADDR_12, B => n7149, C => n7150,
                           D => n6987, Z => b1530_FLASH_PLAY_ADDR_12);
   U1504 : AO2N port map( A => buff_FLASH_PLAY_ADDR_11, B => n7149, C => n7150,
                           D => n6986, Z => b1530_FLASH_PLAY_ADDR_11);
   U1505 : AO2N port map( A => buff_FLASH_PLAY_ADDR_10, B => n7149, C => n7150,
                           D => n6985, Z => b1530_FLASH_PLAY_ADDR_10);
   U1506 : AO2N port map( A => buff_FLASH_PLAY_ADDR_9, B => n7149, C => n7150, 
                           D => n6984, Z => b1530_FLASH_PLAY_ADDR_9);
   U1507 : AO2N port map( A => buff_FLASH_PLAY_ADDR_8, B => n7149, C => n7150, 
                           D => n6982, Z => b1530_FLASH_PLAY_ADDR_8);
   U1508 : AO2N port map( A => buff_FLASH_PLAY_ADDR_7, B => n7151, C => n7152, 
                           D => n6990, Z => b1530_FLASH_PLAY_ADDR_7);
   U1509 : AO2N port map( A => buff_FLASH_PLAY_ADDR_6, B => n7151, C => n7152, 
                           D => n6989, Z => b1530_FLASH_PLAY_ADDR_6);
   U1510 : AO2N port map( A => buff_FLASH_PLAY_ADDR_5, B => n7151, C => n7152, 
                           D => n6988, Z => b1530_FLASH_PLAY_ADDR_5);
   U1511 : AO2N port map( A => buff_FLASH_PLAY_ADDR_4, B => n7151, C => n7152, 
                           D => n6987, Z => b1530_FLASH_PLAY_ADDR_4);
   U1512 : AO2N port map( A => buff_FLASH_PLAY_ADDR_3, B => n7151, C => n7152, 
                           D => n6986, Z => b1530_FLASH_PLAY_ADDR_3);
   U1513 : AO2N port map( A => buff_FLASH_PLAY_ADDR_2, B => n7151, C => n7152, 
                           D => n6985, Z => b1530_FLASH_PLAY_ADDR_2);
   U1514 : AO2N port map( A => buff_FLASH_PLAY_ADDR_1, B => n7151, C => n7152, 
                           D => n6984, Z => b1530_FLASH_PLAY_ADDR_1);
   U1515 : AO2N port map( A => buff_FLASH_PLAY_ADDR_0, B => n7151, C => n7152, 
                           D => n6982, Z => b1530_FLASH_PLAY_ADDR_0);
   U1516 : AO2N port map( A => buff_FLASH_WRITE_ADDR_19, B => n7154, C => n7155
                           , D => n6986, Z => b1530_FLASH_WRITE_ADDR_19);
   U1517 : AO2N port map( A => buff_FLASH_WRITE_ADDR_18, B => n7154, C => n7155
                           , D => n6985, Z => b1530_FLASH_WRITE_ADDR_18);
   U1518 : AO2N port map( A => buff_FLASH_WRITE_ADDR_17, B => n7154, C => n7155
                           , D => n6984, Z => b1530_FLASH_WRITE_ADDR_17);
   U1519 : AO2N port map( A => buff_FLASH_WRITE_ADDR_16, B => n7154, C => n7155
                           , D => n6982, Z => b1530_FLASH_WRITE_ADDR_16);
   U1520 : AO2N port map( A => buff_FLASH_WRITE_ADDR_15, B => n7156, C => n7157
                           , D => n6990, Z => b1530_FLASH_WRITE_ADDR_15);
   U1521 : AO2N port map( A => buff_FLASH_WRITE_ADDR_14, B => n7156, C => n7157
                           , D => n6989, Z => b1530_FLASH_WRITE_ADDR_14);
   U1522 : AO2N port map( A => buff_FLASH_WRITE_ADDR_13, B => n7156, C => n7157
                           , D => n6988, Z => b1530_FLASH_WRITE_ADDR_13);
   U1523 : AO2N port map( A => buff_FLASH_WRITE_ADDR_12, B => n7156, C => n7157
                           , D => n6987, Z => b1530_FLASH_WRITE_ADDR_12);
   U1524 : AO2N port map( A => buff_FLASH_WRITE_ADDR_11, B => n7156, C => n7157
                           , D => n6986, Z => b1530_FLASH_WRITE_ADDR_11);
   U1525 : AO2N port map( A => buff_FLASH_WRITE_ADDR_10, B => n7156, C => n7157
                           , D => n6985, Z => b1530_FLASH_WRITE_ADDR_10);
   U1526 : AO2N port map( A => buff_FLASH_WRITE_ADDR_9, B => n7156, C => n7157,
                           D => n6984, Z => b1530_FLASH_WRITE_ADDR_9);
   U1527 : AO2N port map( A => buff_FLASH_WRITE_ADDR_8, B => n7156, C => n7157,
                           D => n6982, Z => b1530_FLASH_WRITE_ADDR_8);
   U1528 : AO2N port map( A => buff_FLASH_WRITE_ADDR_7, B => n7158, C => n7159,
                           D => n6990, Z => b1530_FLASH_WRITE_ADDR_7);
   U1529 : AO2N port map( A => buff_FLASH_WRITE_ADDR_6, B => n7158, C => n7159,
                           D => n6989, Z => b1530_FLASH_WRITE_ADDR_6);
   U1530 : AO2N port map( A => buff_FLASH_WRITE_ADDR_5, B => n7158, C => n7159,
                           D => n6988, Z => b1530_FLASH_WRITE_ADDR_5);
   U1531 : AO2N port map( A => buff_FLASH_WRITE_ADDR_4, B => n7158, C => n7159,
                           D => n6987, Z => b1530_FLASH_WRITE_ADDR_4);
   U1532 : AO2N port map( A => buff_FLASH_WRITE_ADDR_3, B => n7158, C => n7159,
                           D => n6986, Z => b1530_FLASH_WRITE_ADDR_3);
   U1533 : AO2N port map( A => buff_FLASH_WRITE_ADDR_2, B => n7158, C => n7159,
                           D => n6985, Z => b1530_FLASH_WRITE_ADDR_2);
   U1534 : AO2N port map( A => buff_FLASH_WRITE_ADDR_1, B => n7158, C => n7159,
                           D => n6984, Z => b1530_FLASH_WRITE_ADDR_1);
   U1535 : AO2N port map( A => buff_FLASH_WRITE_ADDR_0, B => n7158, C => n7159,
                           D => n6982, Z => b1530_FLASH_WRITE_ADDR_0);
   U1536 : AO25 port map( A => n7160, B => n6802, C => n7161, D => n6804, E => 
                           n7162, Z => b1530_FLASH_WRITE_CONFIRM_BIT);
   U1537 : AO2N port map( A => buff_RAM_DATA_IN_7, B => n7163, C => n7164, D =>
                           cpu_out(7), Z => b1530_RAM_DATA_IN_7);
   U1538 : AO2N port map( A => buff_RAM_DATA_IN_6, B => n7163, C => n7164, D =>
                           cpu_out(6), Z => b1530_RAM_DATA_IN_6);
   U1539 : AO2N port map( A => buff_RAM_DATA_IN_5, B => n7163, C => n7164, D =>
                           cpu_out(5), Z => b1530_RAM_DATA_IN_5);
   U1540 : AO2N port map( A => buff_RAM_DATA_IN_4, B => n7163, C => n7164, D =>
                           cpu_out(4), Z => b1530_RAM_DATA_IN_4);
   U1541 : AO2N port map( A => buff_RAM_DATA_IN_3, B => n7163, C => n7164, D =>
                           cpu_out(3), Z => b1530_RAM_DATA_IN_3);
   U1542 : AO2N port map( A => buff_RAM_DATA_IN_2, B => n7163, C => n7164, D =>
                           cpu_out(2), Z => b1530_RAM_DATA_IN_2);
   U1543 : AO2N port map( A => buff_RAM_DATA_IN_1, B => n7163, C => n7164, D =>
                           cpu_out(1), Z => b1530_RAM_DATA_IN_1);
   U1544 : AO2N port map( A => buff_RAM_DATA_IN_0, B => n7163, C => n7164, D =>
                           cpu_out(0), Z => b1530_RAM_DATA_IN_0);
   U1545 : AO6C port map( A => n7168, B => n7169, C => n7170, Z => n7167);
   U1546 : AO6C port map( A => n7172, B => n7173, C => n7174, Z => n7171);
   U1547 : AO2A port map( A => n7180, B => n7181, C => buff_PC_UART_ACK_RCV, D 
                           => n7179, Z => n7014);
   U1548 : AO2A port map( A => n7180, B => n7184, C => buff_LCD_UART_SEND, D =>
                           n7179, Z => n7005);
   U1549 : AO2A port map( A => n7186, B => n7187, C => buff_LCD_UART_DATA_7, D 
                           => n7185, Z => n7006);
   U1550 : AO2A port map( A => n7188, B => n7187, C => buff_LCD_UART_DATA_6, D 
                           => n7185, Z => n7007);
   U1551 : AO2A port map( A => n7189, B => n7187, C => buff_LCD_UART_DATA_5, D 
                           => n7185, Z => n7008);
   U1552 : AO2A port map( A => n7190, B => n7187, C => buff_LCD_UART_DATA_4, D 
                           => n7185, Z => n7009);
   U1553 : AO2A port map( A => n7191, B => n7187, C => buff_LCD_UART_DATA_3, D 
                           => n7185, Z => n7010);
   U1554 : AO2A port map( A => n7192, B => n7187, C => buff_LCD_UART_DATA_2, D 
                           => n7185, Z => n7011);
   U1555 : AO2A port map( A => n7193, B => n7187, C => buff_LCD_UART_DATA_1, D 
                           => n7185, Z => n7012);
   U1556 : AO2A port map( A => n7194, B => n7187, C => buff_LCD_UART_DATA_0, D 
                           => n7185, Z => n7013);
   U1557 : AO2A port map( A => n7180, B => n7195, C => buff_DAC_SEND_DATA, D =>
                           n7179, Z => n7136);
   U1558 : AO2A port map( A => n7186, B => n7197, C => buff_DAC_DATA_BYTEL_7, D
                           => n7196, Z => n7128);
   U1559 : AO2A port map( A => n7188, B => n7197, C => buff_DAC_DATA_BYTEL_6, D
                           => n7196, Z => n7129);
   U1560 : AO2A port map( A => n7189, B => n7197, C => buff_DAC_DATA_BYTEL_5, D
                           => n7196, Z => n7130);
   U1561 : AO2A port map( A => n7190, B => n7197, C => buff_DAC_DATA_BYTEL_4, D
                           => n7196, Z => n7131);
   U1562 : AO2A port map( A => n7191, B => n7197, C => buff_DAC_DATA_BYTEL_3, D
                           => n7196, Z => n7132);
   U1563 : AO2A port map( A => n7192, B => n7197, C => buff_DAC_DATA_BYTEL_2, D
                           => n7196, Z => n7133);
   U1564 : AO2A port map( A => n7193, B => n7197, C => buff_DAC_DATA_BYTEL_1, D
                           => n7196, Z => n7134);
   U1565 : AO2A port map( A => n7194, B => n7197, C => buff_DAC_DATA_BYTEL_0, D
                           => n7196, Z => n7135);
   U1566 : AO2A port map( A => n7186, B => n7199, C => buff_DAC_DATA_BYTEH_7, D
                           => n7198, Z => n7120);
   U1567 : AO2A port map( A => n7188, B => n7199, C => buff_DAC_DATA_BYTEH_6, D
                           => n7198, Z => n7121);
   U1568 : AO2A port map( A => n7189, B => n7199, C => buff_DAC_DATA_BYTEH_5, D
                           => n7198, Z => n7122);
   U1569 : AO2A port map( A => n7190, B => n7199, C => buff_DAC_DATA_BYTEH_4, D
                           => n7198, Z => n7123);
   U1570 : AO2A port map( A => n7191, B => n7199, C => buff_DAC_DATA_BYTEH_3, D
                           => n7198, Z => n7124);
   U1571 : AO2A port map( A => n7192, B => n7199, C => buff_DAC_DATA_BYTEH_2, D
                           => n7198, Z => n7125);
   U1572 : AO2A port map( A => n7193, B => n7199, C => buff_DAC_DATA_BYTEH_1, D
                           => n7198, Z => n7126);
   U1573 : AO2A port map( A => n7194, B => n7199, C => buff_DAC_DATA_BYTEH_0, D
                           => n7198, Z => n7127);
   U1574 : AO6C port map( A => n7201, B => n6807, C => buff_CLOCK_RST, Z => 
                           n7091);
   U1575 : AO6C port map( A => n7201, B => n6807, C => buff_CLOCK_READ, Z => 
                           n7202);
   U1576 : AO6C port map( A => n7201, B => n6807, C => buff_CLOCK_HOLD, Z => 
                           n7203);
   U1577 : AO8 port map( A => n7205, B => n7206, C => n6802, D => n7207, Z => 
                           n7204);
   U1578 : AO8 port map( A => n7207, B => n7208, C => n7209, D => n7180, Z => 
                           n6998);
   U1579 : AO3A port map( A => n6768, B => n7340, C => n7353, D => n7354, Z => 
                           n7352);
   U1580 : OR8 port map( A => n7414, B => n7262, C => n7259, D => n7415, E => 
                           n7292, F => n7289, G => n7286, H => n7283, Z => 
                           n7413);
   U1581 : IV4 port map( A => flashi(1), Z => n7162);
   U1582 : AO3A port map( A => n7417, B => n7307, C => n7400, D => n7362, Z => 
                           n7416);
   U1583 : ND3P port map( A => n7419, B => n7412, C => n7411, Z => n7418);
   U1584 : AO7A port map( A => buff_MP3_DMA_STATE_0, B => buff_MP3_DMA_STATE_1,
                           C => n7427, Z => n7426);
   U1585 : AO2N port map( A => buff_PLAYSTATE_1, B => n7179, C => n7336, D => 
                           n7430, Z => n7087);
   U1586 : AO17 port map( A => n7209, B => n7208, C => n7180, D => n7433, Z => 
                           n7002);
   U1587 : AO3C port map( A => n7206, B => n7326, C => n7436, D => n6778, Z => 
                           n7435);
   U1588 : ND8P port map( A => requestmp3, B => n7000, C => n6797, D => n7438, 
                           E => n7439, F => n6798, G => n6814, H => n7089, Z =>
                           n7437);
   U1589 : IV4 port map( A => cpu_addr(9), Z => n7175);
   U1590 : AO17 port map( A => n7420, B => n7437, C => n7447, D => rst, Z => 
                           n7038);
   U1591 : IV4 port map( A => cpu_addr(8), Z => n7176);
   U1592 : IV4 port map( A => cpu_addr(7), Z => n7177);
   U1593 : IV4 port map( A => cpu_addr(6), Z => n7178);
   U1594 : AO1N port map( A => n7441, B => n7450, C => n7451, D => n7363, Z => 
                           n7449);
   U1595 : AO7A port map( A => n6758, B => cpu_addr(5), C => n6753, Z => n7456)
                           ;
   U1596 : AO8 port map( A => cpu_addr(3), B => n6771, C => n7173, D => n7456, 
                           Z => n7380);
   U1597 : OR8 port map( A => n7229, B => n7232, C => n7223, D => n7226, E => 
                           n7217, F => n7220, G => n7211, H => n7214, Z => 
                           n7459);
   U1598 : OR8 port map( A => n7253, B => n7256, C => n7247, D => n7250, E => 
                           n7241, F => n7244, G => n7235, H => n7238, Z => 
                           n7460);
   U1599 : OR6 port map( A => n7277, B => n7280, C => n7274, D => n7271, E => 
                           n7268, F => n7265, Z => n7414);
   U1600 : OR6 port map( A => n7301, B => n7304, C => n7298, D => n7295, E => 
                           n7459, F => n7460, Z => n7415);
   U1601 : AO3N port map( A => cpu_out(5), B => n7369, C => n7337, D => n7428, 
                           Z => n7461);
   U1602 : AO2A port map( A => n7403, B => n6997, C => n7462, D => n6987, Z => 
                           n7092);
   U1603 : AO3C port map( A => n7206, B => n7325, C => n7463, D => n7016, Z => 
                           n7434);
   U1604 : AO3N port map( A => n7206, B => n7327, C => n7464, D => n7355, Z => 
                           n7433);
   U1605 : AO6N port map( A => buff_STATE_1, B => n7416, C => n7422, Z => n7465
                           );
   U1606 : OR6 port map( A => n7466, B => n7467, C => n7468, D => n7469, E => 
                           n7470, F => n7465, Z => n7432);
   U1607 : OR6 port map( A => n7471, B => n7472, C => n7473, D => n7349, E => 
                           n7422, F => n7443, Z => n7431);
   U1608 : AO6A port map( A => n7425, B => buff_PLAYSTATE_1, C => n6756, Z => 
                           n7474);
   U1609 : AO1N port map( A => n7451, B => cpu_out(7), C => n7345, D => n7349, 
                           Z => n7475);
   U1610 : AO6A port map( A => n7408, B => n7451, C => n7476, Z => n7018);
   U1611 : AO6A port map( A => n7335, B => n7451, C => n7477, Z => n7020);
   U1612 : AO3N port map( A => n7445, B => n7175, C => n7016, D => n7478, Z => 
                           n7056);
   U1613 : AO3N port map( A => n7445, B => n7176, C => n6781, D => n7479, Z => 
                           n7059);
   U1614 : AO3N port map( A => n7445, B => n7177, C => n7016, D => n7480, Z => 
                           n7062);
   U1615 : AO3N port map( A => n7445, B => n7178, C => n6781, D => n7481, Z => 
                           n7065);
   U1616 : AO3N port map( A => n7174, B => n7445, C => n7016, D => n7482, Z => 
                           n7068);
   U1617 : AO3N port map( A => n7317, B => n7445, C => n6781, D => n7483, Z => 
                           n7071);
   U1618 : AO3N port map( A => n7320, B => n7445, C => n7016, D => n7484, Z => 
                           n7074);
   U1619 : AO3N port map( A => n7318, B => n7445, C => n6781, D => n7485, Z => 
                           n7077);
   U1620 : AO2A port map( A => n7315, B => n7470, C => buff_FLASH_WRITE_ADDR_15
                           , D => n7451, Z => n7036);
   U1621 : AO2A port map( A => n7313, B => n7470, C => buff_FLASH_WRITE_ADDR_14
                           , D => n7451, Z => n7040);
   U1622 : AO2A port map( A => n7314, B => n7470, C => buff_FLASH_WRITE_ADDR_13
                           , D => n7451, Z => n7043);
   U1623 : AO2A port map( A => n7312, B => n7470, C => buff_FLASH_WRITE_ADDR_12
                           , D => n7451, Z => n7046);
   U1624 : AO2A port map( A => n7310, B => n7470, C => buff_FLASH_WRITE_ADDR_11
                           , D => n7451, Z => n7049);
   U1625 : AO3N port map( A => n7445, B => n7311, C => n6781, D => n7486, Z => 
                           n7053);
   U1626 : AO3N port map( A => n7169, B => n7445, C => n7016, D => n7487, Z => 
                           n7080);
   U1627 : AO3N port map( A => n7308, B => n7445, C => n6781, D => n7488, Z => 
                           n7083);
   U1628 : AO1N port map( A => n7446, B => cpu_re, C => n7443, D => n7204, Z =>
                           n6999);
   U1629 : AO2A port map( A => n7372, B => dac_data_req, C => uarto(8), D => 
                           n6757, Z => n7490);
   U1630 : AO29 port map( A => uarto(9), B => n7322, C => n7373, D => n6758, E 
                           => n7492, Z => n7491);
   U1631 : AO2A port map( A => n7452, B => uarto(0), C => n6755, D => 
                           button_play, Z => n7493);
   U1632 : AO2N port map( A => n6754, B => clock_minutes(7), C => n7495, D => 
                           clock_seconds(7), Z => n7494);
   U1633 : AO3A port map( A => clock_hours(7), B => n7454, C => n7493, D => 
                           n7491, Z => n7496);
   U1634 : AO2A port map( A => n7455, B => ram_data_out(7), C => n6914, D => 
                           n7442, Z => n7094);
   U1635 : AO2A port map( A => n7452, B => uarto(1), C => button_stop, D => 
                           n6755, Z => n7497);
   U1636 : AO7A port map( A => clock_seconds(6), B => n7453, C => n7497, Z => 
                           n7498);
   U1637 : AO2A port map( A => n7454, B => clock_hours(6), C => 
                           clock_minutes(6), D => n6754, Z => n7499);
   U1638 : AO2A port map( A => n7455, B => ram_data_out(6), C => n7442, D => 
                           flashi(1), Z => n7098);
   U1639 : AO2A port map( A => n7452, B => uarto(2), C => button_prev, D => 
                           n6755, Z => n7500);
   U1640 : AO7A port map( A => clock_seconds(5), B => n7453, C => n7500, Z => 
                           n7501);
   U1641 : AO2A port map( A => n7454, B => clock_hours(5), C => 
                           clock_minutes(5), D => n6754, Z => n7502);
   U1642 : AO2A port map( A => n7455, B => ram_data_out(5), C => n6911, D => 
                           n7442, Z => n7101);
   U1643 : AO2A port map( A => n7452, B => uarto(3), C => button_next, D => 
                           n6755, Z => n7503);
   U1644 : AO7A port map( A => clock_seconds(4), B => n7453, C => n7503, Z => 
                           n7504);
   U1645 : AO2A port map( A => n7454, B => clock_hours(4), C => 
                           clock_minutes(4), D => n6754, Z => n7505);
   U1646 : AO2A port map( A => n7455, B => ram_data_out(4), C => n6909, D => 
                           n7442, Z => n7104);
   U1647 : AO2A port map( A => n7452, B => uarto(4), C => clock_seconds(3), D 
                           => n7495, Z => n7506);
   U1648 : AO2A port map( A => n7454, B => clock_hours(3), C => 
                           clock_minutes(3), D => n6754, Z => n7507);
   U1649 : AO2A port map( A => n7455, B => ram_data_out(3), C => n6907, D => 
                           n7442, Z => n7107);
   U1650 : AO2A port map( A => n7452, B => uarto(5), C => clock_seconds(2), D 
                           => n7495, Z => n7508);
   U1651 : AO2A port map( A => n7454, B => clock_hours(2), C => 
                           clock_minutes(2), D => n6754, Z => n7509);
   U1652 : AO2A port map( A => n7455, B => ram_data_out(2), C => n6905, D => 
                           n7442, Z => n7110);
   U1653 : AO2A port map( A => n7452, B => uarto(6), C => clock_seconds(1), D 
                           => n7495, Z => n7510);
   U1654 : AO2A port map( A => n7454, B => clock_hours(1), C => 
                           clock_minutes(1), D => n6754, Z => n7511);
   U1655 : AO2A port map( A => n7455, B => ram_data_out(1), C => n6903, D => 
                           n7442, Z => n7113);
   U1656 : AO2A port map( A => n7452, B => uarto(7), C => clock_seconds(0), D 
                           => n7495, Z => n7512);
   U1657 : AO2A port map( A => n7454, B => clock_hours(0), C => 
                           clock_minutes(0), D => n6754, Z => n7513);
   U1658 : AO2A port map( A => n7455, B => ram_data_out(0), C => n6901, D => 
                           n7442, Z => n7116);
   U1659 : AO3N port map( A => cpu_we, B => n7365, C => n7332, D => n7401, Z =>
                           n7514);
   U1660 : AO17 port map( A => buff_FLASHO_WDATA_7, B => n7521, C => n7475, D 
                           => rst, Z => n7520);
   U1661 : AO17 port map( A => buff_FLASHO_OE, B => n7523, C => n7349, D => rst
                           , Z => n7522);
   U1662 : AO17 port map( A => n7090, B => n6989, C => n7203, D => rst, Z => 
                           n7524);
   U1663 : AO17 port map( A => n7090, B => n6988, C => n7202, D => rst, Z => 
                           n7525);
   U1664 : AO7C port map( A => cpu_addr(0), B => cpu_addr(5), C => cpu_addr(3),
                           Z => n7527);
   U1665 : IV4 port map( A => n7426, Z => n7183);
   U1666 : IV4 port map( A => b1530_FLASH_STOP_ADDR_4, Z => n7222);
   U1667 : IV4 port map( A => b1530_FLASH_STOP_ADDR_5, Z => n7219);
   U1668 : IV4 port map( A => b1530_FLASH_STOP_ADDR_6, Z => n7216);
   U1669 : IV4 port map( A => b1530_FLASH_STOP_ADDR_7, Z => n7213);
   U1670 : IV4 port map( A => b1530_FLASH_STOP_ADDR_0, Z => n7234);
   U1671 : IV4 port map( A => b1530_FLASH_STOP_ADDR_1, Z => n7231);
   U1672 : IV4 port map( A => b1530_FLASH_STOP_ADDR_2, Z => n7228);
   U1673 : IV4 port map( A => b1530_FLASH_STOP_ADDR_3, Z => n7225);
   U1674 : IV4 port map( A => b1530_FLASH_STOP_ADDR_12, Z => n7246);
   U1675 : IV4 port map( A => b1530_FLASH_STOP_ADDR_13, Z => n7243);
   U1676 : IV4 port map( A => b1530_FLASH_STOP_ADDR_14, Z => n7240);
   U1677 : IV4 port map( A => b1530_FLASH_STOP_ADDR_15, Z => n7237);
   U1678 : IV4 port map( A => b1530_FLASH_STOP_ADDR_8, Z => n7258);
   U1679 : IV4 port map( A => b1530_FLASH_STOP_ADDR_9, Z => n7255);
   U1680 : IV4 port map( A => b1530_FLASH_STOP_ADDR_10, Z => n7252);
   U1681 : IV4 port map( A => b1530_FLASH_STOP_ADDR_11, Z => n7249);
   U1682 : IV4 port map( A => b1530_FLASH_STOP_ADDR_20, Z => n7270);
   U1683 : IV4 port map( A => b1530_FLASH_STOP_ADDR_21, Z => n7267);
   U1684 : IV4 port map( A => b1530_FLASH_STOP_ADDR_22, Z => n7264);
   U1685 : IV4 port map( A => b1530_FLASH_STOP_ADDR_23, Z => n7261);
   U1686 : IV4 port map( A => b1530_FLASH_STOP_ADDR_16, Z => n7282);
   U1687 : IV4 port map( A => b1530_FLASH_STOP_ADDR_17, Z => n7279);
   U1688 : IV4 port map( A => b1530_FLASH_STOP_ADDR_18, Z => n7276);
   U1689 : IV4 port map( A => b1530_FLASH_STOP_ADDR_19, Z => n7273);
   U1690 : IV4 port map( A => b1530_FLASH_STOP_ADDR_28, Z => n7294);
   U1691 : IV4 port map( A => b1530_FLASH_STOP_ADDR_29, Z => n7291);
   U1692 : IV4 port map( A => b1530_FLASH_STOP_ADDR_30, Z => n7288);
   U1693 : IV4 port map( A => b1530_FLASH_STOP_ADDR_31, Z => n7285);
   U1694 : IV4 port map( A => b1530_FLASH_STOP_ADDR_24, Z => n7306);
   U1695 : IV4 port map( A => b1530_FLASH_STOP_ADDR_25, Z => n7303);
   U1696 : IV4 port map( A => b1530_FLASH_STOP_ADDR_26, Z => n7300);
   U1697 : IV4 port map( A => b1530_FLASH_STOP_ADDR_27, Z => n7297);
   U1698 : AO7A port map( A => n7332, B => n7364, C => buff_RAM_WE, Z => n7119)
                           ;
   U1699 : AO1N port map( A => n7529, B => n7142, C => n7396, D => n7399, Z => 
                           n7530);
   U1700 : AO2N port map( A => buff_PLAYSTATE_0, B => n7526, C => 
                           buff_PLAYSTATE_1, D => n7530, Z => n7430);
   U1701 : AO25 port map( A => n7474, B => n7531, C => n7180, D => n7201, E => 
                           n7367, Z => n7089);
   U1702 : AO25 port map( A => n6800, B => n7383, C => n6749, D => n7404, E => 
                           n7384, Z => n7181);
   U1703 : AO25 port map( A => n6801, B => n7385, C => n6750, D => n7404, E => 
                           n7200, Z => n7184);
   U1704 : AO2N port map( A => buff_FLASH_WRITE_ADDR_19, B => n7451, C => 
                           buff_FLASHO_ADDR_19, D => n7533, Z => n7032);
   U1705 : AO2N port map( A => buff_FLASH_WRITE_ADDR_18, B => n7451, C => 
                           buff_FLASHO_ADDR_18, D => n7533, Z => n7033);
   U1706 : AO2N port map( A => buff_FLASH_WRITE_ADDR_17, B => n7451, C => 
                           buff_FLASHO_ADDR_17, D => n7533, Z => n7034);
   U1707 : AO2N port map( A => buff_FLASH_WRITE_ADDR_16, B => n7451, C => 
                           buff_FLASHO_ADDR_16, D => n7533, Z => n7035);
   U1708 : AO25 port map( A => n6800, B => n7384, C => n6751, D => n7404, E => 
                           n7383, Z => n7195);
   U1709 : AO7A port map( A => buff_STOPPED, B => n7371, C => n7490, Z => n7492
                           );
   U1710 : AO7C port map( A => n7494, B => n7496, C => n7400, Z => n7096);
   U1711 : AO3A port map( A => n7499, B => n7498, C => n7333, D => cpu_re, Z =>
                           n7099);
   U1712 : AO3A port map( A => n7502, B => n7501, C => n7333, D => cpu_re, Z =>
                           n7102);
   U1713 : AO3A port map( A => n7505, B => n7504, C => n7333, D => cpu_re, Z =>
                           n7105);
   U1714 : AO6N port map( A => n7507, B => n7506, C => n7400, Z => n7108);
   U1715 : AO6N port map( A => n7509, B => n7508, C => n7400, Z => n7111);
   U1716 : AO6N port map( A => n7511, B => n7510, C => n7400, Z => n7114);
   U1717 : AO6N port map( A => n7513, B => n7512, C => n7400, Z => n7117);
   U1718 : AO17 port map( A => n7461, B => n7407, C => n7180, D => n7201, Z => 
                           n6997);
   U1719 : AO17 port map( A => n7457, B => n6791, C => n7180, D => n7201, Z => 
                           n6981);
   U1720 : AO17 port map( A => n6792, B => n7395, C => n7180, D => n7201, Z => 
                           n6991);
   U1721 : AO17 port map( A => n6795, B => n7375, C => n7180, D => n7201, Z => 
                           n6993);
   U1722 : AO17 port map( A => n7458, B => n6793, C => n7180, D => n7201, Z => 
                           n6995);
   U1723 : AO17 port map( A => n6793, B => n6787, C => n7180, D => n7201, Z => 
                           n7185);
   U1724 : AO17 port map( A => n7489, B => n7407, C => n7180, D => n7201, Z => 
                           n7196);
   U1725 : AO17 port map( A => n6792, B => n7394, C => n7180, D => n7201, Z => 
                           n7198);
   U1726 : AO17 port map( A => n6810, B => n7388, C => n7180, D => n7201, Z => 
                           n7156);
   U1727 : AO17 port map( A => n7515, B => n7407, C => n7180, D => n7201, Z => 
                           n7158);
   U1728 : AO17 port map( A => n7516, B => n6809, C => n7180, D => n7201, Z => 
                           n7154);
   U1729 : AO17 port map( A => n6812, B => n7378, C => n7180, D => n7201, Z => 
                           n7149);
   U1730 : AO17 port map( A => n6795, B => n7376, C => n7180, D => n7201, Z => 
                           n7151);
   U1731 : AO17 port map( A => n6812, B => n7379, C => n7180, D => n7201, Z => 
                           n7145);
   U1732 : AO17 port map( A => n7517, B => n6793, C => n7180, D => n7201, Z => 
                           n7147);
   U1733 : AO7A port map( A => n7330, B => n6808, C => n7534, Z => n7536);
   U1734 : AO3C port map( A => n6808, B => n7329, C => n7444, D => n7534, Z => 
                           n7535);

end SYN_FNORD;

library IEEE,MTC45000,MTC45100X,LIB_GENERATORS,STVLIB;

use IEEE.std_logic_1164.all;
use IEEE.std_logic_arith.all;
use MTC45000.VCOMPONENTS.all;
use MTC45100X.VCOMPONENTS.all;
use LIB_GENERATORS.PCK_GENERATORS.all;
use STVLIB.ST_TIMING.all;
use STVLIB.ST_VSS.all;

entity mp3ram_BYTES1024 is

   port( addr : in std_logic_vector (9 downto 0);  clk, we : in std_logic;  
         data_in : in std_logic_vector (7 downto 0);  data_out : out 
         std_logic_vector (7 downto 0));

end mp3ram_BYTES1024;

architecture SYN_SYNT of mp3ram_BYTES1024 is

   component SPS2_1024x8m8
      port( Q : out std_logic_vector (7 downto 0);  CK, CSN, WEN, OEN : in 
            std_logic;  A : in std_logic_vector (9 downto 0);  D : in 
            std_logic_vector (7 downto 0));
   end component;
   
   component BF1T1
      port( A : in std_logic;  Z : out std_logic);
   end component;
   
   component BF1T2
      port( A : in std_logic;  Z : out std_logic);
   end component;
   
   signal gnd, n2, n3, n4, n5, n6, n7, n8, n9, n10, n11, n12, n13, n14, n15, 
      n16, n17, n18 : std_logic;

begin
   
   mr_ram : SPS2_1024x8m8 port map( Q(7) => data_out(7), Q(6) => data_out(6), 
                           Q(5) => data_out(5), Q(4) => data_out(4), Q(3) => 
                           data_out(3), Q(2) => data_out(2), Q(1) => 
                           data_out(1), Q(0) => data_out(0), CK => clk, CSN => 
                           gnd, WEN => n2, OEN => gnd, A(9) => addr(9), A(8) =>
                           addr(8), A(7) => addr(7), A(6) => addr(6), A(5) => 
                           addr(5), A(4) => addr(4), A(3) => addr(3), A(2) => 
                           addr(2), A(1) => addr(1), A(0) => addr(0), D(7) => 
                           n3, D(6) => n5, D(5) => n7, D(4) => n9, D(3) => n11,
                           D(2) => n13, D(1) => n15, D(0) => n17);
   gnd <= '0';
   U4 : BF1T1 port map( A => we, Z => n2);
   U5 : BF1T1 port map( A => n4, Z => n3);
   U6 : BF1T2 port map( A => data_in(7), Z => n4);
   U7 : BF1T1 port map( A => n6, Z => n5);
   U8 : BF1T2 port map( A => data_in(6), Z => n6);
   U9 : BF1T1 port map( A => n8, Z => n7);
   U10 : BF1T2 port map( A => data_in(5), Z => n8);
   U11 : BF1T1 port map( A => n10, Z => n9);
   U12 : BF1T2 port map( A => data_in(4), Z => n10);
   U13 : BF1T1 port map( A => n12, Z => n11);
   U14 : BF1T2 port map( A => data_in(3), Z => n12);
   U15 : BF1T1 port map( A => n14, Z => n13);
   U16 : BF1T2 port map( A => data_in(2), Z => n14);
   U17 : BF1T1 port map( A => n16, Z => n15);
   U18 : BF1T2 port map( A => data_in(1), Z => n16);
   U19 : BF1T1 port map( A => n18, Z => n17);
   U20 : BF1T2 port map( A => data_in(0), Z => n18);

end SYN_SYNT;

library IEEE,MTC45000,MTC45100X,LIB_GENERATORS,STVLIB;

use IEEE.std_logic_1164.all;
use IEEE.std_logic_arith.all;
use MTC45000.VCOMPONENTS.all;
use MTC45100X.VCOMPONENTS.all;
use LIB_GENERATORS.PCK_GENERATORS.all;
use STVLIB.ST_TIMING.all;
use STVLIB.ST_VSS.all;

entity dacuart_DW01_incdec_5_0 is

   port( A : in std_logic_vector (4 downto 0);  INC_DEC : in std_logic;  SUM : 
         out std_logic_vector (4 downto 0));

end dacuart_DW01_incdec_5_0;

architecture SYN_rpl of dacuart_DW01_incdec_5_0 is

   component EN
      port( A, B : in std_logic;  Z : out std_logic);
   end component;
   
   component OR2
      port( A, B : in std_logic;  Z : out std_logic);
   end component;
   
   component IV
      port( A : in std_logic;  Z : out std_logic);
   end component;
   
   signal carry_2, carry_4, carry_3 : std_logic;

begin
   
   U6 : EN port map( A => carry_4, B => A(4), Z => SUM(4));
   U7 : OR2 port map( A => A(3), B => carry_3, Z => carry_4);
   U8 : EN port map( A => carry_3, B => A(3), Z => SUM(3));
   U9 : OR2 port map( A => A(2), B => carry_2, Z => carry_3);
   U10 : EN port map( A => carry_2, B => A(2), Z => SUM(2));
   U11 : OR2 port map( A => A(1), B => A(0), Z => carry_2);
   U12 : EN port map( A => A(0), B => A(1), Z => SUM(1));
   U13 : IV port map( A => A(0), Z => SUM(0));

end SYN_rpl;

library IEEE,MTC45000,MTC45100X,LIB_GENERATORS,STVLIB;

use IEEE.std_logic_1164.all;
use IEEE.std_logic_arith.all;
use MTC45000.VCOMPONENTS.all;
use MTC45100X.VCOMPONENTS.all;
use LIB_GENERATORS.PCK_GENERATORS.all;
use STVLIB.ST_TIMING.all;
use STVLIB.ST_VSS.all;

entity dacuart is

   port( clk, rst : in std_logic;  dacbytes : in std_logic_vector (15 downto 0)
         ;  takethisdac : in std_logic;  requestdac : out std_logic;  daco : 
         out std_logic_vector (0 to 2));

end dacuart;

architecture SYN_FOOBAR of dacuart is

   component ND2
      port( A, B : in std_logic;  Z : out std_logic);
   end component;
   
   component IVP
      port( A : in std_logic;  Z : out std_logic);
   end component;
   
   component ND5P
      port( A, B, C, D, E : in std_logic;  Z : out std_logic);
   end component;
   
   component AN4P
      port( A, B, C, D : in std_logic;  Z : out std_logic);
   end component;
   
   component FD1Q
      port( CP, D : in std_logic;  Q : out std_logic);
   end component;
   
   component FD1SQP
      port( CP, D, TE, TI : in std_logic;  Q : out std_logic);
   end component;
   
   component AN2
      port( A, B : in std_logic;  Z : out std_logic);
   end component;
   
   component BF1T1
      port( A : in std_logic;  Z : out std_logic);
   end component;
   
   component IV
      port( A : in std_logic;  Z : out std_logic);
   end component;
   
   component OR2A
      port( A, B : in std_logic;  Z : out std_logic);
   end component;
   
   component AO7A
      port( A, B, C : in std_logic;  Z : out std_logic);
   end component;
   
   component AO2N
      port( A, B, C, D : in std_logic;  Z : out std_logic);
   end component;
   
   component AO17
      port( A, B, C, D : in std_logic;  Z : out std_logic);
   end component;
   
   component AN3X4
      port( A, B, C : in std_logic;  Z : out std_logic);
   end component;
   
   component AO6A
      port( A, B, C : in std_logic;  Z : out std_logic);
   end component;
   
   component AO2A
      port( A, B, C, D : in std_logic;  Z : out std_logic);
   end component;
   
   component IV4
      port( A : in std_logic;  Z : out std_logic);
   end component;
   
   component FD1
      port( CP, D : in std_logic;  Q, QN : out std_logic);
   end component;
   
   component FD1SQX4
      port( CP, D, TE, TI : in std_logic;  Q : out std_logic);
   end component;
   
   component FD1SP
      port( CP, D, TE, TI : in std_logic;  Q, QN : out std_logic);
   end component;
   
   component dacuart_DW01_incdec_5_0
      port( A : in std_logic_vector (4 downto 0);  INC_DEC : in std_logic;  SUM
            : out std_logic_vector (4 downto 0));
   end component;
   
   component AO34
      port( A, B, C, D : in std_logic;  Z : out std_logic);
   end component;
   
   component AO3A
      port( A, B, C, D : in std_logic;  Z : out std_logic);
   end component;
   
   component ND2P
      port( A, B : in std_logic;  Z : out std_logic);
   end component;
   
   signal feed_in_STATE, feed_in_BITCOUNT_4, feed_in_BITCOUNT_3, ARG244_3, 
      feed_DACBYTES_5, n61_DIN, feed_DACBYTES_11, feed_DACBYTES_2, 
      feed_in_BITCOUNT_2, feed_in_DACBYTES_15, feed_STATE, feed_BITCOUNT_1, 
      feed_CLOCK_OUT, ARG244_4, feed_in_REQUESTDAC, feed_DACBYTES_3, 
      feed_BITCOUNT_0, feed_in_CLOCK_OUT, ARG244_2, feed_DACBYTES_10, 
      feed_DACBYTES_4, feed_in_BITCOUNT_0, ARG244_0, feed_REQUESTDAC, 
      feed_DACBYTES_6, feed_DACBYTES_12, feed_DACBYTES_15, feed_DACBYTES_1, 
      feed_BITCOUNT_2, feed_DACBYTES_8, feed_DACBYTES_0, feed_DACBYTES_14, 
      feed_DACBYTES_9, feed_BITCOUNT_4, feed_BITCOUNT_3, ARG244_1, 
      feed_DACBYTES_13, feed_DACBYTES_7, n521, n522, n523, n524, n525, n526, 
      n527, n528, n529, n530, n531, n532, n533, n534, n535, n536, n537, n538, 
      n539, n540, n541, n542, n543, n544, n545, n546, n547, n548, n549, n550, 
      n551, n552, net1142, n553, n554, n555, n556, n557, n558, n559, n560, n561
      , n562, n563, n564, n565, n566, n567, n568, n569, n570, n571, n572, n573,
      n574, n575, n576, n577, n578, n579, n580, n581, n582, n583, n584, n585, 
      n586, n587, n588, n589 : std_logic;

begin
   
   U74 : ND2 port map( A => takethisdac, B => n564, Z => n567);
   U75 : IVP port map( A => n541, Z => n547);
   U76 : IVP port map( A => n588, Z => n562);
   U77 : ND2 port map( A => rst, B => n542, Z => n560);
   U78 : IVP port map( A => n567, Z => n542);
   U79 : IVP port map( A => n560, Z => n561);
   U80 : ND5P port map( A => n569, B => n570, C => n568, D => n571, E => n572, 
                           Z => n565);
   U81 : IVP port map( A => n565, Z => n563);
   U82 : AN4P port map( A => n569, B => n568, C => n570, D => n571, Z => n543);
   U83 : IVP port map( A => feed_in_BITCOUNT_4, Z => n544);
   U84 : IVP port map( A => rst, Z => n559);
   U85 : IVP port map( A => n61_DIN, Z => n552);
   feed_reg_REQUESTDAC : FD1Q port map( CP => clk, D => feed_in_REQUESTDAC, Q 
                           => feed_REQUESTDAC);
   feed_reg_DACBYTES_0 : FD1SQP port map( CP => clk, D => n538, TE => n562, TI 
                           => n556, Q => feed_DACBYTES_0);
   feed_reg_DACBYTES_1 : FD1SQP port map( CP => clk, D => n537, TE => n562, TI 
                           => n538, Q => feed_DACBYTES_1);
   feed_reg_DACBYTES_2 : FD1SQP port map( CP => clk, D => n536, TE => n562, TI 
                           => n537, Q => feed_DACBYTES_2);
   feed_reg_DACBYTES_3 : FD1SQP port map( CP => clk, D => n535, TE => n562, TI 
                           => n536, Q => feed_DACBYTES_3);
   feed_reg_DACBYTES_4 : FD1SQP port map( CP => clk, D => n534, TE => n562, TI 
                           => n535, Q => feed_DACBYTES_4);
   feed_reg_DACBYTES_5 : FD1SQP port map( CP => clk, D => n533, TE => n562, TI 
                           => n534, Q => feed_DACBYTES_5);
   feed_reg_DACBYTES_6 : FD1SQP port map( CP => clk, D => n532, TE => n562, TI 
                           => n533, Q => feed_DACBYTES_6);
   feed_reg_DACBYTES_7 : FD1SQP port map( CP => clk, D => n531, TE => n562, TI 
                           => n532, Q => feed_DACBYTES_7);
   feed_reg_DACBYTES_8 : FD1SQP port map( CP => clk, D => n530, TE => n562, TI 
                           => n531, Q => feed_DACBYTES_8);
   feed_reg_DACBYTES_9 : FD1SQP port map( CP => clk, D => n529, TE => n562, TI 
                           => n530, Q => feed_DACBYTES_9);
   feed_reg_DACBYTES_10 : FD1SQP port map( CP => clk, D => n528, TE => n562, TI
                           => n529, Q => feed_DACBYTES_10);
   feed_reg_DACBYTES_11 : FD1SQP port map( CP => clk, D => n527, TE => n562, TI
                           => n528, Q => feed_DACBYTES_11);
   feed_reg_DACBYTES_12 : FD1SQP port map( CP => clk, D => n526, TE => n562, TI
                           => n527, Q => feed_DACBYTES_12);
   feed_reg_DACBYTES_13 : FD1SQP port map( CP => clk, D => n525, TE => n562, TI
                           => n526, Q => feed_DACBYTES_13);
   feed_reg_DACBYTES_14 : FD1SQP port map( CP => clk, D => n524, TE => n562, TI
                           => n525, Q => feed_DACBYTES_14);
   feed_reg_DACBYTES_15 : FD1SQP port map( CP => clk, D => feed_in_DACBYTES_15,
                           TE => n562, TI => n524, Q => feed_DACBYTES_15);
   feed_reg_BITCOUNT_4 : FD1SQP port map( CP => clk, D => feed_in_BITCOUNT_4, 
                           TE => n562, TI => ARG244_4, Q => feed_BITCOUNT_4);
   U86 : IVP port map( A => feed_BITCOUNT_4, Z => n572);
   feed_reg_STATE : FD1Q port map( CP => clk, D => feed_in_STATE, Q => 
                           feed_STATE);
   requestdac_reg : FD1Q port map( CP => clk, D => feed_in_REQUESTDAC, Q => 
                           requestdac);
   daco_reg_SCLK : FD1Q port map( CP => clk, D => feed_in_CLOCK_OUT, Q => 
                           daco(1));
   daco_reg_CS : FD1SQP port map( CP => clk, D => n557, TE => n61_DIN, TI => 
                           n558, Q => daco(0));
   U87 : AN2 port map( A => feed_BITCOUNT_1, B => n522, Z => n521);
   U88 : AN2 port map( A => n567, B => rst, Z => n522);
   U89 : BF1T1 port map( A => feed_STATE, Z => n523);
   U90 : IV port map( A => n523, Z => n564);
   U91 : ND2 port map( A => feed_BITCOUNT_3, B => n522, Z => n550);
   U92 : ND2 port map( A => feed_BITCOUNT_2, B => n522, Z => n551);
   U93 : ND2 port map( A => feed_BITCOUNT_0, B => n522, Z => n549);
   U94 : BF1T1 port map( A => n582, Z => n524);
   U95 : BF1T1 port map( A => n583, Z => n525);
   U96 : BF1T1 port map( A => n584, Z => n526);
   U97 : BF1T1 port map( A => n585, Z => n527);
   U98 : BF1T1 port map( A => n586, Z => n528);
   U99 : BF1T1 port map( A => n574, Z => n529);
   U100 : BF1T1 port map( A => n573, Z => n530);
   U101 : BF1T1 port map( A => n575, Z => n531);
   U102 : BF1T1 port map( A => n576, Z => n532);
   U103 : BF1T1 port map( A => n577, Z => n533);
   U104 : BF1T1 port map( A => n578, Z => n534);
   U105 : BF1T1 port map( A => n579, Z => n535);
   U106 : BF1T1 port map( A => n580, Z => n536);
   U107 : BF1T1 port map( A => n581, Z => n537);
   U108 : BF1T1 port map( A => n587, Z => n538);
   U109 : ND2 port map( A => feed_REQUESTDAC, B => n567, Z => n566);
   U110 : BF1T1 port map( A => n566, Z => n539);
   U111 : OR2A port map( A => rst, B => feed_CLOCK_OUT, Z => feed_in_CLOCK_OUT)
                           ;
   U112 : BF1T1 port map( A => n553, Z => n540);
   U113 : BF1T1 port map( A => feed_DACBYTES_15, Z => n541);
   U114 : AO7A port map( A => feed_BITCOUNT_4, B => n559, C => n560, Z => 
                           feed_in_BITCOUNT_4);
   U115 : AO7A port map( A => rst, B => n543, C => n544, Z => n61_DIN);
   U116 : AO2N port map( A => n541, B => n522, C => dacbytes(15), D => n561, Z 
                           => feed_in_DACBYTES_15);
   U117 : AO17 port map( A => n545, B => n546, C => n547, D => n548, Z => n553)
                           ;
   U118 : AN3X4 port map( A => n549, B => n550, C => n551, Z => n546);
   U119 : AO6A port map( A => n572, B => n522, C => n521, Z => n545);
   U120 : AO2A port map( A => net1142, B => n552, C => dacbytes(15), D => n561,
                           Z => n548);
   U121 : IV4 port map( A => n550, Z => feed_in_BITCOUNT_3);
   U122 : IV4 port map( A => n549, Z => feed_in_BITCOUNT_0);
   U123 : IV4 port map( A => n551, Z => feed_in_BITCOUNT_2);
   daco_reg_DIN : FD1 port map( CP => clk, D => n540, Q => daco(2), QN => 
                           net1142);
   feed_reg_CLOCK_OUT : FD1SQX4 port map( CP => clk, D => n554, TE => 
                           feed_in_CLOCK_OUT, TI => n555, Q => feed_CLOCK_OUT);
   n554 <= '1';
   n555 <= '0';
   n556 <= '0';
   feed_reg_BITCOUNT_0 : FD1SP port map( CP => clk, D => feed_in_BITCOUNT_0, TE
                           => n562, TI => ARG244_0, Q => feed_BITCOUNT_0, QN =>
                           n570);
   feed_reg_BITCOUNT_1 : FD1SP port map( CP => clk, D => n521, TE => n562, TI 
                           => ARG244_1, Q => feed_BITCOUNT_1, QN => n569);
   feed_reg_BITCOUNT_2 : FD1SP port map( CP => clk, D => feed_in_BITCOUNT_2, TE
                           => n562, TI => ARG244_2, Q => feed_BITCOUNT_2, QN =>
                           n568);
   feed_reg_BITCOUNT_3 : FD1SP port map( CP => clk, D => feed_in_BITCOUNT_3, TE
                           => n562, TI => ARG244_3, Q => feed_BITCOUNT_3, QN =>
                           n571);
   n557 <= '1';
   n558 <= '0';
   sub_105_minus_minus : dacuart_DW01_incdec_5_0 port map( A(4) => 
                           feed_in_BITCOUNT_4, A(3) => feed_in_BITCOUNT_3, A(2)
                           => feed_in_BITCOUNT_2, A(1) => n521, A(0) => 
                           feed_in_BITCOUNT_0, INC_DEC => n589, SUM(4) => 
                           ARG244_4, SUM(3) => ARG244_3, SUM(2) => ARG244_2, 
                           SUM(1) => ARG244_1, SUM(0) => ARG244_0);
   U129 : AO34 port map( A => n563, B => n564, C => n559, D => n560, Z => 
                           feed_in_STATE);
   U130 : AO3A port map( A => n523, B => n565, C => rst, D => n539, Z => 
                           feed_in_REQUESTDAC);
   U131 : AO2N port map( A => feed_DACBYTES_8, B => n522, C => dacbytes(8), D 
                           => n561, Z => n573);
   U132 : AO2N port map( A => feed_DACBYTES_9, B => n522, C => dacbytes(9), D 
                           => n561, Z => n574);
   U133 : AO2N port map( A => feed_DACBYTES_7, B => n522, C => dacbytes(7), D 
                           => n561, Z => n575);
   U134 : AO2N port map( A => feed_DACBYTES_6, B => n522, C => dacbytes(6), D 
                           => n561, Z => n576);
   U135 : AO2N port map( A => feed_DACBYTES_5, B => n522, C => dacbytes(5), D 
                           => n561, Z => n577);
   U136 : AO2N port map( A => feed_DACBYTES_4, B => n522, C => dacbytes(4), D 
                           => n561, Z => n578);
   U137 : AO2N port map( A => feed_DACBYTES_3, B => n522, C => dacbytes(3), D 
                           => n561, Z => n579);
   U138 : AO2N port map( A => feed_DACBYTES_2, B => n522, C => dacbytes(2), D 
                           => n561, Z => n580);
   U139 : AO2N port map( A => feed_DACBYTES_1, B => n522, C => dacbytes(1), D 
                           => n561, Z => n581);
   U140 : AO2N port map( A => feed_DACBYTES_14, B => n522, C => dacbytes(14), D
                           => n561, Z => n582);
   U141 : AO2N port map( A => feed_DACBYTES_13, B => n522, C => dacbytes(13), D
                           => n561, Z => n583);
   U142 : AO2N port map( A => feed_DACBYTES_12, B => n522, C => dacbytes(12), D
                           => n561, Z => n584);
   U143 : AO2N port map( A => feed_DACBYTES_11, B => n522, C => dacbytes(11), D
                           => n561, Z => n585);
   U144 : AO2N port map( A => feed_DACBYTES_10, B => n522, C => dacbytes(10), D
                           => n561, Z => n586);
   U145 : AO2N port map( A => feed_DACBYTES_0, B => n522, C => dacbytes(0), D 
                           => n561, Z => n587);
   U146 : ND2P port map( A => n61_DIN, B => feed_in_CLOCK_OUT, Z => n588);
   n589 <= '1';

end SYN_FOOBAR;

library IEEE,MTC45000,MTC45100X,LIB_GENERATORS,STVLIB;

use IEEE.std_logic_1164.all;
use IEEE.std_logic_arith.all;
use MTC45000.VCOMPONENTS.all;
use MTC45100X.VCOMPONENTS.all;
use LIB_GENERATORS.PCK_GENERATORS.all;
use STVLIB.ST_TIMING.all;
use STVLIB.ST_VSS.all;

entity controller is

   port( clk, rst : in std_logic;  flashi : in std_logic_vector (0 to 7);  
         flasho : out std_logic_vector (0 to 30);  buttoni : in 
         std_logic_vector (0 to 3);  mp3i : in std_logic;  mp3o, spi : out 
         std_logic_vector (0 to 2);  rxd : in std_logic;  txd : out std_logic);

end controller;

architecture SYN_structural of controller is

   component core_6502
      port( clk, reset, irq_in, nmi_in : in std_logic;  addr_pin : out 
            std_logic_vector (15 downto 0);  din : in std_logic_vector (7 
            downto 0);  dout : out std_logic_vector (7 downto 0);  dout_oe, 
            we_pin, rd_pin, sync : out std_logic;  halt : in std_logic);
   end component;
   
   component clock_MASTER_CLOCK12000000
      port( clk, rst, zero, read, hold : in std_logic;  seconds, minutes, hours
            : out std_logic_vector (7 downto 0));
   end component;
   
   component uart_MASTER_CLOCK12000000_BAUD_RATE_OUT9600_BAUD_RATE_IN115200
      port( clk, rst, rxd : in std_logic;  txd : out std_logic;  uarti : in 
            std_logic_vector (0 to 9);  uarto : out std_logic_vector (0 to 9));
   end component;
   
   component mmu
      port( clk : in std_logic;  halt : out std_logic;  rst : in std_logic;  
            uarti : out std_logic_vector (0 to 9);  uarto : in std_logic_vector
            (0 to 9);  cpu_addr : in std_logic_vector (15 downto 0);  cpu_in : 
            out std_logic_vector (7 downto 0);  cpu_out : in std_logic_vector 
            (7 downto 0);  cpu_we, cpu_re : in std_logic;  ram_data_in : out 
            std_logic_vector (7 downto 0);  ram_data_out : in std_logic_vector 
            (7 downto 0);  ram_we : out std_logic;  flashi : in 
            std_logic_vector (0 to 7);  flasho : out std_logic_vector (0 to 30)
            ;  button_play, button_stop, button_prev, button_next : in 
            std_logic;  clock_rst, clock_hold, clock_read : out std_logic;  
            clock_seconds, clock_minutes, clock_hours : in std_logic_vector (7 
            downto 0);  mp3i : in std_logic;  mp3o : out std_logic_vector (0 to
            2);  dac_data_byteh, dac_data_bytel : out std_logic_vector (7 
            downto 0);  dac_send_data : out std_logic;  dac_data_req : in 
            std_logic);
   end component;
   
   component mp3ram_BYTES1024
      port( addr : in std_logic_vector (9 downto 0);  clk, we : in std_logic;  
            data_in : in std_logic_vector (7 downto 0);  data_out : out 
            std_logic_vector (7 downto 0));
   end component;
   
   component dacuart
      port( clk, rst : in std_logic;  dacbytes : in std_logic_vector (15 downto
            0);  takethisdac : in std_logic;  requestdac : out std_logic;  daco
            : out std_logic_vector (0 to 2));
   end component;
   
   component IVP
      port( A : in std_logic;  Z : out std_logic);
   end component;
   
   component IV
      port( A : in std_logic;  Z : out std_logic);
   end component;
   
   signal cpu_out_5, dac_data_bytel_0, cpu_addr_6, clock_seconds_7, cpu_in_0, 
      ram_data_in_0, clock_minutes_2, uarti_DATA_2, clock_hours_7, uarto_DATA_4
      , dac_data_byteh_6, ram_data_out_5, clock_read, cpu_addr_15, cpu_addr_12,
      dac_data_req, cpu_in_7, ram_data_out_2, cpu_addr_8, dac_data_bytel_7, 
      cpu_addr_1, clock_minutes_5, clock_hours_0, uarto_DATA_3, 
      dac_data_byteh_1, uarti_DATA_5, ram_data_in_7, clock_seconds_0, rstinv, 
      cpu_out_2, irq, cpu_out_6, cpu_out_4, cpu_out_3, cpu_in_6, 
      clock_minutes_4, clock_hours_1, uarti_DATA_4, dac_send_data, clock_rst, 
      uarto_DATA_2, dac_data_byteh_0, ram_data_out_3, cpu_addr_13, cpu_addr_9, 
      dac_data_bytel_6, clock_seconds_1, cpu_addr_7, cpu_addr_0, ram_data_in_6,
      ram_we, ram_data_in_1, cpu_addr_14, clock_hold, clock_seconds_6, 
      uarti_SEND, cpu_in_1, halt, ram_data_out_4, cpu_re, clock_minutes_3, 
      dac_data_bytel_1, clock_hours_6, uarto_DATA_5, dac_data_byteh_7, 
      clock_seconds_4, uarti_DATA_3, cpu_out_1, cpu_addr_11, cpu_addr_5, 
      cpu_in_3, cpu_we, ram_data_in_3, uarti_DATA_1, uarti_ACK_RCV, 
      uarto_DATA_7, clock_minutes_1, clock_hours_4, dac_data_byteh_5, 
      dac_data_bytel_3, ram_data_out_6, cpu_addr_2, cpu_in_4, ram_we_inv, 
      uarto_RXREADY, dac_data_bytel_4, dac_data_byteh_2, ram_data_out_1, 
      uarto_DATA_0, clock_minutes_6, clock_hours_3, uarti_DATA_6, ram_data_in_4
      , cpu_out_0, cpu_addr_10, cpu_in_5, dac_data_bytel_5, clock_seconds_3, 
      uarti_DATA_7, dac_data_byteh_3, clock_minutes_7, uarto_DATA_1, 
      clock_hours_2, uarto_TXEMPTY, ram_data_out_0, cpu_out_7, cpu_addr_4, 
      cpu_addr_3, clock_seconds_2, ram_data_in_5, ram_data_in_2, 
      clock_seconds_5, cpu_in_2, dac_data_bytel_2, uarto_DATA_6, ram_data_out_7
      , clock_minutes_0, clock_hours_5, dac_data_byteh_4, uarti_DATA_0 : 
      std_logic;

begin
   
   mr_cpu : core_6502 port map( clk => clk, reset => rstinv, irq_in => irq, 
                           nmi_in => irq, addr_pin(15) => cpu_addr_15, 
                           addr_pin(14) => cpu_addr_14, addr_pin(13) => 
                           cpu_addr_13, addr_pin(12) => cpu_addr_12, 
                           addr_pin(11) => cpu_addr_11, addr_pin(10) => 
                           cpu_addr_10, addr_pin(9) => cpu_addr_9, addr_pin(8) 
                           => cpu_addr_8, addr_pin(7) => cpu_addr_7, 
                           addr_pin(6) => cpu_addr_6, addr_pin(5) => cpu_addr_5
                           , addr_pin(4) => cpu_addr_4, addr_pin(3) => 
                           cpu_addr_3, addr_pin(2) => cpu_addr_2, addr_pin(1) 
                           => cpu_addr_1, addr_pin(0) => cpu_addr_0, din(7) => 
                           cpu_in_7, din(6) => cpu_in_6, din(5) => cpu_in_5, 
                           din(4) => cpu_in_4, din(3) => cpu_in_3, din(2) => 
                           cpu_in_2, din(1) => cpu_in_1, din(0) => cpu_in_0, 
                           dout(7) => cpu_out_7, dout(6) => cpu_out_6, dout(5) 
                           => cpu_out_5, dout(4) => cpu_out_4, dout(3) => 
                           cpu_out_3, dout(2) => cpu_out_2, dout(1) => 
                           cpu_out_1, dout(0) => cpu_out_0, dout_oe => open, 
                           we_pin => cpu_we, rd_pin => cpu_re, sync => open, 
                           halt => halt);
   irq <= '0';
   mr_clock : clock_MASTER_CLOCK12000000 port map( clk => clk, rst => rst, zero
                           => clock_rst, read => clock_read, hold => clock_hold
                           , seconds(7) => clock_seconds_7, seconds(6) => 
                           clock_seconds_6, seconds(5) => clock_seconds_5, 
                           seconds(4) => clock_seconds_4, seconds(3) => 
                           clock_seconds_3, seconds(2) => clock_seconds_2, 
                           seconds(1) => clock_seconds_1, seconds(0) => 
                           clock_seconds_0, minutes(7) => clock_minutes_7, 
                           minutes(6) => clock_minutes_6, minutes(5) => 
                           clock_minutes_5, minutes(4) => clock_minutes_4, 
                           minutes(3) => clock_minutes_3, minutes(2) => 
                           clock_minutes_2, minutes(1) => clock_minutes_1, 
                           minutes(0) => clock_minutes_0, hours(7) => 
                           clock_hours_7, hours(6) => clock_hours_6, hours(5) 
                           => clock_hours_5, hours(4) => clock_hours_4, 
                           hours(3) => clock_hours_3, hours(2) => clock_hours_2
                           , hours(1) => clock_hours_1, hours(0) => 
                           clock_hours_0);
   mr_uart : uart_MASTER_CLOCK12000000_BAUD_RATE_OUT9600_BAUD_RATE_IN115200 
                           port map( clk => clk, rst => rst, rxd => rxd, txd =>
                           txd, uarti(0) => uarti_DATA_7, uarti(1) => 
                           uarti_DATA_6, uarti(2) => uarti_DATA_5, uarti(3) => 
                           uarti_DATA_4, uarti(4) => uarti_DATA_3, uarti(5) => 
                           uarti_DATA_2, uarti(6) => uarti_DATA_1, uarti(7) => 
                           uarti_DATA_0, uarti(8) => uarti_SEND, uarti(9) => 
                           uarti_ACK_RCV, uarto(0) => uarto_DATA_7, uarto(1) =>
                           uarto_DATA_6, uarto(2) => uarto_DATA_5, uarto(3) => 
                           uarto_DATA_4, uarto(4) => uarto_DATA_3, uarto(5) => 
                           uarto_DATA_2, uarto(6) => uarto_DATA_1, uarto(7) => 
                           uarto_DATA_0, uarto(8) => uarto_RXREADY, uarto(9) =>
                           uarto_TXEMPTY);
   mr_ram : mp3ram_BYTES1024 port map( addr(9) => cpu_addr_9, addr(8) => 
                           cpu_addr_8, addr(7) => cpu_addr_7, addr(6) => 
                           cpu_addr_6, addr(5) => cpu_addr_5, addr(4) => 
                           cpu_addr_4, addr(3) => cpu_addr_3, addr(2) => 
                           cpu_addr_2, addr(1) => cpu_addr_1, addr(0) => 
                           cpu_addr_0, clk => clk, we => ram_we_inv, data_in(7)
                           => ram_data_in_7, data_in(6) => ram_data_in_6, 
                           data_in(5) => ram_data_in_5, data_in(4) => 
                           ram_data_in_4, data_in(3) => ram_data_in_3, 
                           data_in(2) => ram_data_in_2, data_in(1) => 
                           ram_data_in_1, data_in(0) => ram_data_in_0, 
                           data_out(7) => ram_data_out_7, data_out(6) => 
                           ram_data_out_6, data_out(5) => ram_data_out_5, 
                           data_out(4) => ram_data_out_4, data_out(3) => 
                           ram_data_out_3, data_out(2) => ram_data_out_2, 
                           data_out(1) => ram_data_out_1, data_out(0) => 
                           ram_data_out_0);
   mr_dacuart : dacuart port map( clk => clk, rst => rst, dacbytes(15) => 
                           dac_data_byteh_7, dacbytes(14) => dac_data_byteh_6, 
                           dacbytes(13) => dac_data_byteh_5, dacbytes(12) => 
                           dac_data_byteh_4, dacbytes(11) => dac_data_byteh_3, 
                           dacbytes(10) => dac_data_byteh_2, dacbytes(9) => 
                           dac_data_byteh_1, dacbytes(8) => dac_data_byteh_0, 
                           dacbytes(7) => dac_data_bytel_7, dacbytes(6) => 
                           dac_data_bytel_6, dacbytes(5) => dac_data_bytel_5, 
                           dacbytes(4) => dac_data_bytel_4, dacbytes(3) => 
                           dac_data_bytel_3, dacbytes(2) => dac_data_bytel_2, 
                           dacbytes(1) => dac_data_bytel_1, dacbytes(0) => 
                           dac_data_bytel_0, takethisdac => dac_send_data, 
                           requestdac => dac_data_req, daco(0) => spi(0), 
                           daco(1) => spi(1), daco(2) => spi(2));
   mr_mmu : mmu port map( clk => clk, halt => halt, rst => rst, uarti(0) => 
                           uarti_DATA_7, uarti(1) => uarti_DATA_6, uarti(2) => 
                           uarti_DATA_5, uarti(3) => uarti_DATA_4, uarti(4) => 
                           uarti_DATA_3, uarti(5) => uarti_DATA_2, uarti(6) => 
                           uarti_DATA_1, uarti(7) => uarti_DATA_0, uarti(8) => 
                           uarti_SEND, uarti(9) => uarti_ACK_RCV, uarto(0) => 
                           uarto_DATA_7, uarto(1) => uarto_DATA_6, uarto(2) => 
                           uarto_DATA_5, uarto(3) => uarto_DATA_4, uarto(4) => 
                           uarto_DATA_3, uarto(5) => uarto_DATA_2, uarto(6) => 
                           uarto_DATA_1, uarto(7) => uarto_DATA_0, uarto(8) => 
                           uarto_RXREADY, uarto(9) => uarto_TXEMPTY, 
                           cpu_addr(15) => cpu_addr_15, cpu_addr(14) => 
                           cpu_addr_14, cpu_addr(13) => cpu_addr_13, 
                           cpu_addr(12) => cpu_addr_12, cpu_addr(11) => 
                           cpu_addr_11, cpu_addr(10) => cpu_addr_10, 
                           cpu_addr(9) => cpu_addr_9, cpu_addr(8) => cpu_addr_8
                           , cpu_addr(7) => cpu_addr_7, cpu_addr(6) => 
                           cpu_addr_6, cpu_addr(5) => cpu_addr_5, cpu_addr(4) 
                           => cpu_addr_4, cpu_addr(3) => cpu_addr_3, 
                           cpu_addr(2) => cpu_addr_2, cpu_addr(1) => cpu_addr_1
                           , cpu_addr(0) => cpu_addr_0, cpu_in(7) => cpu_in_7, 
                           cpu_in(6) => cpu_in_6, cpu_in(5) => cpu_in_5, 
                           cpu_in(4) => cpu_in_4, cpu_in(3) => cpu_in_3, 
                           cpu_in(2) => cpu_in_2, cpu_in(1) => cpu_in_1, 
                           cpu_in(0) => cpu_in_0, cpu_out(7) => cpu_out_7, 
                           cpu_out(6) => cpu_out_6, cpu_out(5) => cpu_out_5, 
                           cpu_out(4) => cpu_out_4, cpu_out(3) => cpu_out_3, 
                           cpu_out(2) => cpu_out_2, cpu_out(1) => cpu_out_1, 
                           cpu_out(0) => cpu_out_0, cpu_we => cpu_we, cpu_re =>
                           cpu_re, ram_data_in(7) => ram_data_in_7, 
                           ram_data_in(6) => ram_data_in_6, ram_data_in(5) => 
                           ram_data_in_5, ram_data_in(4) => ram_data_in_4, 
                           ram_data_in(3) => ram_data_in_3, ram_data_in(2) => 
                           ram_data_in_2, ram_data_in(1) => ram_data_in_1, 
                           ram_data_in(0) => ram_data_in_0, ram_data_out(7) => 
                           ram_data_out_7, ram_data_out(6) => ram_data_out_6, 
                           ram_data_out(5) => ram_data_out_5, ram_data_out(4) 
                           => ram_data_out_4, ram_data_out(3) => ram_data_out_3
                           , ram_data_out(2) => ram_data_out_2, ram_data_out(1)
                           => ram_data_out_1, ram_data_out(0) => ram_data_out_0
                           , ram_we => ram_we, flashi(0) => flashi(0), 
                           flashi(1) => flashi(1), flashi(2) => flashi(2), 
                           flashi(3) => flashi(3), flashi(4) => flashi(4), 
                           flashi(5) => flashi(5), flashi(6) => flashi(6), 
                           flashi(7) => flashi(7), flasho(0) => flasho(0), 
                           flasho(1) => flasho(1), flasho(2) => flasho(2), 
                           flasho(3) => flasho(3), flasho(4) => flasho(4), 
                           flasho(5) => flasho(5), flasho(6) => flasho(6), 
                           flasho(7) => flasho(7), flasho(8) => flasho(8), 
                           flasho(9) => flasho(9), flasho(10) => flasho(10), 
                           flasho(11) => flasho(11), flasho(12) => flasho(12), 
                           flasho(13) => flasho(13), flasho(14) => flasho(14), 
                           flasho(15) => flasho(15), flasho(16) => flasho(16), 
                           flasho(17) => flasho(17), flasho(18) => flasho(18), 
                           flasho(19) => flasho(19), flasho(20) => flasho(20), 
                           flasho(21) => flasho(21), flasho(22) => flasho(22), 
                           flasho(23) => flasho(23), flasho(24) => flasho(24), 
                           flasho(25) => flasho(25), flasho(26) => flasho(26), 
                           flasho(27) => flasho(27), flasho(28) => flasho(28), 
                           flasho(29) => flasho(29), flasho(30) => flasho(30), 
                           button_play => buttoni(0), button_stop => buttoni(1)
                           , button_prev => buttoni(2), button_next => 
                           buttoni(3), clock_rst => clock_rst, clock_hold => 
                           clock_hold, clock_read => clock_read, 
                           clock_seconds(7) => clock_seconds_7, 
                           clock_seconds(6) => clock_seconds_6, 
                           clock_seconds(5) => clock_seconds_5, 
                           clock_seconds(4) => clock_seconds_4, 
                           clock_seconds(3) => clock_seconds_3, 
                           clock_seconds(2) => clock_seconds_2, 
                           clock_seconds(1) => clock_seconds_1, 
                           clock_seconds(0) => clock_seconds_0, 
                           clock_minutes(7) => clock_minutes_7, 
                           clock_minutes(6) => clock_minutes_6, 
                           clock_minutes(5) => clock_minutes_5, 
                           clock_minutes(4) => clock_minutes_4, 
                           clock_minutes(3) => clock_minutes_3, 
                           clock_minutes(2) => clock_minutes_2, 
                           clock_minutes(1) => clock_minutes_1, 
                           clock_minutes(0) => clock_minutes_0, clock_hours(7) 
                           => clock_hours_7, clock_hours(6) => clock_hours_6, 
                           clock_hours(5) => clock_hours_5, clock_hours(4) => 
                           clock_hours_4, clock_hours(3) => clock_hours_3, 
                           clock_hours(2) => clock_hours_2, clock_hours(1) => 
                           clock_hours_1, clock_hours(0) => clock_hours_0, mp3i
                           => mp3i, mp3o(0) => mp3o(0), mp3o(1) => mp3o(1), 
                           mp3o(2) => mp3o(2), dac_data_byteh(7) => 
                           dac_data_byteh_7, dac_data_byteh(6) => 
                           dac_data_byteh_6, dac_data_byteh(5) => 
                           dac_data_byteh_5, dac_data_byteh(4) => 
                           dac_data_byteh_4, dac_data_byteh(3) => 
                           dac_data_byteh_3, dac_data_byteh(2) => 
                           dac_data_byteh_2, dac_data_byteh(1) => 
                           dac_data_byteh_1, dac_data_byteh(0) => 
                           dac_data_byteh_0, dac_data_bytel(7) => 
                           dac_data_bytel_7, dac_data_bytel(6) => 
                           dac_data_bytel_6, dac_data_bytel(5) => 
                           dac_data_bytel_5, dac_data_bytel(4) => 
                           dac_data_bytel_4, dac_data_bytel(3) => 
                           dac_data_bytel_3, dac_data_bytel(2) => 
                           dac_data_bytel_2, dac_data_bytel(1) => 
                           dac_data_bytel_1, dac_data_bytel(0) => 
                           dac_data_bytel_0, dac_send_data => dac_send_data, 
                           dac_data_req => dac_data_req);
   U6 : IVP port map( A => rst, Z => rstinv);
   U7 : IV port map( A => ram_we, Z => ram_we_inv);

end SYN_structural;

library IEEE,MTC45000,MTC45100X,LIB_GENERATORS,STVLIB;

use IEEE.std_logic_1164.all;
use IEEE.std_logic_arith.all;
use MTC45000.VCOMPONENTS.all;
use MTC45100X.VCOMPONENTS.all;
use LIB_GENERATORS.PCK_GENERATORS.all;
use STVLIB.ST_TIMING.all;
use STVLIB.ST_VSS.all;

entity controller_top is

   port( clk, rst : in std_logic;  flash_addr : out std_logic_vector (19 downto
         0);  flash_data : in std_logic_vector (7 downto 0);  button_play, 
         button_stop, button_prev, button_next : in std_logic;  mp3_rst, 
         mp3_data, mp3_valid : out std_logic;  mp3_req : in std_logic;  spi_cs,
         spi_sclk, spi_din : out std_logic;  rxd : in std_logic;  txd : out 
         std_logic);

end controller_top;

architecture SYN_structural of controller_top is

   component controller
      port( clk, rst : in std_logic;  flashi : in std_logic_vector (0 to 7);  
            flasho : out std_logic_vector (0 to 30);  buttoni : in 
            std_logic_vector (0 to 3);  mp3i : in std_logic;  mp3o, spi : out 
            std_logic_vector (0 to 2);  rxd : in std_logic;  txd : out 
            std_logic);
   end component;
   
   component B2CR
      port( Z : out std_logic;  A : in std_logic);
   end component;
   
   component IBUF
      port( Z : out std_logic;  A : in std_logic);
   end component;
   
   component BF1T1
      port( A : in std_logic;  Z : out std_logic);
   end component;
   
   component BF1T2
      port( A : in std_logic;  Z : out std_logic);
   end component;
   
   signal n103, n119, flasho_ADDR_12, n114, flasho_ADDR_0, n109, flasho_ADDR_9,
      n117, flasho_ADDR_15, n108, flasho_ADDR_7, mp3o_RST, n107, mp3o_DATA, 
      mp3o_VALID, n112, flasho_ADDR_14, spi_DIN_port, flasho_ADDR_13, 
      flasho_ADDR_6, flasho_ADDR_1, flasho_ADDR_8, n110, flasho_ADDR_11, 
      flasho_ADDR_3, n118, flasho_ADDR_18, flasho_ADDR_16, flasho_ADDR_4, n105,
      n106, spi_CS_port, n113, n115, n104, flasho_ADDR_17, flasho_ADDR_5, 
      flasho_ADDR_10, flasho_ADDR_2, flasho_ADDR_19, spi_SCLK_port, n116, n111,
      n952, n953, UNCONNECTED_1, UNCONNECTED_2, UNCONNECTED_3, UNCONNECTED_4, 
      UNCONNECTED_5, UNCONNECTED_6, UNCONNECTED_7, UNCONNECTED_8, UNCONNECTED_9
      , UNCONNECTED_10, UNCONNECTED_11 : std_logic;

begin
   
   ctrl : controller port map( clk => n103, rst => n953, flashi(0) => n105, 
                           flashi(1) => n106, flashi(2) => n107, flashi(3) => 
                           n108, flashi(4) => n109, flashi(5) => n110, 
                           flashi(6) => n111, flashi(7) => n112, flasho(0) => 
                           UNCONNECTED_1, flasho(1) => UNCONNECTED_2, flasho(2)
                           => UNCONNECTED_3, flasho(3) => UNCONNECTED_4, 
                           flasho(4) => UNCONNECTED_5, flasho(5) => 
                           UNCONNECTED_6, flasho(6) => UNCONNECTED_7, flasho(7)
                           => UNCONNECTED_8, flasho(8) => flasho_ADDR_19, 
                           flasho(9) => flasho_ADDR_18, flasho(10) => 
                           flasho_ADDR_17, flasho(11) => flasho_ADDR_16, 
                           flasho(12) => flasho_ADDR_15, flasho(13) => 
                           flasho_ADDR_14, flasho(14) => flasho_ADDR_13, 
                           flasho(15) => flasho_ADDR_12, flasho(16) => 
                           flasho_ADDR_11, flasho(17) => flasho_ADDR_10, 
                           flasho(18) => flasho_ADDR_9, flasho(19) => 
                           flasho_ADDR_8, flasho(20) => flasho_ADDR_7, 
                           flasho(21) => flasho_ADDR_6, flasho(22) => 
                           flasho_ADDR_5, flasho(23) => flasho_ADDR_4, 
                           flasho(24) => flasho_ADDR_3, flasho(25) => 
                           flasho_ADDR_2, flasho(26) => flasho_ADDR_1, 
                           flasho(27) => flasho_ADDR_0, flasho(28) => 
                           UNCONNECTED_9, flasho(29) => UNCONNECTED_10, 
                           flasho(30) => UNCONNECTED_11, buttoni(0) => n113, 
                           buttoni(1) => n114, buttoni(2) => n115, buttoni(3) 
                           => n116, mp3i => n117, mp3o(0) => mp3o_RST, mp3o(1) 
                           => mp3o_DATA, mp3o(2) => mp3o_VALID, spi(0) => 
                           spi_CS_port, spi(1) => spi_SCLK_port, spi(2) => 
                           spi_DIN_port, rxd => n952, txd => n119);
   U4 : B2CR port map( Z => txd, A => n119);
   U5 : IBUF port map( Z => n118, A => rxd);
   U6 : B2CR port map( Z => spi_din, A => spi_DIN_port);
   U7 : B2CR port map( Z => spi_sclk, A => spi_SCLK_port);
   U8 : B2CR port map( Z => spi_cs, A => spi_CS_port);
   U9 : IBUF port map( Z => n117, A => mp3_req);
   U10 : B2CR port map( Z => mp3_valid, A => mp3o_VALID);
   U11 : B2CR port map( Z => mp3_data, A => mp3o_DATA);
   U12 : B2CR port map( Z => mp3_rst, A => mp3o_RST);
   U13 : IBUF port map( Z => n116, A => button_next);
   U14 : IBUF port map( Z => n115, A => button_prev);
   U15 : IBUF port map( Z => n114, A => button_stop);
   U16 : IBUF port map( Z => n113, A => button_play);
   U17 : IBUF port map( Z => n112, A => flash_data(0));
   U18 : IBUF port map( Z => n111, A => flash_data(1));
   U19 : IBUF port map( Z => n110, A => flash_data(2));
   U20 : IBUF port map( Z => n109, A => flash_data(3));
   U21 : IBUF port map( Z => n108, A => flash_data(4));
   U22 : IBUF port map( Z => n107, A => flash_data(5));
   U23 : IBUF port map( Z => n106, A => flash_data(6));
   U24 : IBUF port map( Z => n105, A => flash_data(7));
   U25 : B2CR port map( Z => flash_addr(0), A => flasho_ADDR_0);
   U26 : B2CR port map( Z => flash_addr(1), A => flasho_ADDR_1);
   U27 : B2CR port map( Z => flash_addr(2), A => flasho_ADDR_2);
   U28 : B2CR port map( Z => flash_addr(3), A => flasho_ADDR_3);
   U29 : B2CR port map( Z => flash_addr(4), A => flasho_ADDR_4);
   U30 : B2CR port map( Z => flash_addr(5), A => flasho_ADDR_5);
   U31 : B2CR port map( Z => flash_addr(6), A => flasho_ADDR_6);
   U32 : B2CR port map( Z => flash_addr(7), A => flasho_ADDR_7);
   U33 : B2CR port map( Z => flash_addr(8), A => flasho_ADDR_8);
   U34 : B2CR port map( Z => flash_addr(9), A => flasho_ADDR_9);
   U35 : B2CR port map( Z => flash_addr(10), A => flasho_ADDR_10);
   U36 : B2CR port map( Z => flash_addr(11), A => flasho_ADDR_11);
   U37 : B2CR port map( Z => flash_addr(12), A => flasho_ADDR_12);
   U38 : B2CR port map( Z => flash_addr(13), A => flasho_ADDR_13);
   U39 : B2CR port map( Z => flash_addr(14), A => flasho_ADDR_14);
   U40 : B2CR port map( Z => flash_addr(15), A => flasho_ADDR_15);
   U41 : B2CR port map( Z => flash_addr(16), A => flasho_ADDR_16);
   U42 : B2CR port map( Z => flash_addr(17), A => flasho_ADDR_17);
   U43 : B2CR port map( Z => flash_addr(18), A => flasho_ADDR_18);
   U44 : B2CR port map( Z => flash_addr(19), A => flasho_ADDR_19);
   U45 : IBUF port map( Z => n104, A => rst);
   U46 : IBUF port map( Z => n103, A => clk);
   U47 : BF1T1 port map( A => n118, Z => n952);
   U48 : BF1T2 port map( A => n104, Z => n953);

end SYN_structural;
